 /*********************************************************************/
 /*                                                                   */
 /* SOURCE FILE NAME: ipfx.h                                          */
 /*                                                                   */
 /* DESCRIPTION: This is the public include file for ipf              */
 /*                                                                   */
 /* COPYRIGHT =                                                       */
 /*   COPYRIGHT (C) SINGALAB PTE LTD 1992, 1993                       */
 /*   All Rights Reserved                                             */
 /*                                                                   */
 /*********************************************************************/

 %dcl #IPFX_H char ext;
 %if #IPFX_H = '' %then %do;
 %#IPFX_H = 'Y';

 %dcl #WINUSER_ char ext;
 %if #WINUSER_ = '' %then %do;
 %include winuser;
 %end;

 /********************************************************************/
 /* Help Manager Initialization Structure used on the                */
 /* XhCreateHelpInstance() call.                                     */
 /********************************************************************/

 %dcl PFUNC_TYPE char ext;
 %if PFUNC_TYPE = '' %then %do;
 %PFUNC_TYPE = 'Y';
 %dcl PFUNC char ext;
 %PFUNC='FARPROC';
 %end;

 /*****************************************************************/
 /* HelpSubTable entry structure                                  */
 /*****************************************************************/
 define alias  HELPSUBTABLE unsigned fixed bin(16);
 define alias PHELPSUBTABLE pointer;

 /*****************************************************************/
 /* HelpTable entry structure                                     */
 /*                                                               */
 /*****************************************************************/

 define structure
   1 HELPTABLE,
     2 usTopic       unsigned fixed bin(16) ,
     2 pHelpSubTable type PHELPSUBTABLE,
     2 usExtPanel    unsigned fixed bin(16) ;
 define alias PHELPTABLE handle HELPTABLE;

 /*****************************************************************/
 /* IPF Initialization Structure used on the                      */
 /* XhCreateHelpInstance() call.                                  */
 /*****************************************************************/

 define structure
   1 HELPINIT,
     2 usHelpTableID         unsigned fixed bin(16) ,
     2 pHelpTable            type PHELPTABLE,
     2 hHelpTableModule      type HINSTANCE,
     2 hAccelMenuBarModule   type HINSTANCE,
     2 ulAccelTable          fixed bin(31) ,
     2 menuBarHierarchy      fixed bin(31) ,
     2 pszHelpWindowTitle    type LPSTR,
     2 usShowPanelId         unsigned fixed bin(16) ,
     2 pszHelpLibraryNames   type LPSTR;
 define alias PHELPINIT handle HELPINIT;


 /********************************************************************/
 /* AC Viewport stucture definitions                                 */
 /********************************************************************/
 %dcl WIN32 char ext;
 %dcl #WIN32 char ext;
 %if (WIN32 = '') & (#WIN32 = '') %then %do;
 define structure
   1 RECTL,
     2 lXLeft   type LONG,
     2 lYBottom type LONG,
     2 lXRight  type LONG,
     2 lYTop    type LONG;
 define alias PRECTL handle RECTL;
 %end;

 /********************************************************************/
 /* Property name used to set help topic ID of a dialog box or a     */
 /* popup menu which may require help from IPF.                      */
 /********************************************************************/
 dcl PROP_HELP_TOPIC_ID char value('PROP_HELP_TOPIC_ID');

 /********************************************************************/
 /* Constants used to define the how the panel IDs are displayed on  */
 /* help panels.                                                     */
 /********************************************************************/

 dcl CMIC_HIDE_PANEL_ID   fixed bin(15) value('0000'xn);
 dcl CMIC_SHOW_PANEL_ID   fixed bin(15) value('0001'xn);
 dcl CMIC_TOGGLE_PANEL_ID fixed bin(15) value('0002'xn);

 /********************************************************************/
 /* Type Flag for HM_DISPLAY_HELP                                    */
 /********************************************************************/
 dcl HM_RESOURCEID        fixed bin(15) value('0000'xn);
 dcl HM_PANELNAME         fixed bin(15) value('0001'xn);

 /********************************************************************/
 /* Res number for the default push buttons                          */
 /********************************************************************/

 dcl CTRL_PREVIOUS_ID     fixed bin(31) value(0);
 dcl CTRL_SEARCH_ID       fixed bin(31) value(1);
 dcl CTRL_PRINT_ID        fixed bin(31) value(2);
 dcl CTRL_INDEX_ID        fixed bin(31) value(3);
 dcl CTRL_CONTENTS_ID     fixed bin(31) value(4);
 dcl CTRL_BACK_ID         fixed bin(31) value(5);
 dcl CTRL_FORWARD_ID      fixed bin(31) value(6);
 dcl CTRL_TUTORIAL_ID     fixed bin(31) value(255);

 /********************************************************************/
 /* Help Manager message base.                                       */
 /********************************************************************/

 dcl HM_MSG_BASE              fixed bin(31) value(WM_USER+'0220'xn);

 /********************************************************************/
 /* Messages applications can send to the Help Manager.              */
 /********************************************************************/

 dcl HM_DISMISS_WINDOW        fixed bin(31) value(HM_MSG_BASE+'0001'xn);
 dcl HM_DISPLAY_HELP          fixed bin(31) value(HM_MSG_BASE+'0002'xn);
 dcl HM_GENERAL_HELP          fixed bin(31) value(HM_MSG_BASE+'0003'xn);
 dcl HM_EXT_HELP              fixed bin(31) value(HM_GENERAL_HELP);
 dcl HM_SET_ACTIVE_WINDOW     fixed bin(31) value(HM_MSG_BASE+'0004'xn);
 dcl HM_LOAD_HELP_TABLE       fixed bin(31) value(HM_MSG_BASE+'0005'xn);
 dcl HM_CREATE_HELP_TABLE     fixed bin(31) value(HM_MSG_BASE+'0006'xn);
 dcl HM_SET_HELP_WINDOW_TITLE fixed bin(31) value(HM_MSG_BASE+'0007'xn);
 dcl HM_SET_SHOW_PANEL_ID     fixed bin(31) value(HM_MSG_BASE+'0008'xn);
 dcl HM_REPLACE_USING_HELP    fixed bin(31) value(HM_MSG_BASE+'0009'xn);
 dcl HM_HELP_INDEX            fixed bin(31) value(HM_MSG_BASE+'000a'xn);
 dcl HM_HELP_CONTENTS         fixed bin(31) value(HM_MSG_BASE+'000b'xn);
 dcl HM_KEYS_HELP             fixed bin(31) value(HM_MSG_BASE+'000c'xn);
 dcl HM_SET_HELP_LIBRARY_NAME fixed bin(31) value(HM_MSG_BASE+'000d'xn);

 /********************************************************************/
 /* Messages the Help Manager sends to the applications active       */
 /* window as defined by the Help Manager.                           */
 /********************************************************************/

 dcl HM_ERROR                 fixed bin(31) value(HM_MSG_BASE+'000e'xn);
 dcl HM_QUERY_KEYS_HELP       fixed bin(31) value(HM_MSG_BASE+'0010'xn);
 dcl HM_QUERY_GENERAL_HELP    fixed bin(31) value(HM_MSG_BASE+'0012'xn);
 dcl HM_ACTIONBAR_COMMAND     fixed bin(31) value(HM_MSG_BASE+'0013'xn);
 dcl HM_INFORM                fixed bin(31) value(HM_MSG_BASE+'0014'xn);

 dcl HM_SET_OBJCOM_WINDOW     fixed bin(31) value(HM_MSG_BASE+'001a'xn);
 dcl HM_UPDATE_OBJCOM_WINDOW_CHAIN fixed bin(31)
                                            value(HM_MSG_BASE+'001b'xn);
 dcl HM_QUERY                 fixed bin(31) value(HM_MSG_BASE+'001c'xn);
 dcl HM_SET_COVERPAGE_SIZE    fixed bin(31) value(HM_MSG_BASE+'001d'xn);
 dcl HM_SET_USERDATA          fixed bin(31) value(HM_MSG_BASE+'0023'xn);
 dcl HM_NOTIFY                fixed bin(31) value(HM_MSG_BASE+'0024'xn);

 dcl HM_QUERY_DDF_DATA        fixed bin(31) value(HM_MSG_BASE+'0025'xn);
 dcl HM_CONTROL               fixed bin(31) value(HM_MSG_BASE+'0026'xn);

 dcl HM_GENERAL_HELP_UNDEFINED fixed bin(31)
                                            value(HM_MSG_BASE+'0027'xn);
 dcl HM_EXT_HELP_UNDEFINED    fixed bin(31)
                                       value(HM_GENERAL_HELP_UNDEFINED);

 /********************************************************************/
 /*  Constants used to query the info from IPF in HM_QUERY message   */
 /********************************************************************/
 dcl HMQW_COVERPAGE               fixed bin(15) value('0001'xn);
 dcl HMQW_INDEX                   fixed bin(15) value('0002'xn);
 dcl HMQW_TOC                     fixed bin(15) value('0003'xn);
 dcl HMQW_SEARCH                  fixed bin(15) value('0004'xn);
 dcl HMQW_VIEWPAGES               fixed bin(15) value('0005'xn);
 dcl HMQW_LIBRARY                 fixed bin(15) value('0006'xn);
 dcl HMQW_VIEWPORT                fixed bin(15) value('0007'xn);
 dcl HMQW_OBJCOM_WINDOW           fixed bin(15) value('0008'xn);
 dcl HMQW_INSTANCE                fixed bin(15) value('0009'xn);
 dcl HMQW_ACTIVEVIEWPORT          fixed bin(15) value('000a'xn);
 dcl CONTROL_SELECTED             fixed bin(15) value('000b'xn);
 dcl HELP_REQUESTED               fixed bin(15) value('000c'xn);

 dcl HMQW_GROUP_VIEWPORT          fixed bin(15) value('00f1'xn);
 dcl HMQW_RES_VIEWPORT            fixed bin(15) value('00f2'xn);
 dcl USERDATA                     fixed bin(15) value('00f3'xn);

 /* param2 of HMQW_VIEWPORT */
 dcl HMQVP_NUMBER                 fixed bin(15) value('0001'xn);
 dcl HMQVP_NAME                   fixed bin(15) value('0002'xn);
 dcl HMQVP_GROUP                  fixed bin(15) value('0003'xn);

 dcl HMERR_INVALID_APPL_WIDGET    fixed bin(31) value(1001);
     /* Invalid application widget */
 dcl HMERR_INVALID_HELP_WIDGET    fixed bin(31) value(1002);
     /* Invalid help instance widget */
 dcl HMERR_HELPTABLE_UNDEFINED    fixed bin(31) value(1003);
     /* Help table not defined */

 dcl HMERR_HELPITEM_NOT_FOUND     fixed bin(31) value(1005);
     /* Invalid help item */
 dcl HMERR_INVALID_HELPITEM_SIZE  fixed bin(31) value(1006);
     /* Invalid help item size */
 dcl HMERR_INVALID_HELPTABLE      fixed bin(31) value(1007);
     /* Invalise help table */
 dcl HMERR_INVALID_CONTROL_ID     fixed bin(31) value(1008);
     /* Invalid control id */
 dcl HMERR_INVALID_HELP_ID        fixed bin(31) value(1009);
     /* Invalid help id */

 dcl HMERR_INDEX_NOT_FOUND        fixed bin(31) value(1011);
     /* no index in file */
 dcl HMERR_CONTENT_NOT_FOUND      fixed bin(31) value(1012);
     /* no table of contents in file */
 dcl HMERR_LIB_FILE_NOT_FOUND     fixed bin(31) value(1013);
     /* cannot find the library file */
 dcl HMERR_OPEN_LIB_FILE          fixed bin(31) value(1014);
     /* can't open library file */
 dcl HMERR_INVALID_HELP_STRUCTURE fixed bin(31) value(1015);
     /* invalid PHELPINIT structure */
 dcl HMERR_INVALID_PARAMETERS     fixed bin(31) value(1016);
     /* invalid parameters */
 dcl HMERR_INVALID_MESSAGE        fixed bin(31) value(1017);
     /* invalid message sent to IPF */
 dcl HMERR_READ_LIB_FILE          fixed bin(31) value(1018);
     /* error reading library file */
 dcl HMERR_CLOSE_LIB_FILE         fixed bin(31) value(1019);
     /* can't close library file */
 dcl HMERR_INVALID_LIB_FILE       fixed bin(31) value(1020);
     /* improper library file given */
 dcl HMERR_MEMORY_ERROR           fixed bin(31) value(1021);
     /* out of memory */
 dcl HMERR_PANEL_NOT_FOUND        fixed bin(31) value(1022);
     /* can't find requested panel or it cannot be loaded   */
 dcl HMERR_RES_FILE_NOT_FOUND     fixed bin(31) value(1024);
     /* the UID file cannot be found */
 dcl HMERR_CLASS_REGISTER_FAIL    fixed bin(31) value(1025);
     /* error Registering IPF Class  */
 dcl HMERR_FONTSET_CREATION_FAIL  fixed bin(31) value(1026);
     /* error creating fonts */
 dcl HMERR_FREE_MEMORY            fixed bin(31) value(1027);
     /* error freeing memory */

 dcl HMERR_OPEN_COPY_FILE         fixed bin(31) value(1031);
     /* error opening file for copy */
 dcl HMERR_READ_APPEND_FILE       fixed bin(31) value(1032);
    /* error reading file for append */
 dcl HMERR_WRITE_COPY_FILE        fixed bin(31) value(1033);
     /* error copying to file */
 dcl HMERR_INVALID_RES_FILE       fixed bin(31) value(1034);
     /* Resource file is not valid */

 /********************************************************************/
 /* error codes returned by DDF API functions                        */
 /********************************************************************/
 dcl HMERR_DDF_MEMORY             fixed bin(31) value(2001);
     /* Not enough memory */
 dcl HMERR_DDF_ALIGN_TYPE         fixed bin(31) value(2002);
     /* Invalid alignment type */
 dcl HMERR_DDF_BACKCOLOR          fixed bin(31) value(2003);
     /* Invalid background color */
 dcl HMERR_DDF_FORECOLOR          fixed bin(31) value(2004);
     /* Invalid foreground color */
 dcl HMERR_DDF_FONTSTYLE          fixed bin(31) value(2005);
     /* Invalid font style */
 dcl HMERR_DDF_REFTYPE            fixed bin(31) value(2006);
     /* Invalid hyper text type */
 dcl HMERR_DDF_LIST_UNCLOSED      fixed bin(31) value(2007);
     /* List definition is not closed */
 dcl HMERR_DDF_LIST_UNINITIALIZED fixed bin(31) value(2008);
     /* List definition is not ready */
 dcl HMERR_DDF_LIST_BREAKTYPE     fixed bin(31) value(2009);
     /* Invalid break type of list def */
 dcl HMERR_DDF_LIST_SPACING       fixed bin(31) value(2010);
     /* Invalid space type of list def */
 dcl HMERR_DDF_HINSTANCE          fixed bin(31) value(2011);
     /* Invalid help instance handle */
 dcl HMERR_DDF_EXCEED_MAX_LENGTH  fixed bin(31) value(2012);
      /* Buffer length is too large */
 dcl HMERR_DDF_EXCEED_MAX_INC     fixed bin(31) value(2013);
     /* Increment length is too large */
 dcl HMERR_DDF_INVALID_DDF        fixed bin(31) value(2014);
     /* Invalid DDF handle */
 dcl HMERR_DDF_FORMAT_TYPE        fixed bin(31) value(2015);
     /* Invalid format type */
 dcl HMERR_DDF_INVALID_PARM       fixed bin(31) value(2016);
     /* Invalid parameter */
 dcl HMERR_DDF_BITMAP             fixed bin(31) value(2017);
     /* Invalid bitmap handle */
 dcl HMERR_DDF_MAX_DDF_FONTS      fixed bin(31) value(2018);
     /* DDF fonts are too many */


 /********************************************************************/
 /* Help API declarations                                            */
 /********************************************************************/

 dcl XhDestroyHelpInstance
     entry (type HWND )
     returns (fixed bin(31) byvalue optional)
     PASCAL external('XhDestroyHelpInstance');

 dcl XhCreateHelpInstance
     entry (type HWND,
            type HELPINIT byaddr,
            type HWND byaddr)
     returns (fixed bin(31) byvalue optional)
     PASCAL external('XhCreateHelpInstance');

 dcl XhAssociateHelpInstance
     entry (type HWND,
            type HWND)
     returns (fixed bin(31) byvalue optional)
     PASCAL external('XhAssociateHelpInstance');

 dcl XhQueryHelpInstance
     entry (type HWND,
            type HWND byaddr)
     returns (fixed bin(31) byvalue optional)
     PASCAL external('XhQueryHelpInstance');

 dcl XhCallIPF
     entry (type HWND,
            unsigned fixed bin(16),
            pointer,
            pointer)
     returns (fixed bin(31) byvalue optional)
     PASCAL external('XhCallIPF');

 dcl XhCreateHelpTable
     entry (type HWND,
            type HELPTABLE byaddr)
     returns (fixed bin(31) byvalue optional)
     PASCAL external('XhCreateHelpTable');

 dcl XhLoadHelpTable
     entry (type HWND,
            unsigned fixed bin(16),
            type HMODULE)
     returns (fixed bin(31) byvalue optional)
     PASCAL external('XhLoadHelpTable');


 /********************************************************************/
 /* AC Viewport stucture definitions                                 */
 /********************************************************************/
 define structure
   1 ACVP,       /* acvp */
     2 cb        unsigned fixed bin(32),/* size of the structure */
     2 ObjectID  unsigned fixed bin(32),/* object identifier */
     2 wgtParent type HWND,/* IPF viewport handle */
     2 wgtOwner  type HWND,/* IPF main window handle */
     2 wgtACVP   type HWND;/* applications window hwnd */
 define alias PACVP handle ACVP;

 /********************************************************************/
 /* DDF defines and prototypes                                       */
 /********************************************************************/
 %dcl PMDDF_H char ext;
 %if PMDDF_H = '' %then %do;
 %PMDDF_H = 'Y';
 %end;

 /********************************************************************/
 /* Define Handle to DDF                                             */
 /********************************************************************/
 define alias HDDF pointer;

 /* DdfHyperText Flags */
 dcl REFERENCE_BY_ID   fixed bin(31) value(0);
 dcl REFERENCE_BY_RES  fixed bin(31) value(1);

 /* DdfBeginList formatting flags */
 dcl HMBT_NONE         fixed bin(31) value(1);
 dcl HMBT_ALL          fixed bin(31) value(2);
 dcl HMBT_FIT          fixed bin(31) value(3);

 dcl HMLS_SINGLELINE   fixed bin(31) value(1);
 dcl HMLS_DOUBLELINE   fixed bin(31) value(2);

 /* DdfBitmap alignment flags */
 dcl ART_RUNIN         fixed bin(31) value('10'xn);
 dcl ART_LEFT          fixed bin(31) value('01'xn);
 dcl ART_RIGHT         fixed bin(31) value('02'xn);
 dcl ART_CENTER        fixed bin(31) value('04'xn);

 /* DdfSetTextAlign align flags */
 dcl ALIGN_LEFT        fixed bin(31) value('01'xn);
 dcl ALIGN_RIGHT       fixed bin(31) value('02'xn);
 dcl ALIGN_CENTER      fixed bin(31) value('04'xn);

 /* DdfSetFontStyle font style flags */
 dcl FM_SEL_ITALIC     fixed bin(31) value('01'xn);
 dcl FM_SEL_BOLD       fixed bin(31) value('02'xn);
 dcl FM_SEL_UNDERSCORE fixed bin(31) value('04'xn);

 /* DdfSetColor Color Flag */
 dcl CLR_UNCHANGED     fixed bin(31) value(-6);
 /* CLR_DEFAULT: clashes with commctrl.cpy (where = 'FF000000'xn) */
 dcl CLR_DEFAULT$      fixed bin(31) value(-1);
 dcl CLR_WHITE         fixed bin(31) value(0);
 dcl CLR_BLUE          fixed bin(31) value(1);
 dcl CLR_RED           fixed bin(31) value(2);
 dcl CLR_PINK          fixed bin(31) value(3);
 dcl CLR_GREEN         fixed bin(31) value(4);
 dcl CLR_CYAN          fixed bin(31) value(5);
 dcl CLR_YELLOW        fixed bin(31) value(6);
 dcl CLR_BROWN         fixed bin(31) value(7);
 dcl CLR_DARKGRAY      fixed bin(31) value(8);
 dcl CLR_DARKBLUE      fixed bin(31) value(9);
 dcl CLR_DARKRED       fixed bin(31) value(10);
 dcl CLR_DARKPINK      fixed bin(31) value(11);
 dcl CLR_DARKGREEN     fixed bin(31) value(12);
 dcl CLR_DARKCYAN      fixed bin(31) value(13);
 dcl CLR_BLACK         fixed bin(31) value(14);
 dcl CLR_PALEGRAY      fixed bin(31) value(15);


 /********************************************************************/
 /* DDF API declarations.                                            */
 /********************************************************************/

 dcl DdfInitialize
     entry (type HWND,
            unsigned fixed bin(32),
            unsigned fixed bin(32))
     returns (type HDDF byvalue optional)
     PASCAL external('DdfInitialize');

 dcl DdfPara
     entry (type HDDF)
     returns (unsigned fixed bin(16) byvalue optional)
     PASCAL external('DdfPara');

 dcl DdfSetFormat
     entry (type HDDF,
            fixed bin(31))
     returns (unsigned fixed bin(16) byvalue optional)
     PASCAL external('DdfSetFormat');

 dcl DdfSetTextAlign
     entry (type HDDF,
            fixed bin(31))
     returns (unsigned fixed bin(16) byvalue optional)
     PASCAL external('DdfSetTextAlign');

 dcl DdfSetColor
     entry (type HDDF,
            fixed bin(31),
            fixed bin(31))
     returns (unsigned fixed bin(16) byvalue optional)
     PASCAL external('DdfSetColor');

 dcl DdfInform
     entry (type HDDF,
            char (*) varz byaddr,
            fixed bin(31))
     returns (unsigned fixed bin(16) byvalue optional)
     PASCAL external('DdfInform');

 dcl DdfSetFontStyle
     entry (type HDDF,
            fixed bin(31))
     returns (unsigned fixed bin(16) byvalue optional)
     PASCAL external('DdfSetFontStyle');

 dcl DdfHyperText
     entry (type HDDF,
            char (*) varz byaddr,
            char (*) varz byaddr, /* use pli_b2z (id) for id */
            fixed bin(31))
     returns (unsigned fixed bin(16) byvalue optional)
     PASCAL external('DdfHyperText');

 dcl DdfBeginList
     entry (type HDDF,
            fixed bin(31),
            fixed bin(31),
            unsigned fixed bin(32))
     returns (unsigned fixed bin(16) byvalue optional)
     PASCAL external('DdfBeginList');

 dcl DdfListItem
     entry (type HDDF,
            char (*) varz byaddr,
            char (*) varz byaddr)
     returns (unsigned fixed bin(16) byvalue optional)
     PASCAL external('DdfListItem');

 dcl DdfEndList
     entry (type HDDF )
     returns (unsigned fixed bin(16) byvalue optional)
     PASCAL external('DdfEndList');

 dcl DdfText
     entry (type HDDF,
            char (*) varz byaddr)
     returns (unsigned fixed bin(16) byvalue optional)
     PASCAL external('DdfText');

 dcl DdfSetFont
     entry (type HDDF,
            char (*) varz byaddr,
            fixed bin(31),
            fixed bin(31))
     returns (unsigned fixed bin(16) byvalue optional)
     PASCAL external('DdfSetFont');

 dcl DdfBitmap
     entry (type HDDF,
            type HBITMAP,
            fixed bin(31))
     returns (unsigned fixed bin(16) byvalue optional)
     PASCAL external('DdfBitmap');

 %end; /* _IPFX_H */

