 /* ++ BUILD Version: 0001                                            */
 /*    -- Increment this if a change has global effects               */
 /*                                                                   */
 /* Copyright 1991-1998 Microsoft Corporation                         */
 /*                                                                   */
 /* Module Name:                                                      */
 /*                                                                   */
 /*   lmchdev.cpy                                                     */
 /*                                                                   */
 /* Abstract:                                                         */
 /*                                                                   */
 /*   This module defines the API function prototypes and data        */
 /*   structures for the following groups of NT API functions:        */
 /*       NetCharDev                                                  */
 /*       NetCharDevQ                                                 */
 /*       NetHandle                                                   */
 /*                                                                   */
 /* [Environment:]                                                    */
 /*                                                                   */
 /*   User Mode - Win32                                               */
 /*                                                                   */
 /* [Notes:]                                                          */
 /*                                                                   */
 /*   You must include NETCONS.CPY before this file, since this file  */
 /*   depends on values defined in NETCONS.CPY.                       */
 /*                                                                   */
 /* --                                                                */

 %dcl #LMCHDEV_ char ext;
 %if #LMCHDEV_ = '' %then %do;
 %#LMCHDEV_ = 'Y';


 /* CharDev Class */

 /* Function Prototypes - CharDev */

 dcl NetCharDevEnum
     entry (WCHAR(*) varz byaddr nonasgn optional,
            type DWORD,
            type LPBYTE byaddr,
            type DWORD,
            type DWORD byaddr,
            type DWORD byaddr,
            type DWORD byaddr)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetCharDevEnum');

 dcl NetCharDevGetInfo
     entry (WCHAR(*) varz byaddr nonasgn optional,
            WCHAR(*) varz byaddr nonasgn,
            type DWORD,
            type LPBYTE byaddr)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetCharDevGetInfo');

 dcl NetCharDevControl
     entry (WCHAR(*) varz byaddr nonasgn optional,
            WCHAR(*) varz byaddr nonasgn,
            type DWORD)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetCharDevControl');


 /* Data Structures - CharDev */

 define structure
   1 CHARDEV_INFO_0,
     2 ch0_dev type LPWSTR;
 define alias  PCHARDEV_INFO_0 handle CHARDEV_INFO_0;
 define alias LPCHARDEV_INFO_0 handle CHARDEV_INFO_0;

 define structure
   1 CHARDEV_INFO_1,
     2 ch1_dev      type LPWSTR,
     2 ch1_status   type DWORD,
     2 ch1_username type LPWSTR,
     2 ch1_time     type DWORD;
 define alias  PCHARDEV_INFO_1 handle CHARDEV_INFO_1;
 define alias LPCHARDEV_INFO_1 handle CHARDEV_INFO_1;


 /* CharDevQ Class */

 /* Function Prototypes - CharDevQ */

 dcl NetCharDevQEnum
     entry (WCHAR(*) varz byaddr nonasgn optional,
            WCHAR(*) varz byaddr nonasgn,
            type DWORD,
            type LPBYTE byaddr,
            type DWORD,
            type DWORD byaddr,
            type DWORD byaddr,
            type DWORD byaddr)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetCharDevQEnum');

 dcl NetCharDevQGetInfo
     entry (WCHAR(*) varz byaddr nonasgn optional,
            WCHAR(*) varz byaddr nonasgn,
            WCHAR(*) varz byaddr nonasgn,
            type DWORD,
            type LPBYTE byaddr)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetCharDevQGetInfo');

 dcl NetCharDevQSetInfo
     entry (WCHAR(*) varz byaddr nonasgn optional,
            WCHAR(*) varz byaddr nonasgn,
            type DWORD,
            type LPBYTE,
            type DWORD byaddr)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetCharDevQSetInfo');

 dcl NetCharDevQPurge
     entry (WCHAR(*) varz byaddr nonasgn optional,
            WCHAR(*) varz byaddr nonasgn)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetCharDevQPurge');

 dcl NetCharDevQPurgeSelf
     entry (WCHAR(*) varz byaddr nonasgn optional,
            WCHAR(*) varz byaddr nonasgn,
            WCHAR(*) varz byaddr nonasgn)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetCharDevQPurgeSelf');


 /* Data Structures - CharDevQ */

 define structure
   1 CHARDEVQ_INFO_0,
     2 cq0_dev type LPWSTR;
 define alias  PCHARDEVQ_INFO_0 handle CHARDEVQ_INFO_0;
 define alias LPCHARDEVQ_INFO_0 handle CHARDEVQ_INFO_0;

 define structure
   1 CHARDEVQ_INFO_1,
     2 cq1_dev      type LPWSTR,
     2 cq1_priority type DWORD,
     2 cq1_devs     type LPWSTR,
     2 cq1_numusers type DWORD,
     2 cq1_numahead type DWORD;
 define alias  PCHARDEVQ_INFO_1 handle CHARDEVQ_INFO_1;
 define alias LPCHARDEVQ_INFO_1 handle CHARDEVQ_INFO_1;

 define structure
   1 CHARDEVQ_INFO_1002,
     2 cq1002_priority type DWORD;
 define alias  PCHARDEVQ_INFO_1002 handle CHARDEVQ_INFO_1002;
 define alias LPCHARDEVQ_INFO_1002 handle CHARDEVQ_INFO_1002;

 define structure
   1 CHARDEVQ_INFO_1003,
     2 cq1003_devs type LPWSTR;
 define alias  PCHARDEVQ_INFO_1003 handle CHARDEVQ_INFO_1003;
 define alias LPCHARDEVQ_INFO_1003 handle CHARDEVQ_INFO_1003;


 /* Special Values and Constants */

 /* Bits for chardev_info_1 field ch1_status. */

 dcl CHARDEV_STAT_OPENED fixed bin(15) value('02'xn);
 dcl CHARDEV_STAT_ERROR  fixed bin(15) value('04'xn);


 /* Opcodes for NetCharDevControl */

 dcl CHARDEV_CLOSE       fixed bin(31) value(0);

 /* Values for parm_err parameter. */

 dcl CHARDEVQ_DEV_PARMNUM      fixed bin(31) value(1);
 dcl CHARDEVQ_PRIORITY_PARMNUM fixed bin(31) value(2);
 dcl CHARDEVQ_DEVS_PARMNUM     fixed bin(31) value(3);
 dcl CHARDEVQ_NUMUSERS_PARMNUM fixed bin(31) value(4);
 dcl CHARDEVQ_NUMAHEAD_PARMNUM fixed bin(31) value(5);

 /* Single-field infolevels for NetCharDevQSetInfo. */

 dcl CHARDEVQ_PRIORITY_INFOLEVEL fixed bin(31)
     value(PARMNUM_BASE_INFOLEVEL + CHARDEVQ_PRIORITY_PARMNUM);
 dcl CHARDEVQ_DEVS_INFOLEVEL     fixed bin(31)
     value(PARMNUM_BASE_INFOLEVEL + CHARDEVQ_DEVS_PARMNUM);

 /* Minimum, maximum, and recommended default for priority. */
 dcl CHARDEVQ_MAX_PRIORITY fixed bin(31) value(1);
 dcl CHARDEVQ_MIN_PRIORITY fixed bin(31) value(9);
 dcl CHARDEVQ_DEF_PRIORITY fixed bin(31) value(5);

 /* Value indicating no requests in the queue. */
 dcl CHARDEVQ_NO_REQUESTS  fixed bin(31) value(-1);

 %end; /* _LMCHDEV_ */

 /* Handle Class */

 %dcl #LMHANDLE_ char ext;
 %if #LMHANDLE_ = '' %then %do;
 %#LMHANDLE_ = 'Y';


 /* Function Prototypes */

 dcl NetHandleGetInfo
     entry (type HANDLE,
            type DWORD,
            type LPBYTE byaddr)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetHandleGetInfo');

 dcl NetHandleSetInfo
     entry (type HANDLE,
            type DWORD,
            type LPBYTE,
            type DWORD,
            type DWORD byaddr)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetHandleSetInfo');


 /*  Data Structures */

 define structure
   1 HANDLE_INFO_1,
     2 hdli1_chartime  type DWORD,
     2 hdli1_charcount type DWORD;
 define alias  PHANDLE_INFO_1 handle HANDLE_INFO_1;
 define alias LPHANDLE_INFO_1 handle HANDLE_INFO_1;


 /* Special Values and Constants */

 /*      Handle Get Info Levels */
 dcl HANDLE_INFO_LEVEL_1 fixed bin(31) value(1);

 /*      Handle Set Info parm numbers */
 dcl HANDLE_CHARTIME_PARMNUM  fixed bin(31) value(1);
 dcl HANDLE_CHARCOUNT_PARMNUM fixed bin(31) value(2);


 %end;
 /* _LMHANDLE_ */
