 /*++ BUILD Version: 0001                                             */
 /*   -- Increment this if a change has global effects                */
 /*                                                                   */
 /* Copyright 1991-1998 Microsoft Corporation                         */
 /*                                                                   */
 /* Module Name:                                                      */
 /*                                                                   */
 /*   lmuse.cpy                                                       */
 /*                                                                   */
 /* Abstract:                                                         */
 /*                                                                   */
 /*   This file contains structures, function prototypes,             */
 /*   and definitions for the NetUse API.                             */
 /*                                                                   */
 /*                                                                   */
 /* Environment:                                                      */
 /*                                                                   */
 /*   User Mode - Win32                                               */
 /*   Portable to any flat, 32-bit environment. (Uses Win32 typedefs.)*/
 /*                                                                   */
 /* Notes:                                                            */
 /*                                                                   */
 /*   You must include NETCONS.H before this file, since this file    */
 /*   depends on values defined in NETCONS.CPY.                       */
 /*--                                                                 */

 %dcl #LMUSE_ char ext;
 %if #LMUSE_ = '' %then %do;
 %#LMUSE_ = 'Y';

 %dcl #LMUSEFLG_ char ext;
 %if #LMUSEFLG_ = '' %then %do;
 %include lmuseflg; /* Deletion force level flags */
 %end;

 /* Function Prototypes */

 dcl NetUseAdd
     entry (WCHAR(*) varz byaddr optional,
            type DWORD,
            type LPBYTE,
            type DWORD byaddr optional)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetUseAdd');

 dcl NetUseDel
     entry (WCHAR(*) varz byaddr optional,
            WCHAR(*) varz byaddr,
            type DWORD)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetUseDel');

 dcl NetUseEnum
     entry (WCHAR(*) varz byaddr optional,
            type DWORD,
            type LPBYTE byaddr,
            type DWORD,
            type DWORD byaddr,
            type DWORD byaddr,
            type DWORD byaddr optional)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetUseEnum');

 dcl NetUseGetInfo
     entry (WCHAR(*) varz byaddr optional,
            WCHAR(*) varz byaddr,
            type DWORD,
            type LPBYTE byaddr)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetUseGetInfo');


 /*  Data Structures */

 define structure
   1 USE_INFO_0,
     2 ui0_local  type LPTSTR,
     2 ui0_remote type LPTSTR;

 define alias  PUSE_INFO_0 handle USE_INFO_0;
 define alias LPUSE_INFO_0 handle USE_INFO_0;

 define structure
   1 USE_INFO_1,
     2 ui1_local    type LPTSTR,
     2 ui1_remote   type LPTSTR,
     2 ui1_password type LPTSTR,
     2 ui1_status   type DWORD,
     2 ui1_asg_type type DWORD,
     2 ui1_refcount type DWORD,
     2 ui1_usecount type DWORD;

 define alias  PUSE_INFO_1 handle USE_INFO_1;
 define alias LPUSE_INFO_1 handle USE_INFO_1;

 define structure
   1 USE_INFO_2,
     2 ui2_local      type LPTSTR,
     2 ui2_remote     type LPTSTR,
     2 ui2_password   type LPTSTR,
     2 ui2_status     type DWORD,
     2 ui2_asg_type   type DWORD,
     2 ui2_refcount   type DWORD,
     2 ui2_usecount   type DWORD,
     2 ui2_username   type LPTSTR,
     2 ui2_domainname type LPTSTR;

 define alias  PUSE_INFO_2 handle USE_INFO_2;
 define alias LPUSE_INFO_2 handle USE_INFO_2;

 define structure
   1 USE_INFO_3,
     2 ui3_ui2   type USE_INFO_2,
     2 ui3_flags type ULONG;

 define alias  PUSE_INFO_3 handle USE_INFO_3;
 define alias LPUSE_INFO_3 handle USE_INFO_3;


 /* Special Values and Constants */


 /* One of these values indicates the parameter within an information */
 /* structure that is invalid when ERROR_INVALID_PARAMETER is         */
 /* returned by NetUseAdd.                                            */


 dcl USE_LOCAL_PARMNUM      fixed bin(31) value(1);
 dcl USE_REMOTE_PARMNUM     fixed bin(31) value(2);
 dcl USE_PASSWORD_PARMNUM   fixed bin(31) value(3);
 dcl USE_ASGTYPE_PARMNUM    fixed bin(31) value(4);
 dcl USE_USERNAME_PARMNUM   fixed bin(31) value(5);
 dcl USE_DOMAINNAME_PARMNUM fixed bin(31) value(6);

 /* Values appearing in the ui1_status field of use_info_1 structure. */
 /* Note that USE_SESSLOST and USE_DISCONN are synonyms.              */

 dcl USE_OK                 fixed bin(31) value(0);
 dcl USE_PAUSED             fixed bin(31) value(1);
 dcl USE_SESSLOST           fixed bin(31) value(2);
 dcl USE_DISCONN            fixed bin(31) value(2);
 dcl USE_NETERR             fixed bin(31) value(3);
 dcl USE_CONN               fixed bin(31) value(4);
 dcl USE_RECONN             fixed bin(31) value(5);


 /* Values of the ui1_asg_type field of use_info_1 structure */

 dcl USE_WILDCARD           fixed bin(31) value(-1);
 dcl USE_DISKDEV            fixed bin(31) value(0);
 dcl USE_SPOOLDEV           fixed bin(31) value(1);
 dcl USE_CHARDEV            fixed bin(31) value(2);
 dcl USE_IPC                fixed bin(31) value(3);

 /* Flags defined in the use_info_3 structure */

 dcl CREATE_NO_CONNECT      fixed bin(15) value('1'xn);
     /* creation flags */


 %end; /* _LMUSE_ */
