 /* ++ BUILD Version: 0001                                            */
 /*                -- Increment this if a change has global effects   */
 /*                                                                   */
 /* Copyright (c) 1996-1999 Microsoft Corporation                     */
 /*                                                                   */
 /* Module Name:                                                      */
 /*                                                                   */
 /*   ntdsapi.cpy                                                     */
 /*                                                                   */
 /* Abstract:                                                         */
 /*                                                                   */
 /*   This file contains structures, function prototypes,             */
 /*   and definitions for public NTDS APIs other than directory       */
 /*   interfaces like LDAP.                                           */
 /*                                                                   */
 /* Environment:                                                      */
 /*                                                                   */
 /*   User Mode - Win32                                               */
 /*                                                                   */
 /* Notes:                                                            */
 /*                                                                   */
 /* --                                                                */


 %dcl #NTDSAPI_H_ char ext;
 %if #NTDSAPI_H_ = '' %then %do;
 %#NTDSAPI_H_ = 'Y';

 %dcl UNICODE char ext;

 %dcl #_wtypes_h__ char ext;
 %if #_wtypes_h__ = '' %then %do;
 %include wtypes;
 %end;

 %dcl #WINNLS_ char ext;
 %if #WINNLS_ = '' %then %do;
 %include winnls;
 %end;

 %include schedule;

 %dcl #NTDSAPI_ char ext;
 %if #NTDSAPI_ = '' %then %do;
 %dcl NTDSAPI char ext;
 %#NTDSAPI_ = 'Y';
 %NTDSAPI = '';
 %end;


 /********************************************************/
 /*                                                      */
 /* Data definitions                                     */
 /*                                                      */
 /********************************************************/


 dcl DS_DEFAULT_LOCALE type DWORD
     value (MAKELCID (MAKELANGID (LANG_ENGLISH, SUBLANG_ENGLISH_US),
                      SORT_DEFAULT));

 dcl DS_DEFAULT_LOCALE_COMPARE_FLAGS type DWORD
     value (ior (NORM_IGNORECASE,
                 NORM_IGNOREKANATYPE,
                 NORM_IGNORENONSPACE,
                 NORM_IGNOREWIDTH));

 /* When booted to DS mode, this event is signalled when the DS has   */
 /* completed its initial sync attempts. The period of time between   */
 /* system startup and this event's state being set is indeterminate  */
 /* from the local service's standpoint. In the meantime the contents */
 /* of the DS should be considered incomplete / out-dated, and the    */
 /* machine will not be advertised as a domain controller to          */
 /* off-machine clients.  Other local services that rely on           */
 /* information published in the DS should avoid accessing (or at     */
 /* least relying on) the contents of the DS until this event is set. */
 dcl DS_SYNCED_EVENT_NAME   char  value('NTDSInitialSyncsCompleted');
 dcl DS_SYNCED_EVENT_NAME_W TCHAR value('NTDSInitialSyncsCompleted');

 /* Permissions bits used in security descriptors in the directory. */
 %dcl #DS_CONTROL_BITS_DEFINED_ char ext;
 %if #DS_CONTROL_BITS_DEFINED_ = '' %then %do;
 %#DS_CONTROL_BITS_DEFINED_ = 'Y';
 dcl ACTRL_DS_OPEN           type DWORD value('00000000'xu);
 dcl ACTRL_DS_CREATE_CHILD   type DWORD value('00000001'xu);
 dcl ACTRL_DS_DELETE_CHILD   type DWORD value('00000002'xu);
 dcl ACTRL_DS_LIST           type DWORD value('00000004'xu);
 dcl ACTRL_DS_SELF           type DWORD value('00000008'xu);
 dcl ACTRL_DS_READ_PROP      type DWORD value('00000010'xu);
 dcl ACTRL_DS_WRITE_PROP     type DWORD value('00000020'xu);
 dcl ACTRL_DS_DELETE_TREE    type DWORD value('00000040'xu);
 dcl ACTRL_DS_LIST_OBJECT    type DWORD value('00000080'xu);
 dcl ACTRL_DS_CONTROL_ACCESS type DWORD value('00000100'xu);

 /* generic read */
 dcl DS_GENERIC_READ         type DWORD
     value (ior (STANDARD_RIGHTS_READ,
                 ACTRL_DS_LIST,
                 ACTRL_DS_READ_PROP,
                 ACTRL_DS_LIST_OBJECT));


 /* generic execute */
 dcl DS_GENERIC_EXECUTE      type DWORD
     value (ior (STANDARD_RIGHTS_EXECUTE,
                 ACTRL_DS_LIST));

 /* generic write */
 dcl DS_GENERIC_WRITE        type DWORD
     value (ior (STANDARD_RIGHTS_WRITE,
                 ACTRL_DS_SELF,
                 ACTRL_DS_WRITE_PROP));

 /* generic all */
 dcl DS_GENERIC_ALL          type DWORD
     value (ior (STANDARD_RIGHTS_REQUIRED,
                 ACTRL_DS_CREATE_CHILD,
                 ACTRL_DS_DELETE_CHILD,
                 ACTRL_DS_DELETE_TREE,
                 ACTRL_DS_READ_PROP,
                 ACTRL_DS_WRITE_PROP,
                 ACTRL_DS_LIST,
                 ACTRL_DS_LIST_OBJECT,
                 ACTRL_DS_CONTROL_ACCESS,
                 ACTRL_DS_SELF));
 %end;

 define ordinal DS_NAME_FORMAT
   ( /* unknown name type */
     DS_UNKNOWN_NAME              value(0),

     /* eg: CN=Spencer Katt,OU=Users,DC=Engineering,DC=Widget,DC=Com */
     DS_FQDN_1779_NAME            value(1),

     /* eg: Engineering\SpencerK */
     /* Domain-only version includes trailing '\\'. */
     DS_NT4_ACCOUNT_NAME          value(2),

     /* Probably "Spencer Katt" but could be something else.       */
     /* I.e. The display name is not necessarily the defining RDN. */
     DS_DISPLAY_NAME              value(3),

     /* obsolete - see #define later */
     /* DS_DOMAIN_SIMPLE_NAME     value (4), */

     /* obsolete - see #define later */
     /* DS_ENTERPRISE_SIMPLE_NAME value(5), */

     /* String-ized GUID as returned by IIDFromString(). */
     /* eg: {4fa050f0-f561-11cf-bdd9-00aa003a77b6}       */
     DS_UNIQUE_ID_NAME            value(6),

     /* eg: engineering.widget.com/software/spencer katt */
     /* Domain-only version includes trailing '/'.       */
     DS_CANONICAL_NAME            value(7),

     /* eg: spencerk@engineering.widget.com */
     DS_USER_PRINCIPAL_NAME       value(8),

     /* Same as DS_CANONICAL_NAME except that rightmost '/' is */
     /* replaced with '\n' - even in domain-only case.         */
     /* eg: engineering.widget.com/software\nspencer katt      */
     DS_CANONICAL_NAME_EX         value(9),

     /* eg: www/www.widget.com@widget.com - generalized service */
     /* principal names.                                        */
     DS_SERVICE_PRINCIPAL_NAME    value(10),

     /* This is the string representation of a SID.              */
     /* Invalid for formatDesired.                               */
     /* See sddl.h for SID binary <--> text conversion routines. */
     /* eg: S-1-5-21-397955417-626881126-188441444-501           */
     DS_SID_OR_SID_HISTORY_NAME   value(11)
   ) prec(31);

 /* Map old name formats to closest new format so that old code       */
 /* builds against new headers w/o errors and still gets (almost)     */
 /* correct result.                                                  */

 dcl DS_DOMAIN_SIMPLE_NAME     type DS_NAME_FORMAT
     value (DS_USER_PRINCIPAL_NAME);
 dcl DS_ENTERPRISE_SIMPLE_NAME type DS_NAME_FORMAT
     value (DS_USER_PRINCIPAL_NAME);

 define alias DS_NAME_FLAGS type DWORD; /* not ordinal, as flags */
 dcl ( DS_NAME_NO_FLAGS              value('0'xu),

       /* Perform a syntactical mapping at the client (if possible) */
       /* withoutgoing out on the wire.                             */
       /* Returns DS_NAME_ERROR_NO_SYNTACTICAL_MAPPING              */
       /* if a purely syntactical mapping is not possible.          */
       DS_NAME_FLAG_SYNTACTICAL_ONLY value('1'xu),

       /* Force a trip to the DC for evaluation, even if this could */
       /* be locally cracked syntactically.                         */
       DS_NAME_FLAG_EVAL_AT_DC       value('2'xu)
     ) type DS_NAME_FLAGS;

 define ordinal DS_NAME_ERROR
   ( DS_NAME_NO_ERROR                     value(0),

     /* Generic processing error.                                     */
     DS_NAME_ERROR_RESOLVING              value(1),

     /* Couldn't find the name at all - or perhaps caller doesn't have*/
     /* rights to see it.                                             */
     DS_NAME_ERROR_NOT_FOUND              value(2),

     /* Input name mapped to more than one output name. */
     DS_NAME_ERROR_NOT_UNIQUE             value(3),

     /* Input name found, but not the associated output format.       */
     /* Can happen if object doesn't have all the required attributes.*/
     DS_NAME_ERROR_NO_MAPPING             value(4),

     /* Unable to resolve entire name, but was able to determine which*/
     /* domain object resides in.  Thus DS_NAME_RESULT_ITEM?.pDomain  */
     /* is valid on return.                                           */
     DS_NAME_ERROR_DOMAIN_ONLY            value(5),

     /* Unable to perform a purely syntactical mapping at the client  */
     /* without going out on the wire.                                */
     DS_NAME_ERROR_NO_SYNTACTICAL_MAPPING value(6)
   ) prec(31);

 dcl DS_NAME_LEGAL_FLAGS type DS_NAME_FLAGS
     value (DS_NAME_FLAG_SYNTACTICAL_ONLY);

 define ordinal DS_SPN_NAME_TYPE
   ( /* "paulle-nec.ntwksta.ms.com" */
     DS_SPN_DNS_HOST  value(0),

     /* "cn=paulle-nec,ou=computers,dc=ntwksta,dc=ms,dc=com" */
     DS_SPN_DN_HOST   value(1),

     /* "paulle-nec" */
     DS_SPN_NB_HOST   value(2),

     /* "ntdev.ms.com" */
     DS_SPN_DOMAIN    value(3),

     /* "ntdev" */
     DS_SPN_NB_DOMAIN value(4),

     /* "cn=anRpcService,cn=RPC Services,cn=system,dc=ms,dc=com"   */
     /* "cn=aWsService,cn=Winsock Services,cn=system,dc=ms,dc=com" */
     /* "cn=aService,dc=itg,dc=ms,dc=com"                          */
     /* "www.ms.com", "ftp.ms.com", "ldap.ms.com"                  */
     /* "products.ms.com"                                          */
     DS_SPN_SERVICE   value(5)
   ) prec(31);


 define ordinal DS_SPN_WRITE_OP          /* example:     */
   ( DS_SPN_ADD_SPN_OP     value(0),     /* add SPNs     */
     DS_SPN_REPLACE_SPN_OP value(1),     /* set all SPNs */
     DS_SPN_DELETE_SPN_OP  value(2)      /* Delete SPNs  */
   ) prec(31);


 define structure
   1 DS_NAME_RESULT_ITEMA,
     2 status  type DWORD,/* DS_NAME_ERROR */
     2 pDomain type LPSTR,/* DNS domain */
     2 pName   type LPSTR;/* name in requested format */
 define alias PDS_NAME_RESULT_ITEMA handle DS_NAME_RESULT_ITEMA;

 define structure
   1 DS_NAME_RESULTA,
     2 cItems  type DWORD,/* item count */
     2 rItems  type PDS_NAME_RESULT_ITEMA;/* item array */
 define alias PDS_NAME_RESULTA handle DS_NAME_RESULTA;

 define structure
   1 DS_NAME_RESULT_ITEMW,
     2 status  type DWORD, /* DS_NAME_ERROR */
     2 pDomain type LPWSTR,/* DNS domain */
     2 pName   type LPWSTR;/* name in requested format */
 define alias PDS_NAME_RESULT_ITEMW handle DS_NAME_RESULT_ITEMW;

 define structure
   1 DS_NAME_RESULTW,
     2 cItems  type DWORD,/* item count */
     2 rItems  type PDS_NAME_RESULT_ITEMW;/* item array */
 define alias PDS_NAME_RESULTW handle DS_NAME_RESULTW;


 %if UNICODE ^= '' %then  %do;
 define alias  DS_NAME_RESULT      type  DS_NAME_RESULTW;
 define alias PDS_NAME_RESULT      type PDS_NAME_RESULTW;
 define alias  DS_NAME_RESULT_ITEM type  DS_NAME_RESULT_ITEMW;
 define alias PDS_NAME_RESULT_ITEM type PDS_NAME_RESULT_ITEMW;
 %end; %else %do;
 define alias  DS_NAME_RESULT      type  DS_NAME_RESULTA;
 define alias PDS_NAME_RESULT      type PDS_NAME_RESULTA;
 define alias  DS_NAME_RESULT_ITEM type  DS_NAME_RESULT_ITEMA;
 define alias PDS_NAME_RESULT_ITEM type PDS_NAME_RESULT_ITEMA;
 %end;

 /* Public replication option flags */

 /* ******************** */
 /* Replica Sync flags */
 /* ******************** */

 /* Perform this operation asynchronously.                            */
 /* Required when using DS_REPSYNC_ALL_SOURCES                        */
 dcl DS_REPSYNC_ASYNCHRONOUS_OPERATION   type DWORD value('00000001'xu);

 /* Writeable replica.  Otherwise, read-only.                         */
 dcl DS_REPSYNC_WRITEABLE                type DWORD value('00000002'xu);

 /* This is a periodic sync request as scheduled by the admin.        */
 dcl DS_REPSYNC_PERIODIC                 type DWORD value('00000004'xu);

 /* Use inter-site messaging                                          */
 dcl DS_REPSYNC_INTERSITE_MESSAGING      type DWORD value('00000008'xu);

 /* Sync from all sources.                                            */
 dcl DS_REPSYNC_ALL_SOURCES              type DWORD value('00000010'xu);

 /* Sync starting from scratch (i.e., at the first USN).              */
 dcl DS_REPSYNC_FULL                     type DWORD value('00000020'xu);

 /* This is a notification of an update that was marked urgent.       */
 dcl DS_REPSYNC_URGENT                   type DWORD value('00000040'xu);

 /* Don't discard this synchronization request, even if a similar     */
 /* sync is pending. */
 dcl DS_REPSYNC_NO_DISCARD               type DWORD value('00000080'xu);

 /* Sync even if link is currently disabled.                          */
 dcl DS_REPSYNC_FORCE                    type DWORD value('00000100'xu);

 /* Causes the source DSA to check if a reps-to is present for the    */
 /* local DSA (aka the destination). If not, one is added.            */
 /* This ensures that source sends change notifications.              */
 dcl DS_REPSYNC_ADD_REFERENCE            type DWORD value('00000200'xu);

 /* A sync from this source has never completed (e.g., a new source). */
 dcl DS_REPSYNC_NEVER_COMPLETED          type DWORD value('00000400'xu);

 /* When this sync is complete, requests a sync                       */
 /* in the opposite direction.                                        */
 dcl DS_REPSYNC_TWO_WAY                  type DWORD value('00000800'xu);



 /* ******************** */
 /* Replica Add flags */
 /* ******************** */

 /* Perform this operation asynchronously.                            */
 dcl DS_REPADD_ASYNCHRONOUS_OPERATION    type DWORD value('00000001'xu);

 /* Create a writeable replica.  Otherwise, read-only.                */
 dcl DS_REPADD_WRITEABLE                 type DWORD value('00000002'xu);

 /* Sync the NC from this source when the DSA is started.             */
 dcl DS_REPADD_INITIAL                   type DWORD value('00000004'xu);

 /* Sync the NC from this source periodically, as defined by the      */
 /* schedule passed in the preptimesSync argument.                    */
 dcl DS_REPADD_PERIODIC                  type DWORD value('00000008'xu);

 /* Sync from the source DSA via an Intersite Messaging Service (ISM) */
 /* transport (e.g., SMTP) rather than native DS RPC.                 */
 dcl DS_REPADD_INTERSITE_MESSAGING       type DWORD value('00000010'xu);

 /* Don't replicate the NC now -- just save enough state such that we */
 /* know to replicate it later. */
 dcl DS_REPADD_ASYNCHRONOUS_REPLICA      type DWORD value('00000020'xu);

 /* Disable notification-based synchronization for the NC from this   */
 /* source. This is expected to be a temporary state; the similar     */
 /* flag  DS_REPADD_NEVER_NOTIFY should be used if the disable is to  */
 /* be more permanent.                                                */
 dcl DS_REPADD_DISABLE_NOTIFICATION      type DWORD value('00000040'xu);

 /* Disable periodic synchronization for the NC from this source      */
 dcl DS_REPADD_DISABLE_PERIODIC          type DWORD value('00000080'xu);

 /* Use compression when replicating.  Saves message size             */
 /* (e.g. network bandwidth) at the expense of extra CPU overhead     */
 /* at both the source and destination servers.                       */
 dcl DS_REPADD_USE_COMPRESSION           type DWORD value('00000100'xu);

 /* Do not request change notifications from this source.             */
 /* When this flag is set, the source will not notify the destination */
 /* when changes occur. Recommended for all intersite replication,    */
 /* which may occur over WAN links. This is expected to be a more or  */
 /* less permanent state; the similar flag                            */
 /* DS_REPADD_DISABLE_NOTIFICATION should be used if notifications    */
 /* are to be disabled only temporarily.                              */
 dcl DS_REPADD_NEVER_NOTIFY              type DWORD value('00000200'xu);




 /* ******************** */
 /* Replica Delete flags */
 /* ******************** */

 /* Perform this operation asynchronously.                            */
 dcl DS_REPDEL_ASYNCHRONOUS_OPERATION    type DWORD value('00000001'xu);

 /* The replica being deleted is writeable.                           */
 dcl DS_REPDEL_WRITEABLE                 type DWORD value('00000002'xu);

 /* Replica is a mail-based replica                                   */
 dcl DS_REPDEL_INTERSITE_MESSAGING       type DWORD value('00000004'xu);

 /* Ignore any error generated by contacting the source to tell it to */
 /* scratch this server from its Reps-To for this NC.                 */
 dcl DS_REPDEL_IGNORE_ERRORS             type DWORD value('00000008'xu);

 /* Do not contact the source telling it to scratch this server from  */
 /* its Rep-To for this NC.  Otherwise, if the link is RPC-based,     */
 /* the source will be contacted.                                     */
 dcl DS_REPDEL_LOCAL_ONLY                type DWORD value('00000010'xu);

 /* Delete all the objects in the NC. 'No source' is incompatible     */
 /* with (and rejected for) writeable NCs.                            */
 /* This is valid only for read-only NCs, and then only if the NC has */
 /* no source.                                                        */
 /* This can occur when the NC has been partially deleted             */
 /* (in which case the KCC periodically calls the delete API          */
 /* with the 'no source' flag set).                                   */
 dcl DS_REPDEL_NO_SOURCE                 type DWORD value('00000020'xu);

 /* Allow deletion of read-only replica even if it sources            */
 /* other read-only replicas.                                         */
 dcl DS_REPDEL_REF_OK                    type DWORD value('00000040'xu);

 /* ******************** */
 /* Replica Modify flags */
 /* ******************** */

 /* Perform this operation asynchronously.                            */
 dcl DS_REPMOD_ASYNCHRONOUS_OPERATION    type DWORD value('00000001'xu);

 /* The replica is writeable.                                         */
 dcl DS_REPMOD_WRITEABLE                 type DWORD value('00000002'xu);


 /* ********************* */
 /* Replica Modify fields */
 /* ********************* */

 dcl DS_REPMOD_UPDATE_FLAGS              type DWORD value('00000001'xu);
 dcl DS_REPMOD_UPDATE_ADDRESS            type DWORD value('00000002'xu);
 dcl DS_REPMOD_UPDATE_SCHEDULE           type DWORD value('00000004'xu);
 dcl DS_REPMOD_UPDATE_RESULT             type DWORD value('00000008'xu);
 dcl DS_REPMOD_UPDATE_TRANSPORT          type DWORD value('00000010'xu);

 /* ****************** */
 /* Update Refs fields */
 /* ****************** */

 /* Perform this operation asynchronously.                            */
 dcl DS_REPUPD_ASYNCHRONOUS_OPERATION    type DWORD value('00000001'xu);

 /* The replica being deleted is writeable.                           */
 dcl DS_REPUPD_WRITEABLE                 type DWORD value('00000002'xu);

 /* Add a reference                                                   */
 dcl DS_REPUPD_ADD_REFERENCE             type DWORD value('00000004'xu);

 /* Remove a reference                                                */
 dcl DS_REPUPD_DELETE_REFERENCE          type DWORD value('00000008'xu);


 /* *********************** */
 /* Well Known Object Guids */
 /* *********************** */

 dcl GUID_USERS_CONTAINER_A              char
     value('a9d1ca15768811d1aded00c04fd8d5cd');
 dcl GUID_COMPUTRS_CONTAINER_A           char
     value('aa312825768811d1aded00c04fd8d5cd');
 dcl GUID_SYSTEMS_CONTAINER_A            char
     value('ab1d30f3768811d1aded00c04fd8d5cd');
 dcl GUID_DOMAIN_CONTROLLERS_CONTAINER_A char
     value('a361b2ffffd211d1aa4b00c04fd7d83a');
 dcl GUID_INFRASTRUCTURE_CONTAINER_A     char
     value('2fbac1870ade11d297c400c04fd8d5cd');
 dcl GUID_DELETED_OBJECTS_CONTAINER_A    char
     value('18e2ea80684f11d2b9aa00c04f79f805');
 dcl GUID_LOSTANDFOUND_CONTAINER_A       char
     value('ab8153b7768811d1aded00c04fd8d5cd');

 dcl GUID_USERS_CONTAINER_W              TCHAR
     value('a9d1ca15768811d1aded00c04fd8d5cd');
 dcl GUID_COMPUTRS_CONTAINER_W           TCHAR
     value('aa312825768811d1aded00c04fd8d5cd');
 dcl GUID_SYSTEMS_CONTAINER_W            TCHAR
     value('ab1d30f3768811d1aded00c04fd8d5cd');
 dcl GUID_DOMAIN_CONTROLLERS_CONTAINER_W TCHAR
     value('a361b2ffffd211d1aa4b00c04fd7d83a');
 dcl GUID_INFRASTRUCTURE_CONTAINER_W     TCHAR
     value('2fbac1870ade11d297c400c04fd8d5cd');
 dcl GUID_DELETED_OBJECTS_CONTAINER_W    TCHAR
     value('18e2ea80684f11d2b9aa00c04f79f805');
 dcl GUID_LOSTANDFOUND_CONTAINER_W       TCHAR
     value('ab8153b7768811d1aded00c04fd8d5cd');

 dcl GUID_USERS_CONTAINER_BYTE              char
     value('a9d1ca15768811d1aded00c04fd8d5cd'x);
 dcl GUID_COMPUTRS_CONTAINER_BYTE           char
     value('aa312825768811d1aded00c04fd8d5cd'x);
 dcl GUID_SYSTEMS_CONTAINER_BYTE            char
     value('ab1d30f3768811d1aded00c04fd8d5cd'x);
 dcl GUID_DOMAIN_CONTROLLERS_CONTAINER_BYTE char
     value('a361b2ffffd211d1aa4b00c04fd7d83a'x);
 dcl GUID_INFRASTRUCTURE_CONTAINER_BYTE     char
     value('2fbac1870ade11d297c400c04fd8d5cd'x);
 dcl GUID_DELETED_OBJECTS_CONTAINER_BYTE    char
     value('18e2ea80684f11d2b9aa00c04f79f805'x);
 dcl GUID_LOSTANDFOUND_CONTAINER_BYTE       char
     value('ab8153b7768811d1aded00c04fd8d5cd'x);


 /********************************************************/
 /*                                                      */
 /* Prototypes                                           */
 /*                                                      */
 /********************************************************/

 /* DSBind takes two optional input parameters which identify whether */
 /* the caller found a domain controller themselves via DsGetDcName   */
 /* or whether a domain controller should be found using default      */
 /* parameters.                                                       */
 /* Behavior of the possible combinations are outlined below.         */
 /*                                                                   */
 /* DomainControllerName(value), DnsDomainName(NULL)                  */
 /*                                                                   */
 /*   The value for DomainControllerName is assumed to have been      */
 /*   obtained via DsGetDcName (i.e. Field with the same name in a    */
 /*   DOMAIN_CONTROLLER_INFO struct on return from DsGetDcName call.) */
 /*   The client is bound to the domain controller at this name.      */
 /*                                                                   */
 /*   Mutual authentication will be performed using an SPN of         */
 /*   LDAP/DomainControllerName provided DomainControllerName         */
 /*   is not a NETBIOS name or IP address - i.e. it must be a         */
 /*   DNS host name.                                                  */
 /*                                                                   */
 /* DomainControllerName(value), DnsDomainName(value)                 */
 /*                                                                   */
 /*   DsBind will connect to the server identified by                 */
 /*   DomainControllerName.                                           */
 /*                                                                   */
 /*   Mutual authentication will be performed using an SPN of         */
 /*   LDAP/DomainControllerName/DnsDomainName provided neither value  */
 /*   is a NETBIOS names or IP address - i.e. they must be            */
 /*   valid DNS names.                                                */
 /*                                                                   */
 /* DomainControllerName(NULL), DnsDomainName(NULL)                   */
 /*                                                                   */
 /*   DsBind will attempt to find to a global catalog and fail if one */
 /*   can not be found.                                               */
 /*                                                                   */
 /*   Mutual authentication will be performed using an SPN of         */
 /*   GC/DnsHostName/ForestName where DnsHostName and ForestName      */
 /*   represent the DomainControllerName and DnsForestName fields     */
 /*   respectively of the DOMAIN_CONTROLLER_INFO returned by the      */
 /*   DsGetDcName call used to find a global catalog.                 */
 /*                                                                   */
 /* DomainControllerName(NULL), DnsDomainName(value)                  */
 /*                                                                   */
 /*   DsBind will attempt to find a domain controller for the domain  */
 /*   identified by DnsDomainName and fail if one can not be found.   */
 /*                                                                   */
 /*   Mutual authentication will be performed using an SPN of         */
 /*   LDAP/DnsHostName/DnsDomainName where DnsDomainName is that      */
 /*   provided by the caller and DnsHostName is that returned by      */
 /*   DsGetDcName for the domain specified - provided DnsDomainName   */
 /*   is a valid DNS domain name - i.e. not a NETBIOS domain name.    */

 dcl DsBindW
     entry (WCHAR (*) varz byaddr optional nonasgn,
            WCHAR (*) varz byaddr optional nonasgn,
            type HANDLE byaddr)
     returns (type DWORD byvalue optional)
     NTDSAPI WINAPI external('DsBindW');

 dcl DsBindA
     entry (char(*) varz byaddr optional nonasgn,
            char(*) varz byaddr optional nonasgn,
            type HANDLE byaddr)
     returns (type DWORD byvalue optional)
     NTDSAPI WINAPI external('DsBindA');

 %dcl DsBind char ext;
 %if UNICODE ^= '' %then %do;
   %DsBind='DsBindW';
 %end; %else %do;
   %DsBind='DsBindA';
 %end;

 dcl DsBindWithCredW
     entry (WCHAR(*) varz byaddr optional nonasgn,
            WCHAR(*) varz byaddr optional nonasgn,
            type RPC_AUTH_IDENTITY_HANDLE,
            type HANDLE byaddr)
     returns (type DWORD byvalue optional)
     NTDSAPI WINAPI external('DsBindWithCredW');

 dcl DsBindWithCredA
     entry (char(*) varz byaddr optional nonasgn,
            char(*) varz byaddr optional nonasgn,
            type RPC_AUTH_IDENTITY_HANDLE,
            type HANDLE byaddr)
     returns (type DWORD byvalue optional)
     NTDSAPI WINAPI external('DsBindWithCredA');

 %dcl DsBindWithCred char ext;
 %if UNICODE ^= '' %then  %do;
   %DsBindWithCred='DsBindWithCredW';
 %end; %else %do;
   %DsBindWithCred='DsBindWithCredA';
 %end;

 /* DsBindWithSpn{A|W} allows the caller to specify the service       */
 /* principal name (SPN) which will be used for mutual authentication */
 /* against the destination server.  Do not provide an SPN if you are */
 /* expecting DsBind to find a server for you as SPNs are machine     */
 /* specific and it is unlikely the SPN you provide matches the       */
 /* server DsBind finds for you.                                      */
 /* Providing a NULL ServicePrincipalName argument results in         */
 /* behaviour identical to DsBindWithCred{A|W}.                       */

 dcl DsBindWithSpnW
     entry (WCHAR(*) varz byaddr optional nonasgn,
            WCHAR(*) varz byaddr optional nonasgn,
            type RPC_AUTH_IDENTITY_HANDLE,
            WCHAR(*) varz byaddr optional nonasgn,
            type HANDLE byaddr)
     returns (type DWORD byvalue optional)
     NTDSAPI WINAPI external('DsBindWithSpnW');

 dcl DsBindWithSpnA
     entry (char(*) varz byaddr optional nonasgn,
            char(*) varz byaddr optional nonasgn,
            type RPC_AUTH_IDENTITY_HANDLE,
            char(*) varz byaddr optional nonasgn,
            type HANDLE byaddr)
     returns (type DWORD byvalue optional)
     NTDSAPI WINAPI external('DsBindWithSpnA');

 %dcl DsBindWithSpn char ext;
 %if UNICODE ^= '' %then  %do;
   %DsBindWithSpn='DsBindWithSpnW';
 %end; %else %do;
   %DsBindWithSpn='DsBindWithSpnA';
 %end;

 /* DsUnBind */

 dcl DsUnBindW
     entry (type HANDLE byaddr)
     returns (type DWORD byvalue optional)
     NTDSAPI WINAPI external('DsUnBindW');

 dcl DsUnBindA
     entry (type HANDLE byaddr)
     returns (type DWORD byvalue optional)
     NTDSAPI WINAPI external('DsUnBindA');

 %dcl DsUnBind char ext;
 %if UNICODE ^= '' %then %do;
   %DsUnBind='DsUnBindW';
 %end; %else %do;
   %DsUnBind='DsUnBindA';
 %end;

 /* DsMakePasswordCredentials                                         */
 /*                                                                   */
 /* This function constructs a credential structure which is suitable */
 /* for input to the DsBindWithCredentials function, or the ldap_open */
 /* function (winldap.cpy).                                           */
 /* The credential must be freed using DsFreeCredential.              */
 /*                                                                   */
 /* None of the input parameters may be present indicating a null,    */
 /* default credential. Otherwise the username must be present.       */
 /* If the domain or password are null, they default to empty strings.*/
 /* The domain name may be null when the username is fully qualified, */
 /* for example UPN format.                                           */

 dcl DsMakePasswordCredentialsW
     entry (WCHAR(*) varz byaddr optional nonasgn,
            WCHAR(*) varz byaddr optional nonasgn,
            WCHAR(*) varz byaddr optional nonasgn,
            type RPC_AUTH_IDENTITY_HANDLE byaddr)
     returns (type DWORD byvalue optional)
     NTDSAPI WINAPI external('DsMakePasswordCredentialsW');

 dcl DsMakePasswordCredentialsA
     entry (char(*) varz byaddr optional nonasgn,
            char(*) varz byaddr optional nonasgn,
            char(*) varz byaddr optional nonasgn,
            type RPC_AUTH_IDENTITY_HANDLE byaddr)
     returns (type DWORD byvalue optional)
     NTDSAPI WINAPI external('DsMakePasswordCredentialsA');

 %dcl DsMakePasswordCredentials char ext;
 %if UNICODE ^= '' %then %do;
   %DsMakePasswordCredentials='DsMakePasswordCredentialsW';
 %end; %else %do;
   %DsMakePasswordCredentials='DsMakePasswordCredentialsA';
 %end;

 dcl DsFreePasswordCredentials
     entry (type RPC_AUTH_IDENTITY_HANDLE)
     NTDSAPI WINAPI external('DsFreePasswordCredentials');

 %dcl DsFreePasswordCredentialsW char ext;
 %DsFreePasswordCredentialsW='DsFreePasswordCredentialS';
 %dcl DsFreePasswordCredentialsA char ext;
 %DsFreePasswordCredentialsA='DsFreePasswordCredentialS';

 /* DsCrackNames */

 dcl DsCrackNamesW
     entry (type HANDLE,
            type DS_NAME_FLAGS,
            type DS_NAME_FORMAT,
            type DS_NAME_FORMAT,
            type DWORD,
            (*) type LPCWSTR byaddr,
            type PDS_NAME_RESULTW byaddr)
     returns (type DWORD byvalue optional)
     NTDSAPI WINAPI external('DsCrackNamesW');

 dcl DsCrackNamesA
     entry (type HANDLE,
            type DS_NAME_FLAGS,
            type DS_NAME_FORMAT,
            type DS_NAME_FORMAT,
            type DWORD,
            (*) type LPCSTR byaddr,
            type PDS_NAME_RESULTA byaddr)
     returns (type DWORD byvalue optional)
     NTDSAPI WINAPI external('DsCrackNamesA');

 %dcl DsCrackNames char ext;
 %if UNICODE ^= '' %then %do;
   %DsCrackNames='DsCrackNamesW';
 %end; %else %do;
   %DsCrackNames='DsCrackNamesA';
 %end;

 /* DsFreeNameResult */

 dcl DsFreeNameResultW
     entry (type DS_NAME_RESULTW byaddr)
     NTDSAPI WINAPI external('DsFreeNameResultW');

 dcl DsFreeNameResultA
     entry (type DS_NAME_RESULTA byaddr)
     NTDSAPI WINAPI external('DsFreeNameResultA');

 %dcl DsFreeNameResult char ext;
 %if UNICODE ^= '' %then %do;
   %DsFreeNameResult='DsFreeNameResultW';
 %end; %else %do;
   %DsFreeNameResult='DsFreeNameResultA';
 %end;

 /* ================================================================= */
 /* DSMakeSpn -- client call to create SPN for a service to which it  */
 /* wants to authenticate.                                            */
 /* This name is then passed to 'pszTargetName' of                    */
 /* InitializeSecurityContext().                                      */
 /*                                                                   */
 /* Notes:                                                            */
 /* If the service name is a DNS host name, or canonical DNS service  */
 /* name e.g. 'www.ms.com', i.e., caller resolved with gethostbyname, */
 /* then instance name should be NULL.                                */
 /* Realm is host name minus first component, unless it is in the     */
 /* exception list                                                    */
 /*                                                                   */
 /* If the service name is NetBIOS machine name, then instance name   */
 /* should be NULL                                                    */
 /* Form must be <domain>\<machine>                                   */
 /* Realm will be <domain>                                            */
 /*                                                                   */
 /* If the service name is that of a replicated service, where each   */
 /* replica has its own account (e.g., with SRV records) then the     */
 /* caller must supply the instance name then realm name is same as   */
 /* ServiceName                                                       */
 /*                                                                   */
 /* If the service name is a DN, then must also supply instance name  */
 /* (DN could be name of service object (incl RPC or Winsock),        */
 /* name of machine account, name of domain object)                   */
 /* then realm name is domain part of the DN                          */
 /*                                                                   */
 /* If the service name is NetBIOS domain name, then must also supply */
 /* instance name, realm name is domain name                          */
 /*                                                                   */
 /* If the service is named by an IP address -- then use referring    */
 /* service name as service name                                      */
 /*                                                                   */
 /*  ServiceClass - e.g. 'http', 'ftp', 'ldap', GUID                  */
 /*  ServiceName  - DNS or DN; assumes we can compute domain from     */
 /*                 service name                                      */
 /*  InstanceName OPTIONAL- DNS name of host for instance of service  */
 /*  InstancePort - port number for instance (0 if default)           */
 /*  Referrer OPTIONAL- DNS name of host that gave this referral      */
 /*  pcSpnLength - in -- max length IN CHARACTERS of principal name   */
 /*                out -- actual                                      */
 /*                Length includes terminator                         */
 /*  pszSPN - server principal name                                   */
 /*                                                                   */
 /* If buffer is not large enough, ERROR_BUFFER_OVERFLOW is returned  */
 /* and the needed length is returned in pcSpnLength.                 */

 dcl DsMakeSpnW
     entry (WCHAR(*) varz byaddr nonasgn,
            WCHAR(*) varz byaddr nonasgn,
            WCHAR(*) varz byaddr optional nonasgn,
            type USHORT,
            WCHAR(*) varz byaddr optional nonasgn,
            type DWORD byaddr,
            WCHAR(*) varz byaddr optional)
     returns (type DWORD byvalue optional)
     NTDSAPI WINAPI external('DsMakeSpnW');

 dcl DsMakeSpnA
     entry (char(*) varz byaddr nonasgn,
            char(*) varz byaddr nonasgn,
            char(*) varz byaddr optional nonasgn,
            type USHORT,
            char(*) varz byaddr optional nonasgn,
            type DWORD byaddr,
            char(*) varz byaddr optional)
     returns (type DWORD byvalue optional)
     NTDSAPI WINAPI external('DsMakeSpnA');

 %dcl DsMakeSpn char ext;
 %if UNICODE ^= '' %then %do;
   %DsMakeSpn='DsMakeSpnW';
 %end; %else %do;
   %DsMakeSpn='DsMakeSpnA';
 %end;

 /* ================================================================= */
 /* DsGetSPN -- server's call to gets SPNs for a service name by      */
 /* which it is known to clients. N.B.: there may be more than one    */
 /* name by which clients know it the SPNs are then passed to         */
 /* DsAddAccountSpn to register them in the DS                        */
 /*                                                                   */
 /*      IN SpnNameType eType,                                        */
 /*      IN LPCTSTR ServiceClass,                                     */
 /* kind of service -- 'http', 'ldap', 'ftp', etc.                    */
 /*      IN LPCTSTR ServiceName OPTIONAL,                             */
 /* name of service -- DN or DNS; not needed for host-based           */
 /*      IN USHORT InstancePort,                                      */
 /* port number (0 => default) for instances                          */
 /*      IN USHORT cInstanceNames,                                    */
 /* count of extra instance names and ports (0=>use gethostbyname)    */
 /*      IN LPCTSTR InstanceNames[] OPTIONAL,                         */
 /* extra instance names (not used for host names)                    */
 /*      IN USHORT InstancePorts[] OPTIONAL,                          */
 /* extra instance ports (0 => default)                               */
 /*      IN OUT PULONG pcSpn,                                         */
 /* count of SPNs                                                     */
 /*      IN OUT LPTSTR * prpszSPN[]                                   */
 /* a bunch of SPNs for this service; free with DsFreeSpnArray        */

 dcl DsGetSpnA
     entry (type DS_SPN_NAME_TYPE,
            char(*) varz byaddr nonasgn,
            char(*) varz byaddr optional nonasgn,
            type USHORT,
            type USHORT,
            (*) type LPCSTR byaddr optional nonasgn,
            (*) type USHORT byaddr optional nonasgn,
            type DWORD byaddr,
            type LPSTR byaddr)
     returns (type DWORD byvalue optional)
     NTDSAPI WINAPI external('DsGetSpnA');

 dcl DsGetSpnW
     entry (type DS_SPN_NAME_TYPE,
            WCHAR(*) varz byaddr nonasgn,
            wCHAR(*) varz byaddr optional nonasgn,
            type USHORT,
            type USHORT,
            (*) type LPCWSTR byaddr optional nonasgn,
            (*) type USHORT optional nonasgn,
            type DWORD byaddr,
            type LPWSTR byaddr)
     returns (type DWORD byvalue optional)
     NTDSAPI WINAPI external('DsGetSpnW');

 %dcl DsGetSpn char ext;
 %if UNICODE ^= '' %then  %do;
   %DsGetSpn='DsGetSpnW';
 %end; %else %do;
   %DsGetSpn='DsGetSpnA';
 %end;

 /* ================================================================= */
 /* DsFreeSpnArray() -- Free array returned by DsGetSpn{A,W}          */

 dcl DsFreeSpnArrayA
     entry (type DWORD,
            type LPSTR byaddr)
     NTDSAPI WINAPI external('DsFreeSpnArrayA');

 dcl DsFreeSpnArrayW
     entry (type DWORD,
            type LPWSTR byaddr)
     NTDSAPI WINAPI external('DsFreeSpnArrayW');

 %dcl DsFreeSpnArray char ext;
 %if UNICODE ^= '' %then %do;
   %DsFreeSpnArray='DsFreeSpnArrayW';
 %end; %else %do;
   %DsFreeSpnArray='DsFreeSpnArrayA';
 %end;

 /* ================================================================= */
 /* DsCrackSpn() -- parse an SPN into the ServiceClass,               */
 /* ServiceName, and InstanceName (and InstancePort) pieces.          */
 /* An SPN is passed in, along with a pointer to the maximum length   */
 /* for each piece and a pointer to a buffer where each piece should  */
 /* go. On exit, the maximum lengths are updated to the actual length */
 /* for each piece and the buffer contain the appropriate piece.      */
 /* The InstancePort is 0 if not  present.                            */
 /*                                                                   */
 /* DWORD DsCrackSpn(                                                 */
 /*      IN LPTSTR pszSPN,              -- the SPN to parse           */
 /*      IN OUT PUSHORT pcServiceClass, -- input -- max length of     */
 /*                                                 ServiceClass      */
 /*                                        output -- actual length    */
 /*      OUT LPCTSTR ServiceClass,      -- the ServiceClass part of   */
 /*                                        the SPN                    */
 /*      IN OUT PUSHORT pcServiceName,  -- input -- max length of     */
 /*                                                 ServiceName       */
 /*                                        output -- actual length    */
 /*      OUT LPCTSTR ServiceName,       -- the ServiceName part of    */
 /*                                        the SPN                    */
 /*      IN OUT PUSHORT pcInstance,     -- input -- max length of     */
 /*                                                 ServiceClass      */
 /*                                        output -- actual length    */
 /*      OUT LPCTSTR InstanceName,      -- the InstanceName part of   */
 /*                                        the SPN                    */
 /*      OUT PUSHORT InstancePort       -- instance port              */
 /*                                                                   */
 /* Note: lengths are in characters, all string lengths include       */
 /*       terminators. All arguments except pszSpn are optional.      */

 dcl DsCrackSpnA
     entry (char(*) varz byaddr nonasgn,
            type DWORD byaddr optional,
            char(*) varz byaddr optional,
            type DWORD byaddr optional,
            char(*) varz byaddr optional,
            type DWORD byaddr optional,
            char(*) varz byaddr optional,
            type USHORT byaddr optional)
     returns (type DWORD byvalue optional)
     NTDSAPI WINAPI external('DsCrackSpnA');

 dcl DsCrackSpnW
     entry (WCHAR(*) varz byaddr nonasgn,
            type DWORD byaddr optional,
            WCHAR(*) varz byaddr optional,
            type DWORD byaddr optional,
            WCHAR(*) varz byaddr optional,
            type DWORD byaddr optional,
            WCHAR(*) varz byaddr optional,
            type USHORT byaddr optional)
     returns (type DWORD byvalue optional)
     NTDSAPI WINAPI external('DsCrackSpnW');

 %dcl DsCrackSpn char ext;
 %if UNICODE ^= '' %then %do;
   %DsCrackSpn='DsCrackSpnW';
 %end; %else %do;
   %DsCrackSpn='DsCrackSpnA';
 %end;


 /* ================================================================= */
 /* DsWriteAccountSpn -- set or add SPNs for an account object        */
 /* Usually done by service itself, or perhaps by an admin.           */
 /*                                                                   */
 /* This call is RPC'd to the DC where the account object is stored,  */
 /* so it can securely enforce policy on what SPNs are allowed on the */
 /* account. Direct LDAP writes to the SPN property are not allowed   */
 /* -- all writes must come through this RPC call.                    */
 /* (Reads via LDAP are OK.)                                          */
 /*                                                                   */
 /* The account object can be a machine account, or a service (user)  */
 /* account.                                                          */
 /*                                                                   */
 /* If called by the service to register itself, it can most easily   */
 /* get the names by calling DsGetSpn with each of the names that     */
 /* clients can use to find the service.                              */
 /*                                                                   */
 /* IN SpnWriteOp eOp,         -- set, add                            */
 /* IN LPCTSTR    pszAccount,  -- DN of account to which to add SPN   */
 /* IN int        cSPN,        -- count of SPNs to add to account     */
 /* IN LPCTSTR    rpszSPN[]    -- SPNs to add to altSecID property    */

 dcl DsWriteAccountSpnA
     entry (type HANDLE,
            type DS_SPN_WRITE_OP,
            char(*) varz byaddr nonasgn,
            type DWORD,
            (*) type LPCSTR byaddr)
     returns (type DWORD byvalue optional)
     NTDSAPI WINAPI external('DsWriteAccountSpnA');

 dcl DsWriteAccountSpnW
     entry (type HANDLE,
            type DS_SPN_WRITE_OP,
            WCHAR(*) varz byaddr nonasgn,
            type DWORD,
            (*) type LPCWSTR byaddr)
     returns (type DWORD byvalue optional)
     NTDSAPI WINAPI external('DsWriteAccountSpnW');

 %dcl DsWriteAccountSpn char ext;
 %if UNICODE ^= '' %then %do;
   %DsWriteAccountSpn='DsWriteAccountSpnW';
 %end; %else %do;
   %DsWriteAccountSpn='DsWriteAccountSpnA';
 %end;

 /* ++                                                                */
 /* Routine Description:                                              */
 /*                                                                   */
 /* Constructs a Service Principal Name suitable to identify the      */
 /* desired server.                                                   */
 /* The service class and part of a dns hostname must be supplied.    */
 /*                                                                   */
 /* This routine is a simplified wrapper to DsMakeSpn.                */
 /* The ServiceName is made canonical by resolving through DNS.       */
 /* Guid-based dns names are not supported.                           */
 /*                                                                   */
 /* The simplified SPN constructed looks like this:                   */
 /*                                                                   */
 /* ServiceClass / ServiceName / ServiceName                          */
 /*                                                                   */
 /* The instance name portion (2nd position) is always defaulted.     */
 /* The port and referrer fields are not used.                        */
 /*                                                                   */
 /* Arguments:                                                        */
 /*                                                                   */
 /*     ServiceClass - Class of service, defined by the service,      */
 /*                    can be any string unique to the service        */
 /*                                                                   */
 /*     ServiceName - dns hostname, fully qualified or not            */
 /*        Stringized IP address is also resolved if necessary        */
 /*                                                                   */
 /*     pcSpnLength - IN, maximum length of buffer, in chars          */
 /*                  OUT, space utilized, in chars, including         */
 /*                       terminator                                  */
 /*                                                                   */
 /*     pszSpn - Buffer, atleast of length *pcSpnLength               */
 /*                                                                   */
 /* Return Value:                                                     */
 /*                                                                   */
 /*     NTDSAPI WINAPI - Win32 error code                             */
 /* --                                                                */

 dcl DsClientMakeSpnForTargetServerW
     entry (WCHAR(*) varz byaddr nonasgn,
            WCHAR(*) varz byaddr nonasgn,
            type DWORD byaddr,
            WCHAR(*) varz byaddr)
     returns (type DWORD byvalue optional)
     NTDSAPI WINAPI external('DsClientMakeSpnForTargetServerW');

 dcl DsClientMakeSpnForTargetServerA
     entry (char(*) varz byaddr nonasgn,
            char(*) varz byaddr nonasgn,
            type DWORD byaddr,
            char(*) varz byaddr)
     returns (type DWORD byvalue optional)
     NTDSAPI WINAPI external('DsClientMakeSpnForTargetServerA');

 %dcl DsClientMakeSpnForTargetServer char ext;
 %if UNICODE ^= '' %then %do;
   %DsClientMakeSpnForTargetServer='DsClientMakeSpnForTargetServerW';
 %end; %else %do;
   %DsClientMakeSpnForTargetServer='DsClientMakeSpnForTargetServerA';
 %end;

 /* ++                                                                */
 /* Routine Description:                                              */
 /*                                                                   */
 /* Register Service Principal Names for a server application.        */
 /*                                                                   */
 /* This routine does the following:                                  */
 /* 1. Enumerates a list of server SPNs using DsGetSpn and the        */
 /*    provided class                                                 */
 /* 2. Determines the domain of the current user context              */
 /* 3. Determines the DN of the current user context if not supplied  */
 /* 4. Locates a domain controller                                    */
 /* 5. Binds to the domain controller                                 */
 /* 6. Uses DsWriteAccountSpn to write the SPNs on the named object DN*/
 /* 7. Unbinds                                                        */
 /*                                                                   */
 /* Construct server SPNs for this service, and write them to the     */
 /* right object.                                                     */
 /*                                                                   */
 /* If the userObjectDn is specified, the SPN is written to that      */
 /* object.                                                           */
 /*                                                                   */
 /* Otherwise the Dn is defaulted, to the user object, then computer. */
 /*                                                                   */
 /* Now, bind to the DS, and register the name on the object for the  */
 /* user this service is running as.  So, if we're running as local   */
 /* system, we'll register it on the computer object itself. If we're */
 /* running as a domain user, we'll add the SPN to the user's object. */
 /*                                                                   */
 /* Arguments:                                                        */
 /*                                                                   */
 /*     Operation    - What should be done with the values:           */
 /*                    add, replace or delete                         */
 /*     ServiceClass - Unique string identifying service              */
 /*     UserObjectDN - Optional, dn of object to write SPN to         */
 /*                                                                   */
 /* Return Value:                                                     */
 /*                                                                   */
 /*     NTDSAPI WINAPI - Win32 error code                             */
 /* --                                                                */

 dcl DsServerRegisterSpnA
     entry (type DS_SPN_WRITE_OP,
            char(*) varz byaddr nonasgn,
            char(*) varz byaddr optional nonasgn)
     returns (type DWORD byvalue optional)
     NTDSAPI WINAPI external('DsServerRegisterSpnA');

 dcl DsServerRegisterSpnW
     entry (type DS_SPN_WRITE_OP,
            WCHAR(*) varz byaddr nonasgn,
            WCHAR(*) varz byaddr optional nonasgn)
     returns (type DWORD byvalue optional)
     NTDSAPI WINAPI external('DsServerRegisterSpnW');

 %dcl DsServerRegisterSpn char ext;
 %if UNICODE ^= '' %then  %do;
   %DsServerRegisterSpn='DsServerRegisterSpnW';
 %end; %else %do;
   %DsServerRegisterSpn='DsServerRegisterSpnA';
 %end;

 /* DsReplicaSync.  The server that this call is executing on is      */
 /* called thedestination.  The destination's naming context will be  */
 /* brought up to date with respect to a source system.               */
 /* The source system is identified by the uuid.                      */
 /* The uuid is that of the source system's 'NTDS Settings' object.   */
 /* The destination system must already be configured such that the   */
 /* source system is one of the systems from which it receives        */
 /* replication data ('replication from'). This is usually done       */
 /* automatically by the KCC.                                         */
 /*                                                                   */
 /*  PARAMETERS:                                                      */
 /*      pNC (DSNAME *)                                               */
 /*          Name of the NC to synchronize.                           */
 /*      puuidSourceDRA (SZ)                                          */
 /*          objectGuid of DSA with which to synchronize the replica. */
 /*      ulOptions (ULONG)                                            */
 /*          Bitwise OR of zero or more flags                         */
 /*   RETURNS: WIN32 STATUS                                           */

 dcl DsReplicaSyncA
     entry (type HANDLE,
            char(*) varz byaddr nonasgn,
            type UUID byaddr nonasgn,
            type ULONG)
     returns (type DWORD byvalue optional)
     NTDSAPI WINAPI external('DsReplicaSyncA');

 dcl DsReplicaSyncW
     entry (type HANDLE,
            WCHAR(*) varz byaddr nonasgn,
            type UUID byaddr nonasgn,
            type ULONG)
     returns (type DWORD byvalue optional)
     NTDSAPI WINAPI external('DsReplicaSyncW');

 %dcl DsReplicaSync char ext;
 %if UNICODE ^= '' %then %do;
   %DsReplicaSync='DsReplicaSyncW';
 %end; %else %do;
   %DsReplicaSync='DsReplicaSyncA';
 %end;

 /* DsReplicaAdd                                                      */
 /*                                                                   */
 /* Description:                                                      */
 /*  This call is executed on the destination.  It causes the         */
 /*  destination to add a 'replication from' reference to the         */
 /*  indicated source system.                                         */
 /*                                                                   */
 /*  The source server is identified by string name, not uuid as with */
 /*  Sync. The DsaSrcAddress parameter is the transport specific      */
 /*  address of the source DSA, usually its guid-based dns name.      */
 /*  The guid in the guid-based dnsname is the object-guid of that    */
 /*  server's ntds-dsa (settings) object.                             */
 /*                                                                   */
 /* Arguments:                                                        */
 /*  pNC (IN) - NC for which to add the replica.                      */
 /*             The NC record must exist locally as either an object  */
 /*             (instantiated or not) or a reference phantom          */
 /*             (i.e., a phantom with a guid).                        */
 /*                                                                   */
 /*  pSourceDsaDN (IN) - DN of the source DSA's ntdsDsa object.       */
 /*                      Required if ulOptions includes               */
 /*                      DS_REPADD_ASYNCHRONOUS_REPLICA,              */
 /*                      ignored otherwise.                           */
 /*                                                                   */
 /*  pTransportDN (IN) - DN of the interSiteTransport object          */
 /*                      representing the transport by which to       */
 /*                      communicate with the source server.          */
 /*                      Required if ulOptions includes               */
 /*                      INTERSITE_MESSAGING, ignored otherwise.      */
 /*                                                                   */
 /*  pszSourceDsaAddress (IN) - Transport-specific address of the     */
 /*                      source DSA.                                  */
 /*                                                                   */
 /*  pSchedule (IN) - Schedule by which to replicate the NC from this */
 /*                   source in the future.                           */
 /*                                                                   */
 /*  ulOptions (IN) - flags                                           */
 /*  returns: WIN32 STATUS                                            */


 dcl DsReplicaAddA
     entry (type HANDLE,
            char(*) varz byaddr nonasgn,
            char(*) varz byaddr optional nonasgn,
            char(*) varz byaddr optional nonasgn,
            char(*) varz byaddr nonasgn,
            type SCHEDULE byaddr nonasgn,
            type DWORD)
     returns (type DWORD byvalue optional)
     NTDSAPI WINAPI external('DsReplicaAddA');

 dcl DsReplicaAddW
     entry (type HANDLE,
            WCHAR(*) varz byaddr nonasgn,
            WCHAR(*) varz byaddr optional nonasgn,
            WCHAR(*) varz byaddr optional nonasgn,
            WCHAR(*) varz byaddr nonasgn,
            type SCHEDULE byaddr nonasgn,
            type DWORD)
     returns (type DWORD byvalue optional)
     NTDSAPI WINAPI external('DsReplicaAddW');

 %dcl DsReplicaAdd char ext;
 %if UNICODE ^= '' %then %do;
   %DsReplicaAdd='DsReplicaAddW';
 %end; %else %do;
   %DsReplicaAdd='DsReplicaAddA';
 %end;

 /* DsReplicaDel                                                      */
 /*                                                                   */
 /* The server that this call is executing on is the destination.     */
 /* The call causes the destination to remove a 'replication from'    */
 /* reference to the indicated source server.                         */
 /* The source server is identified by string name, not uuid as with  */
 /* Sync.                                                             */
 /* The DsaSrc parameter is the transport specific address of the     */
 /* source DSA, usually its guid-based dns name. The guid in the      */
 /* guid-based dns name is the object-guid of that server's ntds-dsa  */
 /* (settings) object.                                                */
 /*                                                                   */
 /*  PARAMETERS:                                                      */
 /*      pNC (DSNAME *)                                               */
 /*          Name of the NC for which to delete a source.             */
 /*      pszSourceDRA (SZ)                                            */
 /*          DSA for which to delete the source.                      */
 /*      ulOptions (ULONG)                                            */
 /*          Bitwise OR of zero or more flags                         */
 /*   RETURNS: WIN32 STATUS                                           */

 dcl DsReplicaDelA
     entry (type HANDLE,
            char(*) varz byaddr nonasgn,
            char(*) varz byaddr nonasgn,
            type ULONG)
     returns (type DWORD byvalue optional)
     NTDSAPI WINAPI external('DsReplicaDelA');

 dcl DsReplicaDelW
     entry (type HANDLE,
            WCHAR(*) varz byaddr nonasgn,
            WCHAR(*) varz byaddr nonasgn,
            type ULONG)
     returns (type DWORD byvalue optional)
     NTDSAPI WINAPI external('DsReplicaDelW');

 %dcl DsReplicaDel char ext;
 %if UNICODE ^= '' %then %do;
   %DsReplicaDel='DsReplicaDelW';
 %end; %else %do;
   %DsReplicaDel='DsReplicaDelA';
 %end;

 /* DsReplicaModify                                                   */
 /*                                                                   */
 /*  Modify a source for a given naming context                       */
 /*                                                                   */
 /*  The value must already exist.                                    */
 /*                                                                   */
 /*  Either the UUID or the address may be used to identify the       */
 /*  current value. If a UUID is specified, the UUID will be used for */
 /*  comparison.  Otherwise, the address will be used for comparison. */
 /*                                                                   */
 /*  PARAMETERS:                                                      */
 /*    pNC (DSNAME *)                                                 */
 /*        Name of the NC for which the Reps-From should be modified. */
 /*    puuidSourceDRA (UUID *)                                        */
 /*        Invocation-ID of the referenced DRA.  May be NULL if:      */
 /*        - ulModifyFields does not include DS_REPMOD_UPDATE_ADDRESS */
 /*        - and pmtxSourceDRA is non-NULL.                           */
 /*    puuidTransportObj (UUID *)                                     */
 /*        objectGuid of the transport by which replication is to be  */
 /*        performed                                                  */
 /*        Ignored if ulModifyFields does not include                 */
 /*        DS_REPMOD_UPDATE_TRANSPORT.                                */
 /*    pszSourceDRA (SZ)                                              */
 /*        DSA for which the reference should be added or deleted.    */
 /*        Ignored if puuidSourceDRA is non-NULL and ulModifyFields   */
 /*        does not include DS_REPMOD_UPDATE_ADDRESS.                 */
 /*    prtSchedule (REPLTIMES *)                                      */
 /*        Periodic replication schedule for this replica. Ignored if */
 /*        ulModifyFields does not include DS_REPMOD_UPDATE_SCHEDULE. */
 /*    ulReplicaFlags (ULONG)                                         */
 /*        Flags to set for this replica.  Ignored if ulModifyFields  */
 /*        does not include DS_REPMOD_UPDATE_FLAGS.                   */
 /*    ulModifyFields (ULONG)                                         */
 /*        Fields to update.  One or more of the following bit flags: */
 /*          UPDATE_ADDRESS                                           */
 /*            Update the MTX_ADDR associated with the referenced     */
 /*            server.                                                */
 /*          UPDATE_SCHEDULE                                          */
 /*            Update the periodic replication schedule               */
 /*            associated with the replica.                           */
 /*          UPDATE_FLAGS                                             */
 /*            Update the flags associated with the replica.          */
 /*          UPDATE_TRANSPORT                                         */
 /*            Update the transport associated with the replica.      */
 /*    ulOptions (ULONG)                                              */
 /*        Bitwise OR of zero or more of the following:               */
 /*          DS_REPMOD_ASYNCHRONOUS_OPERATION                         */
 /*            Perform this operation asynchronously.                 */
 /*   RETURNS: WIN32 STATUS                                           */

 dcl DsReplicaModifyA
     entry (type HANDLE,
            char(*) varz byaddr nonasgn,
            type UUID byaddr optional nonasgn,
            char(*) varz byaddr optional nonasgn,
            char(*) varz byaddr optional nonasgn,
            type SCHEDULE byaddr optional nonasgn,
            type DWORD,
            type DWORD,
            type DWORD)
     returns (type DWORD byvalue optional)
     NTDSAPI WINAPI external('DsReplicaModifyA');

 dcl DsReplicaModifyW
     entry (type HANDLE,
            WCHAR(*) varz byaddr nonasgn,
            type UUID byaddr optional nonasgn,
            WCHAR(*) varz byaddr optional nonasgn,
            WCHAR(*) varz byaddr optional nonasgn,
            type SCHEDULE byaddr optional nonasgn,
            type DWORD,
            type DWORD,
            type DWORD)
     returns (type DWORD byvalue optional)
     NTDSAPI WINAPI external('DsReplicaModifyW');

 %dcl DsReplicaModify char ext;
 %if UNICODE ^= '' %then %do;
   %DsReplicaModify='DsReplicaModifyW';
 %end; %else %do;
   %DsReplicaModify='DsReplicaModifyA';
 %end;

 /* DsReplicaUpdateRefs                                               */
 /*                                                                   */
 /* In this case, the RPC is being executed on the 'source' of        */
 /* destination-source replication relationship. This function tells  */
 /* the source that it no longer supplies replication information to  */
 /* the indicated destination system.                                 */
 /* Add or remove a target server from the Reps-To property on the    */
 /* given NC.                                                         */
 /* Add/remove a reference given the DSNAME of the corresponding      */
 /* NTDS-DSA object.                                                  */
 /*                                                                   */
 /*  PARAMETERS:                                                      */
 /*      pNC (DSNAME *)                                               */
 /*          Name of the NC for which the Reps-To should be modified. */
 /*      DsaDest (SZ)                                                 */
 /*          Network address of DSA for which the reference should be */
 /*          added or deleted.                                        */
 /*      pUuidDsaDest (UUID *)                                        */
 /*          Invocation-ID of DSA for which the reference should be   */
 /*          added or deleted.                                        */
 /*      ulOptions (ULONG)                                            */
 /*          Bitwise OR of zero or more of the following:             */
 /*            DS_REPUPD_ASYNC_OP                                     */
 /*              Perform this operation asynchronously.               */
 /*            DS_REPUPD_ADD_REFERENCE                                */
 /*              Add the given server to the Reps-To property.        */
 /*            DS_REPUPD_DEL_REFERENCE                                */
 /*              Remove the given server from the Reps-To property.   */
 /*          Note that ADD_REF and DEL_REF may be paired to perform   */
 /*          'add or update'.                                         */
 /*                                                                   */
 /*   RETURNS: WIN32 STATUS                                           */

 dcl DsReplicaUpdateRefsA
     entry (type HANDLE,
            char(*) varz byaddr nonasgn,
            char(*) varz byaddr nonasgn,
            type UUID byaddr nonasgn,
            type ULONG)
     returns (type DWORD byvalue optional)
     NTDSAPI WINAPI external('DsReplicaUpdateRefsA');

 dcl DsReplicaUpdateRefsW
     entry (type HANDLE,
            WCHAR(*) varz byaddr nonasgn,
            WCHAR(*) varz byaddr nonasgn,
            type UUID byaddr nonasgn,
            type ULONG)
     returns (type DWORD byvalue optional)
     NTDSAPI WINAPI external('DsReplicaUpdateRefsW');

 %dcl DsReplicaUpdateRefs char ext;
 %if UNICODE ^= '' %then %do;
   %DsReplicaUpdateRefs='DsReplicaUpdateRefsW';
 %end; %else %do;
   %DsReplicaUpdateRefs='DsReplicaUpdateRefsA';
 %end;

 /* Friends of DsReplicaSyncAll */

 define ordinal DS_REPSYNCALL_ERROR
   ( DS_REPSYNCALL_WIN32_ERROR_CONTACTING_SERVER value(0),
     DS_REPSYNCALL_WIN32_ERROR_REPLICATING       value(1),
     DS_REPSYNCALL_SERVER_UNREACHABLE            value(2)
   ) prec(31);

 define ordinal DS_REPSYNCALL_EVENT
   ( DS_REPSYNCALL_EVENT_ERROR                   value(0),
     DS_REPSYNCALL_EVENT_SYNC_STARTED            value(1),
     DS_REPSYNCALL_EVENT_SYNC_COMPLETED          value(2),
     DS_REPSYNCALL_EVENT_FINISHED                value(3)
   ) prec(31);

 /* Friends of DsReplicaSyncAll */

 define structure
   1 DS_REPSYNCALL_SYNCA,
     2 pszSrcId type LPSTR,
     2 pszDstId type LPSTR,
     2 pszNC    type LPSTR,
     2 pguidSrc handle GUID,
     2 pguidDst handle GUID;
 define alias PDS_REPSYNCALL_SYNCA handle DS_REPSYNCALL_SYNCA;

 define structure
   1 DS_REPSYNCALL_SYNCW,
     2 pszSrcId type LPWSTR,
     2 pszDstId type LPWSTR,
     2 pszNC    type LPWSTR,
     2 pguidSrc handle GUID,
     2 pguidDst handle GUID;
 define alias PDS_REPSYNCALL_SYNCW handle DS_REPSYNCALL_SYNCW;

 define structure
   1 DS_REPSYNCALL_ERRINFOA,
     2 pszSvrId   type LPSTR,
     2 error      type DS_REPSYNCALL_ERROR,
     2 dwWin32Err type DWORD,
     2 pszSrcId   type LPSTR;
 define alias PDS_REPSYNCALL_ERRINFOA handle DS_REPSYNCALL_ERRINFOA;

 define structure
   1 DS_REPSYNCALL_ERRINFOW,
     2 pszSvrId   type LPWSTR,
     2 error      type DS_REPSYNCALL_ERROR,
     2 dwWin32Err type DWORD,
     2 pszSrcId   type LPWSTR;
 define alias PDS_REPSYNCALL_ERRINFOW handle DS_REPSYNCALL_ERRINFOW;

 define structure
   1 DS_REPSYNCALL_UPDATEA,
     2 event    type DS_REPSYNCALL_EVENT,
     2 pErrInfo handle DS_REPSYNCALL_ERRINFOA,
     2 pSync    handle DS_REPSYNCALL_SYNCA;
 define alias PDS_REPSYNCALL_UPDATEA handle DS_REPSYNCALL_UPDATEA;

 define structure
   1 DS_REPSYNCALL_UPDATEW,
     2 event    type DS_REPSYNCALL_EVENT,
     2 pErrInfo handle DS_REPSYNCALL_ERRINFOW,
     2 pSync    handle DS_REPSYNCALL_SYNCW;
 define alias PDS_REPSYNCALL_UPDATEW handle DS_REPSYNCALL_UPDATEW;


 %if UNICODE ^= '' %then %do;
 define alias  DS_REPSYNCALL_SYNC    type  DS_REPSYNCALL_SYNCW;
 define alias  DS_REPSYNCALL_ERRINFO type  DS_REPSYNCALL_ERRINFOW;
 define alias  DS_REPSYNCALL_UPDATE  type  DS_REPSYNCALL_UPDATEW;
 define alias PDS_REPSYNCALL_SYNC    type PDS_REPSYNCALL_SYNCW;
 define alias PDS_REPSYNCALL_ERRINFO type PDS_REPSYNCALL_ERRINFOW;
 define alias PDS_REPSYNCALL_UPDATE  type PDS_REPSYNCALL_UPDATEW;
 %end; %else %do;
 define alias  DS_REPSYNCALL_SYNC    type  DS_REPSYNCALL_SYNCA;
 define alias  DS_REPSYNCALL_ERRINFO type  DS_REPSYNCALL_ERRINFOA;
 define alias  DS_REPSYNCALL_UPDATE  type  DS_REPSYNCALL_UPDATEA;
 define alias PDS_REPSYNCALL_SYNC    type PDS_REPSYNCALL_SYNCA;
 define alias PDS_REPSYNCALL_ERRINFO type PDS_REPSYNCALL_ERRINFOA;
 define alias PDS_REPSYNCALL_UPDATE  type PDS_REPSYNCALL_UPDATEA;
 %end;

 /* ********************* */
 /* Replica SyncAll flags */
 /* ********************* */

 /* This option has no effect. */
 dcl DS_REPSYNCALL_NO_OPTIONS            type DWORD value('00000000'xu);

 /* Ordinarily, if a server cannot be contacted, DsReplicaSyncAll    */
 /* tries to route around it and replicate from as many servers as   */
 /* possible.  Enabling this option will cause DsReplicaSyncAll to   */
 /* generate a fatal error if any server cannot be contacted, or if  */
 /* any server is unreachable (due to a disconnected or broken       */
 /* topology.)                                                       */
 dcl DS_REPSYNCALL_ABORT_IF_SERVER_UNAVAILABLE
                                         type DWORD value('00000001'xu);

 /* This option disables transitive replication; syncs will only be   */
 /* performed with adjacent servers and no DsBind calls will be made. */
 dcl DS_REPSYNCALL_SYNC_ADJACENT_SERVERS_ONLY
                                         type DWORD value('00000002'xu);

 /* Ordinarily, when DsReplicaSyncAll encounters a non-fatal error,   */
 /* it returns the GUID DNS of the relevant server(s).  Enabling this */
 /* option causes DsReplicaSyncAll to return the servers' DNs instead.*/
 dcl DS_REPSYNCALL_ID_SERVERS_BY_DN      type DWORD value('00000004'xu);

 /* This option disables all syncing.  The topology will still be     */
 /* analyzed and unavailable / unreachable servers will still be      */
 /* identified.                                                       */
 dcl DS_REPSYNCALL_DO_NOT_SYNC           type DWORD value('00000008'xu);

 /* Ordinarily, DsReplicaSyncAll attempts to bind to all servers      */
 /* before generating the topology.  If a server cannot be contacted, */
 /* DsReplicaSyncAll excludes that server from the topology and tries */
 /* to route around it. If this option is enabled, checking will be   */
 /* bypassed and DsReplicaSyncAll will assume all servers are         */
 /* responding. This will speed operation of DsReplicaSyncAll, but if */
 /* some servers are not responding, some transitive replications may */
 /* be blocked.                                                       */
 dcl DS_REPSYNCALL_SKIP_INITIAL_CHECK    type DWORD value('00000010'xu);

 /* Push mode. Push changes from the home server out to all partners  */
 /* using transitive replication.  This reverses the direction of     */
 /* replication, and the order of execution of the replication sets   */
 /* from the usual 'pulling' mode of execution.                       */
 dcl DS_REPSYNCALL_PUSH_CHANGES_OUTWARD  type DWORD value('00000020'xu);

 /* Cross site boundaries.  By default, the only servers that are     */
 /* considered are those in the same site as the home system.         */
 /* With this option, all servers in the enterprise, across all sites,*/
 /* are eligible.  They must be connected by a synchronous (RPC)      */
 /* transport, however.                                               */
 dcl DS_REPSYNCALL_CROSS_SITE_BOUNDARIES type DWORD value('00000040'xu);

 /* DsReplicaSyncAll.  Syncs the destination server with all other    */
 /*                    servers in the site.                           */
 /*                                                                   */
 /*  PARAMETERS:                                                      */
 /* hDS      (IN) - A DS connection bound to the destination server.  */
 /* pszNameContext (IN) - The naming context to synchronize           */
 /* ulFlags        (IN) - Bitwise OR of zero or more flags            */
 /* pFnCallBack    (IN, OPTIONAL) - Callback function for             */
 /*                       message-passing.                            */
 /* pCallbackData  (IN, OPTIONAL) - A pointer that will be passed to  */
 /*                       the first argument of the callback function.*/
 /* pErrors       (OUT, OPTIONAL) - Pointer to a                      */
 /*                       (PDS_REPSYNCALL_ERRINFO *) Object that will */
 /*                       hold an array of error structures.          */

 dcl DsReplicaSyncAllA
     entry (type HANDLE,
            char(*) varz byaddr nonasgn optional,
            type ULONG,
            entry (type LPVOID,
                   type PDS_REPSYNCALL_UPDATEA byaddr)
            returns (type BOOL optional)
            limited options (byvalue nodescriptor linkage(stdcall)),
            type LPVOID,
            pointer byaddr) /* to array of PDS_REPSYNCALL_ERRINFOW */
     returns (type DWORD byvalue optional)
     NTDSAPI WINAPI external('DsReplicaSyncAllA');

 dcl DsReplicaSyncAllW
     entry (type HANDLE,
            WCHAR(*) varz byaddr nonasgn optional,
            type ULONG,
            entry (type LPVOID,
                   type PDS_REPSYNCALL_UPDATEW byaddr)
            returns (type BOOL optional)
            limited options (byvalue nodescriptor linkage(stdcall)),
            type LPVOID,
            pointer byaddr) /* to array of PDS_REPSYNCALL_ERRINFOW */
     returns (type DWORD byvalue optional)
     NTDSAPI WINAPI external('DsReplicaSyncAllW');

 %dcl DsReplicaSyncAll char ext;
 %if UNICODE ^= '' %then %do;
   %DsReplicaSyncAll='DsReplicaSyncAllW';
 %end; %else %do;
   %DsReplicaSyncAll='DsReplicaSyncAllA';
 %end;

 dcl DsRemoveDsServerW
     entry (type HANDLE,
            WCHAR(*) varz byaddr,
            WCHAR(*) varz byaddr optional,
            type BOOL byaddr optional,
            type BOOL)
     returns (type DWORD byvalue optional)
     NTDSAPI WINAPI external('DsRemoveDsServerW');

 dcl DsRemoveDsServerA
     entry (type HANDLE,
            char(*) varz byaddr,
            char(*) varz byaddr optional,
            type BOOL byaddr optional,
            type BOOL)
     returns (type DWORD byvalue optional)
     NTDSAPI WINAPI external('DsRemoveDsServerA');

 %dcl DsRemoveDsServer char ext;
 %if UNICODE ^= '' %then %do;
   %DsRemoveDsServer='DsRemoveDsServerW';
 %end; %else %do;
   %DsRemoveDsServer='DsRemoveDsServerA';
 %end;

 dcl DsRemoveDsDomainW
     entry (type HANDLE,
            WCHAR(*) varz byaddr)
     returns (type DWORD byvalue optional)
     NTDSAPI WINAPI external('DsRemoveDsDomainW');

 dcl DsRemoveDsDomainA
     entry (type HANDLE,
            char(*) varz byaddr)
     returns (type DWORD byvalue optional)
     NTDSAPI WINAPI external('DsRemoveDsDomainA');

 %dcl DsRemoveDsDomain char ext;
 %if UNICODE ^= '' %then %do;
   %DsRemoveDsDomain='DsRemoveDsDomainW';
 %end; %else %do;
   %DsRemoveDsDomain='DsRemoveDsDomainA';
 %end;

 dcl DsListSitesA
     entry (type HANDLE,
            type PDS_NAME_RESULTA byaddr)
     returns (type DWORD byvalue optional)
     NTDSAPI WINAPI external('DsListSitesA');

 dcl DsListSitesW
     entry (type HANDLE,
            type PDS_NAME_RESULTW byaddr)
     returns (type DWORD byvalue optional)
     NTDSAPI WINAPI external('DsListSitesW');

 %dcl DsListSites char ext;
 %if UNICODE ^= '' %then %do;
   %DsListSites='DsListSitesW';
 %end; %else %do;
   %DsListSites='DsListSitesA';
 %end;

 dcl DsListServersInSiteA
     entry (type HANDLE,
            char(*) varz byaddr nonasgn,
            type PDS_NAME_RESULTA byaddr)
     returns (type DWORD byvalue optional)
     NTDSAPI WINAPI external('DsListServersInSiteA');

 dcl DsListServersInSiteW
     entry (type HANDLE,
            WCHAR(*) varz byaddr nonasgn,
            type PDS_NAME_RESULTW byaddr)
     returns (type DWORD byvalue optional)
     NTDSAPI WINAPI external('DsListServersInSiteW');

 %dcl DsListServersInSite char ext;
 %if UNICODE ^= '' %then  %do;
   %DsListServersInSite='DsListServersInSiteW';
 %end; %else %do;
   %DsListServersInSite='DsListServersInSiteA';
 %end;

 dcl DsListDomainsInSiteA
     entry (type HANDLE,
            char(*) varz byaddr nonasgn,
            type PDS_NAME_RESULTA byaddr)
     returns (type DWORD byvalue optional)
     NTDSAPI WINAPI external('DsListDomainsInSiteA');

 dcl DsListDomainsInSiteW
     entry (type HANDLE,
            WCHAR(*) varz byaddr nonasgn,
            type PDS_NAME_RESULTW byaddr)
     returns (type DWORD byvalue optional)
     NTDSAPI WINAPI external('DsListDomainsInSiteW');

 %dcl DsListDomainsInSite char ext;
 %if UNICODE ^= '' %then %do;
   %DsListDomainsInSite='DsListDomainsInSiteW';
 %end; %else %do;
   %DsListDomainsInSite='DsListDomainsInSiteA';
 %end;

 dcl DsListServersForDomainInSiteA
     entry (type HANDLE,
            char(*) varz byaddr nonasgn,
            char(*) varz byaddr nonasgn,
            type PDS_NAME_RESULTA byaddr)
     returns (type DWORD byvalue optional)
     NTDSAPI WINAPI external('DsListServersForDomainInSiteA');

 dcl DsListServersForDomainInSiteW
     entry (type HANDLE,
            WCHAR(*) varz byaddr nonasgn,
            WCHAR(*) varz byaddr nonasgn,
            type PDS_NAME_RESULTW byaddr)
     returns (type DWORD byvalue optional)
     NTDSAPI WINAPI external('DsListServersForDomainInSiteW');

 %dcl DsListServersForDomainInSite char ext;
 %if UNICODE ^= '' %then %do;
   %DsListServersForDomainInSite='DsListServersForDomainInSiteW';
 %end; %else %do;
   %DsListServersForDomainInSite='DsListServersForDomainInSiteA';
 %end;

 /* Define indices for DsListInfoForServer return data. Check status */
 /* for each field as a given value may not be present.              */

 dcl DS_LIST_DSA_OBJECT_FOR_SERVER     fixed bin(31) value(0);
 dcl DS_LIST_DNS_HOST_NAME_FOR_SERVER  fixed bin(31) value(1);
 dcl DS_LIST_ACCOUNT_OBJECT_FOR_SERVER fixed bin(31) value(2);

 dcl DsListInfoForServerA
     entry (type HANDLE,
            char(*) varz byaddr nonasgn,
            type PDS_NAME_RESULTA byaddr)
     returns (type DWORD byvalue optional)
     NTDSAPI WINAPI external('DsListInfoForServerA');

 dcl DsListInfoForServerW
     entry (type HANDLE,
            WCHAR(*) varz byaddr nonasgn,
            type PDS_NAME_RESULTW byaddr)
     returns (type DWORD byvalue optional)
     NTDSAPI WINAPI external('DsListInfoForServerW');

 %dcl DsListInfoForServer char ext;
 %if UNICODE ^= '' %then %do;
   %DsListInfoForServer='DsListInfoForServerW';
 %end; %else %do;
   %DsListInfoForServer='DsListInfoForServerA';
 %end;

 /* Define indices for DsListRoles return data.  Check status for */
 /* each field as a given value may not be present.               */

 dcl DS_ROLE_SCHEMA_OWNER         fixed bin(31) value(0);
 dcl DS_ROLE_DOMAIN_OWNER         fixed bin(31) value(1);
 dcl DS_ROLE_PDC_OWNER            fixed bin(31) value(2);
 dcl DS_ROLE_RID_OWNER            fixed bin(31) value(3);
 dcl DS_ROLE_INFRASTRUCTURE_OWNER fixed bin(31) value(4);

 dcl DsListRolesA
     entry (type HANDLE,
            type PDS_NAME_RESULTA byaddr)
     returns (type DWORD byvalue optional)
     NTDSAPI WINAPI external('DsListRolesA');

 dcl DsListRolesW
     entry (type HANDLE,
            type PDS_NAME_RESULTW byaddr)
     returns (type DWORD byvalue optional)
     NTDSAPI WINAPI external('DsListRolesW');

 %dcl DsListRoles char ext;
 %if UNICODE ^= '' %then %do;
   %DsListRoles='DsListRolesW';
 %end; %else %do;
   %DsListRoles='DsListRolesA';
 %end;

 /* Definitions required for DsMapSchemaGuid routines. */

 dcl DS_SCHEMA_GUID_NOT_FOUND     fixed bin(31) value(0);
 dcl DS_SCHEMA_GUID_ATTR          fixed bin(31) value(1);
 dcl DS_SCHEMA_GUID_ATTR_SET      fixed bin(31) value(2);
 dcl DS_SCHEMA_GUID_CLASS         fixed bin(31) value(3);
 dcl DS_SCHEMA_GUID_CONTROL_RIGHT fixed bin(31) value(4);

 define structure
   1 DS_SCHEMA_GUID_MAPA,
     2 guid     type GUID,  /* mapped GUID */
     2 guidType type DWORD, /* DS_SCHEMA_GUID_* value */
     2 pName    type LPSTR; /* might be NULL */
 define alias PDS_SCHEMA_GUID_MAPA handle DS_SCHEMA_GUID_MAPA;

 define structure
   1 DS_SCHEMA_GUID_MAPW,
     2 guid     type GUID,  /* mapped GUID */
     2 guidType type DWORD, /* DS_SCHEMA_GUID_* value */
     2 pName    type LPWSTR;/* might be NULL */
 define alias PDS_SCHEMA_GUID_MAPW handle DS_SCHEMA_GUID_MAPW;

 dcl DsMapSchemaGuidsA
     entry (type HANDLE,
            type DWORD,
            type GUID byaddr,
            type PDS_SCHEMA_GUID_MAPA byaddr)
     returns (type DWORD byvalue optional)
     NTDSAPI WINAPI external('DsMapSchemaGuidsA');

 dcl DsFreeSchemaGuidMapA
     entry (type PDS_SCHEMA_GUID_MAPA )
     NTDSAPI WINAPI external('DsFreeSchemaGuidMapA');

 dcl DsMapSchemaGuidsW
     entry (type HANDLE,
            type DWORD,
            type GUID byaddr,
            type PDS_SCHEMA_GUID_MAPW byaddr)
     returns (type DWORD byvalue optional)
     NTDSAPI WINAPI external('DsMapSchemaGuidsW');

 dcl DsFreeSchemaGuidMapW
     entry (type PDS_SCHEMA_GUID_MAPW )
     NTDSAPI WINAPI external('DsFreeSchemaGuidMapW');


 %dcl DsMapSchemaGuids char ext;
 %dcl DsFreeSchemaGuidMap char ext;
 %if UNICODE ^= '' %then %do;
 define alias  DS_SCHEMA_GUID_MAP type  DS_SCHEMA_GUID_MAPW;
 define alias PDS_SCHEMA_GUID_MAP type PDS_SCHEMA_GUID_MAPW;
 %DsMapSchemaGuids='DsMapSchemaGuidsW';
 %DsFreeSchemaGuidMap='DsFreeSchemaGuidMapW';
 %end; %else %do;
 define alias  DS_SCHEMA_GUID_MAP type  DS_SCHEMA_GUID_MAPA;
 define alias PDS_SCHEMA_GUID_MAP type PDS_SCHEMA_GUID_MAPA;
 %DsMapSchemaGuids='DsMapSchemaGuidsA';
 %DsFreeSchemaGuidMap='DsFreeSchemaGuidMapA';
 %end;

 define structure
   1 DS_DOMAIN_CONTROLLER_INFO_1A,
     2 NetbiosName        type LPSTR, /* might be NULL */
     2 DnsHostName        type LPSTR, /* might be NULL */
     2 SiteName           type LPSTR, /* might be NULL */
     2 ComputerObjectName type LPSTR, /* might be NULL */
     2 ServerObjectName   type LPSTR, /* might be NULL */
     2 fIsPdc             type BOOL,
     2 fDsEnabled         type BOOL;
 define alias PDS_DOMAIN_CONTROLLER_INFO_1A
        handle DS_DOMAIN_CONTROLLER_INFO_1A;

 define structure
   1 DS_DOMAIN_CONTROLLER_INFO_1W,
     2 NetbiosName        type LPWSTR,/* might be NULL */
     2 DnsHostName        type LPWSTR,/* might be NULL */
     2 SiteName           type LPWSTR,/* might be NULL */
     2 ComputerObjectName type LPWSTR,/* might be NULL */
     2 ServerObjectName   type LPWSTR,/* might be NULL */
     2 fIsPdc             type BOOL,
     2 fDsEnabled         type BOOL;
 define alias PDS_DOMAIN_CONTROLLER_INFO_1W
        handle DS_DOMAIN_CONTROLLER_INFO_1W;

 define structure
   1 DS_DOMAIN_CONTROLLER_INFO_2A,
    2 NetbiosName        type LPSTR, /* might be NULL */
    2 DnsHostName        type LPSTR, /* might be NULL */
    2 SiteName           type LPSTR, /* might be NULL */
    2 SiteObjectName     type LPSTR, /* might be NULL */
    2 ComputerObjectName type LPSTR, /* might be NULL */
    2 ServerObjectName   type LPSTR, /* might be NULL */
    2 NtdsDsaObjectName  type LPSTR, /* might be NULL */
    2 fIsPdc             type BOOL,
    2 fDsEnabled         type BOOL,
    2 fIsGc              type BOOL,
      /* Valid iff SiteObjectName non-NULL. */
    2 SiteObjectGuid type GUID,
      /* Valid iff ComputerObjectName non-NULL. */
    2 ComputerObjectGuid type GUID,
      /* Valid iff ServerObjectName non-NULL; */
    2 ServerObjectGuid   type GUID,
      /* Valid iff fDsEnabled is TRUE. */
    2 NtdsDsaObjectGuid  type GUID;
 define alias PDS_DOMAIN_CONTROLLER_INFO_2A
        handle DS_DOMAIN_CONTROLLER_INFO_2A;

 define structure
   1 DS_DOMAIN_CONTROLLER_INFO_2W,
    2 NetbiosName        type LPWSTR,/* might be NULL */
    2 DnsHostName        type LPWSTR,/* might be NULL */
    2 SiteName           type LPWSTR,/* might be NULL */
    2 SiteObjectName     type LPWSTR,/* might be NULL */
    2 ComputerObjectName type LPWSTR,/* might be NULL */
    2 ServerObjectName   type LPWSTR,/* might be NULL */
    2 NtdsDsaObjectName  type LPWSTR,/* might be NULL */
    2 fIsPdc             type BOOL,
    2 fDsEnabled         type BOOL,
    2 fIsGc              type BOOL,
      /* Valid iff SiteObjectName non-NULL. */
    2 SiteObjectGuid     type GUID,
      /* Valid iff ComputerObjectName non-NULL. */
    2 ComputerObjectGuid type GUID,
      /* Valid iff ServerObjectName non-NULL; */
    2 ServerObjectGuid   type GUID,
      /* Valid iff fDsEnabled is TRUE. */
    2 NtdsDsaObjectGuid  type GUID;
 define alias PDS_DOMAIN_CONTROLLER_INFO_2W
        handle DS_DOMAIN_CONTROLLER_INFO_2W;

 /* The following APIs strictly find domain controller account        */
 /* objects in the DS and return information associated with them.    */
 /* As such, they may return entries which correspond to domain       */
 /* controllers long since decommissioned, etc. and there is no       */
 /* guarantee that there exists a physical domain controller at all.  */
 /* Use DsGetDcName (dsgetdc.cpy) to find live domain controllers for */
 /* a domain.                                                         */

 dcl DsGetDomainControllerInfoA
     entry (type HANDLE,
            char(*) varz byaddr nonasgn,
            type DWORD,
            type DWORD byaddr,
            pointer byaddr)
     returns (type DWORD byvalue optional)
     NTDSAPI WINAPI external('DsGetDomainControllerInfoA');

 dcl DsGetDomainControllerInfoW
     entry (type HANDLE,
            WCHAR(*) varz byaddr nonasgn,
            type DWORD,
            type DWORD byaddr,
            pointer byaddr)
     returns (type DWORD byvalue optional)
     NTDSAPI WINAPI external('DsGetDomainControllerInfoW');

 dcl DsFreeDomainControllerInfoA
     entry (type DWORD,
            type DWORD,
            pointer)
     NTDSAPI WINAPI external('DsFreeDomainControllerInfoA');

 dcl DsFreeDomainControllerInfoW
     entry (type DWORD,
            type DWORD,
            pointer)
     NTDSAPI WINAPI external('DsFreeDomainControllerInfoW');

 %dcl DsGetDomainControllerInfo char ext;
 %dcl DsFreeDomainControllerInfo char ext;
 %if UNICODE ^= '' %then %do;
 define alias  DS_DOMAIN_CONTROLLER_INFO_1
         type  DS_DOMAIN_CONTROLLER_INFO_1W;
 define alias  DS_DOMAIN_CONTROLLER_INFO_2
         type  DS_DOMAIN_CONTROLLER_INFO_2W;
 define alias PDS_DOMAIN_CONTROLLER_INFO_1
         type PDS_DOMAIN_CONTROLLER_INFO_1W;
 define alias PDS_DOMAIN_CONTROLLER_INFO_2
         type PDS_DOMAIN_CONTROLLER_INFO_2W;
 %DsGetDomainControllerInfo='DsGetDomainControllerInfoW';
 %DsFreeDomainControllerInfo='DsFreeDomainControllerInfoW';
 %end; %else %do;
 define alias  DS_DOMAIN_CONTROLLER_INFO_1
         type  DS_DOMAIN_CONTROLLER_INFO_1A;
 define alias  DS_DOMAIN_CONTROLLER_INFO_2
         type  DS_DOMAIN_CONTROLLER_INFO_2A;
 define alias PDS_DOMAIN_CONTROLLER_INFO_1
         type PDS_DOMAIN_CONTROLLER_INFO_1A;
 define alias PDS_DOMAIN_CONTROLLER_INFO_2
         type PDS_DOMAIN_CONTROLLER_INFO_2A;
 %DsGetDomainControllerInfo='DsGetDomainControllerInfoA';
 %DsFreeDomainControllerInfo='DsFreeDomainControllerInfoA';
 %end;

 /* Which task should be run? */
 define ordinal DS_KCC_TASKID
   ( DS_KCC_TASKID_UPDATE_TOPOLOGY value(0)
   ) prec (31);

 /* Don't wait for completion of the task; queue it and return. */
 dcl DS_KCC_FLAG_ASYNC_OP fixed bin(31) value(1);

 dcl DsReplicaConsistencyCheck
     entry (type HANDLE,
            type DS_KCC_TASKID,
            type DWORD)
     returns (type DWORD byvalue optional)
     NTDSAPI WINAPI external('DsReplicaConsistencyCheck');


 define ordinal DS_REPL_INFO_TYPE
   ( DS_REPL_INFO_NEIGHBORS                value(0),
       /* returns DS_REPL_NEIGHBORS * */
     DS_REPL_INFO_CURSORS_FOR_NC           value(1),
       /* returns DS_REPL_CURSORS * */
     DS_REPL_INFO_METADATA_FOR_OBJ         value(2),
       /* returns DS_REPL_OBJECT_META_DATA * */
     DS_REPL_INFO_KCC_DSA_CONNECT_FAILURES value(3),
       /* both return */
     DS_REPL_INFO_KCC_DSA_LINK_FAILURES    value(4),
       /*    DS_REPL_KCC_DSA_FAILURES * */
     DS_REPL_INFO_PENDING_OPS              value(5)
       /* returns DS_REPL_PENDING_OPS * */
     ) PREC(31);

 /* Bit values for the dwReplicaFlags field of the DS_REPL_NEIGHBOR */
 /* structure.                                                      */
 dcl DS_REPL_NBR_WRITEABLE               type DWORD value('10'xu);
 dcl DS_REPL_NBR_SYNC_ON_STARTUP         type DWORD value('20'xu);
 dcl DS_REPL_NBR_DO_SCHEDULED_SYNCS      type DWORD value('40'xu);
 dcl DS_REPL_NBR_USE_ASYNC_INTERSITE_TRANSPORT
                                         type DWORD value('80'xu);
 dcl DS_REPL_NBR_TWO_WAY_SYNC            type DWORD value('200'xu);
 dcl DS_REPL_NBR_FULL_SYNC_IN_PROGRESS   type DWORD value('10000'xu);
 dcl DS_REPL_NBR_FULL_SYNC_NEXT_PACKET   type DWORD value('20000'xu);
 dcl DS_REPL_NBR_NEVER_SYNCED            type DWORD value('200000'xu);
 dcl DS_REPL_NBR_IGNORE_CHANGE_NOTIFICATIONS
                                         type DWORD value('4000000'xu);
 dcl DS_REPL_NBR_DISABLE_SCHEDULED_SYNC  type DWORD value('8000000'xu);
 dcl DS_REPL_NBR_COMPRESS_CHANGES        type DWORD value('10000000'xu);
 dcl DS_REPL_NBR_NO_CHANGE_NOTIFICATIONS type DWORD value('20000000'xu);

 define structure
   1 DS_REPL_NEIGHBORW,
     2 pszNamingContext                   type LPWSTR,
     2 pszSourceDsaDN                     type LPWSTR,
     2 pszSourceDsaAddress                type LPWSTR,
     2 pszAsyncIntersiteTransportDN       type LPWSTR,
     2 dwReplicaFlags                     type DWORD,
     2 dwReserved                         type DWORD,/* alignment */
     2 uuidNamingContextObjGuid           type UUID,
     2 uuidSourceDsaObjGuid               type UUID,
     2 uuidSourceDsaInvocationID          type UUID,
     2 uuidAsyncIntersiteTransportObjGuid type UUID,
     2 usnLastObjChangeSynced             type USN,
     2 usnAttributeFilter                 type USN,
     2 ftimeLastSyncSuccess               type FILETIME,
     2 ftimeLastSyncAttempt               type FILETIME,
     2 dwLastSyncResult                   type DWORD,
     2 cNumConsecutiveSyncFailures        type DWORD;

 define structure
   1 DS_REPL_NEIGHBORSW,
     2 cNumNeighbors type DWORD,
     2 dwReserved    type DWORD,/* alignment */
     2 rgNeighbor    (1) type DS_REPL_NEIGHBORW; /* refer */

 define structure
   1 DS_REPL_CURSOR,
     2 uuidSourceDsaInvocationID type UUID,
     2 usnAttributeFilter        type USN;

 define structure
   1 DS_REPL_CURSORS,
     2 cNumCursors type DWORD,
     2 dwReserved  type DWORD,/* alignment */
     2 rgCursor    (1) type DS_REPL_CURSOR; /* refer */

 define structure
   1 DS_REPL_ATTR_META_DATA,
     2 pszAttributeName                   type LPWSTR,
     2 dwVersion                          type DWORD,
     2 ftimeLastOriginatingChange         type FILETIME,
     2 uuidLastOriginatingDsaInvocationID type UUID,
     2 usnOriginatingChange               type USN,
       /* in the originating DSA's USN space */
     2 usnLocalChange                     type USN;
       /* in the local DSA's USN space */

 define structure
   1 DS_REPL_OBJ_META_DATA,
     2 cNumEntries type DWORD,
     2 dwReserved  type DWORD,/* alignment */
     2 rgMetaData  (1) type DS_REPL_ATTR_META_DATA; /* refer */

 define structure
   1 DS_REPL_KCC_DSA_FAILUREW,
     2 pszDsaDN          type LPWSTR,
     2 uuidDsaObjGuid    type UUID,
     2 ftimeFirstFailure type FILETIME,
     2 cNumFailures      type DWORD,
     2 dwLastResult      type DWORD;/* Win32 error code */

 define structure
   1 DS_REPL_KCC_DSA_FAILURESW,
     2 cNumEntries  type DWORD,
     2 dwReserved   type DWORD,/* alignment */
     2 rgDsaFailure (1) type DS_REPL_KCC_DSA_FAILUREW; /* refer */

 define ordinal DS_REPL_OP_TYPE
   ( DS_REPL_OP_TYPE_SYNC        value(0),
     DS_REPL_OP_TYPE_ADD,
     DS_REPL_OP_TYPE_DELETE,
     DS_REPL_OP_TYPE_MODIFY,
     DS_REPL_OP_TYPE_UPDATE_REFS
   ) prec(31);

 define structure
   1 DS_REPL_OPW,
     2 ftimeEnqueued            type FILETIME,
       /* time at which the operation was enqueued */
     2 ulSerialNumber           type ULONG,
       /* ID of this sync; unique per machine per boot */
     2 ulPriority               type ULONG,/* > priority, > urgency */
     2 OpType                   type DS_REPL_OP_TYPE,
     2 ulOptions                type ULONG,
       /* Zero or more bits specific to OpType; e.g.  */
       /* DS_REPADD_* for DS_REPL_OP_TYPE_ADD,        */
       /* DS_REPSYNC_* for DS_REPL_OP_TYPE_SYNC, etc. */
     2 pszNamingContext         type LPWSTR,
     2 pszDsaDN                 type LPWSTR,
     2 pszDsaAddress            type LPWSTR,
     2 uuidNamingContextObjGuid type UUID,
     2 uuidDsaObjGuid           type UUID;

 define structure
   1 DS_REPL_PENDING_OPSW,
     2 ftimeCurrentOpStarted type FILETIME,
     2 cNumPendingOps        type DWORD,
     2 rgPendingOp           (1) type DS_REPL_OPW; /* refer */


 dcl DsReplicaGetInfoW
     entry (type HANDLE,
            type DS_REPL_INFO_TYPE,
            WCHAR(*) varz byaddr nonasgn,
            type UUID byaddr,
            pointer byaddr)
     returns (type DWORD byvalue optional)
     NTDSAPI WINAPI external('DsReplicaGetInfoW');

 dcl DsReplicaFreeInfo
     entry (type DS_REPL_INFO_TYPE,
            pointer)
     NTDSAPI WINAPI external('DsReplicaFreeInfo');


 %dcl DsReplicaGetInfo char ext;
 %if UNICODE ^= '' %then %do;
 %DsReplicaGetInfo='DsReplicaGetInfoW';
 define alias DS_REPL_NEIGHBOR             type DS_REPL_NEIGHBORW;
 define alias DS_REPL_NEIGHBORS            type DS_REPL_NEIGHBORSW;
 define alias DS_REPL_KCC_DSA_FAILURES type DS_REPL_KCC_DSA_FAILURESW;
 define alias DS_REPL_KCC_DSA_FAILURE  type DS_REPL_KCC_DSA_FAILUREW;
 define alias DS_REPL_OP                   type DS_REPL_OPW;
 define alias DS_REPL_PENDING_OPS      type DS_REPL_PENDING_OPSW;
 %end; %else %do;
 /* No ANSI equivalents currently supported. */
 %end;

 dcl DsAddSidHistoryW
     entry (type HANDLE,
            type DWORD,                   /* in - sbz for now */
            WCHAR(*) varz byaddr nonasgn, /* in - DNS or NetBIOS */
            WCHAR(*) varz byaddr nonasgn, /* in - SAM account name */
            WCHAR(*) varz byaddr nonasgn optional,
            type RPC_AUTH_IDENTITY_HANDLE,/* in - creds for src domain*/
            WCHAR(*) varz byaddr nonasgn, /* in - DNS or NetBIOS */
            WCHAR(*) varz byaddr nonasgn) /* in - SAM account name */
     returns (type DWORD byvalue optional)
     NTDSAPI WINAPI external('DsAddSidHistoryW');

 dcl DsAddSidHistoryA
     entry (type HANDLE,
            type DWORD,                   /* in - sbz for now */
            char(*) varz byaddr nonasgn,  /* in - DNS or NetBIOS */
            char(*) varz byaddr nonasgn,  /* in - SAM account name */
            char(*) varz byaddr nonasgn optional,
            type RPC_AUTH_IDENTITY_HANDLE,/* in - creds for src domain*/
            char(*) varz byaddr nonasgn,  /* in - DNS or NetBIOS */
            char(*) varz byaddr nonasgn)  /* in - SAM account name */
     returns (type DWORD byvalue optional)
     NTDSAPI WINAPI external('DsAddSidHistoryA');

 %dcl DsAddSidHistory char ext;
 %if UNICODE ^= '' %then %do;
   %DsAddSidHistory='DsAddSidHistoryW';
 %end; %else %do;
   %DsAddSidHistory='DsAddSidHistoryA';
 %end;

 /* The DsInheritSecurityIdentity API adds the source principal's SID */
 /* and SID history to the destination principal's SID history and    */
 /* then DELETES THE SOURCE PRINCIPAL. Source and destination         */
 /* principal must be in the same domain.                             */

 dcl DsInheritSecurityIdentityW
     entry (type HANDLE,
            type DWORD,                   /* in - sbz for now */
            WCHAR(*) varz byaddr nonasgn, /* in - distinguished name */
            WCHAR(*) varz byaddr nonasgn) /* in - distinguished name */
     returns (type DWORD byvalue optional)
     NTDSAPI WINAPI external('DsInheritSecurityIdentityW');

 dcl DsInheritSecurityIdentityA
     entry (type HANDLE,
            type DWORD,                   /* in - sbz for now */
            char(*) varz byaddr nonasgn,  /* in - distinguished name */
            char(*) varz byaddr nonasgn)  /* in - distinguished name */
     returns (type DWORD byvalue optional)
     NTDSAPI WINAPI external('DsInheritSecurityIdentityA');


 %dcl DsInheritSecurityIdentity char ext;
 %if UNICODE ^= '' %then %do;
   %DsInheritSecurityIdentity='DsInheritSecurityIdentityW';
 %end; %else %do;
   %DsInheritSecurityIdentity='DsInheritSecurityIdentityA';
 %end;

 /* ++                                                                */
 /* ================================================================= */
 /* NTDSAPI                                                           */
 /* DWORD                                                             */
 /* NTDSAPI WINAPI                                                    */
 /* DsQuoteRdnValue(                                                  */
 /*     IN     DWORD    cUnquotedRdnValueLength,                      */
 /*     IN     LPCTCH   psUnquotedRdnValue,                           */
 /*     IN OUT DWORD    *pcQuotedRdnValueLength,                      */
 /*     OUT    LPTCH    psQuotedRdnValue                              */
 /*     )                                                             */
 /* ++                                                                */
 /*                                                                   */
 /* Description                                                       */
 /*                                                                   */
 /*   This client call converts an RDN value into a quoted RDN value  */
 /*   if the RDN value contains characters that require quotes.       */
 /*   The resultant RDN can be submitted as part of a DN to the DS    */
 /*   using various APIs such as LDAP.                                */
 /*                                                                   */
 /*   No quotes are added if none are needed. In this case, the       */
 /*   output RDN value will be the same as the input RDN value.       */
 /*                                                                   */
 /*   The RDN is quoted in accordance with the specification          */
 /*   "Lightweight Directory Access Protocol (v3): UTF-8 String       */
 /*   Representation of Distinguished Names", RFC 2253.               */
 /*                                                                   */
 /*   The input and output RDN values are *NOT* NULL terminated.      */
 /*                                                                   */
 /*   The changes made by this call can be undone by calling          */
 /*   DsUnquoteRdnValue().                                            */
 /*                                                                   */
 /* Arguments:                                                        */
 /*                                                                   */
 /*   cUnquotedRdnValueLength - The length of psUnquotedRdnValue in   */
 /*                             chars.                                */
 /*                                                                   */
 /*   psUnquotedRdnValue      - Unquoted RDN value.                   */
 /*                                                                   */
 /*   pcQuotedRdnValueeLength -                                       */
 /*       IN, maximum length of psQuotedRdnValue, in chars            */
 /*       OUT ERROR_SUCCESS, chars utilized in psQuotedRdnValue       */
 /*       OUT ERROR_BUFFER_OVERFLOW, chars needed in psQuotedRdnValue */
 /*                                                                   */
 /*   psQuotedRdnValue - The resultant and perhaps quoted RDN value   */
 /*                                                                   */
 /* Return Value:                                                     */
 /*   ERROR_SUCCESS                                                   */
 /*       If quotes or escapes were needed, then psQuotedRdnValue     */
 /*       contains the quoted, escaped version of psUnquotedRdnValue. */
 /*       Otherwise, psQuotedRdnValue contains a copy of              */
 /*       psUnquotedRdnValue. In either case, pcQuotedRdnValueLength  */
 /*       contains the space utilized, in chars.                      */
 /*                                                                   */
 /*   ERROR_BUFFER_OVERFLOW                                           */
 /*       psQuotedRdnValueLength contains the space needed, in chars, */
 /*       to hold psQuotedRdnValue.                                   */
 /*                                                                   */
 /*   ERROR_INVALID_PARAMETER                                         */
 /*       Invalid parameter.                                          */
 /*                                                                   */
 /*   ERROR_NOT_ENOUGH_MEMORY                                         */
 /*       Allocation error.                                           */
 /* --                                                                */

 dcl DsQuoteRdnValueW
     entry (type DWORD,
            WCHAR (*) varz byaddr nonasgn,
            type DWORD byaddr,
            WCHAR (*) varz byaddr)
     returns (type DWORD byvalue optional)
     NTDSAPI WINAPI external('DsQuoteRdnValueW');

 dcl DsQuoteRdnValueA
     entry (type DWORD,
            char (*) varz byaddr nonasgn,
            type DWORD byaddr,
            char (*) varz byaddr)
     returns (type DWORD byvalue optional)
     NTDSAPI WINAPI external('DsQuoteRdnValueA');

 %dcl DsQuoteRdnValue char ext;
 %if UNICODE ^= '' %then %do;
   %DsQuoteRdnValue='DsQuoteRdnValueW';
 %end; %else %do;
   %DsQuoteRdnValue='DsQuoteRdnValueA';
 %end;

 /* ++                                                                */
 /* ================================================================= */
 /* NTDSAPI                                                           */
 /* DWORD                                                             */
 /* NTDSAPI WINAPI                                                    */
 /* DsUnquoteRdnValue(                                                */
 /*     IN     DWORD    cQuotedRdnValueLength,                        */
 /*     IN     LPCTCH   psQuotedRdnValue,                             */
 /*     IN OUT DWORD    *pcUnquotedRdnValueLength,                    */
 /*     OUT    LPTCH    psUnquotedRdnValue                            */
 /*     )                                                             */
 /*                                                                   */
 /* Description                                                       */
 /*                                                                   */
 /*   This client call converts a quoted RDN Value into an unquoted   */
 /*   RDN Value. The resultant RDN value should *NOT* be submitted as */
 /*   part of a DN to the DS using various APIs such as LDAP.         */
 /*                                                                   */
 /*   When psQuotedRdnValue is quoted:                                */
 /*       The leading and trailing quote are removed.                 */
 /*                                                                   */
 /*       Whitespace before the first quote is discarded.             */
 /*                                                                   */
 /*       Whitespace trailing the last quote is discarded.            */
 /*                                                                   */
 /*       Escapes are removed and the char following the escape is    */
 /*       kept.                                                       */
 /*                                                                   */
 /*   The following actions are taken when psQuotedRdnValue is        */
 /*   unquoted:                                                       */
 /*                                                                   */
 /*       Leading whitespace is discarded.                            */
 /*                                                                   */
 /*       Trailing whitespace is kept.                                */
 /*                                                                   */
 /*       Escaped non-special chars return an error.                  */
 /*                                                                   */
 /*       Unescaped special chars return an error.                    */
 /*                                                                   */
 /*       RDN values beginning with # (ignoring leading whitespace)   */
 /*       are treated as a stringized BER value and converted         */
 /*       accordingly.                                                */
 /*                                                                   */
 /*       Escaped hex digits (\89) are converted into a binary byte   */
 /*       (0x89).                                                     */
 /*                                                                   */
 /*       Escapes are removed from escaped special chars.             */
 /*                                                                   */
 /*   The following actions are always taken:                         */
 /*       Escaped special chars are unescaped.                        */
 /*                                                                   */
 /*   The input and output RDN values are not NULL terminated.        */
 /*                                                                   */
 /* Arguments:                                                        */
 /*                                                                   */
 /*   cQuotedRdnValueLength - The length of psQuotedRdnValue in       */
 /*                           chars.                                  */
 /*   psQuotedRdnValue - RDN value that may be quoted and may be      */
 /*                      escaped .                                    */
 /*                                                                   */
 /*   pcUnquotedRdnValueLength - IN, maximum length of                */
 /*                                  psUnquotedRdnValue, in chars     */
 /*                              OUT ERROR_SUCCESS, chars used in     */
 /*                                  psUnquotedRdnValue               */
 /*                              OUT ERROR_BUFFER_OVERFLOW, chars     */
 /*                                  needed for psUnquotedRdnValue    */
 /*                                                                   */
 /*   psUnquotedRdnValue - The resultant unquoted RDN value.          */
 /*                                                                   */
 /* Return Value:                                                     */
 /*   ERROR_SUCCESS                                                   */
 /*       psUnquotedRdnValue contains the unquoted and unescaped      */
 /*       version of psQuotedRdnValue. pcUnquotedRdnValueLength       */
 /*       contains the space used, in chars.                          */
 /*                                                                   */
 /*   ERROR_BUFFER_OVERFLOW                                           */
 /*       psUnquotedRdnValueLength contains the space needed,         */
 /*       in chars, to hold psUnquotedRdnValue.                       */
 /*                                                                   */
 /*   ERROR_INVALID_PARAMETER                                         */
 /*       Invalid parameter.                                          */
 /*                                                                   */
 /*   ERROR_NOT_ENOUGH_MEMORY                                         */
 /*       Allocation error.                                           */
 /* --                                                                */

 dcl DsUnquoteRdnValueW
     entry (type DWORD,
            WCHAR (*) varz byaddr nonasgn,
            type DWORD byaddr,
            WCHAR (*) varz byaddr)
     returns (type DWORD byvalue optional)
     NTDSAPI WINAPI external('DsUnquoteRdnValueW');

 dcl DsUnquoteRdnValueA
     entry (type DWORD,
            char (*) varz byaddr nonasgn,
            type DWORD byaddr,
            char (*) varz byaddr)
     returns (type DWORD byvalue optional)
     NTDSAPI WINAPI external('DsUnquoteRdnValueA');

 %dcl DsUnquoteRdnValue char ext;
 %if UNICODE ^= '' %then %do;
   %DsUnquoteRdnValue='DsUnquoteRdnValueW';
 %end; %else %do;
   %DsUnquoteRdnValue='DsUnquoteRdnValueA';
 %end;

 %end; /* _NTDSAPI_H_ */

