 /* ++                                                                */
 /*                                                                   */
 /* Copyright (c) 1999  Microsoft Corporation                         */
 /*                                                                   */
 /* Module Name:                                                      */
 /*                                                                   */
 /*     sfc.cpy                                                       */
 /*                                                                   */
 /* Abstract:                                                         */
 /*                                                                   */
 /*     Header file for public SFC interfaces.                        */
 /*                                                                   */
 /* Author:                                                           */
 /*                                                                   */
 /*     Wesley Witt (wesw) 2-Feb-1999                                 */
 /*                                                                   */
 /* Revision History:                                                 */
 /*                                                                   */
 /* --                                                                */



 %dcl #SFC_ char ext;
 %if #SFC_ = '' %then %do;
 %#SFC_ = 'Y';

 %dcl #WINDEF_ char ext;
 %if #WINDEF_ = '' %then %do;
 %include windef;
 %end;


 dcl SFC_DISABLE_NORMAL    fixed bin(31) value(0);
 dcl SFC_DISABLE_ASK       fixed bin(31) value(1);
 dcl SFC_DISABLE_ONCE      fixed bin(31) value(2);
 dcl SFC_DISABLE_SETUP     fixed bin(31) value(3);
 dcl SFC_DISABLE_NOPOPUPS  fixed bin(31) value(4);

 dcl SFC_SCAN_NORMAL       fixed bin(31) value(0);
 dcl SFC_SCAN_ALWAYS       fixed bin(31) value(1);
 dcl SFC_SCAN_ONCE         fixed bin(31) value(2);

 dcl SFC_QUOTA_DEFAULT     fixed bin(31) value(50);
 dcl SFC_QUOTA_ALL_FILES   fixed bin(31) value(-1 );


 define structure
   1 PROTECTED_FILE_DATA,
     2 FileName   WCHAR (MAX_PATH-1) varz,
     2 FileNumber type DWORD;
 define alias PPROTECTED_FILE_DATA handle PROTECTED_FILE_DATA;


 dcl SfcGetNextProtectedFile
     entry (type HANDLE, /* must be NULL */
            type PROTECTED_FILE_DATA byaddr)
     returns (type BOOL byvalue optional)
     WINAPI external('SfcGetNextProtectedFile');

 dcl SfcIsFileProtected
     entry (type HANDLE, /* must be NULL */
            WCHAR(*) varz byaddr nonasgn)
     returns (type BOOL byvalue optional)
     WINAPI external('SfcIsFileProtected');


 /* new APIs which are not currently supported, but are stubbed out */

 dcl SfpVerifyFile
     entry (TCHAR(*) varz byaddr nonasgn,
            TCHAR(*) varz byaddr,
            type DWORD)
     returns (type BOOL byvalue optional)
     options (byvalue nodescriptor) external('SfpVerifyFile');

 %end; /* _SFC_ */
