 /*++ BUILD Version: 0002                                             */
 /*         -- Increment this if a change has global effects          */
 /*                                                                   */
 /* Copyright (c) 1989-1998  Microsoft Corporation                    */
 /*                                                                   */
 /* Module Name:                                                      */
 /*                                                                   */
 /*   wincon.cpy                                                      */
 /*                                                                   */
 /* Abstract:                                                         */
 /*                                                                   */
 /*   This module contains the public data structures, data types,    */
 /*   and procedures exported by the NT console subsystem.            */
 /*                                                                   */
 /* Created:                                                          */
 /*                                                                   */
 /*   26-Oct-1990                                                     */
 /*                                                                   */
 /* Revision History:                                                 */
 /*                                                                   */
 /*--                                                                 */

 %dcl #WINCON_ char ext;
 %if #WINCON_ = '' %then %do;
 %#WINCON_ = 'Y';

 /* Pull in WINBASE.CPY if necessary */
 %dcl #WINBASE_ char ext;
 %if #WINBASE_ = '' %then %do;
   %include winbase;
 %end;

 %dcl UNICODE char ext;

 define structure
   1 COORD,
     2 X type SHORT,
     2 Y type SHORT;

 define alias PCOORD handle COORD;

 define structure
   1 SMALL_RECT,
     2 Left   type SHORT,
     2 Top    type SHORT,
     2 Right  type SHORT,
     2 Bottom type SHORT;

 define alias PSMALL_RECT handle SMALL_RECT;

 define structure
   1 KEY_EVENT_RECORD,   /* the key is enhanced. */
     2 bKeyDown          type BOOL,
     2 wRepeatCount      type WORD,
     2 wVirtualKeyCode   type WORD,
     2 wVirtualScanCode  type WORD,
     2 uChar union,
       3 UnicodeChar     WCHAR,
       3 AsciiChar       CHAR,
     2 dwControlKeyState type DWORD;

 define alias PKEY_EVENT_RECORD handle KEY_EVENT_RECORD;

 /* ControlKeyState flags */

 dcl RIGHT_ALT_PRESSED  type DWORD value('0001'xu);
     /* the right alt key is pressed. */
 dcl LEFT_ALT_PRESSED   type DWORD value('0002'xu);
     /* the left alt key is pressed. */
 dcl RIGHT_CTRL_PRESSED type DWORD value('0004'xu);
     /* the right ctrl key is pressed. */
 dcl LEFT_CTRL_PRESSED  type DWORD value('0008'xu);
     /* the left ctrl key is pressed. */
 dcl SHIFT_PRESSED      type DWORD value('0010'xu);
     /* the shift key is pressed. */
 dcl NUMLOCK_ON         type DWORD value('0020'xu);
     /* the numlock light is on. */
 dcl SCROLLLOCK_ON      type DWORD value('0040'xu);
     /* the scrolllock light is on. */
 dcl CAPSLOCK_ON        type DWORD value('0080'xu);
     /* the capslock light is on. */
 dcl ENHANCED_KEY       type DWORD value('0100'xu);
     /* the key is enhanced. */
 dcl NLS_DBCSCHAR       type DWORD value('00010000'xu);
     /* DBCS for JPN: SBCS/DBCS mode. */
 dcl NLS_ALPHANUMERIC   type DWORD value('00000000'xu);
     /* DBCS for JPN: Alphanumeric mode. */
 dcl NLS_KATAKANA       type DWORD value('00020000'xu);
     /* DBCS for JPN: Katakana mode. */
 dcl NLS_HIRAGANA       type DWORD value('00040000'xu);
     /* DBCS for JPN: Hiragana mode. */
 dcl NLS_ROMAN          type DWORD value('00400000'xu);
     /* DBCS for JPN: Roman/Noroman mode. */
 dcl NLS_IME_CONVERSION type DWORD value('00800000'xu);
     /* DBCS for JPN: IME conversion. */
 dcl NLS_IME_DISABLE    type DWORD value('20000000'xu);
     /* DBCS for JPN: IME enable/disable. */

 define structure
   1 MOUSE_EVENT_RECORD,
     2 dwMousePosition   type COORD,
     2 dwButtonState     type DWORD,
     2 dwControlKeyState type DWORD,
     2 dwEventFlags      type DWORD;

 define alias PMOUSE_EVENT_RECORD handle MOUSE_EVENT_RECORD;

 /* ButtonState flags */

 dcl FROM_LEFT_1ST_BUTTON_PRESSED type DWORD value('0001'xu);
 dcl RIGHTMOST_BUTTON_PRESSED     type DWORD value('0002'xu);
 dcl FROM_LEFT_2ND_BUTTON_PRESSED type DWORD value('0004'xu);
 dcl FROM_LEFT_3RD_BUTTON_PRESSED type DWORD value('0008'xu);
 dcl FROM_LEFT_4TH_BUTTON_PRESSED type DWORD value('0010'xu);

 /* EventFlags */

 dcl MOUSE_MOVED   type DWORD value('0001'xu);
 dcl DOUBLE_CLICK  type DWORD value('0002'xu);
 dcl MOUSE_WHEELED type DWORD value('0004'xu);

 define structure
   1 WINDOW_BUFFER_SIZE_RECORD,
     2 dwSize type COORD;

 define alias PWINDOW_BUFFER_SIZE_RECORD
              handle WINDOW_BUFFER_SIZE_RECORD;

 define structure
   1 MENU_EVENT_RECORD,
     2 dwCommandId type UINT;

 define alias PMENU_EVENT_RECORD handle MENU_EVENT_RECORD;

 define structure
   1 FOCUS_EVENT_RECORD,
     2 bSetFocus type BOOL;

 define alias PFOCUS_EVENT_RECORD handle FOCUS_EVENT_RECORD;

 define structure
   1 INPUT_RECORD,
     2 EventType type WORD,
     2 Event union,
       3 KeyEvent              type KEY_EVENT_RECORD,
       3 MouseEvent            type MOUSE_EVENT_RECORD,
       3 WindowBufferSizeEvent type WINDOW_BUFFER_SIZE_RECORD,
       3 MenuEvent             type MENU_EVENT_RECORD,
       3 FocusEvent            type FOCUS_EVENT_RECORD;

 define alias PINPUT_RECORD handle INPUT_RECORD;

 /*  EventType flags: */

 dcl KEY_EVENT                type WORD value('0001'xu);
     /* Event contains key event record */
 dcl MOUSE_EVENT$             type WORD value('0002'xu); /* renamed! */
     /* Event contains mouse event record */
 dcl WINDOW_BUFFER_SIZE_EVENT type WORD value('0004'xu);
     /* Event contains window change event record */
 dcl MENU_EVENT               type WORD value('0008'xu);
     /* Event contains menu event record */
 dcl FOCUS_EVENT              type WORD value('0010'xu);
     /* event contains focus change */

 define structure
   1 CHAR_INFO,   /* event contains focus change */
     2 Char,
       3 UnicodeChar WCHAR,
       3 AsciiChar   CHAR,
     2 Attributes    type WORD;

 define alias PCHAR_INFO handle CHAR_INFO;

 /* Attributes flags: */

 dcl FOREGROUND_BLUE            type WORD value('0001'xu);
     /* text color contains blue. */
 dcl FOREGROUND_GREEN           type WORD value('0002'xu);
     /* text color contains green. */
 dcl FOREGROUND_RED             type WORD value('0004'xu);
     /* text color contains red. */
 dcl FOREGROUND_INTENSITY       type WORD value('0008'xu);
     /* text color is intensified. */
 dcl BACKGROUND_BLUE            type WORD value('0010'xu);
     /* background color contains blue. */
 dcl BACKGROUND_GREEN           type WORD value('0020'xu);
     /* background color contains green. */
 dcl BACKGROUND_RED             type WORD value('0040'xu);
     /* background color contains red. */
 dcl BACKGROUND_INTENSITY       type WORD value('0080'xu);
     /* background color is intensified. */
 dcl COMMON_LVB_LEADING_BYTE    type WORD value('0100'xu);
     /* Leading Byte of DBCS */
 dcl COMMON_LVB_TRAILING_BYTE   type WORD value('0200'xu);
     /* Trailing Byte of DBCS */
 dcl COMMON_LVB_GRID_HORIZONTAL type WORD value('0400'xu);
     /* DBCS: Grid attribute: top horizontal. */
 dcl COMMON_LVB_GRID_LVERTICAL  type WORD value('0800'xu);
     /* DBCS: Grid attribute: left vertical. */
 dcl COMMON_LVB_GRID_RVERTICAL  type WORD value('1000'xu);
     /* DBCS: Grid attribute: right vertical. */
 dcl COMMON_LVB_REVERSE_VIDEO   type WORD value('4000'xu);
     /* DBCS: Reverse fore/back ground attribute. */
 dcl COMMON_LVB_UNDERSCORE      type WORD value('8000'xu);
     /* DBCS: Underscore. */

 dcl COMMON_LVB_SBCSDBCS        type WORD value('0300'xu);
     /* SBCS or DBCS flag. */


 define structure
   1 CONSOLE_SCREEN_BUFFER_INFO, /* background color is intensified. */
     2 dWSize              type COORD,
     2 dwCursorPosition    type COORD,
     2 wAttributes         type WORD,
     2 srWindow            type SMALL_RECT,
     2 dwMaximumWindowSize type COORD;

 define alias PCONSOLE_SCREEN_BUFFER_INFO
              handle CONSOLE_SCREEN_BUFFER_INFO;

 define structure
   1 CONSOLE_CURSOR_INFO,
     2 dwSize   type DWORD,
     2 bVisible type BOOL;

 define alias PCONSOLE_CURSOR_INFO handle CONSOLE_CURSOR_INFO;

 /* alias definition for ctrl-c handler routines */

 define alias PHANDLER_ROUTINE
        entry (type DWORD)
        returns (type BOOL byvalue optional)
        limited WINAPI;

 dcl CTRL_C_EVENT        type DWORD value(0);
 dcl CTRL_BREAK_EVENT    type DWORD value(1);
 dcl CTRL_CLOSE_EVENT    type DWORD value(2);
 /* 3 is reserved! */
 /* 4 is reserved! */
 dcl CTRL_LOGOFF_EVENT   type DWORD value(5);
 dcl CTRL_SHUTDOWN_EVENT type DWORD value(6);

 /*  Input Mode flags: */

 dcl ENABLE_PROCESSED_INPUT    type DWORD value('0001'xu);
 dcl ENABLE_LINE_INPUT         type DWORD value('0002'xu);
 dcl ENABLE_ECHO_INPUT         type DWORD value('0004'xu);
 dcl ENABLE_WINDOW_INPUT       type DWORD value('0008'xu);
 dcl ENABLE_MOUSE_INPUT        type DWORD value('0010'xu);

 /* Output Mode flags: */

 dcl ENABLE_PROCESSED_OUTPUT   type DWORD value('0001'xu);
 dcl ENABLE_WRAP_AT_EOL_OUTPUT type DWORD value('0002'xu);


 /* direct API definitions. */

 dcl PeekConsoleInputA
     entry (type HANDLE,
            type INPUT_RECORD byaddr,
            type DWORD,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINBASEAPI WINAPI external('PeekConsoleInputA');
 dcl PeekConsoleInputW
     entry (type HANDLE,
            type INPUT_RECORD byaddr,
            type DWORD,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINBASEAPI WINAPI external('PeekConsoleInputW');

 %dcl PeekConsoleInput char ext;
 %if UNICODE ^= '' %then %do;
    %PeekConsoleInput='PeekConsoleInputW';
 %end; %else %do;
   %PeekConsoleInput='PeekConsoleInputA';
 %end; /* !UNICODE */

 dcl ReadConsoleInputA
     entry (type HANDLE,
            type INPUT_RECORD byaddr,
            type DWORD,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINBASEAPI WINAPI external('ReadConsoleInputA');
 dcl ReadConsoleInputW
     entry (type HANDLE,
            type INPUT_RECORD byaddr,
            type DWORD,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINBASEAPI WINAPI external('ReadConsoleInputW');

 %dcl ReadConsoleInput char ext;
 %if UNICODE ^= '' %then %do;
   %ReadConsoleInput='ReadConsoleInputW';
 %end; %else %do;
   %ReadConsoleInput='ReadConsoleInputA';
 %end; /* !UNICODE */

 dcl WriteConsoleInputA
     entry (type HANDLE,
            type INPUT_RECORD byaddr nonasgn,
            type DWORD,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINBASEAPI WINAPI external('WriteConsoleInputA');
 dcl WriteConsoleInputW
     entry (type HANDLE,
            type INPUT_RECORD byaddr nonasgn,
            type DWORD,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINBASEAPI WINAPI external('WriteConsoleInputW');

 %dcl WriteConsoleInput char ext;
 %if UNICODE ^= '' %then %do;
   %WriteConsoleInput='WriteConsoleInputW';
 %end; %else %do;
   %WriteConsoleInput='WriteConsoleInputA';
 %end; /* !UNICODE */

 dcl ReadConsoleOutputA
     entry (type HANDLE,
            (*,*) type CHAR_INFO byaddr,
            type COORD,
            type COORD,
            type SMALL_RECT byaddr)
     returns (type BOOL byvalue optional)
     WINBASEAPI WINAPI external('ReadConsoleOutputA');
 dcl ReadConsoleOutputW
     entry (type HANDLE,
            (*,*) type CHAR_INFO byaddr,
            type COORD,
            type COORD,
            type SMALL_RECT byaddr)
     returns (type BOOL byvalue optional)
     WINBASEAPI WINAPI external('ReadConsoleOutputW');

 %dcl ReadConsoleOutput char ext;
 %if UNICODE ^= '' %then %do;
   %ReadConsoleOutput='ReadConsoleOutputW';
 %end; %else %do;
   %ReadConsoleOutput='ReadConsoleOutputA';
 %end; /* !UNICODE */

 dcl WriteConsoleOutputA
     entry (type HANDLE,
            (*,*) type CHAR_INFO byaddr nonasgn,
            type COORD,
            type COORD,
            type SMALL_RECT byaddr)
     returns (type BOOL byvalue optional)
     WINBASEAPI WINAPI external('WriteConsoleOutputA');
 dcl WriteConsoleOutputW
      entry (type HANDLE,
            (*,*) type CHAR_INFO byaddr nonasgn,
            type COORD,
            type COORD,
            type SMALL_RECT byaddr)
     returns (type BOOL byvalue optional)
     WINBASEAPI WINAPI external('WriteConsoleOutputW');

 %dcl WriteConsoleOutput char ext;
 %if UNICODE ^= '' %then %do;
   %WriteConsoleOutput='WriteConsoleOutputW';
 %end; %else %do;
 %WriteConsoleOutput='WriteConsoleOutputA';
 %end; /* !UNICODE */

 dcl ReadConsoleOutputCharacterA
     entry (type HANDLE,
            char(*) varz byaddr,
            type DWORD,
            type COORD,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINBASEAPI WINAPI external('ReadConsoleOutputCharacterA');
 dcl ReadConsoleOutputCharacterW
     entry (type HANDLE,
            WCHAR(*) varz byaddr,
            type DWORD,
            type COORD,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINBASEAPI WINAPI external('ReadConsoleOutputCharacterW');

 %dcl ReadConsoleOutputCharacter char ext;
 %if UNICODE ^= '' %then  %do;
   %ReadConsoleOutputCharacter='ReadConsoleOutputCharacterW';
 %end; %else %do;
   %ReadConsoleOutputCharacter='ReadConsoleOutputCharacterA';
 %end; /* !UNICODE */

 dcl ReadConsoleOutputAttribute
     entry (type HANDLE,
            pointer, /* address of buffer */
            type DWORD,
            type COORD,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINBASEAPI WINAPI external('ReadConsoleOutputAttribute');

 dcl WriteConsoleOutputCharacterA
     entry (type HANDLE,
            char(*) varz byaddr nonasgn,
            type DWORD,
            type COORD,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINBASEAPI WINAPI external('WriteConsoleOutputCharacterA');
 dcl WriteConsoleOutputCharacterW
     entry (type HANDLE,
            WCHAR(*) varz byaddr nonasgn,
            type DWORD,
            type COORD,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINBASEAPI WINAPI external('WriteConsoleOutputCharacterW');

 %dcl WriteConsoleOutputCharacter char ext;
 %if UNICODE ^= '' %then %do;
   %WriteConsoleOutputCharacter='WriteConsoleOutputCharacterW';
 %end; %else %do;
   %WriteConsoleOutputCharacter='WriteConsoleOutputCharacterA';
 %end; /* !UNICODE */

 dcl WriteConsoleOutputAttribute
     entry (type HANDLE,
            pointer, /* to buffer */
            type DWORD,
            type COORD,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINBASEAPI WINAPI external('WriteConsoleOutputAttribute');

 dcl FillConsoleOutputCharacterA
     entry (type HANDLE,
            CHAR,
            type DWORD,
            type COORD,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINBASEAPI WINAPI external('FillConsoleOutputCharacterA');
 dcl FillConsoleOutputCharacterW
     entry (type HANDLE,
            WCHAR,
            type DWORD,
            type COORD,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINBASEAPI WINAPI external('FillConsoleOutputCharacterW');

 %dcl FillConsoleOutputCharacter char ext;
 %if UNICODE ^= '' %then %do;
   %FillConsoleOutputCharacter='FillConsoleOutputCharacterW';
 %end; %else %do;
   %FillConsoleOutputCharacter='FillConsoleOutputCharacterA';
 %end; /* !UNICODE */

 dcl FillConsoleOutputAttribute
     entry (type HANDLE,
            type WORD,
            type DWORD,
            type COORD,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINBASEAPI WINAPI external('FillConsoleOutputAttribute');

 dcl GetConsoleMode
     entry (type HANDLE,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINBASEAPI WINAPI external('GetConsoleMode');

 dcl GetNumberOfConsoleInputEvents
     entry (type HANDLE,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINBASEAPI WINAPI external('GetNumberOfConsoleInputEvents');

 dcl GetConsoleScreenBufferInfo
     entry (type HANDLE,
            type CONSOLE_SCREEN_BUFFER_INFO byaddr)
     returns (type BOOL byvalue optional)
     WINBASEAPI WINAPI external('GetConsoleScreenBufferInfo');

 dcl GetLargestConsoleWindowSize
     entry (type HANDLE)
     returns (type COORD byvalue optional)
     WINBASEAPI WINAPI external('GetLargestConsoleWindowSize');

 dcl GetConsoleCursorInfo
     entry (type HANDLE,
            type CONSOLE_CURSOR_INFO byaddr)
     returns (type BOOL byvalue optional)
     WINBASEAPI WINAPI external('GetConsoleCursorInfo');

 dcl GetNumberOfConsoleMouseButtons
     entry (type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINBASEAPI WINAPI external('GetNumberOfConsoleMouseButtons');

 dcl SetConsoleMode
     entry (type HANDLE,
            type DWORD)
     returns (type BOOL byvalue optional)
     WINBASEAPI WINAPI external('SetConsoleMode');

 dcl SetConsoleActiveScreenBuffer
     entry (type HANDLE)
     returns (type BOOL byvalue optional)
     WINBASEAPI WINAPI external('SetConsoleActiveScreenBuffer');

 dcl FlushConsoleInputBuffer
     entry (type HANDLE)
     returns (type BOOL byvalue optional)
     WINBASEAPI WINAPI external('FlushConsoleInputBuffer');

 dcl SetConsoleScreenBufferSize
     entry (type HANDLE,
            type COORD)
     returns (type BOOL byvalue optional)
     WINBASEAPI WINAPI external('SetConsoleScreenBufferSize');

 dcl SetConsoleCursorPosition
     entry (type HANDLE,
            type COORD)
     returns (type BOOL byvalue optional)
     WINBASEAPI WINAPI external('SetConsoleCursorPosition');

 dcl SetConsoleCursorInfo
     entry (type HANDLE,
            type CONSOLE_CURSOR_INFO byaddr nonasgn)
     returns (type BOOL byvalue optional)
     WINBASEAPI WINAPI external('SetConsoleCursorInfo');

 dcl ScrollConsoleScreenBufferA
     entry (type HANDLE,
            type SMALL_RECT byaddr nonasgn,
            type SMALL_RECT byaddr nonasgn,
            type COORD,
            type CHAR_INFO byaddr nonasgn)
     returns (type BOOL byvalue optional)
     WINBASEAPI WINAPI external('ScrollConsoleScreenBufferA');
 dcl ScrollConsoleScreenBufferW
     entry (type HANDLE,
            type SMALL_RECT byaddr nonasgn,
            type SMALL_RECT byaddr nonasgn,
            type COORD,
            type CHAR_INFO byaddr nonasgn)
     returns (type BOOL byvalue optional)
     WINBASEAPI WINAPI external('ScrollConsoleScreenBufferW');

 %dcl ScrollConsoleScreenBuffer char ext;
 %if UNICODE ^= '' %then %do;
 %ScrollConsoleScreenBuffer='ScrollConsoleScreenBufferW';
 %end; %else %do;
   %ScrollConsoleScreenBuffer='ScrollConsoleScreenBufferA';
 %end; /* !UNICODE */

 dcl SetConsoleWindowInfo
     entry (type HANDLE,
            type BOOL,
            type SMALL_RECT byaddr nonasgn)
     returns (type BOOL byvalue optional)
     WINBASEAPI WINAPI external('SetConsoleWindowInfo');

 dcl SetConsoleTextAttribute
     entry (type HANDLE,
            type WORD)
     returns (type BOOL byvalue optional)
     WINBASEAPI WINAPI external('SetConsoleTextAttribute');

 dcl SetConsoleCtrlHandler
     entry (type PHANDLER_ROUTINE optional byvalue,
            type BOOL)
     returns (type BOOL byvalue optional)
     WINBASEAPI WINAPI external('SetConsoleCtrlHandler');

 dcl GenerateConsoleCtrlEvent
     entry (type DWORD,
            type DWORD)
     returns (type BOOL byvalue optional)
     WINBASEAPI WINAPI external('GenerateConsoleCtrlEvent');

 dcl AllocConsole
     entry ()
     returns (type BOOL byvalue optional)
     WINBASEAPI WINAPI external('AllocConsole');

 dcl FreeConsole
     entry ()
     returns (type BOOL byvalue optional)
     WINBASEAPI WINAPI external('FreeConsole');


 dcl GetConsoleTitleA
     entry (char(*) varz byaddr,
            type DWORD)
          returns (type DWORD byvalue optional)
     WINBASEAPI WINAPI external('GetConsoleTitleA');
 dcl GetConsoleTitleW
     entry (WCHAR(*) varz byaddr,
            type DWORD)
     returns (type DWORD byvalue optional)
     WINBASEAPI WINAPI external('GetConsoleTitleW');

 %dcl GetConsoleTitle char ext;
 %if UNICODE ^= '' %then %do;
   %GetConsoleTitle='GetConsoleTitleW';
 %end; %else %do;
   %GetConsoleTitle='GetConsoleTitleA';
 %end; /* !UNICODE */

 dcl SetConsoleTitleA
     entry (char(*) varz byaddr nonasgn)
     returns (type BOOL byvalue optional)
     WINBASEAPI WINAPI external('SetConsoleTitleA');
 dcl SetConsoleTitleW
     entry (WCHAR(*) varz byaddr nonasgn)
     returns (type BOOL byvalue optional)
     WINBASEAPI WINAPI external('SetConsoleTitleW');

 %dcl SetConsoleTitle char ext;
 %if UNICODE ^= '' %then %do;
   %SetConsoleTitle='SetConsoleTitleW';
 %end; %else %do;
   %SetConsoleTitle='SetConsoleTitleA';
 %end; /* !UNICODE */

 dcl ReadConsoleA
     entry (type HANDLE,
            type LPVOID,
            type DWORD,
            type DWORD byaddr,
            type LPVOID)
     returns (type BOOL byvalue optional)
     WINBASEAPI WINAPI external('ReadConsoleA');
 dcl ReadConsoleW
     entry (type HANDLE,
            type LPVOID,
            type DWORD,
            type DWORD byaddr,
            type LPVOID)
     returns (type BOOL byvalue optional)
     WINBASEAPI WINAPI external('ReadConsoleW');

 %dcl ReadConsole char ext;
 %if UNICODE ^= '' %then %do;
   %ReadConsole='ReadConsoleW';
 %end; %else %do;
   %ReadConsole='ReadConsoleA';
 %end; /* !UNICODE */

 dcl WriteConsoleA
     entry (type HANDLE,
            pointer, /* to data */
            type DWORD,
            type DWORD byaddr,
            type LPVOID)
     returns (type BOOL byvalue optional)
     WINBASEAPI WINAPI external('WriteConsoleA');
 dcl WriteConsoleW
     entry (type HANDLE,
            pointer, /* to data */
            type DWORD,
            type DWORD byaddr,
            type LPVOID)
     returns (type BOOL byvalue optional)
     WINBASEAPI WINAPI external('WriteConsoleW');

 %dcl WriteConsole char ext;
 %if UNICODE ^= '' %then %do;
   %WriteConsole='WriteConsoleW';
 %end; %else %do;
   %WriteConsole='WriteConsoleA';
 %end; /* !UNICODE */

 dcl CONSOLE_TEXTMODE_BUFFER type DWORD value(1);

 dcl CreateConsoleScreenBuffer
     entry (type DWORD,
            type DWORD,
            type SECURITY_ATTRIBUTES byaddr optional,
            type DWORD,
            type LPVOID)
     returns (type HANDLE byvalue optional)
     WINBASEAPI WINAPI external('CreateConsoleScreenBuffer');

 dcl GetConsoleCP
     entry ()
     returns (type UINT byvalue optional)
     WINBASEAPI WINAPI external('GetConsoleCP');

 dcl SetConsoleCP
     entry (type UINT)
     returns (type BOOL byvalue optional)
     WINBASEAPI WINAPI external('SetConsoleCP');

 dcl GetConsoleOutputCP
     entry ()
     returns (type UINT byvalue optional)
     WINBASEAPI WINAPI external('GetConsoleOutputCP');

 dcl SetConsoleOutputCP
     entry (type UINT)
     returns (type BOOL byvalue optional)
     WINBASEAPI WINAPI external('SetConsoleOutputCP');

 %end; /* #WINCON_ */
