 /*********************************************************************/
 /*                                                                   */
 /* winver.cpy -  Version management functions, types, and definitions*/
 /*                                                                   */
 /*               Include file for VER.DLL.  This library is          */
 /*               designed to allow version stamping of Windows       */
 /*               executable files and of special .VER files for DOS  */
 /*               executable files.                                   */
 /*                                                                   */
 /*      Copyright 1993 - 1998 Microsoft Corp.  All rights reserved   */
 /*                                                                   */
 /*********************************************************************/


 %dcl VER_H char ext;
 %if VER_H = '' %then %do;
 %VER_H = 'Y';

 %dcl #WINUSER_ char ext;
 %if #WINUSER_ = '' %then %do;
   %include WinUser;
 %end;

 %dcl UNICODE char ext;

 /* ----- Symbols ----- */
 dcl VS_FILE_INFO         pointer value(RT_VERSION); /* > winuser.cpy */
 dcl VS_VERSION_INFO      fixed bin(31) value(1);
 dcl VS_USER_DEFINED      fixed bin(31) value(100);

 /* ----- VS_VERSION.dwFileFlags ----- */
 dcl VS_FFI_SIGNATURE     type DWORD value('BD04EFFE'xu);
 dcl VS_FFI_STRUCVERSION  type DWORD value('00010000'xu);
 dcl VS_FFI_FILEFLAGSMASK type DWORD value('0000003F'xu);

 /* ----- VS_VERSION.dwFileFlags ----- */
 dcl VS_FF_DEBUG          type DWORD value('00000001'xu);
 dcl VS_FF_PRERELEASE     type DWORD value('00000002'xu);
 dcl VS_FF_PATCHED        type DWORD value('00000004'xu);
 dcl VS_FF_PRIVATEBUILD   type DWORD value('00000008'xu);
 dcl VS_FF_INFOINFERRED   type DWORD value('00000010'xu);
 dcl VS_FF_SPECIALBUILD   type DWORD value('00000020'xu);

 /* ----- VS_VERSION.dwFileOS ----- */
 dcl VOS_UNKNOWN          type DWORD value('00000000'xu);
 dcl VOS_DOS              type DWORD value('00010000'xu);
 dcl VOS_OS216            type DWORD value('00020000'xu);
 dcl VOS_OS232            type DWORD value('00030000'xu);
 dcl VOS_NT               type DWORD value('00040000'xu);

 dcl VOS__BASE            type DWORD value('00000000'xu);
 dcl VOS__WINDOWS16       type DWORD value('00000001'xu);
 dcl VOS__PM16            type DWORD value('00000002'xu);
 dcl VOS__PM32            type DWORD value('00000003'xu);
 dcl VOS__WINDOWS32       type DWORD value('00000004'xu);

 dcl VOS_DOS_WINDOWS16    type DWORD value('00010001'xu);
 dcl VOS_DOS_WINDOWS32    type DWORD value('00010004'xu);
 dcl VOS_OS216_PM16       type DWORD value('00020002'xu);
 dcl VOS_OS232_PM32       type DWORD value('00030003'xu);
 dcl VOS_NT_WINDOWS32     type DWORD value('00040004'xu);

 /* ----- VS_VERSION.dwFileType ----- */
 dcl VFT_UNKNOWN          type DWORD value('00000000'xu);
 dcl VFT_APP              type DWORD value('00000001'xu);
 dcl VFT_DLL              type DWORD value('00000002'xu);
 dcl VFT_DRV              type DWORD value('00000003'xu);
 dcl VFT_FONT             type DWORD value('00000004'xu);
 dcl VFT_VXD              type DWORD value('00000005'xu);
 dcl VFT_STATIC_LIB       type DWORD value('00000007'xu);

 /* ----- VS_VERSION.dwFileSubtype for VFT_WINDOWS_DRV ----- */
 dcl VFT2_UNKNOWN         type DWORD value('00000000'xu);
 dcl VFT2_DRV_PRINTER     type DWORD value('00000001'xu);
 dcl VFT2_DRV_KEYBOARD    type DWORD value('00000002'xu);
 dcl VFT2_DRV_LANGUAGE    type DWORD value('00000003'xu);
 dcl VFT2_DRV_DISPLAY     type DWORD value('00000004'xu);
 dcl VFT2_DRV_MOUSE       type DWORD value('00000005'xu);
 dcl VFT2_DRV_NETWORK     type DWORD value('00000006'xu);
 dcl VFT2_DRV_SYSTEM      type DWORD value('00000007'xu);
 dcl VFT2_DRV_INSTALLABLE type DWORD value('00000008'xu);
 dcl VFT2_DRV_SOUND       type DWORD value('00000009'xu);
 dcl VFT2_DRV_COMM        type DWORD value('0000000A'xu);
 dcl VFT2_DRV_INPUTMETHOD type DWORD value('0000000B'xu);

 /* ----- VS_VERSION.dwFileSubtype for VFT_WINDOWS_FONT ----- */
 dcl VFT2_FONT_RASTER     type DWORD value('00000001'xu);
 dcl VFT2_FONT_VECTOR     type DWORD value('00000002'xu);
 dcl VFT2_FONT_TRUETYPE   type DWORD value('00000003'xu);

 /* ----- VerFindFile() flags ----- */
 dcl VFFF_ISSHAREDFILE    type DWORD value('0001'xu);

 dcl VFF_CURNEDEST        type DWORD value('0001'xu);
 dcl VFF_FILEINUSE        type DWORD value('0002'xu);
 dcl VFF_BUFFTOOSMALL     type DWORD value('0004'xu);

 /* ----- VerInstallFile() flags ----- */
 dcl VIFF_FORCEINSTALL    type DWORD value('0001'xu);
 dcl VIFF_DONTDELETEOLD   type DWORD value('0002'xu);

 dcl VIF_TEMPFILE         type DWORD value('00000001'xu);
 dcl VIF_MISMATCH         type DWORD value('00000002'xu);
 dcl VIF_SRCOLD           type DWORD value('00000004'xu);

 dcl VIF_DIFFLANG         type DWORD value('00000008'xu);
 dcl VIF_DIFFCODEPG       type DWORD value('00000010'xu);
 dcl VIF_DIFFTYPE         type DWORD value('00000020'xu);

 dcl VIF_WRITEPROT        type DWORD value('00000040'xu);
 dcl VIF_FILEINUSE        type DWORD value('00000080'xu);
 dcl VIF_OUTOFSPACE       type DWORD value('00000100'xu);
 dcl VIF_ACCESSVIOLATION  type DWORD value('00000200'xu);
 dcl VIF_SHARINGVIOLATION type DWORD value('00000400'xu);
 dcl VIF_CANNOTCREATE     type DWORD value('00000800'xu);
 dcl VIF_CANNOTDELETE     type DWORD value('00001000'xu);
 dcl VIF_CANNOTRENAME     type DWORD value('00002000'xu);
 dcl VIF_CANNOTDELETECUR  type DWORD value('00004000'xu);
 dcl VIF_OUTOFMEMORY      type DWORD value('00008000'xu);

 dcl VIF_CANNOTREADSRC    type DWORD value('00010000'xu);
 dcl VIF_CANNOTREADDST    type DWORD value('00020000'xu);

 dcl VIF_BUFFTOOSMALL     type DWORD value('00040000'xu);

 /* ----- Types and structures ----- */

 define structure
   1 VS_FIXEDFILEINFO,
     2 dwSignature        type DWORD,/* e.g. 0xfeef04bd */
     2 dwStrucVersion     type DWORD,/* e.g. 0x00000042 = "0.42" */
     2 dwFileVersionMS    type DWORD,/* e.g. 0x00030075 = "3.75" */
     2 dwFileVersionLS    type DWORD,/* e.g. 0x00000031 = "0.31" */
     2 dwProductVersionMS type DWORD,/* e.g. 0x00030010 = "3.10" */
     2 dwProductVersionLS type DWORD,/* e.g. 0x00000031 = "0.31" */
     2 dwFileFlagsMask    type DWORD,/* = 0x3F for version "0.42" */
     2 dwFileFlags        type DWORD,
                          /* e.g. ior (VFF_DEBUG, VFF_PRERELEASE) */
     2 dwFileOS           type DWORD,/* e.g. VOS_DOS_WINDOWS16 */
     2 dwFileType         type DWORD,/* e.g. VFT_DRIVER */
     2 dwFileSubtype      type DWORD,/* e.g. VFT2_DRV_KEYBOARD */
     2 dwFileDateMS       type DWORD,/* e.g. 0 */
     2 dwFileDateLS       type DWORD;/* e.g. 0 */

 /* ----- Function prototypes ----- */

 dcl VerFindFileA
     entry (type DWORD,
            char (*) varz byaddr,
            char (*) varz byaddr,
            char (*) varz byaddr,
            char (*) varz byaddr,
            type UINT byaddr,
            char (*) varz byaddr,
            type UINT byaddr)
     returns (type DWORD byvalue optional)
     APIENTRY external('VerFindFileA');
 dcl VerFindFileW
     entry (type DWORD,
            WCHAR (*) varz byaddr,
            WCHAR (*) varz byaddr,
            WCHAR (*) varz byaddr,
            WCHAR (*) varz byaddr,
            type UINT byaddr,
            WCHAR (*) varz byaddr,
            type UINT byaddr)
     returns (type DWORD byvalue optional)
     APIENTRY external('VerFindFileW');

 %dcl VerFindFile char ext;
 %if UNICODE ^= '' %then %do;
   %VerFindFile='VerFindFileW';
 %end; %else %do;
   %VerFindFile='VerFindFileA';
 %end; /* !UNICODE */

 dcl VerInstallFileA
     entry (type DWORD,
            char (*) varz byaddr,
            char (*) varz byaddr,
            char (*) varz byaddr,
            char (*) varz byaddr,
            char (*) varz byaddr,
            char (*) varz byaddr,
            type UINT byaddr)
     returns (type DWORD byvalue optional)
     APIENTRY external('VerInstallFileA');
 dcl VerInstallFileW
     entry (type DWORD,
            WCHAR (*) varz byaddr,
            WCHAR (*) varz byaddr,
            WCHAR (*) varz byaddr,
            WCHAR (*) varz byaddr,
            WCHAR (*) varz byaddr,
            WCHAR (*) varz byaddr,
            type UINT byaddr)
     returns (type DWORD byvalue optional)
     APIENTRY external('VerInstallFileW');

 %dcl VerInstallFile char ext;
 %if UNICODE ^= '' %then %do;
   %VerInstallFile='VerInstallFileW';
 %end; %else %do;
   %VerInstallFile='VerInstallFileA';
 %end; /* !UNICODE */

 /* Returns size of version info in bytes */
 dcl GetFileVersionInfoSizeA
     entry (char (*) varz byaddr, /* Filename of version stamped file */
            type DWORD byaddr)  /* Info for use by GetFileVersionInfo */
     returns (type DWORD byvalue optional)
     APIENTRY external('GetFileVersionInfoSizeA');
 /* Returns size of version info in bytes */
 dcl GetFileVersionInfoSizeW
     entry (WCHAR (*) varz byaddr, /* Filename of version stamped file*/
            type DWORD byaddr)  /* Info for use by GetFileVersionInfo */
     returns (type DWORD byvalue optional)
     APIENTRY external('GetFileVersionInfoSizeW');

 %dcl GetFileVersionInfoSize char ext;
 %if UNICODE ^= '' %then %do;
   %GetFileVersionInfoSize='GetFileVersionInfoSizeW';
 %end; %else %do;
   %GetFileVersionInfoSize='GetFileVersionInfoSizeA';
 %end; /* !UNICODE */

 /* Read version info into buffer */
 dcl GetFileVersionInfoA
     entry (char (*) varz byaddr, /* Filename of version stamped file */
            type DWORD,  /* Information from GetFileVersionSize */
            type DWORD,  /* Length of buffer for info */
            type LPVOID) /* Buffer to place the data structure */
     returns (type BOOL byvalue optional)
     APIENTRY external('GetFileVersionInfoA');
 /* Read version info into buffer */
 dcl GetFileVersionInfoW
     entry (WCHAR (*) varz byaddr, /* Filename of version stamped file*/
            type DWORD,  /* Information from GetFileVersionSize */
            type DWORD,  /* Length of buffer for info */
            type LPVOID) /* Buffer to place the data structure */
     returns (type BOOL byvalue optional)
     APIENTRY external('GetFileVersionInfoW');

 %dcl GetFileVersionInfo char ext;
 %if UNICODE ^= '' %then %do;
   %GetFileVersionInfo='GetFileVersionInfoW';
 %end; %else %do;
   %GetFileVersionInfo='GetFileVersionInfoA';
 %end; /* !UNICODE */

 dcl VerLanguageNameA
     entry (type DWORD,
            char (*) varz byaddr,
            type DWORD)
     returns (type DWORD byvalue optional)
     APIENTRY external('VerLanguageNameA');
 dcl VerLanguageNameW
     entry (type DWORD,
            WCHAR (*) varz byaddr,
            type DWORD)
     returns (type DWORD byvalue optional)
     APIENTRY external('VerLanguageNameW');

 %dcl VerLanguageName char ext;
 %if UNICODE ^= '' %then %do;
   %VerLanguageName='VerLanguageNameW';
 %end; %else %do;
   %VerLanguageName='VerLanguageNameA';
 %end; /* !UNICODE */

 dcl VerQueryValueA
     entry (type LPVOID,
            char (*) varz byaddr,
            type LPVOID byaddr,
            type UINT byaddr)
     returns (type BOOL byvalue optional)
     APIENTRY external('VerQueryValueA');
 dcl VerQueryValueW
     entry (type LPVOID,
            WCHAR (*) varz byaddr,
            type LPVOID byaddr,
            type UINT byaddr)
     returns (type BOOL byvalue optional)
     APIENTRY external('VerQueryValueW');

 %dcl VerQueryValue char ext;
 %if UNICODE ^= '' %then %do;
   %VerQueryValue='VerQueryValueW';
 %end; %else %do;
   %VerQueryValue='VerQueryValueA';
 %end; /* !UNICODE */

 %end; /* !VER_H */
