 /*********************************************************/
 /*  CREATED BY C2PLI CONVERSION UTILITY                  */
 /*********************************************************/
  /******************************************************************/
  /* This include file is used by DB2API1.PLI, DB2API2.PLI,         */
  /*   DB2API3.PLI and DB2API4.PLI.                                 */
  /*                                                                */
  /*  The samples DB2API1,DB2API2,DB2API3 and DB2API4 must be       */
  /*  compiled and run in sequence to work correctly.               */
  /*  Compile, link and run each sample before going on to the      */
  /*  next sample. (You must have created SAMPLE database for       */
  /*  the PLI SQL pre-processor to work).                           */
  /*                                                                */
  /* For more information on the DB/2 APIs, refer to                */
  /* DB2/2 Programming Reference                                    */
  /******************************************************************/
  /******************************************************************/
  /*                                                                */
  /*                                                                */
  /*   (C) Copyright IBM Corp. 1992 - 1996. All Rights Reserved.    */
  /*   US Government Users Restricted Rights-- Use, duplication or  */
  /*   disclosure restricted by GSA ADP Schedule Contract with      */
  /*   IBM Corp.                                                    */
  /*                                                                */
  /* DISCLAIMER OF WARRANTIES                                       */
  /*   The following enclosed code is sample code created by IBM  */
  /*   Corporation. This sample code is not part of any standard    */
  /*   IBM product and is provided to you solely for the purpose of */
  /*   assisting you in the development of your applications.  The  */
  /*   code is provided "AS IS", without warranty of any kind.      */
  /*   IBM shall not be liable for any damages arising out of your  */
  /*   use of the sample code, even if IBM has been advised of the  */
  /*   possibility of such damages.                                 */
  /*                                                                */
  /*                                                                */
  /*                                                                */
  /******************************************************************/

 /* Operating System Control Parameters */


    %dcl SQL_API_RC char ext;
    %if SQL_API_RC = '' %then %do;

       %SQL_API_RC = 'fixed bin(31)';

       %dcl SQL_API_FN char scan;
       %SQL_API_FN = 'options(byvalue linkage(system) nodescriptor) ';

    %end;

 /* Define aliases */
 define alias double real float bin(53);


 /* tableSpace container descriptor */
 define structure
   1 SQLETSCDESC,
        2 sqlctype char,                           /* container type */
        2 pad1 char(3),                                /* reserved */
        2 sqlcsize fixed bin(31),              /* container size (4K */
                                                           /* pages) */
        2 sqlclen fixed bin(15),              /* length of container */
                                                             /* name */
       2 sqlcontr char(256),
                                                   /* container name */
                                             /* (includes 1 byte for */
                                               /* C NULL terminator) */
        2 pad2 char(2);                         /* 2 bytes padding */
                                                      /* before next */
                                                        /* container */

 define structure
   1 sqledbdesc,
        2 sqldbdid char(8),                         /* eye catcher */
        2 sqldbccp fixed bin(31),               /* comment code page */
        2 sqldbcss fixed bin(31),             /* Source of collating */
                                                              /* seq */
        2 sqldbudc char(256),                      /* user-defined */
                                                    /* collating seq */
        2 sqldbcmt char(30),                            /* comment */
        2 pad char(1),                                 /* reserved */
        2 sqldbsgp unsigned fixed bin(31) ,         /* obsolete: use */
                                                         /* sqltsext */
        2 sqldbnsg fixed bin(15),              /* number of segments */
        2 pad2 char(2),                                /* reserved */
        2 sqltsext fixed bin(31),             /* default extent size */
       2 sqlcatts handle SQLETSDESC,
       2 sqlusrts handle SQLETSDESC,
       2 sqltmpts handle SQLETSDESC;


 /* tableSpace descriptor */
 define structure
   1 SQLETSDESC,
        2 sqltsdid char(8),                          /* eyecatcher */
                                               /* descriptor version */
        2 sqlextnt fixed bin(31),              /* extent size (in 4K */
                                                           /* pages) */
        2 sqlprftc fixed bin(31),               /* prefetch size (4K */
                                                           /* pages) */
        2 sqlpovhd type double,                      /* i/o overhead */
        2 sqltrfrt type double,                 /* i/o transfer rate */
        2 sqltstyp char,                          /* tableSpace type */
        2 pad1 char,                                     /* reserved */
        2 sqlccnt fixed bin(15),                  /* container count */
        2 containr dim(0:1-1) type SQLETSCDESC;/* array of container */
                                                            /* specs */


                                    /* Start Database Manager        */
 dcl   sqlgstar  entry (  )
          returns( byvalue optional  SQL_API_RC )
            SQL_API_FN external;

                                    /* Create Database               */
 dcl   sqlgcrea  entry (
        unsigned fixed bin(16),     /* drive/path length             */
        unsigned fixed bin(16),     /* local alias length            */
        unsigned fixed bin(16),     /* database length               */
        pointer,                    /* SQLCA                         */
        pointer,                    /* reserved                      */
        unsigned fixed bin(16),     /* reserved                      */
        pointer,                    /* db locale and codeset     */
        handle sqledbdesc,          /* db description block          */
        pointer,                    /* drive/path                    */
        pointer,                    /* local alias                   */
         pointer)                   /* database                      */
          returns( byvalue optional  SQL_API_RC )
           SQL_API_FN external;

                                    /* Restart Database              */
 dcl   sqlgrstd  entry (
        unsigned fixed bin(16),     /* password length               */
        unsigned fixed bin(16),     /* user name length              */
        unsigned fixed bin(16),     /* database alias length         */
        pointer,                    /* SQLCA                         */
        pointer,                    /* password                      */
        pointer,                    /* user name                     */
         pointer)                   /* database alias                */
          returns( byvalue optional  SQL_API_RC )
           SQL_API_FN external;


                                  /* Get Error Message               */
    dcl   sqlgintp  entry (
           fixed bin(15),         /* buffer size                     */
           fixed bin(15),         /* line width                      */
           pointer,               /* SQLCA                           */
            pointer)              /* buffer                          */
             returns( byvalue optional SQL_API_RC )
              SQL_API_FN external;


                                    /* Stop Database Manager         */
 dcl   sqlgstdm  entry (
         pointer )                  /* SQLCA                         */
          returns( byvalue optional  SQL_API_RC )
           SQL_API_FN external;


                                    /* Drop Database                 */
 dcl   sqlgdrpd  entry (
        unsigned fixed bin(16),     /* reserved                      */
        unsigned fixed bin(16),     /* database alias length         */
        pointer,                    /* SQLCA                         */
        pointer,                    /* reserved                      */
         pointer)                   /* database alias                */
          returns( byvalue optional  SQL_API_RC )
           SQL_API_FN external;

