 /* ++                                                                */
 /*                                                                   */
 /* Copyright (c) 1995-1999 Microsoft Corporation                     */
 /*                                                                   */
 /* Module Name:                                                      */
 /*                                                                   */
 /*   setupapi.cpy                                                    */
 /*                                                                   */
 /* Abstract:                                                         */
 /*                                                                   */
 /*   Public header file for Windows NT Setup and Device Installer    */
 /*   services Dll.                                                   */
 /*                                                                   */
 /* --                                                                */

 %dcl #INC_SETUPAPI char ext;
 %if #INC_SETUPAPI = '' %then %do;
 %#INC_SETUPAPI = 'Y';

 %dcl UNICODE char ext;


 /* Define API decoration for direct importing of DLL references. */

 %dcl WINSETUPAPI char ext;
 %WINSETUPAPI = '';

 %dcl #_LPGUID_DEFINED__ char ext;
 %if #_LPGUID_DEFINED__ = '' %then %do;
 %#_LPGUID_DEFINED__ = 'Y';
 define alias LPGUID handle GUID;
 %end;

 /* Pull in WINREG.CPY (includes WINBASE.CPY) if necessary */
 %dcl #WINREG_ char ext;
 %if #WINREG_ = '' %then %do;
   %include winreg;
 %end;

 %dcl #WINUSER_ char ext;
 %if #WINUSER_ = '' %then %do;
 %include winuser;
 %end;


 /* Include commctrl.cpy for our use of HIMAGELIST and wizard support.*/

 %dcl #INC_COMMCTRL char ext;
 %if #INC_COMMCTRL = '' %then %do;
 %include commctrl;
 %end;


 /* Define maximum string length constants as specified by */
 /* Windows 95. */

 dcl LINE_LEN              fixed bin(31) value(256);
     /* Win95-compatible maximum for displayable */
     /* strings coming from a device INF.        */
 dcl MAX_INF_STRING_LENGTH fixed bin(31) value(4096);
     /* Actual maximum size of an INF string */
     /* (including string substitutions).    */
 dcl MAX_TITLE_LEN         fixed bin(31) value(60);
 dcl MAX_INSTRUCTION_LEN   fixed bin(31) value(256);
 dcl MAX_LABEL_LEN         fixed bin(31) value(30);
 dcl MAX_SERVICE_NAME_LEN  fixed bin(31) value(256);
 dcl MAX_SUBTITLE_LEN      fixed bin(31) value(256);


 /* Define maximum length of a machine name in the format expected by */
 /* ConfigMgr32                                                       */
 /* CM_Connect_Machine (i.e., "\\MachineName\0").                     */

 dcl SP_MAX_MACHINENAME_LENGTH fixed bin(31)
     value(MAX_COMPUTERNAME_LENGTH + 3);

 /* Define type for reference to loaded inf file */

 define alias HINF type PVOID;

 /* Inf context structure. Applications must not interpret or */
 /* overwrite values in these structures. */

 define structure
   1 INFCONTEXT,
     2 Inf        type PVOID,
     2 CurrentInf type PVOID,
     2 Section    type UINT,
     2 Line       type UINT;
 define alias PINFCONTEXT handle INFCONTEXT;


 /* Inf file information structure. */

 define structure
   1 SP_INF_INFORMATION,
     2 InfStyle    type DWORD,
     2 InfCount    type DWORD,
     2 VersionData (ANYSIZE_ARRAY) type BYTE;
 define alias PSP_INF_INFORMATION handle SP_INF_INFORMATION;


 /* Define structure for passing alternate platform info into */
 /* SetupSetFileQueueAlternatePlatform and                    */
 /* SetupQueryInfOriginalFileInformation.                     */

 define structure
   1 SP_ALTPLATFORM_INFO,
     2 cbSize                type DWORD,
       /* platform to use (VER_PLATFORM_WIN32_WINDOWS */
       /* or VER_PLATFORM_WIN32_NT)                   */
     2 Platform              type DWORD,
       /* major and minor version numbers to use */
     2 MajorVersion          type DWORD,
     2 MinorVersion          type DWORD,
       /* processor architecture to use (PROCESSOR_ARCHITECTURE_INTEL,*/
       /* PROCESSOR_ARCHITECTURE_ALPHA, PROCESSOR_ARCHITECTURE_IA64,  */
       /* or PROCESSOR_ARCHITECTURE_ALPHA64)                          */
     2 ProcessorArchitecture type WORD,
     2 Reserved              type WORD;/* must be zero. */
 define alias PSP_ALTPLATFORM_INFO handle SP_ALTPLATFORM_INFO;


 /* Define structure that is filled in by                      */
 /* SetupQueryInfOriginalFileInformation to indicate the INF's */
 /* original name and the original name of the (potentially    */
 /* platform-specific) catalog file specified by that INF.     */

 define structure
   1 SP_ORIGINAL_FILE_INFO_A,
     2 cbSize              type DWORD,
     2 OriginalInfName     char (MAX_PATH-1) varz,
     2 OriginalCatalogName char (MAX_PATH-1) varz;
 define alias PSP_ORIGINAL_FILE_INFO_A handle SP_ORIGINAL_FILE_INFO_A;

 define structure
   1 SP_ORIGINAL_FILE_INFO_W,
     2 cbSize              type DWORD,
     2 OriginalInfName     WCHAR (MAX_PATH-1) varz,
     2 OriginalCatalogName WCHAR (MAX_PATH-1) varz;
 define alias PSP_ORIGINAL_FILE_INFO_W handle SP_ORIGINAL_FILE_INFO_W;


 %if UNICODE ^= '' %then %do;
 define alias  SP_ORIGINAL_FILE_INFO type  SP_ORIGINAL_FILE_INFO_W;
 define alias PSP_ORIGINAL_FILE_INFO type PSP_ORIGINAL_FILE_INFO_W;
 %end; %else %do;
 define alias  SP_ORIGINAL_FILE_INFO type  SP_ORIGINAL_FILE_INFO_A;
 define alias PSP_ORIGINAL_FILE_INFO type PSP_ORIGINAL_FILE_INFO_A;
 %end;


 /* SP_INF_INFORMATION.InfStyle values */

 dcl INF_STYLE_NONE  type DWORD value('00000000'xu);
     /* unrecognized or non-existent */
 dcl INF_STYLE_OLDNT type DWORD value('00000001'xu);
     /* winnt 3.x */
 dcl INF_STYLE_WIN4  type DWORD value('00000002'xu);
     /* Win95 */


 /* Additional InfStyle flags that may be specified when calling */
 /* SetupOpenInfFile.                                            */

 dcl INF_STYLE_CACHE_ENABLE  type DWORD value('00000010'xu);
     /* always cache INF, even outside of %windir%\Inf */
 dcl INF_STYLE_CACHE_DISABLE type DWORD value('00000020'xu);
     /* delete cached INF information */


 /* Target directory specs. */

 dcl DIRID_ABSOLUTE         fixed bin(31) value(-1);
    /* real 32-bit -1 */
 dcl DIRID_ABSOLUTE_16BIT   fixed bin(16) unsigned value('ffff'xu);
    /* 16-bit -1 for compat w/setupx */
 dcl DIRID_NULL             fixed bin(16) unsigned value(0);
 dcl DIRID_SRCPATH          fixed bin(16) unsigned value(1);
 dcl DIRID_WINDOWS          fixed bin(16) unsigned value(10);
 dcl DIRID_SYSTEM           fixed bin(16) unsigned value(11);
    /* system32 */
 dcl DIRID_DRIVERS          fixed bin(16) unsigned value(12);
 dcl DIRID_IOSUBSYS         fixed bin(16) unsigned value(DIRID_DRIVERS);
 dcl DIRID_INF              fixed bin(16) unsigned value(17);
 dcl DIRID_HELP             fixed bin(16) unsigned value(18);
 dcl DIRID_FONTS            fixed bin(16) unsigned value(20);
 dcl DIRID_VIEWERS          fixed bin(16) unsigned value(21);
 dcl DIRID_COLOR            fixed bin(16) unsigned value(23);
 dcl DIRID_APPS             fixed bin(16) unsigned value(24);
 dcl DIRID_SHARED           fixed bin(16) unsigned value(25);
 dcl DIRID_BOOT             fixed bin(16) unsigned value(30);

 dcl DIRID_SYSTEM16         fixed bin(16) unsigned value(50);
 dcl DIRID_SPOOL            fixed bin(16) unsigned value(51);
 dcl DIRID_SPOOLDRIVERS     fixed bin(16) unsigned value(52);
 dcl DIRID_USERPROFILE      fixed bin(16) unsigned value(53);
 dcl DIRID_LOADER           fixed bin(16) unsigned value(54);
 dcl DIRID_PRINTPROCESSOR   fixed bin(16) unsigned value(55);

 dcl DIRID_DEFAULT          fixed bin(16) unsigned value(DIRID_SYSTEM);

 /* The following DIRIDs are for commonly-used shell                  */
 /* "special folders". The complete list of such folders is contained */
 /* in shlobj.h.  In that headerfile, each folder is assigned a       */
 /* CSIDL_* value.  The DIRID values below are created by taking the  */
 /* CSIDL value in shlobj.h and OR'ing it with 0x4000. Thus, if an    */
 /* INF needs to reference other special folders not defined below,   */
 /* it may generate one using the above mechanism, and setupapi will  */
 /* automatically deal with it and use the corresponding shell's path */
 /* where appropriate. (Remember that DIRIDs must be specified in     */
 /* decimal, not hex, in an INF when used for string substitution.)   */

 dcl DIRID_COMMON_STARTMENU        fixed bin(16) unsigned value(16406);
     /* All Users\Start Menu */
 dcl DIRID_COMMON_PROGRAMS         fixed bin(16) unsigned value(16407);
     /* All Users\Start Menu\Programs */
 dcl DIRID_COMMON_STARTUP          fixed bin(16) unsigned value(16408);
     /* All Users\Start Menu\Programs\Startup */
 dcl DIRID_COMMON_DESKTOPDIRECTORY fixed bin(16) unsigned value(16409);
     /* All Users\Desktop */
 dcl DIRID_COMMON_FAVORITES        fixed bin(16) unsigned value(16415);
     /* All Users\Favorites */
 dcl DIRID_COMMON_APPDATA          fixed bin(16) unsigned value(16419);
     /* All Users\Application Data */

 dcl DIRID_PROGRAM_FILES           fixed bin(16) unsigned value(16422);
     /* Program Files */
 dcl DIRID_PROGRAM_FILES_COMMON    fixed bin(16) unsigned value(16427);
     /* Program Files\Common */
 dcl DIRID_PROGRAM_FILES_COMMONX86 fixed bin(16) unsigned value(16428);
     /* x86 Program Files\Common on RISC */

 dcl DIRID_COMMON_TEMPLATES        fixed bin(16) unsigned value(16429);
     /* All Users\Templates */
 dcl DIRID_COMMON_DOCUMENTS        fixed bin(16) unsigned value(16430);
     /* All Users\Documents */

 /* First user-definable dirid. See SetupSetDirectoryId(). */
 dcl DIRID_USER                  fixed bin(16) unsigned value('8000'xu);


 /* Setup callback notification routine type */

 define alias PSP_FILE_CALLBACK_A
        entry (type PVOID,
               type UINT,
               type UINT_PTR,
               type UINT_PTR)
        returns (type UINT byvalue optional)
        limited CALLBACK;

 define alias PSP_FILE_CALLBACK_W
        entry (type PVOID,
               type UINT,
               type UINT_PTR,
               type UINT_PTR)
        returns (type UINT byvalue optional)
        limited CALLBACK;

 %if UNICODE ^= '' %then %do;
 define alias PSP_FILE_CALLBACK type PSP_FILE_CALLBACK_W;
 %end; %else %do;
 define alias PSP_FILE_CALLBACK type PSP_FILE_CALLBACK_A;
 %end;


 /* Operation/queue start/end notification. These are ordinal values. */

 dcl SPFILENOTIFY_STARTQUEUE      type UINT value('00000001'xu);
 dcl SPFILENOTIFY_ENDQUEUE        type UINT value('00000002'xu);
 dcl SPFILENOTIFY_STARTSUBQUEUE   type UINT value('00000003'xu);
 dcl SPFILENOTIFY_ENDSUBQUEUE     type UINT value('00000004'xu);
 dcl SPFILENOTIFY_STARTDELETE     type UINT value('00000005'xu);
 dcl SPFILENOTIFY_ENDDELETE       type UINT value('00000006'xu);
 dcl SPFILENOTIFY_DELETEERROR     type UINT value('00000007'xu);
 dcl SPFILENOTIFY_STARTRENAME     type UINT value('00000008'xu);
 dcl SPFILENOTIFY_ENDRENAME       type UINT value('00000009'xu);
 dcl SPFILENOTIFY_RENAMEERROR     type UINT value('0000000a'xu);
 dcl SPFILENOTIFY_STARTCOPY       type UINT value('0000000b'xu);
 dcl SPFILENOTIFY_ENDCOPY         type UINT value('0000000c'xu);
 dcl SPFILENOTIFY_COPYERROR       type UINT value('0000000d'xu);
 dcl SPFILENOTIFY_NEEDMEDIA       type UINT value('0000000e'xu);
 dcl SPFILENOTIFY_QUEUESCAN       type UINT value('0000000f'xu);

 /* These are used with SetupIterateCabinet(). */

 dcl SPFILENOTIFY_CABINETINFO     type DWORD value('00000010'xu);
 dcl SPFILENOTIFY_FILEINCABINET   type DWORD value('00000011'xu);
 dcl SPFILENOTIFY_NEEDNEWCABINET  type DWORD value('00000012'xu);
 dcl SPFILENOTIFY_FILEEXTRACTED   type DWORD value('00000013'xu);
 dcl SPFILENOTIFY_FILEOPDELAYED   type DWORD value('00000014'xu);

 /* These are used for backup operations */

 dcl SPFILENOTIFY_STARTBACKUP     type DWORD value('00000015'xu);
 dcl SPFILENOTIFY_BACKUPERROR     type DWORD value('00000016'xu);
 dcl SPFILENOTIFY_ENDBACKUP       type DWORD value('00000017'xu);

 /* Extended notification for SetupScanFileQueue */
 /* (Flags=SPQ_SCAN_USE_CALLBACKEX)              */

 dcl SPFILENOTIFY_QUEUESCAN_EX    type DWORD value('00000018'xu);

 /* Copy notification. These are bit flags that may be combined. */

 dcl SPFILENOTIFY_LANGMISMATCH    type DWORD value('00010000'xu);
 dcl SPFILENOTIFY_TARGETEXISTS    type DWORD value('00020000'xu);
 dcl SPFILENOTIFY_TARGETNEWER     type DWORD value('00040000'xu);


 /* File operation codes and callback outcomes. */

 dcl FILEOP_COPY                  fixed bin(31) value(0);
 dcl FILEOP_RENAME                fixed bin(31) value(1);
 dcl FILEOP_DELETE                fixed bin(31) value(2);
 dcl FILEOP_BACKUP                fixed bin(31) value(3);

 dcl FILEOP_ABORT                 fixed bin(31) value(0);
 dcl FILEOP_DOIT                  fixed bin(31) value(1);
 dcl FILEOP_SKIP                  fixed bin(31) value(2);
 dcl FILEOP_RETRY                 fixed bin(31) value(FILEOP_DOIT);
 dcl FILEOP_NEWPATH               fixed bin(31) value(4);

 /* Flags in inf copy sections */

 dcl COPYFLG_WARN_IF_SKIP         type DWORD value('00000001'xu);
     /* warn if user tries to skip file */
 dcl COPYFLG_NOSKIP               type DWORD value('00000002'xu);
     /* disallow skipping this file */
 dcl COPYFLG_NOVERSIONCHECK       type DWORD value('00000004'xu);
     /* ignore versions and overwrite target */
 dcl COPYFLG_FORCE_FILE_IN_USE    type DWORD value('00000008'xu);
     /* force file-in-use behavior */
 dcl COPYFLG_NO_OVERWRITE         type DWORD value('00000010'xu);
     /* do not copy if file exists on target */
 dcl COPYFLG_NO_VERSION_DIALOG    type DWORD value('00000020'xu);
     /* do not copy if target is newer */
 dcl COPYFLG_OVERWRITE_OLDER_ONLY type DWORD value('00000040'xu);
     /* leave target alone if version same as source */
 dcl COPYFLG_REPLACEONLY          type DWORD value('00000400'xu);
     /* copy only if file exists on target */
 dcl COPYFLG_NODECOMP             type DWORD value('00000800'xu);
     /* don't attempt to decompress file; copy as-is */
 dcl COPYFLG_REPLACE_BOOT_FILE    type DWORD value('00001000'xu);
     /* file must be present upon reboot (i.e., it's */
     /* needed by the loader); this flag implies a reboot */
 dcl COPYFLG_NOPRUNE              type DWORD value('00002000'xu);
     /* never prune this file */


 /* Flags in inf delete sections */
 /* New flags go in high word */

 dcl DELFLG_IN_USE                type DWORD value('00000001'xu);
     /* queue in-use file for delete */
 dcl DELFLG_IN_USE1               type DWORD value('00010000'xu);
     /* high-word version of DELFLG_IN_USE */


 /* Source and file paths.                                            */
 /* Used when notifying queue callback of SPFILENOTIFY_STARTxxx,      */
 /* SPFILENOTIFY_ENDxxx, and SPFILENOTIFY_xxxERROR.                   */

 define structure
   1 FILEPATHS_A,
     2 Target     type PCSTR,
     2 Source     type PCSTR,/* not used for delete operations */
     2 Win32Error type UINT,
     2 Flags      type DWORD;/* such as SP_COPY_NOSKIP for copy errors*/
 define alias PFILEPATHS_A handle FILEPATHS_A;

 define structure
   1 FILEPATHS_W,
     2 Target     type PCWSTR,
     2 Source     type PCWSTR,/* not used for delete operations */
     2 Win32Error type UINT,
     2 Flags      type DWORD;/* such as SP_COPY_NOSKIP for copy errors*/
 define alias PFILEPATHS_W handle FILEPATHS_W;


 %if UNICODE ^= '' %then %do;
 define alias  FILEPATHS type  FILEPATHS_W;
 define alias PFILEPATHS type PFILEPATHS_W;
 %end; %else %do;
 define alias  FILEPATHS type  FILEPATHS_A;
 define alias PFILEPATHS type PFILEPATHS_A;
 %end;


 /* Structure used with SPFILENOTIFY_NEEDMEDIA */

 define structure
   1 SOURCE_MEDIA_A,
     2 Reserved    type PCSTR,
     2 Tagfile     type PCSTR,/* may be SYSNULL */
     2 Description type PCSTR,
     /* Pathname part and filename part of source file */
     /* that caused us to need the media. */
     2 SourcePath  type PCSTR,
     2 SourceFile  type PCSTR,
     2 Flags       type DWORD;/* subset of SP_COPY_xxx */
 define alias PSOURCE_MEDIA_A handle SOURCE_MEDIA_A;

 define structure
   1 SOURCE_MEDIA_W,
     2 Reserved    type PCWSTR,
     2 Tagfile     type PCWSTR,/* may be SYSNULL */
     2 Description type PCWSTR,
     /* Pathname part and filename part of source file */
     /* that caused us to need the media. */
     2 SourcePath  type PCWSTR,
     2 SourceFile  type PCWSTR,
     2 Flags       type DWORD;/* subset of SP_COPY_xxx */
 define alias PSOURCE_MEDIA_W handle SOURCE_MEDIA_W;

 %if UNICODE ^= '' %then %do;
 define alias  SOURCE_MEDIA type  SOURCE_MEDIA_W;
 define alias PSOURCE_MEDIA type PSOURCE_MEDIA_W;
 %end; %else %do;
 define alias  SOURCE_MEDIA type  SOURCE_MEDIA_A;
 define alias PSOURCE_MEDIA type PSOURCE_MEDIA_A;
 %end;

 /* Structure used with SPFILENOTIFY_CABINETINFO and */
 /* SPFILENOTIFY_NEEDNEWCABINET                      */

 define structure
   1 CABINET_INFO_A,
     2 CabinetPath   type PCSTR,
     2 CabinetFile   type PCSTR,
     2 DiskName      type PCSTR,
     2 SetId         type USHORT,
     2 CabinetNumber type USHORT;
 define alias PCABINET_INFO_A handle CABINET_INFO_A;

 define structure
   1 CABINET_INFO_W,
     2 CabinetPath   type PCWSTR,
     2 CabinetFile   type PCWSTR,
     2 DiskName      type PCWSTR,
     2 SetId         type USHORT,
     2 CabinetNumber type USHORT;
 define alias PCABINET_INFO_W handle CABINET_INFO_W;

 %if UNICODE ^= '' %then %do;
 define alias  CABINET_INFO type  CABINET_INFO_W;
 define alias PCABINET_INFO type PCABINET_INFO_W;
 %end; %else %do;
 define alias  CABINET_INFO type  CABINET_INFO_A;
 define alias PCABINET_INFO type PCABINET_INFO_A;
 %end;


 /* Structure used with SPFILENOTIFY_FILEINCABINET */

 define structure
   1 FILE_IN_CABINET_INFO_A,
     2 NameInCabinet  type PCSTR,
     2 FileSize       type DWORD,
     2 Win32Error     type DWORD,
     2 DosDate        type WORD,
     2 DosTime        type WORD,
     2 DosAttribs     type WORD,
     2 FullTargetName char (MAX_PATH-1) varz;
 define alias PFILE_IN_CABINET_INFO_A handle FILE_IN_CABINET_INFO_A;

 define structure
   1 FILE_IN_CABINET_INFO_W,
     2 NameInCabinet  type PCWSTR,
     2 FileSize       type DWORD,
     2 Win32Error     type DWORD,
     2 DosDate        type WORD,
     2 DosTime        type WORD,
     2 DosAttribs     type WORD,
     2 FullTargetName WCHAR (MAX_PATH-1) varz;
 define alias PFILE_IN_CABINET_INFO_W handle FILE_IN_CABINET_INFO_W;


 %if UNICODE ^= '' %then %do;
 define alias  FILE_IN_CABINET_INFO type  FILE_IN_CABINET_INFO_W;
 define alias PFILE_IN_CABINET_INFO type PFILE_IN_CABINET_INFO_W;
 %end; %else %do;
 define alias  FILE_IN_CABINET_INFO type  FILE_IN_CABINET_INFO_A;
 define alias PFILE_IN_CABINET_INFO type PFILE_IN_CABINET_INFO_A;
 %end;


 /* Define type for setup file queue */

 define alias HSPFILEQ type PVOID;

 /* Structure used with SetupQueueCopyIndirect */

 define structure
   1 SP_FILE_COPY_PARAMS_A,
     2 cbSize             type DWORD,
     2 QueueHandle        type HSPFILEQ,
     2 SourceRootPath     type PCSTR,
     2 SourcePath         type PCSTR,
     2 SourceFilename     type PCSTR,
     2 SourceDescription  type PCSTR,
     2 SourceTagfile      type PCSTR,
     2 TargetDirectory    type PCSTR,
     2 TargetFilename     type PCSTR,
     2 CopyStyle          type DWORD,
     2 LayoutInf          type HINF,
     2 SecurityDescriptor type PCSTR;
 define alias PSP_FILE_COPY_PARAMS_A handle SP_FILE_COPY_PARAMS_A;

 define structure
   1 SP_FILE_COPY_PARAMS_W,
     2 cbSize             type DWORD,
     2 QueueHandle        type HSPFILEQ,
     2 SourceRootPath     type PCWSTR,
     2 SourcePath         type PCWSTR,
     2 SourceFilename     type PCWSTR,
     2 SourceDescription  type PCWSTR,
     2 SourceTagfile      type PCWSTR,
     2 TargetDirectory    type PCWSTR,
     2 TargetFilename     type PCWSTR,
     2 CopyStyle          type DWORD,
     2 LayoutInf          type HINF,
     2 SecurityDescriptor type PCWSTR;
 define alias PSP_FILE_COPY_PARAMS_W handle SP_FILE_COPY_PARAMS_W;


 %if UNICODE ^= '' %then %do;
 define alias  SP_FILE_COPY_PARAMS type  SP_FILE_COPY_PARAMS_W;
 define alias PSP_FILE_COPY_PARAMS type PSP_FILE_COPY_PARAMS_W;
 %end; %else %do;
 define alias  SP_FILE_COPY_PARAMS type  SP_FILE_COPY_PARAMS_A;
 define alias PSP_FILE_COPY_PARAMS type PSP_FILE_COPY_PARAMS_A;
 %end;


 /* Define type for setup disk space list */

 define alias HDSKSPC type PVOID;

 /* Define type for reference to device information set */

 define alias HDEVINFO type PVOID;


 /* Device information structure (references a device instance */
 /* that is a member of a device information set)              */

 define structure
   1 SP_DEVINFO_DATA,
     2 cbSize    type DWORD,
     2 ClassGuid type GUID,
     2 DevInst   type DWORD,/* DEVINST handle */
     2 Reserved  type ULONG_PTR;
 define alias PSP_DEVINFO_DATA handle SP_DEVINFO_DATA;


 /* Device interface information structure (references a device */
 /* interface that is associated with the device information    */
 /* element that owns it).                                      */

 define structure
   1 SP_DEVICE_INTERFACE_DATA,
     2 cbSize             type DWORD,
     2 InterfaceClassGuid type GUID,
     2 Flags              type DWORD,
     2 Reserved           type ULONG_PTR;
 define alias PSP_DEVICE_INTERFACE_DATA handle SP_DEVICE_INTERFACE_DATA;

 /* Flags for SP_DEVICE_INTERFACE_DATA.Flags field. */
 dcl SPINT_ACTIVE  type DWORD value('00000001'xu);
 dcl SPINT_DEFAULT type DWORD value('00000002'xu);
 dcl SPINT_REMOVED type DWORD value('00000004'xu);

 /* Backward compatibility -- do not use. */
 define alias  SP_INTERFACE_DEVICE_DATA type  SP_DEVICE_INTERFACE_DATA;
 define alias PSP_INTERFACE_DEVICE_DATA type PSP_DEVICE_INTERFACE_DATA;

 dcl SPID_ACTIVE  fixed bin(31) value(SPINT_ACTIVE);
 dcl SPID_DEFAULT fixed bin(31) value(SPINT_DEFAULT);
 dcl SPID_REMOVED fixed bin(31) value(SPINT_REMOVED);


 define structure
   1 SP_DEVICE_INTERFACE_DETAIL_DATA_A,
     2 cbSize     type DWORD,
     2 DevicePath char(ANYSIZE_ARRAY-1) varz;

 define alias PSP_DEVICE_INTERFACE_DETAIL_DATA_A
        handle SP_DEVICE_INTERFACE_DETAIL_DATA_A;

 define structure
   1 SP_DEVICE_INTERFACE_DETAIL_DATA_W,
     2 cbSize     type DWORD,
     2 DevicePath WCHAR(ANYSIZE_ARRAY-1) varz;

 define alias PSP_DEVICE_INTERFACE_DETAIL_DATA_W
        handle SP_DEVICE_INTERFACE_DETAIL_DATA_W;


 %if UNICODE ^= '' %then %do;
 define alias  SP_DEVICE_INTERFACE_DETAIL_DATA
         type  SP_DEVICE_INTERFACE_DETAIL_DATA_W;
 define alias PSP_DEVICE_INTERFACE_DETAIL_DATA
         type PSP_DEVICE_INTERFACE_DETAIL_DATA_W;
 %end; %else %do;
 define alias  SP_DEVICE_INTERFACE_DETAIL_DATA
         type  SP_DEVICE_INTERFACE_DETAIL_DATA_A;
 define alias PSP_DEVICE_INTERFACE_DETAIL_DATA
         type PSP_DEVICE_INTERFACE_DETAIL_DATA_A;
 %end;


 /* Backward compatibility -- do not use. */

 define alias  SP_INTERFACE_DEVICE_DETAIL_DATA_W
         type  SP_DEVICE_INTERFACE_DETAIL_DATA_W;
 define alias PSP_INTERFACE_DEVICE_DETAIL_DATA_W
         type PSP_DEVICE_INTERFACE_DETAIL_DATA_W;
 define alias  SP_INTERFACE_DEVICE_DETAIL_DATA_A
         type  SP_DEVICE_INTERFACE_DETAIL_DATA_A;
 define alias PSP_INTERFACE_DEVICE_DETAIL_DATA_A
         type PSP_DEVICE_INTERFACE_DETAIL_DATA_A;

 %if UNICODE ^= '' %then %do;
 define alias  SP_INTERFACE_DEVICE_DETAIL_DATA
         type SP_INTERFACE_DEVICE_DETAIL_DATA_W;
 define alias PSP_INTERFACE_DEVICE_DETAIL_DATA
         type PSP_INTERFACE_DEVICE_DETAIL_DATA_W;
 %end; %else %do;
 define alias  SP_INTERFACE_DEVICE_DETAIL_DATA
         type  SP_INTERFACE_DEVICE_DETAIL_DATA_A;
 define alias PSP_INTERFACE_DEVICE_DETAIL_DATA
         type PSP_INTERFACE_DEVICE_DETAIL_DATA_A;
 %end;


 /* Structure for detailed information on a device information set    */
 /* (used for  SetupDiGetDeviceInfoListDetail which supercedes the    */
 /* functionality of SetupDiGetDeviceInfoListClass).                  */

 define structure
   1 SP_DEVINFO_LIST_DETAIL_DATA_A,
     2 cbSize              type DWORD,
     2 ClassGuid           type GUID,
     2 RemoteMachineHandle type HANDLE,
     2 RemoteMachineName   char (SP_MAX_MACHINENAME_LENGTH-1) varz;

 define alias PSP_DEVINFO_LIST_DETAIL_DATA_A
        handle SP_DEVINFO_LIST_DETAIL_DATA_A;

 define structure
   1 SP_DEVINFO_LIST_DETAIL_DATA_W,
     2 cbSize              type DWORD,
     2 ClassGuid           type GUID,
     2 RemoteMachineHandle type HANDLE,
     2 RemoteMachineName   WCHAR (SP_MAX_MACHINENAME_LENGTH-1) varz;

 define alias PSP_DEVINFO_LIST_DETAIL_DATA_W
        handle SP_DEVINFO_LIST_DETAIL_DATA_W;

 %if UNICODE ^= '' %then %do;
 define alias  SP_DEVINFO_LIST_DETAIL_DATA
         type  SP_DEVINFO_LIST_DETAIL_DATA_W;
 define alias PSP_DEVINFO_LIST_DETAIL_DATA
         type PSP_DEVINFO_LIST_DETAIL_DATA_W;
 %end; %else %do;
 define alias  SP_DEVINFO_LIST_DETAIL_DATA
         type  SP_DEVINFO_LIST_DETAIL_DATA_A;
 define alias PSP_DEVINFO_LIST_DETAIL_DATA
         type PSP_DEVINFO_LIST_DETAIL_DATA_A;
 %end;


 /* Class installer function codes */

 dcl DIF_SELECTDEVICE                 type DWORD value('00000001'xu);
 dcl DIF_INSTALLDEVICE                type DWORD value('00000002'xu);
 dcl DIF_ASSIGNRESOURCES              type DWORD value('00000003'xu);
 dcl DIF_PROPERTIES                   type DWORD value('00000004'xu);
 dcl DIF_REMOVE                       type DWORD value('00000005'xu);
 dcl DIF_FIRSTTIMESETUP               type DWORD value('00000006'xu);
 dcl DIF_FOUNDDEVICE                  type DWORD value('00000007'xu);
 dcl DIF_SELECTCLASSDRIVERS           type DWORD value('00000008'xu);
 dcl DIF_VALIDATECLASSDRIVERS         type DWORD value('00000009'xu);
 dcl DIF_INSTALLCLASSDRIVERS          type DWORD value('0000000A'xu);
 dcl DIF_CALCDISKSPACE                type DWORD value('0000000B'xu);
 dcl DIF_DESTROYPRIVATEDATA           type DWORD value('0000000C'xu);
 dcl DIF_VALIDATEDRIVER               type DWORD value('0000000D'xu);
 dcl DIF_MOVEDEVICE                   type DWORD value('0000000E'xu);
 dcl DIF_DETECT                       type DWORD value('0000000F'xu);
 dcl DIF_INSTALLWIZARD                type DWORD value('00000010'xu);
 dcl DIF_DESTROYWIZARDDATA            type DWORD value('00000011'xu);
 dcl DIF_PROPERTYCHANGE               type DWORD value('00000012'xu);
 dcl DIF_ENABLECLASS                  type DWORD value('00000013'xu);
 dcl DIF_DETECTVERIFY                 type DWORD value('00000014'xu);
 dcl DIF_INSTALLDEVICEFILES           type DWORD value('00000015'xu);
 dcl DIF_UNREMOVE                     type DWORD value('00000016'xu);
 dcl DIF_SELECTBESTCOMPATDRV          type DWORD value('00000017'xu);
 dcl DIF_ALLOW_INSTALL                type DWORD value('00000018'xu);
 dcl DIF_REGISTERDEVICE               type DWORD value('00000019'xu);
 dcl DIF_NEWDEVICEWIZARD_PRESELECT    type DWORD value('0000001A'xu);
 dcl DIF_NEWDEVICEWIZARD_SELECT       type DWORD value('0000001B'xu);
 dcl DIF_NEWDEVICEWIZARD_PREANALYZE   type DWORD value('0000001C'xu);
 dcl DIF_NEWDEVICEWIZARD_POSTANALYZE  type DWORD value('0000001D'xu);
 dcl DIF_NEWDEVICEWIZARD_FINISHINSTALL
                                      type DWORD value('0000001E'xu);
 dcl DIF_UNUSED1                      type DWORD value('0000001F'xu);
 dcl DIF_INSTALLINTERFACES            type DWORD value('00000020'xu);
 dcl DIF_DETECTCANCEL                 type DWORD value('00000021'xu);
 dcl DIF_REGISTER_COINSTALLERS        type DWORD value('00000022'xu);
 dcl DIF_ADDPROPERTYPAGE_ADVANCED     type DWORD value('00000023'xu);
 dcl DIF_ADDPROPERTYPAGE_BASIC        type DWORD value('00000024'xu);
 dcl DIF_RESERVED1                    type DWORD value('00000025'xu);
 dcl DIF_TROUBLESHOOTER               type DWORD value('00000026'xu);

 define alias DI_FUNCTION type UINT;
   /* Function type for device installer */


 /* Device installation parameters structure (associated with a       */
 /* particular device information element, or globally with a device  */
 /* information set)                                                  */

 define structure
   1 SP_DEVINSTALL_PARAMS_A,
     2 cbSize                   type DWORD,
     2 Flags                    type DWORD,
     2 FlagsEx                  type DWORD,
     2 hwndParent               type HWND,
     2 InstallMsgHandler        type PSP_FILE_CALLBACK,
     2 InstallMsgHandlerContext type PVOID,
     2 FileQueue                type HSPFILEQ,
     2 ClassInstallReserved     type ULONG_PTR,
     2 Reserved                 type DWORD,
     2 DriverPath               char (MAX_PATH-1) varz;
 define alias PSP_DEVINSTALL_PARAMS_A handle SP_DEVINSTALL_PARAMS_A;

 define structure
   1 SP_DEVINSTALL_PARAMS_W,
     2 cbSize                   type DWORD,
     2 Flags                    type DWORD,
     2 FlagsEx                  type DWORD,
     2 hwndParent               type HWND,
     2 InstallMsgHandler        type PSP_FILE_CALLBACK,
     2 InstallMsgHandlerContext type PVOID,
     2 FileQueue                type HSPFILEQ,
     2 ClassInstallReserved     type ULONG_PTR,
     2 Reserved                 type DWORD,
     2 DriverPath               WCHAR (MAX_PATH-1) varz;
 define alias PSP_DEVINSTALL_PARAMS_W handle SP_DEVINSTALL_PARAMS_W;

 %if UNICODE ^= '' %then %do;
 define alias  SP_DEVINSTALL_PARAMS type  SP_DEVINSTALL_PARAMS_W;
 define alias PSP_DEVINSTALL_PARAMS type PSP_DEVINSTALL_PARAMS_W;
 %end; %else %do;
 define alias  SP_DEVINSTALL_PARAMS type  SP_DEVINSTALL_PARAMS_A;
 define alias PSP_DEVINSTALL_PARAMS type PSP_DEVINSTALL_PARAMS_A;
 %end;


 /* SP_DEVINSTALL_PARAMS.Flags values */

 /* Flags for choosing a device */

 dcl DI_SHOWOEM                       type DWORD value('00000001'xu);
     /* support Other... button */
 dcl DI_SHOWCOMPAT                    type DWORD value('00000002'xu);
     /* show compatibility list */
 dcl DI_SHOWCLASS                     type DWORD value('00000004'xu);
     /* show class list */
 dcl DI_SHOWALL                       type DWORD value('00000007'xu);
     /* both class & compat list shown */
 dcl DI_NOVCP                         type DWORD value('00000008'xu);
     /* don't create a new copy queue--use caller-supplied FileQueue */
 dcl DI_DIDCOMPAT                     type DWORD value('00000010'xu);
     /* Searched for compatible devices */
 dcl DI_DIDCLASS                      type DWORD value('00000020'xu);
     /* Searched for class devices */
 dcl DI_AUTOASSIGNRES                 type DWORD value('00000040'xu);
     /* No UI for resources if possible */

 /* flags returned by DiInstallDevice to indicate need to             */
 /* reboot/restart                                                    */
 dcl DI_NEEDRESTART                   type DWORD value('00000080'xu);
     /* Reboot required to take effect */
 dcl DI_NEEDREBOOT                    type DWORD value('00000100'xu);
     /* "" */

 /* flags for device installation */
 dcl DI_NOBROWSE                      type DWORD value('00000200'xu);
     /* no Browse... in InsertDisk */

 /* Flags set by DiBuildDriverInfoList */
 dcl DI_MULTMFGS                      type DWORD value('00000400'xu);
     /* Set if multiple manufacturers in class driver list */

 /* Flag indicates that device is disabled */
 dcl DI_DISABLED                      type DWORD value('00000800'xu);
     /* Set if device disabled */

 /* Flags for Device/Class Properties */
 dcl DI_GENERALPAGE_ADDED             type DWORD value('00001000'xu);
 dcl DI_RESOURCEPAGE_ADDED            type DWORD value('00002000'xu);

 /* Flag to indicate the setting properties for this Device (or class)*/
 /* caused a change so the Dev Mgr UI probably needs to be updatd.    */
 dcl DI_PROPERTIES_CHANGE             type DWORD value('00004000'xu);

 /* Flag to indicate that the sorting from the INF file               */
 /* should be used.                                                   */
 dcl DI_INF_IS_SORTED                 type DWORD value('00008000'xu);

 /* Flag to indicate that only the the INF specified by               */
 /* SP_DEVINSTALL_PARAMS.DriverPath should be searched.               */
 dcl DI_ENUMSINGLEINF                 type DWORD value('00010000'xu);

 /* Flag that prevents ConfigMgr from removing/re-enumerating devices */
 /* during device registration, installation, and deletion.           */
 dcl DI_DONOTCALLCONFIGMG             type DWORD value('00020000'xu);

 /* The following flag can be used to install a device disabled       */
 dcl DI_INSTALLDISABLED               type DWORD value('00040000'xu);

 /* Flag that causes SetupDiBuildDriverInfoList to build a device's   */
 /* compatible driver list from its existing class driver list,       */
 /* instead of the normal INF search.                                 */
 dcl DI_COMPAT_FROM_CLASS             type DWORD value('00080000'xu);

 /* This flag is set if the Class Install params should be used.      */
 dcl DI_CLASSINSTALLPARAMS            type DWORD value('00100000'xu);

 /* This flag is set if the caller of DiCallClassInstaller does NOT   */
 /* want the internal default action performed if the Class installer */
 /* returns ERROR_DI_DO_DEFAULT.                                      */
 dcl DI_NODI_DEFAULTACTION            type DWORD value('00200000'xu);

 /* The setupx flag, DI_NOSYNCPROCESSING (0x00400000L) is not support */
 /* in the Setup APIs.                                                */

 /* flags for device installation */
 dcl DI_QUIETINSTALL                  type DWORD value('00800000'xu);
     /* don't confuse the user with questions or excess info */
 dcl DI_NOFILECOPY                    type DWORD value('01000000'xu);
     /* No file Copy necessary */
 dcl DI_FORCECOPY                     type DWORD value('02000000'xu);
     /* Force files to be copied from install path */
 dcl DI_DRIVERPAGE_ADDED              type DWORD value('04000000'xu);
     /* Prop provider added Driver page. */
 dcl DI_USECI_SELECTSTRINGS           type DWORD value('08000000'xu);
     /* Use Class Installer Provided strings in the Select Device Dlg */
 dcl DI_OVERRIDE_INFFLAGS             type DWORD value('10000000'xu);
     /* Override INF flags */
 dcl DI_PROPS_NOCHANGEUSAGE           type DWORD value('20000000'xu);
     /* No Enable/Disable in General Props */

 dcl DI_NOSELECTICONS                 type DWORD value('40000000'xu);
     /* No small icons in select device dialogs */

 dcl DI_NOWRITE_IDS                   type DWORD value('80000000'xu);
     /* Don't write HW & Compat IDs on install */


 /* SP_DEVINSTALL_PARAMS.FlagsEx values */

 dcl DI_FLAGSEX_USEOLDINFSEARCH       type DWORD value('00000001'xu);
     /* Inf Search functions should not use Index Search */
 dcl DI_FLAGSEX_AUTOSELECTRANK0       type DWORD value('00000002'xu);
     /* SetupDiSelectDevice doesn't prompt user if rank 0 match */
 dcl DI_FLAGSEX_CI_FAILED             type DWORD value('00000004'xu);
     /* Failed to Load/Call class installer */

 dcl DI_FLAGSEX_DIDINFOLIST           type DWORD value('00000010'xu);
     /* Did the Class Info List */
 dcl DI_FLAGSEX_DIDCOMPATINFO         type DWORD value('00000020'xu);
     /* Did the Compat Info List */

 dcl DI_FLAGSEX_FILTERCLASSES         type DWORD value('00000040'xu);
 dcl DI_FLAGSEX_SETFAILEDINSTALL      type DWORD value('00000080'xu);
 dcl DI_FLAGSEX_DEVICECHANGE          type DWORD value('00000100'xu);
 dcl DI_FLAGSEX_ALWAYSWRITEIDS        type DWORD value('00000200'xu);
 dcl DI_FLAGSEX_PROPCHANGE_PENDING    type DWORD value('00000400'xu);
     /* One or more device property sheets have had changes made      */
     /* to them, and need to have a DIF_PROPERTYCHANGE occur.         */
 dcl DI_FLAGSEX_ALLOWEXCLUDEDDRVS     type DWORD value('00000800'xu);
 dcl DI_FLAGSEX_NOUIONQUERYREMOVE     type DWORD value('00001000'xu);
 dcl DI_FLAGSEX_USECLASSFORCOMPAT     type DWORD value('00002000'xu);
     /* Use the device's class when building compat drv list.         */
     /* (Ignored if DI_COMPAT_FROM_CLASS flag is specified.)          */
 dcl DI_FLAGSEX_OLDINF_IN_CLASSLIST   type DWORD value('00004000'xu);
     /* Search legacy INFs when building class driver list.           */
 dcl DI_FLAGSEX_NO_DRVREG_MODIFY      type DWORD value('00008000'xu);
     /* Don't run AddReg and DelReg for device's software (driver) key*/
 dcl DI_FLAGSEX_IN_SYSTEM_SETUP       type DWORD value('00010000'xu);
     /* Installation is occurring during initial system setup.        */
 dcl DI_FLAGSEX_INET_DRIVER           type DWORD value('00020000'xu);
     /* Driver came from Windows Update */
 dcl DI_FLAGSEX_APPENDDRIVERLIST      type DWORD value('00040000'xu);
     /* Cause SetupDiBuildDriverInfoList to append                    */
     /* a new driver list to an existing list.                        */
 dcl DI_FLAGSEX_PREINSTALLBACKUP      type DWORD value('00080000'xu);
     /* backup all files required by old inf before install           */
 dcl DI_FLAGSEX_BACKUPONREPLACE       type DWORD value('00100000'xu);
     /* backup files required by old inf as they are replaced         */
 dcl DI_FLAGSEX_DRIVERLIST_FROM_URL   type DWORD value('00200000'xu);
     /* build driver list from INF(s) retrieved from URL specified    */
     /* in SP_DEVINSTALL_PARAMS.DriverPath (empty string means        */
     /* Windows Update website)                                       */
 dcl DI_FLAGSEX_RESERVED1             type DWORD value('00400000'xu);
 dcl DI_FLAGSEX_EXCLUDE_OLD_INET_DRIVERS
                                      type DWORD value('00800000'xu);
     /* Don't include old Internet drivers when building a driver list*/
 dcl DI_FLAGSEX_POWERPAGE_ADDED       type DWORD value('00800000'xu);
     /* class installer added their own power page */


 /* Class installation parameters header. This must be the first      */
 /* field of any class install parameter structure.                   */
 /* The InstallFunction field must be set to                          */
 /* the function code corresponding to the structure, and the cbSize  */
 /* field must be set to the size of the header structure. E.g.,      */
 /* dcl EnableClassParams type SP_ENABLECLASS_PARAMS                  */
 /* EnableClassParams.ClassInstallHeader.cbSize                       */
 /*  = size(: SP_CLASSINSTALL_HEADER :)                               */
 /* EnableClassParams.ClassInstallHeader.InstallFunction              */
 /*  = DIF_ENABLECLASS                                                */

 define structure
   1 SP_CLASSINSTALL_HEADER,
     2 cbSize          type DWORD,
     2 InstallFunction type DI_FUNCTION;
 define alias PSP_CLASSINSTALL_HEADER handle SP_CLASSINSTALL_HEADER;


 /* Structure corresponding to a DIF_ENABLECLASS install function. */

 define structure
   1 SP_ENABLECLASS_PARAMS,
     2 ClassInstallHeader type SP_CLASSINSTALL_HEADER,
     2 ClassGuid          type GUID,
     2 EnableMessage      type DWORD;
 define alias PSP_ENABLECLASS_PARAMS handle SP_ENABLECLASS_PARAMS;

 dcl ENABLECLASS_QUERY   fixed bin(31) value(0);
 dcl ENABLECLASS_SUCCESS fixed bin(31) value(1);
 dcl ENABLECLASS_FAILURE fixed bin(31) value(2);


 /* Structure corresponding to a DIF_MOVEDEVICE install function. */

 define structure
   1 SP_MOVEDEV_PARAMS,
     2 ClassInstallHeader   type SP_CLASSINSTALL_HEADER,
     2 SourceDeviceInfoData type SP_DEVINFO_DATA;
 define alias PSP_MOVEDEV_PARAMS handle SP_MOVEDEV_PARAMS;


 /* Values indicating a change in a device's state */

 dcl DICS_ENABLE     type DWORD value('00000001'xu);
 dcl DICS_DISABLE    type DWORD value('00000002'xu);
 dcl DICS_PROPCHANGE type DWORD value('00000003'xu);
 dcl DICS_START      type DWORD value('00000004'xu);
 dcl DICS_STOP       type DWORD value('00000005'xu);

 /* Values specifying the scope of a device property change */

 dcl DICS_FLAG_GLOBAL         type DWORD value('00000001'xu);
     /* make change in all hardware profiles */
 dcl DICS_FLAG_CONFIGSPECIFIC type DWORD value('00000002'xu);
     /* make change in specified profile only */
 dcl DICS_FLAG_CONFIGGENERAL  type DWORD value('00000004'xu);
     /* 1 or more hardware profile-specific changes to follow. */

 /* Structure corresponding to a DIF_PROPERTYCHANGE install function. */

 define structure
   1 SP_PROPCHANGE_PARAMS,
     2 ClassInstallHeader type SP_CLASSINSTALL_HEADER,
     2 StateChange        type DWORD,
     2 Scope              type DWORD,
     2 HwProfile          type DWORD;
 define alias PSP_PROPCHANGE_PARAMS handle SP_PROPCHANGE_PARAMS;


 /* Structure corresponding to a DIF_REMOVE install function. */

 define structure
   1 SP_REMOVEDEVICE_PARAMS,
     2 ClassInstallHeader type SP_CLASSINSTALL_HEADER,
     2 Scope              type DWORD,
     2 HwProfile          type DWORD;
 define alias PSP_REMOVEDEVICE_PARAMS handle SP_REMOVEDEVICE_PARAMS;

 dcl DI_REMOVEDEVICE_GLOBAL              type DWORD value('00000001'xu);
 dcl DI_REMOVEDEVICE_CONFIGSPECIFIC      type DWORD value('00000002'xu);


 /* Structure corresponding to a DIF_UNREMOVE install function. */

 define structure
   1 SP_UNREMOVEDEVICE_PARAMS,
     2 ClassInstallHeader type SP_CLASSINSTALL_HEADER,
     2 Scope              type DWORD,
     2 HwProfile          type DWORD;
 define alias PSP_UNREMOVEDEVICE_PARAMS handle SP_UNREMOVEDEVICE_PARAMS;

 dcl DI_UNREMOVEDEVICE_CONFIGSPECIFIC    type DWORD value('00000002'xu);

 /* Structure corresponding to a DIF_SELECTDEVICE install function. */

 define structure
   1 SP_SELECTDEVICE_PARAMS_A,
     2 ClassInstallHeader type SP_CLASSINSTALL_HEADER,
     2 Title              char (MAX_TITLE_LEN-1) varz,
     2 Instructions       char (MAX_INSTRUCTION_LEN-1) varz,
     2 ListLabel          char (MAX_LABEL_LEN-1) varz,
     2 SubTitle           char (MAX_SUBTITLE_LEN-1) varz,
     2 Reserved (2)       type BYTE;/* DWORD size alignment */
 define alias PSP_SELECTDEVICE_PARAMS_A handle SP_SELECTDEVICE_PARAMS_A;

 define structure
   1 SP_SELECTDEVICE_PARAMS_W,
     2 ClassInstallHeader type SP_CLASSINSTALL_HEADER,
     2 Title              WCHAR(MAX_TITLE_LEN-1) varz,
     2 Instructions       WCHAR(MAX_INSTRUCTION_LEN-1) varz,
     2 ListLabel          WCHAR(MAX_LABEL_LEN-1) varz,
     2 SubTitle           WCHAR(MAX_SUBTITLE_LEN-1) varz;
 define alias PSP_SELECTDEVICE_PARAMS_W handle SP_SELECTDEVICE_PARAMS_W;


 %if UNICODE ^= '' %then %do;
 define alias  SP_SELECTDEVICE_PARAMS type  SP_SELECTDEVICE_PARAMS_W;
 define alias PSP_SELECTDEVICE_PARAMS type PSP_SELECTDEVICE_PARAMS_W;
 %end; %else %do;
 define alias  SP_SELECTDEVICE_PARAMS type  SP_SELECTDEVICE_PARAMS_A;
 define alias PSP_SELECTDEVICE_PARAMS type PSP_SELECTDEVICE_PARAMS_A;
 %end;


 /* Callback routine for giving progress notification during detection*/

 define alias PDETECT_PROGRESS_NOTIFY
        entry (type PVOID,
               type DWORD)
        returns (type BOOL byvalue optional)
        limited CALLBACK;

 /* where:                                                            */
 /*     ProgressNotifyParam - value supplied by caller requesting     */
 /*                           detection.                              */
 /*     DetectComplete      - Percent completion, to be incremented   */
 /*                           by class installer, as it steps through */
 /*                           its detection.                          */
 /* Return Value - If TRUE, then detection is cancelled.              */
 /* Allows caller requesting detection to stop detection asap.        */


 /* Structure corresponding to a DIF_DETECT install function. */

 define structure
   1 SP_DETECTDEVICE_PARAMS,
     2 ClassInstallHeader   type SP_CLASSINSTALL_HEADER,
     2 DetectProgressNotify type PDETECT_PROGRESS_NOTIFY,
     2 ProgressNotifyParam  type PVOID;
 define alias PSP_DETECTDEVICE_PARAMS handle SP_DETECTDEVICE_PARAMS;


 /* 'Add New Device' installation wizard structure                    */
 /* (backward-compatibility only - respond to DIF_NEWDEVICEWIZARD_*   */
 /* requests instead).                                                */

 /* Structure corresponding to a DIF_INSTALLWIZARD install function.  */
 /* (NOTE: This structure is also applicable for                      */
 /* DIF_DESTROYWIZARDDATA, but DIF_INSTALLWIZARD is the associated    */
 /* function code in the class installation parameter structure in    */
 /* both cases.)                                                      */

 /* Define maximum number of dynamic wizard pages that                */
 /* can be added to hardware install wizard.                          */

 dcl MAX_INSTALLWIZARD_DYNAPAGES fixed bin(31) value(20);

 define structure
   1 SP_INSTALLWIZARD_DATA,
     2 ClassInstallHeader type SP_CLASSINSTALL_HEADER,
     2 Flags              type DWORD,
     2 DynamicPages (MAX_INSTALLWIZARD_DYNAPAGES) type HPROPSHEETPAGE,
     2 NumDynamicPages    type DWORD,
     2 DynamicPageFlags   type DWORD,
     2 PrivateFlags       type DWORD,
     2 PrivateData        type LPARAM,
     2 hwndWizardDlg      type HWND;
 define alias PSP_INSTALLWIZARD_DATA handle SP_INSTALLWIZARD_DATA;


 /* SP_INSTALLWIZARD_DATA.Flags values */

 dcl NDW_INSTALLFLAG_DIDFACTDEFS        type DWORD value('00000001'xu);
 dcl NDW_INSTALLFLAG_HARDWAREALLREADYIN type DWORD value('00000002'xu);
 dcl NDW_INSTALLFLAG_NEEDRESTART      type DWORD value(DI_NEEDRESTART);
 dcl NDW_INSTALLFLAG_NEEDREBOOT       type DWORD value(DI_NEEDREBOOT);
 dcl NDW_INSTALLFLAG_NEEDSHUTDOWN       type DWORD value('00000200'xu);
 dcl NDW_INSTALLFLAG_EXPRESSINTRO       type DWORD value('00000400'xu);
 dcl NDW_INSTALLFLAG_SKIPISDEVINSTALLED type DWORD value('00000800'xu);
 dcl NDW_INSTALLFLAG_NODETECTEDDEVS     type DWORD value('00001000'xu);
 dcl NDW_INSTALLFLAG_INSTALLSPECIFIC    type DWORD value('00002000'xu);
 dcl NDW_INSTALLFLAG_SKIPCLASSLIST      type DWORD value('00004000'xu);
 dcl NDW_INSTALLFLAG_CI_PICKED_OEM      type DWORD value('00008000'xu);
 dcl NDW_INSTALLFLAG_PCMCIAMODE         type DWORD value('00010000'xu);
 dcl NDW_INSTALLFLAG_PCMCIADEVICE       type DWORD value('00020000'xu);
 dcl NDW_INSTALLFLAG_USERCANCEL         type DWORD value('00040000'xu);
 dcl NDW_INSTALLFLAG_KNOWNCLASS         type DWORD value('00080000'xu);



 /* SP_INSTALLWIZARD_DATA.DynamicPageFlags values */

 /* This flag is set if a Class installer has added pages to the      */
 /* install wizard.                                                   */

 dcl DYNAWIZ_FLAG_PAGESADDED            type DWORD value('00000001'xu);


 /* Set this flag if you jump to the analyze page, and want it to     */
 /* handle conflicts for you.  NOTE.  You will not get control back   */
 /* in the event of a conflict if you set this flag.                  */

 dcl DYNAWIZ_FLAG_ANALYZE_HANDLECONFLICT
                                        type DWORD value('00000008'xu);


 /* The following flags are not used by the Windows NT hardware       */
 /* wizard.                                                           */

 dcl DYNAWIZ_FLAG_INSTALLDET_NEXT       type DWORD value('00000002'xu);
 dcl DYNAWIZ_FLAG_INSTALLDET_PREV       type DWORD value('00000004'xu);



 /* Reserve a range of wizard page resource IDs for internal use.     */
 /* Some of these IDs are for use by class installers that respond    */
 /* to the obsolete DIF_INSTALLWIZARD/DIF_DESTROYWIZARDDATA messages. */
 /* These IDs are listed below.                                       */

 dcl MIN_IDD_DYNAWIZ_RESOURCE_ID      fixed bin(31) value(10000);
 dcl MAX_IDD_DYNAWIZ_RESOURCE_ID      fixed bin(31) value(11000);


 /* Define wizard page resource IDs to be used when adding custom     */
 /* pages to the hardware install wizard via DIF_INSTALLWIZARD. Pages */
 /* marked with (CLASS INSTALLER PROVIDED) _must_ be supplied by the  */
 /* class installer if it responds to the DIF_INSTALLWIZARD request.  */


 /* Resource ID for the first page that the install wizard will go to */
 /* after adding the class installer pages. (CLASS INSTALLER PROVIDED)*/

 dcl IDD_DYNAWIZ_FIRSTPAGE                fixed bin(31) value(10000);

 /* Resource ID for the page that the Select Device page will go back */
 /* to. (CLASS INSTALLER PROVIDED)                                    */

 dcl IDD_DYNAWIZ_SELECT_PREVPAGE          fixed bin(31) value(10001);

 /* Resource ID for the page that the Select Device page will go      */
 /* forward to. (CLASS INSTALLER PROVIDED)                            */

 dcl IDD_DYNAWIZ_SELECT_NEXTPAGE          fixed bin(31) value(10002);

 /* Resource ID for the page that the Analyze dialog should go back   */
 /* to. This will only be used in the event that there is a problem,  */
 /*  and the user selects Back from the analyze proc.                 */
 /* (CLASS INSTALLER PROVIDED)                                        */

 dcl IDD_DYNAWIZ_ANALYZE_PREVPAGE         fixed bin(31) value(10003);

 /* Resource ID for the page that the Analyze dialog should go to if  */
 /* it continues from the analyze proc. (CLASS INSTALLER PROVIDED)    */

 dcl IDD_DYNAWIZ_ANALYZE_NEXTPAGE         fixed bin(31) value(10004);

 /* Resource ID of the hardware install wizard's select device page.  */
 /* This ID can be used to go directly to the hardware install        */
 /* wizard's select device page.  (This is the resource ID of the     */
 /* Select Device wizard page retrieved via SetupDiGetWizardPage when */
 /* SPWPT_SELECTDEVICE is the requested PageType.)                    */

 dcl IDD_DYNAWIZ_SELECTDEV_PAGE           fixed bin(31) value(10009);

 /* Resource ID of the hardware install wizard's device analysis page.*/
 /* This ID can be use to go directly to the hardware install wizard's*/
 /* analysis page.                                                    */

 dcl IDD_DYNAWIZ_ANALYZEDEV_PAGE          fixed bin(31) value(10010);

 /* Resource ID of the hardware install wizard's install detected     */
 /* devices page.This ID can be use to go directly to the hardware    */
 /* install wizard's install detected devices page.                   */

 dcl IDD_DYNAWIZ_INSTALLDETECTEDDEVS_PAGE fixed bin(31) value(10011);

 /* Resource ID of the hardware install wizard's select class page.   */
 /* This ID can be use to go directly to the hardware install wizard's*/
 /* select class page.                                                */

 dcl IDD_DYNAWIZ_SELECTCLASS_PAGE         fixed bin(31) value(10012);


 /* The following class installer-provided wizard page resource IDs   */
 /* are not used by the Windows NT hardware wizard.                   */

 dcl IDD_DYNAWIZ_INSTALLDETECTED_PREVPAGE fixed bin(31) value(10006);
 dcl IDD_DYNAWIZ_INSTALLDETECTED_NEXTPAGE fixed bin(31) value(10007);
 dcl IDD_DYNAWIZ_INSTALLDETECTED_NODEVS   fixed bin(31) value(10008);



 /* Structure corresponding to the following DIF_NEWDEVICEWIZARD_*    */
 /* install functions:                                                */

 /*     DIF_NEWDEVICEWIZARD_PRESELECT     */
 /*     DIF_NEWDEVICEWIZARD_SELECT        */
 /*     DIF_NEWDEVICEWIZARD_PREANALYZE    */
 /*     DIF_NEWDEVICEWIZARD_POSTANALYZE   */
 /*     DIF_NEWDEVICEWIZARD_FINISHINSTALL */

 define structure
   1 SP_NEWDEVICEWIZARD_DATA,
     2 ClassInstallHeader type SP_CLASSINSTALL_HEADER,
     2 Flags            type DWORD,/* presently unused--must be zero. */
     2 DynamicPages (MAX_INSTALLWIZARD_DYNAPAGES-1) type HPROPSHEETPAGE,
     2 NumDynamicPages  type DWORD,
     2 hwndWizardDlg    type HWND;
 define alias PSP_NEWDEVICEWIZARD_DATA handle SP_NEWDEVICEWIZARD_DATA;

 define alias  SP_ADDPROPERTYPAGE_DATA type  SP_NEWDEVICEWIZARD_DATA;
 define alias PSP_ADDPROPERTYPAGE_DATA type PSP_NEWDEVICEWIZARD_DATA;



 /* Structure corresponding to the DIF_TROUBLESHOOTER install function*/

 define structure
   1 SP_TROUBLESHOOTER_PARAMS_A,
     2 ClassInstallHeader type SP_CLASSINSTALL_HEADER,
     2 ChmFile            char (MAX_PATH-1) varz,
     2 HtmlTroubleShooter char (MAX_PATH-1) varz;
 define alias PSP_TROUBLESHOOTER_PARAMS_A
        handle SP_TROUBLESHOOTER_PARAMS_A;

 define structure
   1 SP_TROUBLESHOOTER_PARAMS_W,
     2 ClassInstallHeader type SP_CLASSINSTALL_HEADER,
     2 ChmFile            WCHAR (MAX_PATH-1) varz,
     2 HtmlTroubleShooter WCHAR (MAX_PATH-1) varz;
 define alias PSP_TROUBLESHOOTER_PARAMS_W
        handle SP_TROUBLESHOOTER_PARAMS_W;

 %if UNICODE ^= '' %then %do;
 define alias  SP_TROUBLESHOOTER_PARAMS
         type  SP_TROUBLESHOOTER_PARAMS_W;
 define alias PSP_TROUBLESHOOTER_PARAMS
         type PSP_TROUBLESHOOTER_PARAMS_W;
 %end; %else %do;
 define alias  SP_TROUBLESHOOTER_PARAMS
         type  SP_TROUBLESHOOTER_PARAMS_A;
 define alias PSP_TROUBLESHOOTER_PARAMS
         type PSP_TROUBLESHOOTER_PARAMS_A;
 %end;



 /* Driver information structure (member of a driver info list that   */
 /* may be associated with a particular device instance,              */
 /* or (globally) with a device information set)                      */

 define structure
   1 SP_DRVINFO_DATA_V2_A,
     2 cbSize        type DWORD,
     2 DriverType    type DWORD,
     2 Reserved      type ULONG_PTR,
     2 Description   char (LINE_LEN-1) varz,
     2 MfgName       char (LINE_LEN-1) varz,
     2 ProviderName  char (LINE_LEN-1) varz,
     2 DriverDate    type FILETIME,
     2 DriverVersion type DWORDLONG;
 define alias PSP_DRVINFO_DATA_V2_A handle SP_DRVINFO_DATA_V2_A;

 define structure
   1 SP_DRVINFO_DATA_V2_W,
     2 cbSize        type DWORD,
     2 DriverType    type DWORD,
     2 Reserved      type ULONG_PTR,
     2 Description   WCHAR (LINE_LEN-1) varz,
     2 MfgName       WCHAR (LINE_LEN-1) varz,
     2 ProviderName  WCHAR (LINE_LEN-1) varz,
     2 DriverDate    type FILETIME,
     2 DriverVersion type DWORDLONG;
 define alias PSP_DRVINFO_DATA_V2_W handle SP_DRVINFO_DATA_V2_W;


 /* Version 1 of the SP_DRVINFO_DATA structures, used only for        */
 /* compatibility with Windows NT 4.0/Windows 95/98 SETUPAPI.DLL      */

 define structure
   1 SP_DRVINFO_DATA_V1_A,
     2 cbSize       type DWORD,
     2 DriverType   type DWORD,
     2 Reserved     type ULONG_PTR,
     2 Description  char (LINE_LEN-1) varz,
     2 MfgName      char (LINE_LEN-1) varz,
     2 ProviderName char (LINE_LEN-1) varz;
 define alias PSP_DRVINFO_DATA_V1_A handle SP_DRVINFO_DATA_V1_A;

 define structure
   1 SP_DRVINFO_DATA_V1_W,
     2 cbSize       type DWORD,
     2 DriverType   type DWORD,
     2 Reserved     type ULONG_PTR,
     2 Description  WCHAR (LINE_LEN-1) varz,
     2 MfgName      WCHAR (LINE_LEN-1) varz,
     2 ProviderName WCHAR (LINE_LEN-1) varz;
 define alias PSP_DRVINFO_DATA_V1_W handle SP_DRVINFO_DATA_V1_W;

 %if UNICODE ^= '' %then %do;
 define alias  SP_DRVINFO_DATA_V1 type  SP_DRVINFO_DATA_V1_W;
 define alias PSP_DRVINFO_DATA_V1 type PSP_DRVINFO_DATA_V1_W;
 define alias  SP_DRVINFO_DATA_V2 type  SP_DRVINFO_DATA_V2_W;
 define alias PSP_DRVINFO_DATA_V2 type PSP_DRVINFO_DATA_V2_W;
 %end; %else %do;
 define alias  SP_DRVINFO_DATA_V1 type  SP_DRVINFO_DATA_V1_A;
 define alias PSP_DRVINFO_DATA_V1 type PSP_DRVINFO_DATA_V1_A;
 define alias  SP_DRVINFO_DATA_V2 type  SP_DRVINFO_DATA_V2_A;
 define alias PSP_DRVINFO_DATA_V2 type PSP_DRVINFO_DATA_V2_A;
 %end;

 %dcl USE_SP_DRVINFO_DATA_V1 char ext;
 %if USE_SP_DRVINFO_DATA_V1 ^= '' %then %do;
 /* use version 1 driver info data structure */
 define alias  SP_DRVINFO_DATA_A type  SP_DRVINFO_DATA_V1_A;
 define alias PSP_DRVINFO_DATA_A type PSP_DRVINFO_DATA_V1_A;
 define alias  SP_DRVINFO_DATA_W type  SP_DRVINFO_DATA_V1_W;
 define alias PSP_DRVINFO_DATA_W type PSP_DRVINFO_DATA_V1_W;
 define alias  SP_DRVINFO_DATA   type  SP_DRVINFO_DATA_V1;
 define alias PSP_DRVINFO_DATA   type PSP_DRVINFO_DATA_V1;
 %end; %else %do;
 /* use version 2 driver info data structure */
 define alias  SP_DRVINFO_DATA_A type  SP_DRVINFO_DATA_V2_A;
 define alias PSP_DRVINFO_DATA_A type PSP_DRVINFO_DATA_V2_A;
 define alias  SP_DRVINFO_DATA_W type  SP_DRVINFO_DATA_V2_W;
 define alias PSP_DRVINFO_DATA_W type PSP_DRVINFO_DATA_V2_W;
 define alias  SP_DRVINFO_DATA   type  SP_DRVINFO_DATA_V2;
 define alias PSP_DRVINFO_DATA   type PSP_DRVINFO_DATA_V2;
 %end; /* use current version of driver info data structure */


 /* Driver information details structure (provides detailed           */
 /* information about a particular driver information structure)      */

 define structure
   1 SP_DRVINFO_DETAIL_DATA_A,
     2 cbSize          type DWORD,
     2 InfDate         type FILETIME,
     2 CompatIDsOffset type DWORD,
     2 CompatIDsLength type DWORD,
     2 Reserved        type ULONG_PTR,
     2 SectionName     char (LINE_LEN-1) varz,
     2 InfFileName     char (MAX_PATH-1) varz,
     2 DrvDescription  char (LINE_LEN-1) varz,
     2 HardwareID      char (ANYSIZE_ARRAY-1) varz;
 define alias PSP_DRVINFO_DETAIL_DATA_A handle SP_DRVINFO_DETAIL_DATA_A;

 define structure
   1 SP_DRVINFO_DETAIL_DATA_W,
     2 cbSize          type DWORD,
     2 InfDate         type FILETIME,
     2 CompatIDsOffset type DWORD,
     2 CompatIDsLength type DWORD,
     2 Reserved        type ULONG_PTR,
     2 SectionName     WCHAR (LINE_LEN-1) varz,
     2 InfFileName     WCHAR (MAX_PATH-1) varz,
     2 DrvDescription  WCHAR (LINE_LEN-1) varz,
     2 HardwareID      WCHAR (ANYSIZE_ARRAY-1) varz;
 define alias PSP_DRVINFO_DETAIL_DATA_W handle SP_DRVINFO_DETAIL_DATA_W;

 %if UNICODE ^= '' %then %do;
 define alias  SP_DRVINFO_DETAIL_DATA type  SP_DRVINFO_DETAIL_DATA_W;
 define alias PSP_DRVINFO_DETAIL_DATA type PSP_DRVINFO_DETAIL_DATA_W;
 %end; %else %do;
 define alias  SP_DRVINFO_DETAIL_DATA type  SP_DRVINFO_DETAIL_DATA_A;
 define alias PSP_DRVINFO_DETAIL_DATA type PSP_DRVINFO_DETAIL_DATA_A;
 %end;


 /* Driver installation parameters (associated with a particular */
 /* driver information element)                                  */

 define structure
   1 SP_DRVINSTALL_PARAMS,
     2 cbSize      type DWORD,
     2 Rank        type DWORD,
     2 Flags       type DWORD,
     2 PrivateData type DWORD_PTR,
     2 Reserved    type DWORD;
 define alias PSP_DRVINSTALL_PARAMS handle SP_DRVINSTALL_PARAMS;


 /* SP_DRVINSTALL_PARAMS.Flags values */

 dcl DNF_DUPDESC             type DWORD value('00000001'xu);
     /* Multiple providers have same desc */
 dcl DNF_OLDDRIVER           type DWORD value('00000002'xu);
     /* Driver node specifies old/current driver */
 dcl DNF_EXCLUDEFROMLIST     type DWORD value('00000004'xu);
     /* If set, this driver node will not be */
     /* displayed in any driver select dialogs. */
 dcl DNF_NODRIVER            type DWORD value('00000008'xu);
     /* if we want to install no driver */
     /* (e.g no mouse drv) */
 dcl DNF_LEGACYINF           type DWORD value('00000010'xu);
     /* this driver node comes from an old-style INF */
 dcl DNF_CLASS_DRIVER        type DWORD value('00000020'xu);
     /* Driver node represents a class driver */
 dcl DNF_COMPATIBLE_DRIVER   type DWORD value('00000040'xu);
     /* Driver node represents a compatible driver */
 dcl DNF_INET_DRIVER         type DWORD value('00000080'xu);
     /* Driver comes from an internet source */
 dcl DNF_UNUSED1             type DWORD value('00000100'xu);
 dcl DNF_INDEXED_DRIVER      type DWORD value('00000200'xu);
     /* Driver is contained in the Windows Driver Index */
 dcl DNF_OLD_INET_DRIVER     type DWORD value('00000400'xu);
     /* Driver came from the Internet, but we don't currently */
     /* have access to it's source files.  Never attempt to */
     /* install a driver with this flag! */
 dcl DNF_BAD_DRIVER          type DWORD value('00000800'xu);
     /* Driver node should not be used at all */

 /* Rank values (the lower the Rank number, the better the Rank) */

 dcl DRIVER_HARDWAREID_RANK  type DWORD value('00000FFF'xu);
     /*Any rank less than or equal to this value is a HardwareID match*/


 /* Setup callback routine for comparing detection signatures */

 define alias PSP_DETSIG_CMPPROC
        entry (type HDEVINFO,
               type SP_DEVINFO_DATA byaddr,
               type SP_DEVINFO_DATA byaddr,
               type PVOID)
        returns (type DWORD byvalue optional)
        limited CALLBACK;


 /* Define context structure handed to co-installers */

 define structure
   1 COINSTALLER_CONTEXT_DATA,
     2 PostProcessing type BOOL,
     2 InstallResult  type DWORD,
     2 PrivateData    type PVOID;
 define alias PCOINSTALLER_CONTEXT_DATA handle COINSTALLER_CONTEXT_DATA;


 /* Structure containing class image list information. */

 define structure
   1 SP_CLASSIMAGELIST_DATA,
     2 cbSize     type DWORD,
     2 ImageList  type HIMAGELIST,
     2 Reserved   type ULONG_PTR;
 define alias PSP_CLASSIMAGELIST_DATA handle SP_CLASSIMAGELIST_DATA;

 /* Structure to be passed as first parameter (LPVOID lpv) to         */
 /* ExtensionPropSheetPageProc entry point in setupapi.dll or to      */
 /* "EnumPropPages32" or "BasicProperties32" entry points provided by */
 /* class/device property page providers.  Used to retrieve a handle  */
 /* (or, potentially, multiple handles) to property pages for a       */
 /* specified property page type.                                     */

 define structure
   1 SP_PROPSHEETPAGE_REQUEST,
     2 cbSize         type DWORD,
     2 PageRequested  type DWORD,
     2 DeviceInfoSet  type HDEVINFO,
     2 DeviceInfoData type PSP_DEVINFO_DATA;
 define alias PSP_PROPSHEETPAGE_REQUEST handle SP_PROPSHEETPAGE_REQUEST;


 /* Property sheet codes used in           */
 /* SP_PROPSHEETPAGE_REQUEST.PageRequested */

 dcl SPPSR_SELECT_DEVICE_RESOURCES      fixed bin(31) value(1);
     /* supplied by setupapi.dll */
 dcl SPPSR_ENUM_BASIC_DEVICE_PROPERTIES fixed bin(31) value(2);
     /* supplied by device's BasicProperties32 provider */
 dcl SPPSR_ENUM_ADV_DEVICE_PROPERTIES   fixed bin(31) value(3);
     /* supplied by class and/or device's EnumPropPages32 provider */


 /* Structure used with SetupGetBackupQueue */

 define structure
   1 SP_BACKUP_QUEUE_PARAMS_A,
     2 cbSize         type DWORD,
     2 FullInfPath    char (MAX_PATH-1) varz,
       /* buffer to hold ANSI pathname of INF file */
     2 FilenameOffset type INT;
       /* offset in CHAR's of filename part (after '\') */
 define alias PSP_BACKUP_QUEUE_PARAMS_A handle SP_BACKUP_QUEUE_PARAMS_A;

 define structure
   1 SP_BACKUP_QUEUE_PARAMS_W,
     2 cbSize         type DWORD,
     2 FullInfPath    WCHAR (MAX_PATH-1) varz,
       /* buffer to hold UNICODE pathname of INF file */
     2 FilenameOffset type INT;
       /* offset in WCHAR's of filename part (after '\') */
 define alias PSP_BACKUP_QUEUE_PARAMS_W handle SP_BACKUP_QUEUE_PARAMS_W;

 %if UNICODE ^= '' %then %do;
 define alias  SP_BACKUP_QUEUE_PARAMS type  SP_BACKUP_QUEUE_PARAMS_W;
 define alias PSP_BACKUP_QUEUE_PARAMS type PSP_BACKUP_QUEUE_PARAMS_W;
 %end; %else %do;
 define alias  SP_BACKUP_QUEUE_PARAMS type  SP_BACKUP_QUEUE_PARAMS_A;
 define alias PSP_BACKUP_QUEUE_PARAMS type PSP_BACKUP_QUEUE_PARAMS_A;
 %end;


 /* Setupapi-specific error codes */

 /* Inf parse outcomes */

 dcl ERROR_EXPECTED_SECTION_NAME  fixed bin(31)
     value(ior(APPLICATION_ERROR_MASK, ERROR_SEVERITY_ERROR, 0));
 dcl ERROR_BAD_SECTION_NAME_LINE  fixed bin(31)
     value(ior(APPLICATION_ERROR_MASK, ERROR_SEVERITY_ERROR, 1));
 dcl ERROR_SECTION_NAME_TOO_LONG  fixed bin(31)
     value(ior(APPLICATION_ERROR_MASK, ERROR_SEVERITY_ERROR, 2));
 dcl ERROR_GENERAL_SYNTAX         fixed bin(31)
     value(ior(APPLICATION_ERROR_MASK, ERROR_SEVERITY_ERROR, 3));


 /* Inf runtime errors */

 dcl ERROR_WRONG_INF_STYLE        fixed bin(31)
     value(ior(APPLICATION_ERROR_MASK, ERROR_SEVERITY_ERROR, '100'xn));
 dcl ERROR_SECTION_NOT_FOUND      fixed bin(31)
     value(ior(APPLICATION_ERROR_MASK, ERROR_SEVERITY_ERROR, '101'xn));
 dcl ERROR_LINE_NOT_FOUND         fixed bin(31)
     value(ior(APPLICATION_ERROR_MASK, ERROR_SEVERITY_ERROR, '102'xn));
 dcl ERROR_NO_BACKUP              fixed bin(31)
     value(ior(APPLICATION_ERROR_MASK, ERROR_SEVERITY_ERROR, '103'xn));


 /* Device Installer/other errors */

 dcl ERROR_NO_ASSOCIATED_CLASS         fixed bin(31)
     value(ior(APPLICATION_ERROR_MASK, ERROR_SEVERITY_ERROR, '200'xn));
 dcl ERROR_CLASS_MISMATCH              fixed bin(31)
     value(ior(APPLICATION_ERROR_MASK, ERROR_SEVERITY_ERROR, '201'xn));
 dcl ERROR_DUPLICATE_FOUND             fixed bin(31)
     value(ior(APPLICATION_ERROR_MASK, ERROR_SEVERITY_ERROR, '202'xn));
 dcl ERROR_NO_DRIVER_SELECTED          fixed bin(31)
     value(ior(APPLICATION_ERROR_MASK, ERROR_SEVERITY_ERROR, '203'xn));
 dcl ERROR_KEY_DOES_NOT_EXIST          fixed bin(31)
     value(ior(APPLICATION_ERROR_MASK, ERROR_SEVERITY_ERROR, '204'xn));
 dcl ERROR_INVALID_DEVINST_NAME        fixed bin(31)
     value(ior(APPLICATION_ERROR_MASK, ERROR_SEVERITY_ERROR, '205'xn));
 dcl ERROR_INVALID_CLASS               fixed bin(31)
     value(ior(APPLICATION_ERROR_MASK, ERROR_SEVERITY_ERROR, '206'xn));
 dcl ERROR_DEVINST_ALREADY_EXISTS      fixed bin(31)
     value(ior(APPLICATION_ERROR_MASK, ERROR_SEVERITY_ERROR, '207'xn));
 dcl ERROR_DEVINFO_NOT_REGISTERED      fixed bin(31)
     value(ior(APPLICATION_ERROR_MASK, ERROR_SEVERITY_ERROR, '208'xn));
 dcl ERROR_INVALID_REG_PROPERTY        fixed bin(31)
     value(ior(APPLICATION_ERROR_MASK, ERROR_SEVERITY_ERROR, '209'xn));
 dcl ERROR_NO_INF                      fixed bin(31)
     value(ior(APPLICATION_ERROR_MASK, ERROR_SEVERITY_ERROR, '20A'xn));
 dcl ERROR_NO_SUCH_DEVINST             fixed bin(31)
     value(ior(APPLICATION_ERROR_MASK, ERROR_SEVERITY_ERROR, '20B'xn));
 dcl ERROR_CANT_LOAD_CLASS_ICON        fixed bin(31)
     value(ior(APPLICATION_ERROR_MASK, ERROR_SEVERITY_ERROR, '20C'xn));
 dcl ERROR_INVALID_CLASS_INSTALLER     fixed bin(31)
     value(ior(APPLICATION_ERROR_MASK, ERROR_SEVERITY_ERROR, '20D'xn));
 dcl ERROR_DI_DO_DEFAULT               fixed bin(31)
     value(ior(APPLICATION_ERROR_MASK, ERROR_SEVERITY_ERROR, '20E'xn));
 dcl ERROR_DI_NOFILECOPY               fixed bin(31)
     value(ior(APPLICATION_ERROR_MASK, ERROR_SEVERITY_ERROR, '20F'xn));
 dcl ERROR_INVALID_HWPROFILE           fixed bin(31)
     value(ior(APPLICATION_ERROR_MASK, ERROR_SEVERITY_ERROR, '210'xn));
 dcl ERROR_NO_DEVICE_SELECTED          fixed bin(31)
     value(ior(APPLICATION_ERROR_MASK, ERROR_SEVERITY_ERROR, '211'xn));
 dcl ERROR_DEVINFO_LIST_LOCKED         fixed bin(31)
     value(ior(APPLICATION_ERROR_MASK, ERROR_SEVERITY_ERROR, '212'xn));
 dcl ERROR_DEVINFO_DATA_LOCKED         fixed bin(31)
     value(ior(APPLICATION_ERROR_MASK, ERROR_SEVERITY_ERROR, '213'xn));
 dcl ERROR_DI_BAD_PATH                 fixed bin(31)
     value(ior(APPLICATION_ERROR_MASK, ERROR_SEVERITY_ERROR, '214'xn));
 dcl ERROR_NO_CLASSINSTALL_PARAMS      fixed bin(31)
     value(ior(APPLICATION_ERROR_MASK, ERROR_SEVERITY_ERROR, '215'xn));
 dcl ERROR_FILEQUEUE_LOCKED            fixed bin(31)
     value(ior(APPLICATION_ERROR_MASK, ERROR_SEVERITY_ERROR, '216'xn));
 dcl ERROR_BAD_SERVICE_INSTALLSECT     fixed bin(31)
     value(ior(APPLICATION_ERROR_MASK, ERROR_SEVERITY_ERROR, '217'xn));
 dcl ERROR_NO_CLASS_DRIVER_LIST        fixed bin(31)
     value(ior(APPLICATION_ERROR_MASK, ERROR_SEVERITY_ERROR, '218'xn));
 dcl ERROR_NO_ASSOCIATED_SERVICE       fixed bin(31)
     value(ior(APPLICATION_ERROR_MASK, ERROR_SEVERITY_ERROR, '219'xn));
 dcl ERROR_NO_DEFAULT_DEVICE_INTERFACE fixed bin(31)
     value(ior(APPLICATION_ERROR_MASK, ERROR_SEVERITY_ERROR, '21A'xn));
 dcl ERROR_DEVICE_INTERFACE_ACTIVE     fixed bin(31)
     value(ior(APPLICATION_ERROR_MASK, ERROR_SEVERITY_ERROR, '21B'xn));
 dcl ERROR_DEVICE_INTERFACE_REMOVED    fixed bin(31)
     value(ior(APPLICATION_ERROR_MASK, ERROR_SEVERITY_ERROR, '21C'xn));
 dcl ERROR_BAD_INTERFACE_INSTALLSECT   fixed bin(31)
     value(ior(APPLICATION_ERROR_MASK, ERROR_SEVERITY_ERROR, '21D'xn));
 dcl ERROR_NO_SUCH_INTERFACE_CLASS     fixed bin(31)
     value(ior(APPLICATION_ERROR_MASK, ERROR_SEVERITY_ERROR, '21E'xn));
 dcl ERROR_INVALID_REFERENCE_STRING    fixed bin(31)
     value(ior(APPLICATION_ERROR_MASK, ERROR_SEVERITY_ERROR, '21F'xn));
 dcl ERROR_INVALID_MACHINENAME         fixed bin(31)
     value(ior(APPLICATION_ERROR_MASK, ERROR_SEVERITY_ERROR, '220'xn));
 dcl ERROR_REMOTE_COMM_FAILURE         fixed bin(31)
     value(ior(APPLICATION_ERROR_MASK, ERROR_SEVERITY_ERROR, '221'xn));
 dcl ERROR_MACHINE_UNAVAILABLE         fixed bin(31)
     value(ior(APPLICATION_ERROR_MASK, ERROR_SEVERITY_ERROR, '222'xn));
 dcl ERROR_NO_CONFIGMGR_SERVICES       fixed bin(31)
     value(ior(APPLICATION_ERROR_MASK, ERROR_SEVERITY_ERROR, '223'xn));
 dcl ERROR_INVALID_PROPPAGE_PROVIDER   fixed bin(31)
     value(ior(APPLICATION_ERROR_MASK, ERROR_SEVERITY_ERROR, '224'xn));
 dcl ERROR_NO_SUCH_DEVICE_INTERFACE    fixed bin(31)
     value(ior(APPLICATION_ERROR_MASK, ERROR_SEVERITY_ERROR, '225'xn));
 dcl ERROR_DI_POSTPROCESSING_REQUIRED  fixed bin(31)
     value(ior(APPLICATION_ERROR_MASK, ERROR_SEVERITY_ERROR, '226'xn));
 dcl ERROR_INVALID_COINSTALLER         fixed bin(31)
     value(ior(APPLICATION_ERROR_MASK, ERROR_SEVERITY_ERROR, '227'xn));
 dcl ERROR_NO_COMPAT_DRIVERS           fixed bin(31)
     value(ior(APPLICATION_ERROR_MASK, ERROR_SEVERITY_ERROR, '228'xn));
 dcl ERROR_NO_DEVICE_ICON              fixed bin(31)
     value(ior(APPLICATION_ERROR_MASK, ERROR_SEVERITY_ERROR, '229'xn));
 dcl ERROR_INVALID_INF_LOGCONFIG       fixed bin(31)
     value(ior(APPLICATION_ERROR_MASK, ERROR_SEVERITY_ERROR, '22A'xn));
 dcl ERROR_DI_DONT_INSTALL             fixed bin(31)
     value(ior(APPLICATION_ERROR_MASK, ERROR_SEVERITY_ERROR, '22B'xn));
 dcl ERROR_INVALID_FILTER_DRIVER       fixed bin(31)
     value(ior(APPLICATION_ERROR_MASK, ERROR_SEVERITY_ERROR, '22C'xn));
 dcl ERROR_NON_WINDOWS_NT_DRIVER       fixed bin(31)
     value(ior(APPLICATION_ERROR_MASK, ERROR_SEVERITY_ERROR, '22D'xn));
 dcl ERROR_NON_WINDOWS_DRIVER          fixed bin(31)
     value(ior(APPLICATION_ERROR_MASK, ERROR_SEVERITY_ERROR, '22E'xn));
 dcl ERROR_NO_CATALOG_FOR_OEM_INF      fixed bin(31)
     value(ior(APPLICATION_ERROR_MASK, ERROR_SEVERITY_ERROR, '22F'xn));
 dcl ERROR_DEVINSTALL_QUEUE_NONNATIVE  fixed bin(31)
     value(ior(APPLICATION_ERROR_MASK, ERROR_SEVERITY_ERROR, '230'xn));
 dcl ERROR_NOT_DISABLEABLE             fixed bin(31)
     value(ior(APPLICATION_ERROR_MASK, ERROR_SEVERITY_ERROR, '231'xn));
 dcl ERROR_CANT_REMOVE_DEVINST         fixed bin(31)
     value(ior(APPLICATION_ERROR_MASK, ERROR_SEVERITY_ERROR, '232'xn));


 /* Backward compatibility--do not use. */

 dcl ERROR_NO_DEFAULT_INTERFACE_DEVICE fixed bin(31)
     value(ERROR_NO_DEFAULT_DEVICE_INTERFACE);
 dcl ERROR_INTERFACE_DEVICE_ACTIVE     fixed bin(31)
     value(ERROR_DEVICE_INTERFACE_ACTIVE);
 dcl ERROR_INTERFACE_DEVICE_REMOVED    fixed bin(31)
     value(ERROR_DEVICE_INTERFACE_REMOVED);
 dcl ERROR_NO_SUCH_INTERFACE_DEVICE    fixed bin(31)
     value(ERROR_NO_SUCH_DEVICE_INTERFACE);


 /* Win9x migration DLL error code */

 dcl ERROR_NOT_INSTALLED fixed bin(31)
     value(ior(APPLICATION_ERROR_MASK, ERROR_SEVERITY_ERROR, '1000'xn));


 dcl SetupGetInfInformationA
     entry (type LPCVOID,
            type DWORD,
            type SP_INF_INFORMATION byaddr optional,
            type DWORD,
            type DWORD byaddr optional)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupGetInfInformationA');

 dcl SetupGetInfInformationW
     entry (type LPCVOID,
            type DWORD,
            type SP_INF_INFORMATION byaddr optional,
            type DWORD,
            type DWORD byaddr optional)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupGetInfInformationW');


 /* SearchControl flags for SetupGetInfInformation */

 dcl INFINFO_INF_SPEC_IS_HINF       fixed bin(31) value(1);
 dcl INFINFO_INF_NAME_IS_ABSOLUTE   fixed bin(31) value(2);
 dcl INFINFO_DEFAULT_SEARCH         fixed bin(31) value(3);
 dcl INFINFO_REVERSE_DEFAULT_SEARCH fixed bin(31) value(4);
 dcl INFINFO_INF_PATH_LIST_SEARCH   fixed bin(31) value(5);


 %dcl SetupGetInfInformation char ext;
 %if UNICODE ^= '' %then %do;
   %SetupGetInfInformation='SetupGetInfInformationW';
 %end; %else %do;
   %SetupGetInfInformation='SetupGetInfInformationA';
 %end;


 dcl SetupQueryInfFileInformationA
     entry (type SP_INF_INFORMATION byaddr,
            type UINT,
            char(*) varz byaddr optional,
            type DWORD,
            type DWORD byaddr optional)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupQueryInfFileInformationA');

 dcl SetupQueryInfFileInformationW
     entry (type SP_INF_INFORMATION byaddr,
            type UINT,
            WCHAR(*) varz byaddr optional,
            type DWORD,
            type DWORD byaddr optional)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupQueryInfFileInformationW');

 %dcl SetupQueryInfFileInformation char ext;
 %if UNICODE ^= '' %then %do;
   %SetupQueryInfFileInformation='SetupQueryInfFileInformationW';
 %end; %else %do;
   %SetupQueryInfFileInformation='SetupQueryInfFileInformationA';
 %end;


 dcl SetupQueryInfOriginalFileInformationA
     entry (type SP_INF_INFORMATION byaddr,
            type UINT,
            type SP_ALTPLATFORM_INFO byaddr optional,
            type SP_ORIGINAL_FILE_INFO_A byaddr)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI
     external('SetupQueryInfOriginalFileInformationA');

 dcl SetupQueryInfOriginalFileInformationW
     entry (type SP_INF_INFORMATION byaddr,
            type UINT,
            type SP_ALTPLATFORM_INFO byaddr optional,
            type SP_ORIGINAL_FILE_INFO_W byaddr)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI
     external('SetupQueryInfOriginalFileInformationW');

 %dcl SetupQueryInfOriginalFileInformation char ext;
 %if UNICODE ^= '' %then %do;
   %SetupQueryInfOriginalFileInformation
     ='SetupQueryInfOriginalFileInformationW';
 %end; %else %do;
   %SetupQueryInfOriginalFileInformation
     ='SetupQueryInfOriginalFileInformationA';
 %end;


 dcl SetupQueryInfVersionInformationA
     entry (type SP_INF_INFORMATION byaddr,
            type UINT,
            char(*) varz byaddr nonasgn optional,
            char(*) varz byaddr optional,
            type DWORD,
            type DWORD byaddr optional)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupQueryInfVersionInformationA');

 dcl SetupQueryInfVersionInformationW
     entry (type SP_INF_INFORMATION byaddr,
            type UINT,
            WCHAR(*) varz byaddr nonasgn optional,
            WCHAR(*) varz byaddr optional,
            type DWORD,
            type DWORD byaddr optional)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupQueryInfVersionInformationW');

 %dcl SetupQueryInfVersionInformation char ext;
 %if UNICODE ^= '' %then %do;
   %SetupQueryInfVersionInformation='SetupQueryInfVersionInformationW';
 %end; %else %do;
   %SetupQueryInfVersionInformation='SetupQueryInfVersionInformationA';
 %end;


 dcl SetupGetInfFileListA
     entry (char(*) varz byaddr nonasgn optional,
            type DWORD,
            char(*) varz byaddr optional,
            type DWORD,
            type DWORD byaddr optional)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupGetInfFileListA');

 dcl SetupGetInfFileListW
     entry (WCHAR(*) varz byaddr nonasgn optional,
            type DWORD,
            WCHAR(*) varz byaddr optional,
            type DWORD,
            type DWORD byaddr optional)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupGetInfFileListW');

 %dcl SetupGetInfFileList char ext;
 %if UNICODE ^= '' %then %do;
   %SetupGetInfFileList='SetupGetInfFileListW';
 %end; %else %do;
   %SetupGetInfFileList='SetupGetInfFileListA';
 %end;


 dcl SetupOpenInfFileW
     entry (WCHAR(*) varz byaddr nonasgn,
            WCHAR(*) varz byaddr nonasgn optional,
            type DWORD,
            type UINT byaddr optional)
     returns (type HINF byvalue optional)
     WINSETUPAPI WINAPI external('SetupOpenInfFileW');

 dcl SetupOpenInfFileA
     entry (char(*) varz byaddr nonasgn,
            char(*) varz byaddr nonasgn optional,
            type DWORD,
            type UINT byaddr optional)
     returns (type HINF byvalue optional)
     WINSETUPAPI WINAPI external('SetupOpenInfFileA');

 %dcl SetupOpenInfFile char ext;
 %if UNICODE ^= '' %then %do;
   %SetupOpenInfFile='SetupOpenInfFileW';
 %end; %else %do;
   %SetupOpenInfFile='SetupOpenInfFileA';
 %end;


 dcl SetupOpenMasterInf
     entry ()
     returns (type HINF byvalue optional)
     WINSETUPAPI WINAPI external('SetupOpenMasterInf');

 dcl SetupOpenAppendInfFileW
     entry (WCHAR(*) varz byaddr nonasgn optional,
            type HINF,
            type UINT byaddr)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupOpenAppendInfFileW');

 dcl SetupOpenAppendInfFileA
     entry (char(*) varz byaddr nonasgn optional,
            type HINF,
            type UINT byaddr)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupOpenAppendInfFileA');

 %dcl SetupOpenAppendInfFile char ext;
 %if UNICODE ^= '' %then %do;
   %SetupOpenAppendInfFile='SetupOpenAppendInfFileW';
 %end; %else %do;
   %SetupOpenAppendInfFile='SetupOpenAppendInfFileA';
 %end;


 dcl SetupCloseInfFile
     entry (type HINF)
     WINSETUPAPI WINAPI external('SetupCloseInfFile');


 dcl SetupFindFirstLineA
     entry (type HINF,
            char(*) varz byaddr nonasgn,
            char(*) varz byaddr nonasgn optional,
            type INFCONTEXT byaddr)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupFindFirstLineA');

 dcl SetupFindFirstLineW
     entry (type HINF,
            WCHAR(*) varz byaddr nonasgn,
            WCHAR(*) varz byaddr nonasgn optional,
            type INFCONTEXT byaddr)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupFindFirstLineW');

 %dcl SetupFindFirstLine char ext;
 %if UNICODE ^= '' %then %do;
   %SetupFindFirstLine='SetupFindFirstLineW';
 %end; %else %do;
   %SetupFindFirstLine='SetupFindFirstLineA';
 %end;


 dcl SetupFindNextLine
     entry (type INFCONTEXT byaddr,
            type INFCONTEXT byaddr)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupFindNextLine');


 dcl SetupFindNextMatchLineA
     entry (type INFCONTEXT byaddr,
            char(*) varz byaddr nonasgn optional,
            type INFCONTEXT byaddr)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupFindNextMatchLineA');

 dcl SetupFindNextMatchLineW
     entry (type INFCONTEXT byaddr,
            WCHAR(*) varz byaddr nonasgn optional,
            type INFCONTEXT byaddr)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupFindNextMatchLineW');

 %dcl SetupFindNextMatchLine char ext;
 %if UNICODE ^= '' %then %do;
   %SetupFindNextMatchLine='SetupFindNextMatchLineW';
 %end; %else %do;
   %SetupFindNextMatchLine='SetupFindNextMatchLineA';
 %end;


 dcl SetupGetLineByIndexA
     entry (type HINF,
            char(*) varz byaddr nonasgn,
            type DWORD,
            type INFCONTEXT byaddr)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupGetLineByIndexA');

 dcl SetupGetLineByIndexW
     entry (type HINF,
            WCHAR(*) varz byaddr nonasgn,
            type DWORD,
            type INFCONTEXT byaddr)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupGetLineByIndexW');

 %dcl SetupGetLineByIndex char ext;
 %if UNICODE ^= '' %then %do;
   %SetupGetLineByIndex='SetupGetLineByIndexW';
 %end; %else %do;
   %SetupGetLineByIndex='SetupGetLineByIndexA';
 %end;


 dcl SetupGetLineCountA
     entry (type HINF,
            char(*) varz byaddr nonasgn)
     returns (type LONG byvalue optional)
     WINSETUPAPI WINAPI external('SetupGetLineCountA');


 dcl SetupGetLineCountW
     entry (type HINF,
            WCHAR(*) varz byaddr nonasgn)
     returns (type LONG byvalue optional)
     WINSETUPAPI WINAPI external('SetupGetLineCountW');

 %dcl SetupGetLineCount char ext;
 %if UNICODE ^= '' %then %do;
   %SetupGetLineCount='SetupGetLineCountW';
 %end; %else %do;
   %SetupGetLineCount='SetupGetLineCountA';
 %end;


 dcl SetupGetLineTextA
     entry (type INFCONTEXT byaddr optional,
            type HINF,
            char(*) varz byaddr nonasgn optional,
            char(*) varz byaddr nonasgn optional,
            char(*) varz byaddr optional,
            type DWORD,
            type DWORD byaddr optional)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupGetLineTextA');


 dcl SetupGetLineTextW
     entry (type INFCONTEXT byaddr optional,
            type HINF,
            WCHAR(*) varz byaddr nonasgn optional,
            WCHAR(*) varz byaddr nonasgn optional,
            WCHAR(*) varz byaddr optional,
            type DWORD,
            type DWORD byaddr optional)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupGetLineTextW');

 %dcl SetupGetLineText char ext;
 %if UNICODE ^= '' %then %do;
   %SetupGetLineText='SetupGetLineTextW';
 %end; %else %do;
   %SetupGetLineText='SetupGetLineTextA';
 %end;


 dcl SetupGetFieldCount
     entry (type INFCONTEXT byaddr)
     returns (type DWORD byvalue optional)
     WINSETUPAPI WINAPI external('SetupGetFieldCount');


 dcl SetupGetStringFieldA
     entry (type INFCONTEXT byaddr,
            type DWORD,
            char(*) varz byaddr optional,
            type DWORD,
            type DWORD byaddr optional)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupGetStringFieldA');

 dcl SetupGetStringFieldW
     entry (type INFCONTEXT byaddr,
            type DWORD,
            WCHAR(*) varz byaddr optional,
            type DWORD,
            type DWORD byaddr optional)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupGetStringFieldW');

 %dcl SetupGetStringField char ext;
 %if UNICODE ^= '' %then %do;
   %SetupGetStringField='SetupGetStringFieldW';
 %end; %else %do;
   %SetupGetStringField='SetupGetStringFieldA';
 %end;


 dcl SetupGetIntField
     entry (type INFCONTEXT byaddr,
            type DWORD,
            type INT byaddr)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupGetIntField');


 dcl SetupGetMultiSzFieldA
     entry (type INFCONTEXT byaddr,
            type DWORD,
            char(*) varz byaddr optional,
            type DWORD,
            type DWORD byaddr optional)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupGetMultiSzFieldA');

 dcl SetupGetMultiSzFieldW
     entry (type INFCONTEXT byaddr,
            type DWORD,
            WCHAR(*) varz byaddr optional,
            type DWORD,
            type DWORD byaddr optional)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupGetMultiSzFieldW');

 %dcl SetupGetMultiSzField char ext;
 %if UNICODE ^= '' %then %do;
   %SetupGetMultiSzField='SetupGetMultiSzFieldW';
 %end; %else %do;
   %SetupGetMultiSzField='SetupGetMultiSzFieldA';
 %end;


 dcl SetupGetBinaryField
     entry (type INFCONTEXT byaddr,
            type DWORD,
            type PBYTE,
            type DWORD,
            type DWORD byaddr optional)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupGetBinaryField');


 dcl SetupGetFileCompressionInfoA
     entry (char(*) varz byaddr nonasgn,
            type PSTR byaddr,
            type DWORD byaddr,
            type DWORD byaddr,
            type UINT byaddr)
     returns (type DWORD byvalue optional)
     WINSETUPAPI WINAPI external('SetupGetFileCompressionInfoA');

 dcl SetupGetFileCompressionInfoW
     entry (WCHAR(*) varz byaddr nonasgn,
            type PWSTR byaddr,
            type DWORD byaddr,
            type DWORD byaddr,
            type UINT byaddr)
     returns (type DWORD byvalue optional)
     WINSETUPAPI WINAPI external('SetupGetFileCompressionInfoW');

 %dcl SetupGetFileCompressionInfo char ext;
 %if UNICODE ^= '' %then %do;
   %SetupGetFileCompressionInfo='SetupGetFileCompressionInfoW';
 %end; %else %do;
   %SetupGetFileCompressionInfo='SetupGetFileCompressionInfoA';
 %end;


 /* Compression types */

 dcl FILE_COMPRESSION_NONE   type UINT value(0);
 dcl FILE_COMPRESSION_WINLZA type UINT value(1);
 dcl FILE_COMPRESSION_MSZIP  type UINT value(2);
 dcl FILE_COMPRESSION_NTCAB  type UINT value(3);

 dcl SetupDecompressOrCopyFileA
     entry (char(*) varz byaddr nonasgn,
            char(*) varz byaddr nonasgn,
            type UINT byaddr optional)
     returns (type DWORD byvalue optional)
     WINSETUPAPI WINAPI external('SetupDecompressOrCopyFileA');

 dcl SetupDecompressOrCopyFileW
     entry (WCHAR(*) varz byaddr nonasgn,
            WCHAR(*) varz byaddr nonasgn,
            type UINT byaddr optional)
     returns (type DWORD byvalue optional)
     WINSETUPAPI WINAPI external('SetupDecompressOrCopyFileW');

 %dcl SetupDecompressOrCopyFile char ext;
 %if UNICODE ^= '' %then %do;
   %SetupDecompressOrCopyFile='SetupDecompressOrCopyFileW';
 %end; %else %do;
   %SetupDecompressOrCopyFile='SetupDecompressOrCopyFileA';
 %end;


 dcl SetupGetSourceFileLocationA
     entry (type HINF,
            type INFCONTEXT byaddr optional,
            char(*) varz byaddr nonasgn optional,
            type UINT byaddr,
            char(*) varz byaddr optional,
            type DWORD,
            type DWORD byaddr optional)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupGetSourceFileLocationA');

 dcl SetupGetSourceFileLocationW
     entry (type HINF,
            type INFCONTEXT byaddr optional,
            WCHAR(*) varz byaddr nonasgn optional,
            type UINT byaddr,
            WCHAR(*) varz byaddr optional,
            type DWORD,
            type DWORD byaddr optional)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupGetSourceFileLocationW');

 %dcl SetupGetSourceFileLocation char ext;
 %if UNICODE ^= '' %then %do;
   %SetupGetSourceFileLocation='SetupGetSourceFileLocationW';
 %end; %else %do;
   %SetupGetSourceFileLocation='SetupGetSourceFileLocationA';
 %end;


 dcl SetupGetSourceFileSizeA
     entry (type HINF,
            type INFCONTEXT byaddr optional,
            char(*) varz byaddr nonasgn optional,
            char(*) varz byaddr nonasgn optional,
            type DWORD byaddr,
            type UINT)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupGetSourceFileSizeA');

 dcl SetupGetSourceFileSizeW
     entry (type HINF,
            type INFCONTEXT byaddr optional,
            WCHAR(*) varz byaddr nonasgn optional,
            WCHAR(*) varz byaddr nonasgn optional,
            type DWORD byaddr,
            type UINT)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupGetSourceFileSizeW');

 %dcl SetupGetSourceFileSize char ext;
 %if UNICODE ^= '' %then %do;
   %SetupGetSourceFileSize='SetupGetSourceFileSizeW';
 %end; %else %do;
   %SetupGetSourceFileSize='SetupGetSourceFileSizeA';
 %end;


 dcl SetupGetTargetPathA
     entry (type HINF,
            type INFCONTEXT byaddr optional,
            char(*) varz byaddr nonasgn optional,
            char(*) varz byaddr optional,
            type DWORD,
            type DWORD byaddr optional)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupGetTargetPathA');

 dcl SetupGetTargetPathW
     entry (type HINF,
            type INFCONTEXT byaddr optional,
            WCHAR(*) varz byaddr nonasgn optional,
            WCHAR(*) varz byaddr optional,
            type DWORD,
            type DWORD byaddr optional)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupGetTargetPathW');

 %dcl SetupGetTargetPath char ext;
 %if UNICODE ^= '' %then %do;
   %SetupGetTargetPath='SetupGetTargetPathW';
 %end; %else %do;
   %SetupGetTargetPath='SetupGetTargetPathA';
 %end;


 /* Define flags for SourceList APIs. */

 dcl SRCLIST_TEMPORARY       type DWORD value('00000001'xu);
 dcl SRCLIST_NOBROWSE        type DWORD value('00000002'xu);
 dcl SRCLIST_SYSTEM          type DWORD value('00000010'xu);
 dcl SRCLIST_USER            type DWORD value('00000020'xu);
 dcl SRCLIST_SYSIFADMIN      type DWORD value('00000040'xu);
 dcl SRCLIST_SUBDIRS         type DWORD value('00000100'xu);
 dcl SRCLIST_APPEND          type DWORD value('00000200'xu);
 dcl SRCLIST_NOSTRIPPLATFORM type DWORD value('00000400'xu);


 dcl SetupSetSourceListA
     entry (type DWORD,
            type PCSTR byaddr,
            type UINT)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupSetSourceListA');

 dcl SetupSetSourceListW
     entry (type DWORD,
            type PCWSTR byaddr,
            type UINT)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupSetSourceListW');

 %dcl SetupSetSourceList char ext;
 %if UNICODE ^= '' %then %do;
   %SetupSetSourceList='SetupSetSourceListW';
 %end; %else %do;
   %SetupSetSourceList='SetupSetSourceListA';
 %end;


 dcl SetupCancelTemporarySourceList
     entry ()
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupCancelTemporarySourceList');


 dcl SetupAddToSourceListA
     entry (type DWORD,
            char(*) varz byaddr nonasgn)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupAddToSourceListA');

 dcl SetupAddToSourceListW
     entry (type DWORD,
            WCHAR(*) varz byaddr nonasgn)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupAddToSourceListW');

 %dcl SetupAddToSourceList char ext;
 %if UNICODE ^= '' %then %do;
   %SetupAddToSourceList='SetupAddToSourceListW';
 %end; %else %do;
   %SetupAddToSourceList='SetupAddToSourceListA';
 %end;


 dcl SetupRemoveFromSourceListA
     entry (type DWORD,
            char(*) varz byaddr nonasgn)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupRemoveFromSourceListA');

 dcl SetupRemoveFromSourceListW
     entry (type DWORD,
            WCHAR(*) varz byaddr nonasgn)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupRemoveFromSourceListW');

 %dcl SetupRemoveFromSourceList char ext;
 %if UNICODE ^= '' %then %do;
   %SetupRemoveFromSourceList='SetupRemoveFromSourceListW';
 %end; %else %do;
   %SetupRemoveFromSourceList='SetupRemoveFromSourceListA';
 %end;


 dcl SetupQuerySourceListA
     entry (type DWORD,
            pointer byaddr, /* to (*) type PCSTR */
            type UINT byaddr)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupQuerySourceListA');

 dcl SetupQuerySourceListW
     entry (type DWORD,
            pointer byaddr, /* to (*) type PCWSTR */
            type UINT byaddr)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupQuerySourceListW');

 %dcl SetupQuerySourceList char ext;
 %if UNICODE ^= '' %then %do;
   %SetupQuerySourceList='SetupQuerySourceListW';
 %end; %else %do;
   %SetupQuerySourceList='SetupQuerySourceListA';
 %end;


 dcl SetupFreeSourceListA
     entry (pointer byaddr, /* to (*) type PCSTR */
            type UINT)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupFreeSourceListA');

 dcl SetupFreeSourceListW
     entry (pointer byaddr, /* to (*) type PCWSTR */
            type UINT)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupFreeSourceListW');

 %dcl SetupFreeSourceList char ext;
 %if UNICODE ^= '' %then %do;
   %SetupFreeSourceList='SetupFreeSourceListW';
 %end; %else %do;
   %SetupFreeSourceList='SetupFreeSourceListA';
 %end;


 dcl SetupPromptForDiskA
     entry (type HWND,
            char(*) varz byaddr nonasgn optional,
            char(*) varz byaddr nonasgn optional,
            char(*) varz byaddr nonasgn optional,
            char(*) varz byaddr nonasgn,
            char(*) varz byaddr nonasgn optional,
            type DWORD,
            char(*) varz byaddr optional,
            type DWORD,
            type DWORD byaddr optional)
     returns (type UINT byvalue optional)
     WINSETUPAPI WINAPI external('SetupPromptForDiskA');

 dcl SetupPromptForDiskW
     entry (type HWND,
            WCHAR(*) varz byaddr nonasgn optional,
            WCHAR(*) varz byaddr nonasgn optional,
            WCHAR(*) varz byaddr nonasgn optional,
            WCHAR(*) varz byaddr nonasgn,
            WCHAR(*) varz byaddr nonasgn optional,
            type DWORD,
            WCHAR(*) varz byaddr optional,
            type DWORD,
            type DWORD byaddr optional)
     returns (type UINT byvalue optional)
     WINSETUPAPI WINAPI external('SetupPromptForDiskW');

 %dcl SetupPromptForDisk char ext;
 %if UNICODE ^= '' %then %do;
   %SetupPromptForDisk='SetupPromptForDiskW';
 %end; %else %do;
   %SetupPromptForDisk='SetupPromptForDiskA';
 %end;


 dcl SetupCopyErrorA
     entry (type HWND,
            char(*) varz byaddr nonasgn optional,
            char(*) varz byaddr nonasgn optional,
            char(*) varz byaddr nonasgn,
            char(*) varz byaddr nonasgn,
            char(*) varz byaddr nonasgn optional,
            type UINT,
            type DWORD,
            char(*) varz byaddr optional,
            type DWORD,
            type DWORD byaddr optional)
     returns (type UINT byvalue optional)
     WINSETUPAPI WINAPI external('SetupCopyErrorA');

 dcl SetupCopyErrorW
     entry (type HWND,
            WCHAR(*) varz byaddr nonasgn optional,
            WCHAR(*) varz byaddr nonasgn optional,
            WCHAR(*) varz byaddr nonasgn,
            WCHAR(*) varz byaddr nonasgn,
            WCHAR(*) varz byaddr nonasgn optional,
            type UINT,
            type DWORD,
            WCHAR(*) varz byaddr optional,
            type DWORD,
            type DWORD byaddr optional)
     returns (type UINT byvalue optional)
     WINSETUPAPI WINAPI external('SetupCopyErrorW');

 %dcl SetupCopyError char ext;
 %if UNICODE ^= '' %then %do;
   %SetupCopyError='SetupCopyErrorW';
 %end; %else %do;
   %SetupCopyError='SetupCopyErrorA';
 %end;


 dcl SetupRenameErrorA
     entry (type HWND,
            char(*) varz byaddr nonasgn optional,
            char(*) varz byaddr nonasgn,
            char(*) varz byaddr nonasgn,
            type UINT,
            type DWORD)
     returns (type UINT byvalue optional)
     WINSETUPAPI WINAPI external('SetupRenameErrorA');

 dcl SetupRenameErrorW
     entry (type HWND,
            WCHAR(*) varz byaddr nonasgn optional,
            WCHAR(*) varz byaddr nonasgn,
            WCHAR(*) varz byaddr nonasgn,
            type UINT,
            type DWORD)
     returns (type UINT byvalue optional)
     WINSETUPAPI WINAPI external('SetupRenameErrorW');

 %dcl SetupRenameError char ext;
 %if UNICODE ^= '' %then %do;
   %SetupRenameError='SetupRenameErrorW';
 %end; %else %do;
   %SetupRenameError='SetupRenameErrorA';
 %end;


 dcl SetupDeleteErrorA
     entry (type HWND,
            char(*) varz byaddr nonasgn optional,
            char(*) varz byaddr nonasgn,
            type UINT,
            type DWORD)
     returns (type UINT byvalue optional)
     WINSETUPAPI WINAPI external('SetupDeleteErrorA');

 dcl SetupDeleteErrorW
     entry (type HWND,
            WCHAR(*) varz byaddr nonasgn optional,
            WCHAR(*) varz byaddr nonasgn,
            type UINT,
            type DWORD)
     returns (type UINT byvalue optional)
     WINSETUPAPI WINAPI external('SetupDeleteErrorW');

 %dcl SetupDeleteError char ext;
 %if UNICODE ^= '' %then %do;
   %SetupDeleteError='SetupDeleteErrorW';
 %end; %else %do;
   %SetupDeleteError='SetupDeleteErrorA';
 %end;


 dcl SetupBackupErrorA
     entry (type HWND,
            char(*) varz byaddr nonasgn optional,
            char(*) varz byaddr nonasgn,
            char(*) varz byaddr nonasgn,
            type UINT,
            type DWORD)
     returns (type UINT byvalue optional)
     WINSETUPAPI WINAPI external('SetupBackupErrorA');

 dcl SetupBackupErrorW
     entry (type HWND,
            WCHAR(*) varz byaddr nonasgn optional,
            WCHAR(*) varz byaddr nonasgn,
            WCHAR(*) varz byaddr nonasgn,
            type UINT,
            type DWORD)
     returns (type UINT byvalue optional)
     WINSETUPAPI WINAPI external('SetupBackupErrorW');

 %dcl SetupBackupError char ext;
 %if UNICODE ^= '' %then %do;
   %SetupBackupError='SetupBackupErrorW';
 %end; %else %do;
   %SetupBackupError='SetupBackupErrorA';
 %end;


 /* Styles for SetupPromptForDisk, SetupCopyError, */
 /* SetupRenameError, SetupDeleteError             */

 dcl IDF_NOBROWSE           type DWORD value('00000001'xu);
 dcl IDF_NOSKIP             type DWORD value('00000002'xu);
 dcl IDF_NODETAILS          type DWORD value('00000004'xu);
 dcl IDF_NOCOMPRESSED       type DWORD value('00000008'xu);
 dcl IDF_CHECKFIRST         type DWORD value('00000100'xu);
 dcl IDF_NOBEEP             type DWORD value('00000200'xu);
 dcl IDF_NOFOREGROUND       type DWORD value('00000400'xu);
 dcl IDF_WARNIFSKIP         type DWORD value('00000800'xu);
 dcl IDF_OEMDISK            type DWORD value('80000000'xu);


 /* Return values for SetupPromptForDisk, SetupCopyError, */
 /* SetupRenameError, SetupDeleteError, SetupBackupError  */

 dcl DPROMPT_SUCCESS        type UINT value(0);
 dcl DPROMPT_CANCEL         type UINT value(1);
 dcl DPROMPT_SKIPFILE       type UINT value(2);
 dcl DPROMPT_BUFFERTOOSMALL type UINT value(3);
 dcl DPROMPT_OUTOFMEMORY    type UINT value(4);


 dcl SetupSetDirectoryIdA
     entry (type HINF,
            type DWORD,
            char(*) varz byaddr nonasgn optional)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupSetDirectoryIdA');

 dcl SetupSetDirectoryIdW
     entry (type HINF,
            type DWORD,
            WCHAR(*) varz byaddr nonasgn optional)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupSetDirectoryIdW');

 %dcl SetupSetDirectoryId char ext;
 %if UNICODE ^= '' %then %do;
   %SetupSetDirectoryId='SetupSetDirectoryIdW';
 %end; %else %do;
   %SetupSetDirectoryId='SetupSetDirectoryIdA';
 %end;


 dcl SetupSetDirectoryIdExA
     entry (type HINF,
            type DWORD,
            char(*) varz byaddr nonasgn optional,
            type DWORD,
            type DWORD,
            type PVOID)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupSetDirectoryIdExA');

 dcl SetupSetDirectoryIdExW
     entry (type HINF,
            type DWORD,
            WCHAR(*) varz byaddr nonasgn optional,
            type DWORD,
            type DWORD,
            type PVOID)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupSetDirectoryIdExW');

 %dcl SetupSetDirectoryIdEx char ext;
 %if UNICODE ^= '' %then %do;
 %SetupSetDirectoryIdEx='SetupSetDirectoryIdExW';
 %end; %else %do;
   %SetupSetDirectoryIdEx='SetupSetDirectoryIdExA';
 %end;


 /* Flags for SetupSetDirectoryIdEx */

 dcl SETDIRID_NOT_FULL_PATH type DWORD value('00000001'xu);

 dcl SetupGetSourceInfoA
     entry (type HINF,
            type UINT,
            type UINT,
            char(*) varz byaddr optional,
            type DWORD,
            type DWORD byaddr optional)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupGetSourceInfoA');

 dcl SetupGetSourceInfoW
     entry (type HINF,
            type UINT,
            type UINT,
            WCHAR(*) varz byaddr optional,
            type DWORD,
            type DWORD byaddr optional)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupGetSourceInfoW');

 %dcl SetupGetSourceInfo char ext;
 %if UNICODE ^= '' %then %do;
   %SetupGetSourceInfo='SetupGetSourceInfoW';
 %end; %else %do;
   %SetupGetSourceInfo='SetupGetSourceInfoA';
 %end;


 /* InfoDesired values for SetupGetSourceInfo */


 dcl SRCINFO_PATH        type UINT value(1);
 dcl SRCINFO_TAGFILE     type UINT value(2);
 dcl SRCINFO_DESCRIPTION type UINT value(3);
 dcl SRCINFO_FLAGS       type UINT value(4);


 dcl SetupInstallFileA
     entry (type HINF,
            type INFCONTEXT byaddr optional,
            char(*) varz byaddr nonasgn optional,
            char(*) varz byaddr nonasgn optional,
            char(*) varz byaddr nonasgn optional,
            type DWORD,
            type PSP_FILE_CALLBACK_A optional byvalue,
            type PVOID)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupInstallFileA');

 dcl SetupInstallFileW
     entry (type HINF,
            type INFCONTEXT byaddr optional,
            WCHAR(*) varz byaddr nonasgn optional,
            WCHAR(*) varz byaddr nonasgn optional,
            WCHAR(*) varz byaddr nonasgn optional,
            type DWORD,
            type PSP_FILE_CALLBACK_W optional byvalue,
            type PVOID)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupInstallFileW');

 %dcl SetupInstallFile char ext;
 %if UNICODE ^= '' %then %do;
   %SetupInstallFile='SetupInstallFileW';
 %end; %else %do;
   %SetupInstallFile='SetupInstallFileA';
 %end;


 dcl SetupInstallFileExA
     entry (type HINF,
            type INFCONTEXT byaddr optional,
            char(*) varz byaddr nonasgn optional,
            char(*) varz byaddr nonasgn optional,
            char(*) varz byaddr nonasgn optional,
            type DWORD,
            type PSP_FILE_CALLBACK_A optional byvalue,
            type PVOID,
            type BOOL byaddr optional)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupInstallFileExA');

 dcl SetupInstallFileExW
     entry (type HINF,
            type INFCONTEXT byaddr optional,
            WCHAR(*) varz byaddr nonasgn optional,
            WCHAR(*) varz byaddr nonasgn optional,
            WCHAR(*) varz byaddr nonasgn optional,
            type DWORD,
            type PSP_FILE_CALLBACK_W optional byvalue,
            type PVOID,
            type BOOL byaddr optional)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupInstallFileExW');

 %dcl SetupInstallFileEx char ext;
 %if UNICODE ^= '' %then %do;
   %SetupInstallFileEx='SetupInstallFileExW';
 %end; %else %do;
   %SetupInstallFileEx='SetupInstallFileExA';
 %end;


 /* CopyStyle values for copy and queue-related APIs */

 dcl SP_COPY_DELETESOURCE        type DWORD value('0000001'xu);
     /* delete source file on successful copy */
 dcl SP_COPY_REPLACEONLY         type DWORD value('0000002'xu);
     /* copy only if target file already present */
 dcl SP_COPY_NEWER               type DWORD value('0000004'xu);
     /* copy only if source newer than or same as target */
 dcl SP_COPY_NEWER_OR_SAME       type DWORD value(SP_COPY_NEWER);
 dcl SP_COPY_NOOVERWRITE         type DWORD value('0000008'xu);
     /* copy only if target doesn't exist */
 dcl SP_COPY_NODECOMP            type DWORD value('0000010'xu);
     /* don't decompress source file while copying */
 dcl SP_COPY_LANGUAGEAWARE       type DWORD value('0000020'xu);
     /* don't overwrite file of different language */
 dcl SP_COPY_SOURCE_ABSOLUTE     type DWORD value('0000040'xu);
     /* SourceFile is a full source path */
 dcl SP_COPY_SOURCEPATH_ABSOLUTE type DWORD value('0000080'xu);
     /* SourcePathRoot is the full path */
 dcl SP_COPY_IN_USE_NEEDS_REBOOT type DWORD value('0000100'xu);
     /* System needs reboot if file in use */
 dcl SP_COPY_FORCE_IN_USE        type DWORD value('0000200'xu);
     /* Force target-in-use behavior */
 dcl SP_COPY_NOSKIP              type DWORD value('0000400'xu);
     /* Skip is disallowed for this file or section */
 dcl SP_FLAG_CABINETCONTINUATION type DWORD value('0000800'xu);
     /* Used with need media notification */
 dcl SP_COPY_FORCE_NOOVERWRITE   type DWORD value('0001000'xu);
     /* like NOOVERWRITE but no callback nofitication */
 dcl SP_COPY_FORCE_NEWER         type DWORD value('0002000'xu);
     /* like NEWER but no callback nofitication */
 dcl SP_COPY_WARNIFSKIP          type DWORD value('0004000'xu);
     /* system critical file: warn if user tries to skip */
 dcl SP_COPY_NOBROWSE            type DWORD value('0008000'xu);
     /* Browsing is disallowed for this file or section */
 dcl SP_COPY_NEWER_ONLY          type DWORD value('0010000'xu);
     /* copy only if source file newer than target */
 dcl SP_COPY_SOURCE_SIS_MASTER   type DWORD value('0020000'xu);
     /* source is single-instance store master */
 dcl SP_COPY_OEMINF_CATALOG_ONLY type DWORD value('0040000'xu);
     /* (SetupCopyOEMInf only) don't copy INF--just catalog */
 dcl SP_COPY_REPLACE_BOOT_FILE   type DWORD value('0080000'xu);
     /* file must be present upon reboot (i.e., it's */
     /* needed by the loader); this flag implies a reboot */
 dcl SP_COPY_NOPRUNE             type DWORD value('0100000'xu);
     /* never prune this file */


 dcl SetupOpenFileQueue
     entry ()
     returns (type HSPFILEQ byvalue optional)
     WINSETUPAPI WINAPI external('SetupOpenFileQueue');


 dcl SetupCloseFileQueue
     entry (type HSPFILEQ)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupCloseFileQueue');

 dcl SetupSetFileQueueAlternatePlatformA
     entry (type HSPFILEQ,
            type SP_ALTPLATFORM_INFO byaddr optional,
            char(*) varz byaddr nonasgn optional)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupSetFileQueueAlternatePlatformA');

 dcl SetupSetFileQueueAlternatePlatformW
     entry (type HSPFILEQ,
            type SP_ALTPLATFORM_INFO byaddr optional,
            WCHAR(*) varz byaddr nonasgn optional)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupSetFileQueueAlternatePlatformW');

 %dcl SetupSetFileQueueAlternatePlatform char ext;
 %if UNICODE ^= '' %then %do;
   %SetupSetFileQueueAlternatePlatform
     ='SetupSetFileQueueAlternatePlatformW';
 %end; %else %do;
   %SetupSetFileQueueAlternatePlatform
     ='SetupSetFileQueueAlternatePlatformA';
 %end;


 dcl SetupSetPlatformPathOverrideA
     entry (char(*) varz byaddr nonasgn optional)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupSetPlatformPathOverrideA');

 dcl SetupSetPlatformPathOverrideW
     entry (WCHAR(*) varz byaddr nonasgn optional)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupSetPlatformPathOverrideW');

 %dcl SetupSetPlatformPathOverride char ext;
 %if UNICODE ^= '' %then %do;
   %SetupSetPlatformPathOverride='SetupSetPlatformPathOverrideW';
 %end; %else %do;
   %SetupSetPlatformPathOverride='SetupSetPlatformPathOverrideA';
 %end;


 dcl SetupQueueCopyA
     entry (type HSPFILEQ,
            char(*) varz byaddr nonasgn optional,
            char(*) varz byaddr nonasgn optional,
            char(*) varz byaddr nonasgn,
            char(*) varz byaddr nonasgn optional,
            char(*) varz byaddr nonasgn optional,
            char(*) varz byaddr nonasgn,
            char(*) varz byaddr nonasgn optional,
            type DWORD)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupQueueCopyA');

 dcl SetupQueueCopyW
     entry (type HSPFILEQ,
            WCHAR(*) varz byaddr nonasgn optional,
            WCHAR(*) varz byaddr nonasgn optional,
            WCHAR(*) varz byaddr nonasgn,
            WCHAR(*) varz byaddr nonasgn optional,
            WCHAR(*) varz byaddr nonasgn optional,
            WCHAR(*) varz byaddr nonasgn,
            WCHAR(*) varz byaddr nonasgn optional,
            type DWORD)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupQueueCopyW');

 %dcl SetupQueueCopy char ext;
 %if UNICODE ^= '' %then %do;
   %SetupQueueCopy='SetupQueueCopyW';
 %end; %else %do;
   %SetupQueueCopy='SetupQueueCopyA';
 %end;


 dcl SetupQueueCopyIndirectA
     entry (type SP_FILE_COPY_PARAMS_A byaddr)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupQueueCopyIndirectA');

 dcl SetupQueueCopyIndirectW
     entry (type SP_FILE_COPY_PARAMS_W byaddr)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupQueueCopyIndirectW');

 %dcl SetupQueueCopyIndirect char ext;
 %if UNICODE ^= '' %then %do;
   %SetupQueueCopyIndirect='SetupQueueCopyIndirectW';
 %end; %else %do;
   %SetupQueueCopyIndirect='SetupQueueCopyIndirectA';
 %end;


 dcl SetupQueueDefaultCopyA
     entry (type HSPFILEQ,
            type HINF,
            char(*) varz byaddr nonasgn,
            char(*) varz byaddr nonasgn,
            char(*) varz byaddr nonasgn,
            type DWORD)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupQueueDefaultCopyA');

 dcl SetupQueueDefaultCopyW
     entry (type HSPFILEQ,
            type HINF,
            WCHAR(*) varz byaddr nonasgn,
            WCHAR(*) varz byaddr nonasgn,
            WCHAR(*) varz byaddr nonasgn,
            type DWORD)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupQueueDefaultCopyW');

 %dcl SetupQueueDefaultCopy char ext;
 %if UNICODE ^= '' %then %do;
   %SetupQueueDefaultCopy='SetupQueueDefaultCopyW';
 %end; %else %do;
   %SetupQueueDefaultCopy='SetupQueueDefaultCopyA';
 %end;


 dcl SetupQueueCopySectionA
     entry (type HSPFILEQ,
            char(*) varz byaddr nonasgn,
            type HINF,
            type HINF,
            char(*) varz byaddr nonasgn,
            type DWORD)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupQueueCopySectionA');

 dcl SetupQueueCopySectionW
     entry (type HSPFILEQ,
            WCHAR(*) varz byaddr nonasgn,
            type HINF,
            type HINF,
            WCHAR(*) varz byaddr nonasgn,
            type DWORD)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupQueueCopySectionW');

 %dcl SetupQueueCopySection char ext;
 %if UNICODE ^= '' %then %do;
   %SetupQueueCopySection='SetupQueueCopySectionW';
 %end; %else %do;
   %SetupQueueCopySection='SetupQueueCopySectionA';
 %end;


 dcl SetupQueueDeleteA
     entry (type HSPFILEQ,
            char(*) varz byaddr nonasgn,
            char(*) varz byaddr nonasgn optional)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupQueueDeleteA');

 dcl SetupQueueDeleteW
     entry (type HSPFILEQ,
            WCHAR(*) varz byaddr nonasgn,
            WCHAR(*) varz byaddr nonasgn optional)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupQueueDeleteW');

 %dcl SetupQueueDelete char ext;
 %if UNICODE ^= '' %then %do;
   %SetupQueueDelete='SetupQueueDeleteW';
 %end; %else %do;
   %SetupQueueDelete='SetupQueueDeleteA';
 %end;


 dcl SetupQueueDeleteSectionA
     entry (type HSPFILEQ,
            type HINF,
            type HINF,
            char(*) varz byaddr nonasgn)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupQueueDeleteSectionA');

 dcl SetupQueueDeleteSectionW
     entry (type HSPFILEQ,
            type HINF,
            type HINF,
            WCHAR(*) varz byaddr nonasgn)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupQueueDeleteSectionW');

 %dcl SetupQueueDeleteSection char ext;
 %if UNICODE ^= '' %then %do;
   %SetupQueueDeleteSection='SetupQueueDeleteSectionW';
 %end; %else %do;
   %SetupQueueDeleteSection='SetupQueueDeleteSectionA';
 %end;


 dcl SetupQueueRenameA
     entry (type HSPFILEQ,
            char(*) varz byaddr nonasgn,
            char(*) varz byaddr nonasgn optional,
            char(*) varz byaddr nonasgn optional,
            char(*) varz byaddr nonasgn)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupQueueRenameA');

 dcl SetupQueueRenameW
     entry (type HSPFILEQ,
            WCHAR(*) varz byaddr nonasgn,
            WCHAR(*) varz byaddr nonasgn optional,
            WCHAR(*) varz byaddr nonasgn optional,
            WCHAR(*) varz byaddr nonasgn)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupQueueRenameW');

 %dcl SetupQueueRename char ext;
 %if UNICODE ^= '' %then %do;
   %SetupQueueRename='SetupQueueRenameW';
 %end; %else %do;
   %SetupQueueRename='SetupQueueRenameA';
 %end;


 dcl SetupQueueRenameSectionA
     entry (type HSPFILEQ,
            type HINF,
            type HINF,
            char(*) varz byaddr nonasgn)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupQueueRenameSectionA');

 dcl SetupQueueRenameSectionW
     entry (type HSPFILEQ,
            type HINF,
            type HINF,
            WCHAR(*) varz byaddr nonasgn)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupQueueRenameSectionW');

 %dcl SetupQueueRenameSection char ext;
 %if UNICODE ^= '' %then %do;
   %SetupQueueRenameSection='SetupQueueRenameSectionW';
 %end; %else %do;
   %SetupQueueRenameSection='SetupQueueRenameSectionA';
 %end;


 dcl SetupCommitFileQueueA
     entry (type HWND,
            type HSPFILEQ,
            type PSP_FILE_CALLBACK_A,
            type PVOID)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupCommitFileQueueA');

 dcl SetupCommitFileQueueW
     entry (type HWND,
            type HSPFILEQ,
            type PSP_FILE_CALLBACK_W,
            type PVOID)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupCommitFileQueueW');

 %dcl SetupCommitFileQueue char ext;
 %if UNICODE ^= '' %then %do;
   %SetupCommitFileQueue='SetupCommitFileQueueW';
 %end; %else %do;
   %SetupCommitFileQueue='SetupCommitFileQueueA';
 %end;


 dcl SetupScanFileQueueA
     entry (type HSPFILEQ,
            type DWORD,
            type HWND,
            type PSP_FILE_CALLBACK_A optional byvalue,
            type PVOID,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupScanFileQueueA');

 dcl SetupScanFileQueueW
     entry (type HSPFILEQ,
            type DWORD,
            type HWND,
            type PSP_FILE_CALLBACK_W optional byvalue,
            type PVOID,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupScanFileQueueW');

 %dcl SetupScanFileQueue char ext;
 %if UNICODE ^= '' %then %do;
   %SetupScanFileQueue='SetupScanFileQueueW';
 %end; %else %do;
   %SetupScanFileQueue='SetupScanFileQueueA';
 %end;


 /* Define flags for SetupScanFileQueue. */

 dcl SPQ_SCAN_FILE_PRESENCE    type DWORD value('00000001'xu);
 dcl SPQ_SCAN_FILE_VALIDITY    type DWORD value('00000002'xu);
 dcl SPQ_SCAN_USE_CALLBACK     type DWORD value('00000004'xu);
 dcl SPQ_SCAN_USE_CALLBACKEX   type DWORD value('00000008'xu);
 dcl SPQ_SCAN_INFORM_USER      type DWORD value('00000010'xu);
 dcl SPQ_SCAN_PRUNE_COPY_QUEUE type DWORD value('00000020'xu);


 /* Define flags used with Param2 for SPFILENOTIFY_QUEUESCAN */

 dcl SPQ_DELAYED_COPY          type DWORD value('00000001'xu);
 /* file was in use, registered for delayed copy */


 /* Define OEM Source Type values for use in SetupCopyOEMInf. */

 dcl SPOST_NONE                fixed bin(31) value(0);
 dcl SPOST_PATH                fixed bin(31) value(1);
 dcl SPOST_URL                 fixed bin(31) value(2);
 dcl SPOST_MAX                 fixed bin(31) value(3);


 dcl SetupCopyOEMInfA
     entry (char(*) varz byaddr nonasgn,
            char(*) varz byaddr nonasgn optional,
            type DWORD,
            type DWORD,
            char(*) varz byaddr optional,
            type DWORD,
            type DWORD byaddr optional,
            type PSTR byaddr optional)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupCopyOEMInfA');

 dcl SetupCopyOEMInfW
     entry (WCHAR(*) varz byaddr nonasgn,
            WCHAR(*) varz byaddr nonasgn optional,
            type DWORD,
            type DWORD,
            WCHAR(*) varz byaddr optional,
            type DWORD,
            type DWORD byaddr optional,
            type PWSTR byaddr optional)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupCopyOEMInfW');

 %dcl SetupCopyOEMInf char ext;
 %if UNICODE ^= '' %then %do;
   %SetupCopyOEMInf='SetupCopyOEMInfW';
 %end; %else %do;
   %SetupCopyOEMInf='SetupCopyOEMInfA';
 %end;


 /* Disk space list APIs */

 dcl SetupCreateDiskSpaceListA
     entry (type PVOID,
            type DWORD,
            type UINT)
     returns (type HDSKSPC byvalue optional)
     WINSETUPAPI WINAPI external('SetupCreateDiskSpaceListA');

 dcl SetupCreateDiskSpaceListW
     entry (type PVOID,
            type DWORD,
            type UINT)
     returns (type HDSKSPC byvalue optional)
     WINSETUPAPI WINAPI external('SetupCreateDiskSpaceListW');

 %dcl SetupCreateDiskSpaceList char ext;
 %if UNICODE ^= '' %then %do;
   %SetupCreateDiskSpaceList='SetupCreateDiskSpaceListW';
 %end; %else %do;
   %SetupCreateDiskSpaceList='SetupCreateDiskSpaceListA';
 %end;


 /* Flags for SetupCreateDiskSpaceList */

 dcl SPDSL_IGNORE_DISK              type DWORD value('00000001'xu);
 /* ignore deletes and on-disk files in copies */
 dcl SPDSL_DISALLOW_NEGATIVE_ADJUST type DWORD value('00000002'xu);


 dcl SetupDuplicateDiskSpaceListA
     entry (type HDSKSPC,
            type PVOID,
            type DWORD,
            type UINT)
     returns (type HDSKSPC byvalue optional)
     WINSETUPAPI WINAPI external('SetupDuplicateDiskSpaceListA');

 dcl SetupDuplicateDiskSpaceListW
     entry (type HDSKSPC,
            type PVOID,
            type DWORD,
            type UINT)
     returns (type HDSKSPC byvalue optional)
     WINSETUPAPI WINAPI external('SetupDuplicateDiskSpaceListW');

 %dcl SetupDuplicateDiskSpaceList char ext;
 %if UNICODE ^= '' %then %do;
   %SetupDuplicateDiskSpaceList='SetupDuplicateDiskSpaceListW';
 %end; %else %do;
   %SetupDuplicateDiskSpaceList='SetupDuplicateDiskSpaceListA';
 %end;


 dcl SetupDestroyDiskSpaceList
     entry (type HDSKSPC)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDestroyDiskSpaceList');


 dcl SetupQueryDrivesInDiskSpaceListA
     entry (type HDSKSPC,
            char(*) varz byaddr optional,
            type DWORD,
            type DWORD byaddr optional)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupQueryDrivesInDiskSpaceListA');

 dcl SetupQueryDrivesInDiskSpaceListW
     entry (type HDSKSPC,
            WCHAR(*) varz byaddr optional,
            type DWORD,
            type DWORD byaddr optional)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupQueryDrivesInDiskSpaceListW');

 %dcl SetupQueryDrivesInDiskSpaceList char ext;
 %if UNICODE ^= '' %then %do;
   %SetupQueryDrivesInDiskSpaceList='SetupQueryDrivesInDiskSpaceListW';
 %end; %else %do;
   %SetupQueryDrivesInDiskSpaceList='SetupQueryDrivesInDiskSpaceListA';
 %end;


 dcl SetupQuerySpaceRequiredOnDriveA
     entry (type HDSKSPC,
            char(*) varz byaddr nonasgn,
            type LONGLONG byaddr,
            type PVOID,
            type UINT)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupQuerySpaceRequiredOnDriveA');

 dcl SetupQuerySpaceRequiredOnDriveW
     entry (type HDSKSPC,
            WCHAR(*) varz byaddr nonasgn,
            type LONGLONG byaddr,
            type PVOID,
            type UINT)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupQuerySpaceRequiredOnDriveW');

 %dcl SetupQuerySpaceRequiredOnDrive char ext;
 %if UNICODE ^= '' %then %do;
   %SetupQuerySpaceRequiredOnDrive='SetupQuerySpaceRequiredOnDriveW';
 %end; %else %do;
   %SetupQuerySpaceRequiredOnDrive='SetupQuerySpaceRequiredOnDriveA';
 %end;


 dcl SetupAdjustDiskSpaceListA
     entry (type HDSKSPC,
            type LPCSTR,
            type LONGLONG,
            type PVOID,
            type UINT)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupAdjustDiskSpaceListA');

 dcl SetupAdjustDiskSpaceListW
     entry (type HDSKSPC,
            type LPCWSTR,
            type LONGLONG,
            type PVOID,
            type UINT)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupAdjustDiskSpaceListW');

 %dcl SetupAdjustDiskSpaceList char ext;
 %if UNICODE ^= '' %then %do;
   %SetupAdjustDiskSpaceList='SetupAdjustDiskSpaceListW';
 %end; %else %do;
   %SetupAdjustDiskSpaceList='SetupAdjustDiskSpaceListA';
 %end;


 dcl SetupAddToDiskSpaceListA
     entry (type HDSKSPC,
            char(*) varz byaddr nonasgn,
            type LONGLONG,
            type UINT,
            type PVOID,
            type UINT)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupAddToDiskSpaceListA');

 dcl SetupAddToDiskSpaceListW
     entry (type HDSKSPC,
            WCHAR(*) varz byaddr nonasgn,
            type LONGLONG,
            type UINT,
            type PVOID,
            type UINT)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupAddToDiskSpaceListW');

 %dcl SetupAddToDiskSpaceList char ext;
 %if UNICODE ^= '' %then %do;
   %SetupAddToDiskSpaceList='SetupAddToDiskSpaceListW';
 %end; %else %do;
   %SetupAddToDiskSpaceList='SetupAddToDiskSpaceListA';
 %end;


 dcl SetupAddSectionToDiskSpaceListA
     entry (type HDSKSPC,
            type HINF,
            type HINF,
            char(*) varz byaddr nonasgn,
            type UINT,
            type PVOID,
            type UINT)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupAddSectionToDiskSpaceListA');

 dcl SetupAddSectionToDiskSpaceListW
     entry (type HDSKSPC,
            type HINF,
            type HINF,
            WCHAR(*) varz byaddr nonasgn,
            type UINT,
            type PVOID,
            type UINT)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupAddSectionToDiskSpaceListW');

 %dcl SetupAddSectionToDiskSpaceList char ext;
 %if UNICODE ^= '' %then %do;
   %SetupAddSectionToDiskSpaceList='SetupAddSectionToDiskSpaceListW';
 %end; %else %do;
   %SetupAddSectionToDiskSpaceList='SetupAddSectionToDiskSpaceListA';
 %end;


 dcl SetupAddInstallSectionToDiskSpaceListA
     entry (type HDSKSPC,
            type HINF,
            type HINF,
            char(*) varz byaddr nonasgn,
            type PVOID,
            type UINT)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI
     external('SetupAddInstallSectionToDiskSpaceListA');

 dcl SetupAddInstallSectionToDiskSpaceListW
     entry (type HDSKSPC,
            type HINF,
            type HINF,
            WCHAR(*) varz byaddr nonasgn,
            type PVOID,
            type UINT)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI
     external('SetupAddInstallSectionToDiskSpaceListW');

 %dcl SetupAddInstallSectionToDiskSpaceList char ext;
 %if UNICODE ^= '' %then %do;
   %SetupAddInstallSectionToDiskSpaceList
     ='SetupAddInstallSectionToDiskSpaceListW';
 %end; %else %do;
   %SetupAddInstallSectionToDiskSpaceList
     ='SetupAddInstallSectionToDiskSpaceListA';
 %end;


 dcl SetupRemoveFromDiskSpaceListA
     entry (type HDSKSPC,
            char(*) varz byaddr nonasgn,
            type UINT,
            type PVOID,
            type UINT)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupRemoveFromDiskSpaceListA');

 dcl SetupRemoveFromDiskSpaceListW
     entry (type HDSKSPC,
            WCHAR(*) varz byaddr nonasgn,
            type UINT,
            type PVOID,
            type UINT)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupRemoveFromDiskSpaceListW');

 %dcl SetupRemoveFromDiskSpaceList char ext;
 %if UNICODE ^= '' %then %do;
   %SetupRemoveFromDiskSpaceList='SetupRemoveFromDiskSpaceListW';
 %end; %else %do;
   %SetupRemoveFromDiskSpaceList='SetupRemoveFromDiskSpaceListA';
 %end;


 dcl SetupRemoveSectionFromDiskSpaceListA
     entry (type HDSKSPC,
            type HINF,
            type HINF,
            char(*) varz byaddr nonasgn,
            type UINT,
            type PVOID,
            type UINT)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI
     external('SetupRemoveSectionFromDiskSpaceListA');

 dcl SetupRemoveSectionFromDiskSpaceListW
     entry (type HDSKSPC,
            type HINF,
            type HINF,
            WCHAR(*) varz byaddr nonasgn,
            type UINT,
            type PVOID,
            type UINT)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI
     external('SetupRemoveSectionFromDiskSpaceListW');

 %dcl SetupRemoveSectionFromDiskSpaceList char ext;
 %if UNICODE ^= '' %then %do;
   %SetupRemoveSectionFromDiskSpaceList
     ='SetupRemoveSectionFromDiskSpaceListW';
 %end; %else %do;
   %SetupRemoveSectionFromDiskSpaceList
     ='SetupRemoveSectionFromDiskSpaceListA';
 %end;


 dcl SetupRemoveInstallSectionFromDiskSpaceListA
     entry (type HDSKSPC,
            type HINF,
            type HINF,
            char(*) varz byaddr nonasgn,
            type PVOID,
            type UINT)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI
     external('SetupRemoveInstallSectionFromDiskSpaceListA');

 dcl SetupRemoveInstallSectionFromDiskSpaceListW
     entry (type HDSKSPC,
            type HINF,
            type HINF,
            WCHAR(*) varz byaddr nonasgn,
            type PVOID,
            type UINT)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI
     external('SetupRemoveInstallSectionFromDiskSpaceListW');

 %dcl SetupRemoveInstallSectionFromDiskSpaceList char ext;
 %if UNICODE ^= '' %then %do;
   %SetupRemoveInstallSectionFromDiskSpaceList
     ='SetupRemoveInstallSectionFromDiskSpaceListW';
 %end; %else %do;
   %SetupRemoveInstallSectionFromDiskSpaceList
     ='SetupRemoveInstallSectionFromDiskSpaceListA';
 %end;


 /* Cabinet APIs */

 dcl SetupIterateCabinetA
     entry (char(*) varz byaddr nonasgn,
            type DWORD,
            type PSP_FILE_CALLBACK_A,
            type PVOID)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupIterateCabinetA');

 dcl SetupIterateCabinetW
     entry (WCHAR(*) varz byaddr nonasgn,
            type DWORD,
            type PSP_FILE_CALLBACK_W,
            type PVOID)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupIterateCabinetW');

 %dcl SetupIterateCabinet char ext;
 %if UNICODE ^= '' %then %do;
   %SetupIterateCabinet='SetupIterateCabinetW';
 %end; %else %do;
   %SetupIterateCabinet='SetupIterateCabinetA';
 %end;


 dcl SetupPromptReboot
     entry (type HSPFILEQ,
            type HWND,
            type BOOL)
     returns (type INT byvalue optional)
     WINSETUPAPI WINAPI external('SetupPromptReboot');

 /* Define flags that are returned by SetupPromptReboot */

 dcl SPFILEQ_FILE_IN_USE        type INT value('00000001'xn);
 dcl SPFILEQ_REBOOT_RECOMMENDED type INT value('00000002'xn);
 dcl SPFILEQ_REBOOT_IN_PROGRESS type INT value('00000004'xn);


 dcl SetupInitDefaultQueueCallback
     entry (type HWND)
     returns (type PVOID byvalue optional)
     WINSETUPAPI WINAPI external('SetupInitDefaultQueueCallback');

 dcl SetupInitDefaultQueueCallbackEx
     entry (type HWND,
            type HWND,
            type UINT,
            type DWORD,
            type PVOID)
     returns (type PVOID byvalue optional)
     WINSETUPAPI WINAPI external('SetupInitDefaultQueueCallbackEx');


 dcl SetupTermDefaultQueueCallback
     entry (type PVOID)
     WINSETUPAPI WINAPI external('SetupTermDefaultQueueCallback');


 dcl SetupDefaultQueueCallbackA
     entry (type PVOID,
            type UINT,
            type UINT_PTR,
            type UINT_PTR)
     returns (type UINT byvalue optional)
     WINSETUPAPI WINAPI external('SetupDefaultQueueCallbackA');

 dcl SetupDefaultQueueCallbackW
     entry (type PVOID,
            type UINT,
            type UINT_PTR,
            type UINT_PTR)
     returns (type UINT byvalue optional)
     WINSETUPAPI WINAPI external('SetupDefaultQueueCallbackW');

 %dcl SetupDefaultQueueCallback char ext;
 %if UNICODE ^= '' %then %do;
   %SetupDefaultQueueCallback='SetupDefaultQueueCallbackW';
 %end; %else %do;
   %SetupDefaultQueueCallback='SetupDefaultQueueCallbackA';
 %end;



 /* Flags for AddReg section lines in INF.  The corresponding value   */
 /* is <ValueType> in the AddReg line format given below:             */

 /* <RegRootString>,<SubKey>,<ValueName>,<ValueType>,<Value>...       */

 /* The low word contains basic flags concerning the general data     */
 /* type and AddReg action. The high word contains values that more   */
 /* specifically identify the data type of the registry value.        */
 /* The high word is ignored by the 16-bit Windows 95 SETUPX APIs.    */

 dcl FLG_ADDREG_BINVALUETYPE     type DWORD value('00000001'xu);
 dcl FLG_ADDREG_NOCLOBBER        type DWORD value('00000002'xu);
 dcl FLG_ADDREG_DELVAL           type DWORD value('00000004'xu);
 dcl FLG_ADDREG_APPEND           type DWORD value('00000008'xu);
     /* Currently supported only for REG_MULTI_SZ values. */
 dcl FLG_ADDREG_KEYONLY          type DWORD value('00000010'xu);
     /* Just create the key, ignore value */
 dcl FLG_ADDREG_OVERWRITEONLY    type DWORD value('00000020'xu);
     /* Set only if value already exists */

 dcl FLG_ADDREG_TYPE_MASK        type DWORD
     value(ior('FFFF0000'xu, FLG_ADDREG_BINVALUETYPE));

 dcl FLG_ADDREG_TYPE_SZ          type DWORD value('00000000'xu);
 dcl FLG_ADDREG_TYPE_MULTI_SZ    type DWORD value('00010000'xu);
 dcl FLG_ADDREG_TYPE_EXPAND_SZ   type DWORD value('00020000'xu);
 dcl FLG_ADDREG_TYPE_BINARY      type DWORD
     value(ior('00000000'xu, FLG_ADDREG_BINVALUETYPE));
 dcl FLG_ADDREG_TYPE_DWORD       type DWORD
     value(ior('00010000'xu, FLG_ADDREG_BINVALUETYPE));
 dcl FLG_ADDREG_TYPE_NONE        type DWORD
     value(ior('00020000'xu, FLG_ADDREG_BINVALUETYPE));


 /* Flags for BitReg section lines in INF. */

 dcl FLG_BITREG_CLEARBITS        type DWORD value('00000000'xu);
 dcl FLG_BITREG_SETBITS          type DWORD value('00000001'xu);


 /* Flags for RegSvr section lines in INF */

 dcl FLG_REGSVR_DLLREGISTER      type DWORD value('00000001'xu);
 dcl FLG_REGSVR_DLLINSTALL       type DWORD value('00000002'xu);

 /* Flags for RegSvr section lines in INF */

 dcl FLG_PROFITEM_CURRENTUSER    type DWORD value('00000001'xu);
 dcl FLG_PROFITEM_DELETE         type DWORD value('00000002'xu);
 dcl FLG_PROFITEM_GROUP          type DWORD value('00000004'xu);



 /* The INF may supply any arbitrary data type ordinal in the         */
 /* highword except for the following: REG_NONE, REG_SZ,              */
 /* REG_EXPAND_SZ, REG_MULTI_SZ. If this technique is used, then the  */
 /* data is given in binary format, one byte per field.               */


 dcl SetupInstallFromInfSectionA
     entry (type HWND,
            type HINF,
            char(*) varz byaddr nonasgn,
            type UINT,
            type HKEY,
            char(*) varz byaddr nonasgn optional,
            type UINT,
            type PSP_FILE_CALLBACK_A optional byvalue,
            type PVOID,
            type HDEVINFO,
            type SP_DEVINFO_DATA byaddr optional)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupInstallFromInfSectionA');

 dcl SetupInstallFromInfSectionW
     entry (type HWND,
            type HINF,
            WCHAR(*) varz byaddr nonasgn,
            type UINT,
            type HKEY,
            WCHAR(*) varz byaddr nonasgn optional,
            type UINT,
            type PSP_FILE_CALLBACK_W optional byvalue,
            type PVOID,
            type HDEVINFO,
            type SP_DEVINFO_DATA byaddr optional)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupInstallFromInfSectionW');

 %dcl SetupInstallFromInfSection char ext;
 %if UNICODE ^= '' %then %do;
   %SetupInstallFromInfSection='SetupInstallFromInfSectionW';
 %end; %else %do;
   %SetupInstallFromInfSection='SetupInstallFromInfSectionA';
 %end;


 /* Flags for SetupInstallFromInfSection */

 dcl SPINST_LOGCONFIG                type UINT value('00000001'xu);
 dcl SPINST_INIFILES                 type UINT value('00000002'xu);
 dcl SPINST_REGISTRY                 type UINT value('00000004'xu);
 dcl SPINST_INI2REG                  type UINT value('00000008'xu);
 dcl SPINST_FILES                    type UINT value('00000010'xu);
 dcl SPINST_BITREG                   type UINT value('00000020'xu);
 dcl SPINST_REGSVR                   type UINT value('00000040'xu);
 dcl SPINST_UNREGSVR                 type UINT value('00000080'xu);
 dcl SPINST_PROFILEITEMS             type UINT value('00000100'xu);
 dcl SPINST_ALL                      type UINT value('000001ff'xu);
 dcl SPINST_SINGLESECTION            type UINT value('00010000'xu);
 dcl SPINST_LOGCONFIG_IS_FORCED      type UINT value('00020000'xu);
 dcl SPINST_LOGCONFIGS_ARE_OVERRIDES type UINT value('00040000'xu);


 dcl SetupInstallFilesFromInfSectionA
     entry (type HINF,
            type HINF,
            type HSPFILEQ,
            char(*) varz byaddr nonasgn,
            char(*) varz byaddr nonasgn optional,
            type UINT)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupInstallFilesFromInfSectionA');

 dcl SetupInstallFilesFromInfSectionW
     entry (type HINF,
            type HINF,
            type HSPFILEQ,
            WCHAR(*) varz byaddr nonasgn,
            WCHAR(*) varz byaddr nonasgn optional,
            type UINT)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupInstallFilesFromInfSectionW');

 %dcl SetupInstallFilesFromInfSection char ext;
 %if UNICODE ^= '' %then %do;
   %SetupInstallFilesFromInfSection='SetupInstallFilesFromInfSectionW';
 %end; %else %do;
   %SetupInstallFilesFromInfSection='SetupInstallFilesFromInfSectionA';
 %end;


 /* Flags for SetupInstallServicesFromInfSection(Ex). These flags are */
 /* also used in the flags field of AddService or DelService lines in */
 /* a device INF. Some of these flags are not permitted in the non-Ex */
 /* API. These flags are marked as such below.                        */


 /* (AddService) move service's tag to front of its group order list  */
 dcl SPSVCINST_TAGTOFRONT                 type UINT value('00000001'xu);


 /* (AddService) **Ex API only** mark this service as the function    */
 /* driver for the device being installed                             */
 dcl SPSVCINST_ASSOCSERVICE               type UINT value('00000002'xu);


 /* (DelService) delete the associated event log entry for a service  */
 /* specified in a DelService entry                                   */
 dcl SPSVCINST_DELETEEVENTLOGENTRY        type UINT value('00000004'xu);


 /* (AddService) don't overwrite display name if it already exists    */
 dcl SPSVCINST_NOCLOBBER_DISPLAYNAME      type UINT value('00000008'xu);


 /* (AddService) don't overwrite start type value if service already  */
 /* exists                                                            */
 dcl SPSVCINST_NOCLOBBER_STARTTYPE        type UINT value('00000010'xu);


 /* (AddService) don't overwrite error control value if service       */
 /* already exists                                                    */
 dcl SPSVCINST_NOCLOBBER_ERRORCONTROL     type UINT value('00000020'xn);


 /* (AddService) don't overwrite load order group if it already exists*/
 dcl SPSVCINST_NOCLOBBER_LOADORDERGROUP   type UINT value('00000040'xu);


 /* (AddService) don't overwrite dependencies list if it already      */
 /* exists                                                            */
 dcl SPSVCINST_NOCLOBBER_DEPENDENCIES     type UINT value('00000080'xu);


 /* (AddService) don't overwrite description if it already exists     */
 dcl SPSVCINST_NOCLOBBER_DESCRIPTION      type UINT value('00000100'xu);


 dcl SetupInstallServicesFromInfSectionA
     entry (type HINF,
            char(*) varz byaddr nonasgn,
            type DWORD)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupInstallServicesFromInfSectionA');

 dcl SetupInstallServicesFromInfSectionW
     entry (type HINF,
            WCHAR(*) varz byaddr nonasgn,
            type DWORD)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupInstallServicesFromInfSectionW');

 %dcl SetupInstallServicesFromInfSection char ext;
 %if UNICODE ^= '' %then %do;
   %SetupInstallServicesFromInfSection
     ='SetupInstallServicesFromInfSectionW';
 %end; %else %do;
   %SetupInstallServicesFromInfSection
     ='SetupInstallServicesFromInfSectionA';
 %end;


 dcl SetupInstallServicesFromInfSectionExA
     entry (type HINF,
            char(*) varz byaddr nonasgn,
            type DWORD,
            type HDEVINFO,
            type SP_DEVINFO_DATA byaddr optional,
            type PVOID,
            type PVOID)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI
     external('SetupInstallServicesFromInfSectionExA');

 dcl SetupInstallServicesFromInfSectionExW
     entry (type HINF,
            WCHAR(*) varz byaddr nonasgn,
            type DWORD,
            type HDEVINFO,
            type SP_DEVINFO_DATA byaddr optional,
            type PVOID,
            type PVOID)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI
     external('SetupInstallServicesFromInfSectionExW');

 %dcl SetupInstallServicesFromInfSectionEx char ext;
 %if UNICODE ^= '' %then %do;
   %SetupInstallServicesFromInfSectionEx
     ='SetupInstallServicesFromInfSectionExW';
 %end; %else %do;
   %SetupInstallServicesFromInfSectionEx
     ='SetupInstallServicesFromInfSectionExA';
 %end;


 /* Define handle type for Setup file log. */

 define alias HSPFILELOG type PVOID;


 dcl SetupInitializeFileLogA
     entry (char(*) varz byaddr nonasgn optional,
            type DWORD)
     returns (type HSPFILELOG byvalue optional)
     WINSETUPAPI WINAPI external('SetupInitializeFileLogA');

 dcl SetupInitializeFileLogW
     entry (WCHAR(*) varz byaddr nonasgn optional,
            type DWORD)
     returns (type HSPFILELOG byvalue optional)
     WINSETUPAPI WINAPI external('SetupInitializeFileLogW');

 %dcl SetupInitializeFileLog char ext;
 %if UNICODE ^= '' %then %do;
   %SetupInitializeFileLog='SetupInitializeFileLogW';
 %end; %else %do;
   %SetupInitializeFileLog='SetupInitializeFileLogA';
 %end;


 /* Flags for SetupInitializeFileLog */

 dcl SPFILELOG_SYSTEMLOG type DWORD value('00000001'xn);
    /* use system log -- must be Administrator */
 dcl SPFILELOG_FORCENEW  type DWORD value('00000002'xn);
    /* not valid with SPFILELOG_SYSTEMLOG */
 dcl SPFILELOG_QUERYONLY type DWORD value('00000004'xn);
    /* allows non-administrators to read system log */


 dcl SetupTerminateFileLog
     entry (type HSPFILELOG)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupTerminateFileLog');

 dcl SetupLogFileA
     entry (type HSPFILELOG,
            char(*) varz byaddr nonasgn optional,
            char(*) varz byaddr nonasgn,
            char(*) varz byaddr nonasgn,
            type DWORD,
            char(*) varz byaddr nonasgn optional,
            char(*) varz byaddr nonasgn optional,
            char(*) varz byaddr nonasgn optional,
            type DWORD)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupLogFileA');

 dcl SetupLogFileW
     entry (type HSPFILELOG,
            WCHAR(*) varz byaddr nonasgn optional,
            WCHAR(*) varz byaddr nonasgn,
            WCHAR(*) varz byaddr nonasgn,
            type DWORD,
            WCHAR(*) varz byaddr nonasgn optional,
            WCHAR(*) varz byaddr nonasgn optional,
            WCHAR(*) varz byaddr nonasgn optional,
            type DWORD)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupLogFileW');

 %dcl SetupLogFile char ext;
 %if UNICODE ^= '' %then %do;
   %SetupLogFile='SetupLogFileW';
 %end; %else %do;
   %SetupLogFile='SetupLogFileA';
 %end;

 /* Flags for SetupLogFile */

 dcl SPFILELOG_OEMFILE type DWORD value('00000001'xu);


 dcl SetupRemoveFileLogEntryA
     entry (type HSPFILELOG,
            char(*) varz byaddr nonasgn optional,
            char(*) varz byaddr nonasgn optional)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupRemoveFileLogEntryA');

 dcl SetupRemoveFileLogEntryW
     entry (type HSPFILELOG,
            WCHAR(*) varz byaddr nonasgn optional,
            WCHAR(*) varz byaddr nonasgn optional)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupRemoveFileLogEntryW');

 %dcl SetupRemoveFileLogEntry char ext;
 %if UNICODE ^= '' %then %do;
   %SetupRemoveFileLogEntry='SetupRemoveFileLogEntryW';
 %end; %else %do;
   %SetupRemoveFileLogEntry='SetupRemoveFileLogEntryA';
 %end;


 /* Items retrievable from SetupQueryFileLog() */

 define ordinal SetupFileLogInfo
   ( SetupFileLogSourceFilename,
     SetupFileLogChecksum,
     SetupFileLogDiskTagfile,
     SetupFileLogDiskDescription,
     SetupFileLogOtherInfo,
     SetupFileLogMax
   ) prec(31);


 dcl SetupQueryFileLogA
     entry (type HSPFILELOG,
            char(*) varz byaddr nonasgn optional,
            char(*) varz byaddr nonasgn,
            type SetupFileLogInfo,
            char(*) varz byaddr optional,
            type DWORD,
            type DWORD byaddr optional)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupQueryFileLogA');

 dcl SetupQueryFileLogW
     entry (type HSPFILELOG,
            WCHAR(*) varz byaddr nonasgn optional,
            WCHAR(*) varz byaddr nonasgn,
            type SetupFileLogInfo,
            WCHAR(*) varz byaddr optional,
            type DWORD,
            type DWORD byaddr optional)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupQueryFileLogW');

 %dcl SetupQueryFileLog char ext;
 %if UNICODE ^= '' %then %do;
   %SetupQueryFileLog='SetupQueryFileLogW';
 %end; %else %do;
   %SetupQueryFileLog='SetupQueryFileLogA';
 %end;


 /* Text logging APIs */

 define alias LogSeverity type DWORD;
 dcl LogSevInformation    type LogSeverity value('00000000'xu);
 dcl LogSevWarning        type LogSeverity value('00000001'xu);
 dcl LogSevError          type LogSeverity value('00000002'xu);
 dcl LogSevFatalError     type LogSeverity value('00000003'xu);
 dcl LogSevMaximum        type LogSeverity value('00000004'xu);


 dcl SetupOpenLog
     entry (type BOOL)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupOpenLog');


 dcl SetupLogErrorA
     entry (char (*) varz byaddr nonasgn,
            type LogSeverity)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupLogErrorA');

 dcl SetupLogErrorW
     entry (WCHAR (*) varz byaddr nonasgn,
            type LogSeverity)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupLogErrorW');

 %dcl SetupLogError char ext;
 %if UNICODE ^= '' %then %do;
   %SetupLogError='SetupLogErrorW';
 %end; %else %do;
   %SetupLogError='SetupLogErrorA';
 %end;


 dcl SetupCloseLog
     entry ()
     WINSETUPAPI WINAPI external('SetupCloseLog');


 /* Backup Information API */

 dcl SetupGetBackupInformationA
     entry (type HSPFILEQ,
            type SP_BACKUP_QUEUE_PARAMS_A byaddr)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupGetBackupInformationA');

 dcl SetupGetBackupInformationW
     entry (type HSPFILEQ,
            type SP_BACKUP_QUEUE_PARAMS_W byaddr)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupGetBackupInformationW');


 %dcl SetupGetBackupInformation char ext;
 %if UNICODE ^= '' %then %do;
   %SetupGetBackupInformation='SetupGetBackupInformationW';
 %end; %else %do;
   %SetupGetBackupInformation='SetupGetBackupInformationA';
 %end;



 /* Device Installer APIs */

 dcl SetupDiCreateDeviceInfoList
     entry (type GUID byaddr optional,
            type HWND)
     returns (type HDEVINFO byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiCreateDeviceInfoList');


 dcl SetupDiCreateDeviceInfoListExA
     entry (type GUID byaddr nonasgn optional,
            type HWND,
            char(*) varz byaddr nonasgn optional,
            type PVOID)
     returns (type HDEVINFO byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiCreateDeviceInfoListExA');

 dcl SetupDiCreateDeviceInfoListExW
     entry (type GUID byaddr nonasgn optional,
            type HWND optional,
            WCHAR(*) varz byaddr nonasgn optional,
            type PVOID)
     returns (type HDEVINFO byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiCreateDeviceInfoListExW');

 %dcl SetupDiCreateDeviceInfoListEx char ext;
 %if UNICODE ^= '' %then %do;
   %SetupDiCreateDeviceInfoListEx='SetupDiCreateDeviceInfoListExW';
 %end; %else %do;
   %SetupDiCreateDeviceInfoListEx='SetupDiCreateDeviceInfoListExA';
 %end;


 dcl SetupDiGetDeviceInfoListClass
     entry (type HDEVINFO,
            type GUID byaddr)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiGetDeviceInfoListClass');


 dcl SetupDiGetDeviceInfoListDetailA
     entry (type HDEVINFO,
            type SP_DEVINFO_LIST_DETAIL_DATA_A byaddr)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiGetDeviceInfoListDetailA');

 dcl SetupDiGetDeviceInfoListDetailW
     entry (type HDEVINFO,
            type SP_DEVINFO_LIST_DETAIL_DATA_W byaddr)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiGetDeviceInfoListDetailW');

 %dcl SetupDiGetDeviceInfoListDetail char ext;
 %if UNICODE ^= '' %then %do;
   %SetupDiGetDeviceInfoListDetail='SetupDiGetDeviceInfoListDetailW';
 %end; %else %do;
   %SetupDiGetDeviceInfoListDetail='SetupDiGetDeviceInfoListDetailA';
 %end;


 /* Flags for SetupDiCreateDeviceInfo */

 dcl DICD_GENERATE_ID       type DWORD value('00000001'xu);
 dcl DICD_INHERIT_CLASSDRVS type DWORD value('00000002'xu);

 dcl SetupDiCreateDeviceInfoA
     entry (type HDEVINFO,
            char(*) varz byaddr nonasgn,
            type GUID byaddr nonasgn,
            char(*) varz byaddr nonasgn optional,
            type HWND,
            type DWORD,
            type SP_DEVINFO_DATA byaddr optional)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiCreateDeviceInfoA');

 dcl SetupDiCreateDeviceInfoW
     entry (type HDEVINFO,
            WCHAR(*) varz byaddr nonasgn,
            type GUID byaddr nonasgn,
            WCHAR(*) varz byaddr nonasgn optional,
            type HWND,
            type DWORD,
            type SP_DEVINFO_DATA byaddr optional)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiCreateDeviceInfoW');

 %dcl SetupDiCreateDeviceInfo char ext;
 %if UNICODE ^= '' %then %do;
   %SetupDiCreateDeviceInfo='SetupDiCreateDeviceInfoW';
 %end; %else %do;
   %SetupDiCreateDeviceInfo='SetupDiCreateDeviceInfoA';
 %end;


 /* Flags for SetupDiOpenDeviceInfo */

 dcl DIOD_INHERIT_CLASSDRVS type DWORD value('00000002'xu);
 dcl DIOD_CANCEL_REMOVE     type DWORD value('00000004'xu);

 dcl SetupDiOpenDeviceInfoA
     entry (type HDEVINFO,
            char(*) varz byaddr nonasgn,
            type HWND,
            type DWORD,
            type SP_DEVINFO_DATA byaddr optional)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiOpenDeviceInfoA');

 dcl SetupDiOpenDeviceInfoW
     entry (type HDEVINFO,
            WCHAR(*) varz byaddr nonasgn,
            type HWND,
            type DWORD,
            type SP_DEVINFO_DATA byaddr optional)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiOpenDeviceInfoW');

 %dcl SetupDiOpenDeviceInfo char ext;
 %if UNICODE ^= '' %then %do;
   %SetupDiOpenDeviceInfo='SetupDiOpenDeviceInfoW';
 %end; %else %do;
   %SetupDiOpenDeviceInfo='SetupDiOpenDeviceInfoA';
 %end;


 dcl SetupDiGetDeviceInstanceIdA
     entry (type HDEVINFO,
            type SP_DEVINFO_DATA byaddr,
            char(*) varz byaddr,
            type DWORD,
            type DWORD byaddr optional)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiGetDeviceInstanceIdA');

 dcl SetupDiGetDeviceInstanceIdW
     entry (type HDEVINFO,
            type SP_DEVINFO_DATA byaddr,
            WCHAR(*) varz byaddr,
            type DWORD,
            type DWORD byaddr)
     returns (type BOOL byvalue optional optional)
     WINSETUPAPI WINAPI external('SetupDiGetDeviceInstanceIdW');

 %dcl SetupDiGetDeviceInstanceId char ext;
 %if UNICODE ^= '' %then %do;
   %SetupDiGetDeviceInstanceId='SetupDiGetDeviceInstanceIdW';
 %end; %else %do;
   %SetupDiGetDeviceInstanceId='SetupDiGetDeviceInstanceIdA';
 %end;


 dcl SetupDiDeleteDeviceInfo
     entry (type HDEVINFO,
            type SP_DEVINFO_DATA byaddr)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiDeleteDeviceInfo');


 dcl SetupDiEnumDeviceInfo
     entry (type HDEVINFO,
            type DWORD,
            type SP_DEVINFO_DATA byaddr)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiEnumDeviceInfo');


 dcl SetupDiDestroyDeviceInfoList
     entry (type HDEVINFO)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiDestroyDeviceInfoList');


 dcl SetupDiEnumDeviceInterfaces
     entry (type HDEVINFO,
            type SP_DEVINFO_DATA byaddr optional,
            type GUID byaddr nonasgn,
            type DWORD,
            type SP_DEVICE_INTERFACE_DATA byaddr)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiEnumDeviceInterfaces');


 /* Backward compatibility--do not use */

 %dcl SetupDiEnumInterfaceDevice char ext;
 %SetupDiEnumInterfaceDevice='SetupDiEnumDeviceInterfaces';


 dcl SetupDiCreateDeviceInterfaceA
     entry (type HDEVINFO,
            type SP_DEVINFO_DATA byaddr,
            type GUID byaddr,
            char(*) varz byaddr nonasgn optional,
            type DWORD,
            type SP_DEVICE_INTERFACE_DATA byaddr optional)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiCreateDeviceInterfaceA');

 dcl SetupDiCreateDeviceInterfaceW
     entry (type HDEVINFO,
            type SP_DEVINFO_DATA byaddr,
            type GUID byaddr,
            WCHAR(*) varz byaddr nonasgn optional,
            type DWORD,
            type SP_DEVICE_INTERFACE_DATA byaddr optional)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiCreateDeviceInterfaceW');

 %dcl SetupDiCreateDeviceInterface char ext;
 %if UNICODE ^= '' %then %do;
   %SetupDiCreateDeviceInterface='SetupDiCreateDeviceInterfaceW';
 %end; %else %do;
   %SetupDiCreateDeviceInterface='SetupDiCreateDeviceInterfaceA';
 %end;


 /* Backward compatibility--do not use. */

 %dcl SetupDiCreateInterfaceDeviceW char ext;
 %SetupDiCreateInterfaceDeviceW='SetupDiCreateDeviceInterfaceW';
 %dcl SetupDiCreateInterfaceDeviceA char ext;
 %SetupDiCreateInterfaceDeviceA='SetupDiCreateDeviceInterfaceA';

 %dcl SetupDiCreateInterfaceDevice char ext;
 %if UNICODE ^= '' %then %do;
 %SetupDiCreateInterfaceDevice='SetupDiCreateDeviceInterfaceW';
 %end; %else %do;
   %SetupDiCreateInterfaceDevice='SetupDiCreateDeviceInterfaceA';
 %end;


 /* Flags for SetupDiOpenDeviceInterface */

 dcl DIODI_NO_ADD type DWORD value('00000001'xn);

 dcl SetupDiOpenDeviceInterfaceA
     entry (type HDEVINFO,
            char(*) varz byaddr nonasgn,
            type DWORD,
            type SP_DEVICE_INTERFACE_DATA byaddr optional)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiOpenDeviceInterfaceA');

 dcl SetupDiOpenDeviceInterfaceW
     entry (type HDEVINFO,
            WCHAR(*) varz byaddr nonasgn,
            type DWORD,
            type SP_DEVICE_INTERFACE_DATA byaddr optional)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiOpenDeviceInterfaceW');

 %dcl SetupDiOpenDeviceInterface char ext;
 %if UNICODE ^= '' %then %do;
   %SetupDiOpenDeviceInterface='SetupDiOpenDeviceInterfaceW';
 %end; %else %do;
   %SetupDiOpenDeviceInterface='SetupDiOpenDeviceInterfaceA';
 %end;

 /* Backward compatibility--do not use */

 %dcl SetupDiOpenInterfaceDeviceW char ext;
 %SetupDiOpenInterfaceDeviceW='SetupDiOpenDeviceInterfaceW';
 %dcl SetupDiOpenInterfaceDeviceA char ext;
 %SetupDiOpenInterfaceDeviceA='SetupDiOpenDeviceInterfaceA';

 %dcl SetupDiOpenInterfaceDevice char ext;
 %if UNICODE ^= '' %then %do;
   %SetupDiOpenInterfaceDevice='SetupDiOpenDeviceInterfaceW';
 %end; %else %do;
   %SetupDiOpenInterfaceDevice='SetupDiOpenDeviceInterfaceA';
 %end;


 dcl SetupDiGetDeviceInterfaceAlias
     entry (type HDEVINFO,
            type SP_DEVICE_INTERFACE_DATA byaddr,
            type GUID byaddr nonasgn,
            type SP_DEVICE_INTERFACE_DATA byaddr)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiGetDeviceInterfaceAlias');

 /* Backward compatibility--do not use. */

 %dcl SetupDiGetInterfaceDeviceAlias char ext;
 %SetupDiGetInterfaceDeviceAlias='SetupDiGetDeviceInterfaceAliaS';


 dcl SetupDiDeleteDeviceInterfaceData
     entry (type HDEVINFO,
            type SP_DEVICE_INTERFACE_DATA byaddr)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiDeleteDeviceInterfaceData');

 /* Backward compatibility--do not use. */

 %dcl SetupDiDeleteInterfaceDeviceData char ext;
 %SetupDiDeleteInterfaceDeviceData='SetupDiDeleteDeviceInterfaceData';


 dcl SetupDiRemoveDeviceInterface
     entry (type HDEVINFO,
            type SP_DEVICE_INTERFACE_DATA byaddr)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiRemoveDeviceInterface');

 /* Backward compatibility--do not use. */

 %dcl SetupDiRemoveInterfaceDevice char ext;
 %SetupDiRemoveInterfaceDevice='SetupDiRemoveDeviceInterface';


 dcl SetupDiGetDeviceInterfaceDetailA
     entry (type HDEVINFO,
            type SP_DEVICE_INTERFACE_DATA byaddr,
            type SP_DEVICE_INTERFACE_DETAIL_DATA_A byaddr optional,
            type DWORD,
            type DWORD byaddr optional,
            type SP_DEVINFO_DATA byaddr optional)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiGetDeviceInterfaceDetailA');

 dcl SetupDiGetDeviceInterfaceDetailW
     entry (type HDEVINFO,
            type SP_DEVICE_INTERFACE_DATA byaddr,
            type SP_DEVICE_INTERFACE_DETAIL_DATA_W byaddr optional,
            type DWORD,
            type DWORD byaddr optional,
            type SP_DEVINFO_DATA byaddr optional)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiGetDeviceInterfaceDetailW');

 %dcl SetupDiGetDeviceInterfaceDetail char ext;
 %if UNICODE ^= '' %then %do;
   %SetupDiGetDeviceInterfaceDetail='SetupDiGetDeviceInterfaceDetailW';
 %end; %else %do;
   %SetupDiGetDeviceInterfaceDetail='SetupDiGetDeviceInterfaceDetailA';
 %end;

 /* Backward compatibility--do not use. */

 %dcl SetupDiGetInterfaceDeviceDetailW char ext;
 %SetupDiGetInterfaceDeviceDetailW='SetupDiGetDeviceInterfaceDetailW';
 %dcl SetupDiGetInterfaceDeviceDetailA char ext;
 %SetupDiGetInterfaceDeviceDetailA='SetupDiGetDeviceInterfaceDetailA';

 %dcl SetupDiGetInterfaceDeviceDetail char ext;
 %if UNICODE ^= '' %then %do;
   %SetupDiGetInterfaceDeviceDetail='SetupDiGetDeviceInterfaceDetailW';
 %end; %else %do;
   %SetupDiGetInterfaceDeviceDetail='SetupDiGetDeviceInterfaceDetailA';
 %end;


 /* Default install handler for DIF_INSTALLINTERFACES. */

 dcl SetupDiInstallDeviceInterfaces
     entry (type HDEVINFO,
            type SP_DEVINFO_DATA byaddr)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiInstallDeviceInterfaces');

 /* Backward compatibility--do not use. */

 %dcl SetupDiInstallInterfaceDevices char ext;
 %SetupDiInstallInterfaceDevices='SetupDiInstallDeviceInterfaceS';


 /* Default install handler for DIF_REGISTERDEVICE */

 /* Flags for SetupDiRegisterDeviceInfo */

 dcl SPRDI_FIND_DUPS type DWORD value('00000001'xn);

 dcl SetupDiRegisterDeviceInfo
     entry (type HDEVINFO,
            type SP_DEVINFO_DATA byaddr,
            type DWORD,
            type PSP_DETSIG_CMPPROC optional byvalue,
            type PVOID,
            type SP_DEVINFO_DATA byaddr optional)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiRegisterDeviceInfo');


 /* Ordinal values distinguishing between class drivers and device    */
 /* drivers. (Passed in 'DriverType' parameter of driver information  */
 /* list APIs)                                                        */

 dcl SPDIT_NODRIVER     type DWORD value('00000000'xu);
 dcl SPDIT_CLASSDRIVER  type DWORD value('00000001'xu);
 dcl SPDIT_COMPATDRIVER type DWORD value('00000002'xu);


 dcl SetupDiBuildDriverInfoList
     entry (type HDEVINFO,
            type SP_DEVINFO_DATA byaddr optional,
            type DWORD)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiBuildDriverInfoList');


 dcl SetupDiCancelDriverInfoSearch
     entry (type HDEVINFO)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiCancelDriverInfoSearch');


 dcl SetupDiEnumDriverInfoA
     entry (type HDEVINFO,
            type SP_DEVINFO_DATA byaddr optional,
            type DWORD,
            type DWORD,
            type SP_DRVINFO_DATA_A byaddr)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiEnumDriverInfoA');

 dcl SetupDiEnumDriverInfoW
     entry (type HDEVINFO,
            type SP_DEVINFO_DATA byaddr optional,
            type DWORD,
            type DWORD,
            type SP_DRVINFO_DATA_W byaddr)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiEnumDriverInfoW');

 %dcl SetupDiEnumDriverInfo char ext;
 %if UNICODE ^= '' %then %do;
   %SetupDiEnumDriverInfo='SetupDiEnumDriverInfoW';
 %end; %else %do;
   %SetupDiEnumDriverInfo='SetupDiEnumDriverInfoA';
 %end;


 dcl SetupDiGetSelectedDriverA
     entry (type HDEVINFO,
            type SP_DEVINFO_DATA byaddr optional,
            type SP_DRVINFO_DATA_A byaddr)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiGetSelectedDriverA');

 dcl SetupDiGetSelectedDriverW
     entry (type HDEVINFO,
            type SP_DEVINFO_DATA byaddr optional,
            type SP_DRVINFO_DATA_W byaddr)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiGetSelectedDriverW');

 %dcl SetupDiGetSelectedDriver char ext;
 %if UNICODE ^= '' %then %do;
   %SetupDiGetSelectedDriver='SetupDiGetSelectedDriverW';
 %end; %else %do;
   %SetupDiGetSelectedDriver='SetupDiGetSelectedDriverA';
 %end;


 dcl SetupDiSetSelectedDriverA
     entry (type HDEVINFO,
            type SP_DEVINFO_DATA byaddr optional,
            type SP_DRVINFO_DATA_A byaddr optional)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiSetSelectedDriverA');


 dcl SetupDiSetSelectedDriverW
    entry (type HDEVINFO,
           type SP_DEVINFO_DATA byaddr optional,
           type SP_DRVINFO_DATA_W byaddr optional)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiSetSelectedDriverW');

 %dcl SetupDiSetSelectedDriver char ext;
 %if UNICODE ^= '' %then %do;
   %SetupDiSetSelectedDriver='SetupDiSetSelectedDriverW';
 %end; %else %do;
   %SetupDiSetSelectedDriver='SetupDiSetSelectedDriverA';
 %end;


 dcl SetupDiGetDriverInfoDetailA
     entry (type HDEVINFO,
            type SP_DEVINFO_DATA byaddr optional,
            type SP_DRVINFO_DATA_A byaddr,
            type SP_DRVINFO_DETAIL_DATA_A byaddr optional,
            type DWORD,
            type DWORD byaddr optional)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiGetDriverInfoDetailA');

 dcl SetupDiGetDriverInfoDetailW
     entry (type HDEVINFO,
            type SP_DEVINFO_DATA byaddr optional,
            type SP_DRVINFO_DATA_W byaddr,
            type SP_DRVINFO_DETAIL_DATA_W byaddr optional,
            type DWORD,
            type DWORD byaddr optional)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiGetDriverInfoDetailW');

 %dcl SetupDiGetDriverInfoDetail char ext;
 %if UNICODE ^= '' %then %do;
   %SetupDiGetDriverInfoDetail='SetupDiGetDriverInfoDetailW';
 %end; %else %do;
   %SetupDiGetDriverInfoDetail='SetupDiGetDriverInfoDetailA';
 %end;


 dcl SetupDiDestroyDriverInfoList
     entry (type HDEVINFO,
            type SP_DEVINFO_DATA byaddr optional,
            type DWORD)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiDestroyDriverInfoList');


 /* Flags controlling what is included in the device information set */
 /* built by SetupDiGetClassDevs                                     */

 dcl DIGCF_DEFAULT         type DWORD value('00000001'xu);
     /* only valid with DIGCF_DEVICEINTERFACE */
 dcl DIGCF_PRESENT         type DWORD value('00000002'xu);
 dcl DIGCF_ALLCLASSES      type DWORD value('00000004'xu);
 dcl DIGCF_PROFILE         type DWORD value('00000008'xu);
 dcl DIGCF_DEVICEINTERFACE type DWORD value('00000010'xu);

 /* Backward compatibility--do not use. */

 dcl DIGCF_INTERFACEDEVICE type DWORD value(DIGCF_DEVICEINTERFACE);


 dcl SetupDiGetClassDevsA
     entry (type GUID byaddr nonasgn optional,
            char(*) varz byaddr nonasgn optional,
            type HWND,
            type DWORD)
     returns (type HDEVINFO byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiGetClassDevsA');

 dcl SetupDiGetClassDevsW
     entry (type GUID byaddr nonasgn optional,
            WCHAR(*) varz byaddr nonasgn optional,
            type HWND,
            type DWORD)
     returns (type HDEVINFO byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiGetClassDevsW');

 %dcl SetupDiGetClassDevs char ext;
 %if UNICODE ^= '' %then %do;
   %SetupDiGetClassDevs='SetupDiGetClassDevsW';
 %end; %else %do;
   %SetupDiGetClassDevs='SetupDiGetClassDevsA';
 %end;


 dcl SetupDiGetClassDevsExA
     entry (type GUID byaddr nonasgn optional,
            char(*) varz byaddr nonasgn optional,
            type HWND,
            type DWORD,
            type HDEVINFO,
            char(*) varz byaddr nonasgn optional,
            type PVOID)
     returns (type HDEVINFO byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiGetClassDevsExA');

 dcl SetupDiGetClassDevsExW
     entry (type GUID byaddr nonasgn optional,
            WCHAR(*) varz byaddr nonasgn optional,
            type HWND,
            type DWORD,
            type HDEVINFO,
            WCHAR(*) varz byaddr nonasgn optional,
            type PVOID)
     returns (type HDEVINFO byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiGetClassDevsExW');

 %dcl SetupDiGetClassDevsEx char ext;
 %if UNICODE ^= '' %then %do;
   %SetupDiGetClassDevsEx='SetupDiGetClassDevsExW';
 %end; %else %do;
   %SetupDiGetClassDevsEx='SetupDiGetClassDevsExA';
 %end;


 dcl SetupDiGetINFClassA
     entry (char(*) varz byaddr nonasgn,
            type GUID byaddr,
            char(*) varz byaddr,
            type DWORD,
            type DWORD byaddr optional)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiGetINFClassA');

 dcl SetupDiGetINFClassW
     entry (WCHAR(*) varz byaddr nonasgn,
            type GUID byaddr,
            WCHAR(*) varz byaddr,
            type DWORD,
            type DWORD byaddr optional)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiGetINFClassW');

 %dcl SetupDiGetINFClass char ext;
 %if UNICODE ^= '' %then %do;
   %SetupDiGetINFClass='SetupDiGetINFClassW';
 %end; %else %do;
   %SetupDiGetINFClass='SetupDiGetINFClassA';
 %end;


 /* Flags controlling exclusion from the class information list built */
 /* by SetupDiBuildClassInfoList(Ex)                                  */

 dcl DIBCI_NOINSTALLCLASS type DWORD value('00000001'xu);
 dcl DIBCI_NODISPLAYCLASS type DWORD value('00000002'xu);

 dcl SetupDiBuildClassInfoList
     entry (type DWORD,
            type GUID byaddr,
            type DWORD,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiBuildClassInfoList');


 dcl SetupDiBuildClassInfoListExA
     entry (type DWORD,
            type GUID byaddr,
            type DWORD,
            type DWORD byaddr,
            char(*) varz byaddr nonasgn optional,
            type PVOID)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiBuildClassInfoListExA');

 dcl SetupDiBuildClassInfoListExW
     entry (type DWORD,
            type GUID byaddr,
            type DWORD,
            type DWORD byaddr,
            WCHAR(*) varz byaddr nonasgn optional,
            type PVOID)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiBuildClassInfoListExW');

 %dcl SetupDiBuildClassInfoListEx char ext;
 %if UNICODE ^= '' %then %do;
   %SetupDiBuildClassInfoListEx='SetupDiBuildClassInfoListExW';
 %end; %else %do;
   %SetupDiBuildClassInfoListEx='SetupDiBuildClassInfoListExA';
 %end;


 dcl SetupDiGetClassDescriptionA
     entry (type GUID byaddr nonasgn,
            char(*) varz byaddr,
            type DWORD,
            type DWORD byaddr optional)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiGetClassDescriptionA');

 dcl SetupDiGetClassDescriptionW
     entry (type GUID byaddr nonasgn,
            WCHAR(*) varz byaddr,
            type DWORD,
            type DWORD byaddr optional)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiGetClassDescriptionW');

 %dcl SetupDiGetClassDescription char ext;
 %if UNICODE ^= '' %then %do;
   %SetupDiGetClassDescription='SetupDiGetClassDescriptionW';
 %end; %else %do;
   %SetupDiGetClassDescription='SetupDiGetClassDescriptionA';
 %end;


 dcl SetupDiGetClassDescriptionExA
     entry (type GUID byaddr nonasgn,
            char(*) varz byaddr,
            type DWORD,
            type DWORD byaddr optional,
            char(*) varz byaddr nonasgn optional,
            type PVOID)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiGetClassDescriptionExA');

 dcl SetupDiGetClassDescriptionExW
     entry (type GUID byaddr nonasgn,
            WCHAR(*) varz byaddr,
            type DWORD,
            type DWORD byaddr optional,
            WCHAR(*) varz byaddr nonasgn optional,
            type PVOID)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiGetClassDescriptionExW');

 %dcl SetupDiGetClassDescriptionEx char ext;
 %if UNICODE ^= '' %then %do;
   %SetupDiGetClassDescriptionEx='SetupDiGetClassDescriptionExW';
 %end; %else %do;
   %SetupDiGetClassDescriptionEx='SetupDiGetClassDescriptionExA';
 %end;


 dcl SetupDiCallClassInstaller
     entry (type DI_FUNCTION,
            type HDEVINFO,
            type SP_DEVINFO_DATA byaddr optional)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiCallClassInstaller');


 /* Default install handler for DIF_SELECTDEVICE */

 dcl SetupDiSelectDevice
     entry (type HDEVINFO,
            type SP_DEVINFO_DATA byaddr optional)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiSelectDevice');


 /* Default install handler for DIF_SELECTBESTCOMPATDRV */

 dcl SetupDiSelectBestCompatDrv
     entry (type HDEVINFO,
            type SP_DEVINFO_DATA byaddr optional)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiSelectBestCompatDrv');


 /* Default install handler for DIF_INSTALLDEVICE */

 dcl SetupDiInstallDevice
     entry (type HDEVINFO,
            type SP_DEVINFO_DATA byaddr)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiInstallDevice');


 /* Default install handler for DIF_INSTALLDEVICEFILES */

 dcl SetupDiInstallDriverFiles
     entry (type HDEVINFO,
            type SP_DEVINFO_DATA byaddr)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiInstallDriverFiles');


 /* Default install handler for DIF_REGISTER_COINSTALLERS */

 dcl SetupDiRegisterCoDeviceInstallers
     entry (type HDEVINFO,
            type SP_DEVINFO_DATA byaddr)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiRegisterCoDeviceInstallers');


 /* Default install handler for DIF_REMOVE */

 dcl SetupDiRemoveDevice
     entry (type HDEVINFO,
            type SP_DEVINFO_DATA byaddr)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiRemoveDevice');


 /* Default install handler for DIF_UNREMOVE */

 dcl SetupDiUnremoveDevice
     entry (type HDEVINFO,
            type SP_DEVINFO_DATA byaddr)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiUnremoveDevice');


 /* Default install handler for DIF_MOVEDEVICE */

 dcl SetupDiMoveDuplicateDevice
     entry (type HDEVINFO,
            type SP_DEVINFO_DATA byaddr)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiMoveDuplicateDevice');


 /* Default install handler for DIF_PROPERTYCHANGE */

 dcl SetupDiChangeState
     entry (type HDEVINFO,
            type SP_DEVINFO_DATA byaddr)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiChangeState');


 dcl SetupDiInstallClassA
     entry (type HWND,
            char(*) varz byaddr nonasgn,
            type DWORD,
            type HSPFILEQ)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiInstallClassA');

 dcl SetupDiInstallClassW
     entry (type HWND,
            WCHAR(*) varz byaddr nonasgn,
            type DWORD,
            type HSPFILEQ)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiInstallClassW');

 %dcl SetupDiInstallClass char ext;
 %if UNICODE ^= '' %then %do;
   %SetupDiInstallClass='SetupDiInstallClassW';
 %end; %else %do;
   %SetupDiInstallClass='SetupDiInstallClassA';
 %end;


 dcl SetupDiInstallClassExA
     entry (type HWND,
            char(*) varz byaddr nonasgn optional,
            type DWORD,
            type HSPFILEQ,
            type GUID byaddr nonasgn optional,
            type PVOID,
            type PVOID)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiInstallClassExA');

 dcl SetupDiInstallClassExW
     entry (type HWND,
            WCHAR(*) varz byaddr nonasgn optional,
            type DWORD,
            type HSPFILEQ,
            type GUID byaddr nonasgn optional,
            type PVOID,
            type PVOID)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiInstallClassExW');

 %dcl SetupDiInstallClassEx char ext;
 %if UNICODE ^= '' %then %do;
   %SetupDiInstallClassEx='SetupDiInstallClassExW';
 %end; %else %do;
   %SetupDiInstallClassEx='SetupDiInstallClassExA';
 %end;


 dcl SetupDiOpenClassRegKey
     entry (type GUID byaddr nonasgn optional,
            type REGSAM)
     returns (type HKEY byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiOpenClassRegKey');


 /* Flags for SetupDiOpenClassRegKeyEx */

 dcl DIOCR_INSTALLER type DWORD value('00000001'xu);
     /* class installer registry branch */
 dcl DIOCR_INTERFACE type DWORD value('00000002'xu);
     /* interface class registry branch */

 dcl SetupDiOpenClassRegKeyExA
     entry (type GUID byaddr nonasgn optional,
            type REGSAM,
            type DWORD,
            char(*) varz byaddr nonasgn optional,
            type PVOID)
     returns (type HKEY byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiOpenClassRegKeyExA');

 dcl SetupDiOpenClassRegKeyExW
     entry (type GUID byaddr nonasgn optional,
            type REGSAM,
            type DWORD,
            WCHAR(*) varz byaddr nonasgn optional,
            type PVOID)
     returns (type HKEY byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiOpenClassRegKeyExW');

 %dcl SetupDiOpenClassRegKeyEx char ext;
 %if UNICODE ^= '' %then %do;
   %SetupDiOpenClassRegKeyEx='SetupDiOpenClassRegKeyExW';
 %end; %else %do;
   %SetupDiOpenClassRegKeyEx='SetupDiOpenClassRegKeyExA';
 %end;


 dcl SetupDiCreateDeviceInterfaceRegKeyA
     entry (type HDEVINFO,
            type SP_DEVICE_INTERFACE_DATA byaddr,
            type DWORD,
            type REGSAM,
            type HINF,
            char(*) varz byaddr nonasgn optional)
     returns (type HKEY byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiCreateDeviceInterfaceRegKeyA');

 dcl SetupDiCreateDeviceInterfaceRegKeyW
     entry (type HDEVINFO,
            type SP_DEVICE_INTERFACE_DATA byaddr,
            type DWORD,
            type REGSAM,
            type HINF,
            WCHAR(*) varz byaddr nonasgn optional)
     returns (type HKEY byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiCreateDeviceInterfaceRegKeyW');

 %dcl SetupDiCreateDeviceInterfaceRegKey char ext;
 %if UNICODE ^= '' %then %do;
   %SetupDiCreateDeviceInterfaceRegKey
     ='SetupDiCreateDeviceInterfaceRegKeyW';
 %end; %else %do;
 %SetupDiCreateDeviceInterfaceRegKey
     ='SetupDiCreateDeviceInterfaceRegKeyA';
 %end;

 /* Backward compatibility--do not use. */

 %dcl SetupDiCreateInterfaceDeviceRegKeyW char ext;
 %SetupDiCreateInterfaceDeviceRegKeyW
   ='SetupDiCreateDeviceInterfaceRegKeyW';
 %dcl SetupDiCreateInterfaceDeviceRegKeyA char ext;
 %SetupDiCreateInterfaceDeviceRegKeyA
   ='SetupDiCreateDeviceInterfaceRegKeyA';

 %dcl SetupDiCreateInterfaceDeviceRegKey char ext;
 %if UNICODE ^= '' %then %do;
   %SetupDiCreateInterfaceDeviceRegKey
     ='SetupDiCreateDeviceInterfaceRegKeyW';
 %end; %else %do;
   %SetupDiCreateInterfaceDeviceRegKey
     ='SetupDiCreateDeviceInterfaceRegKeyA';
 %end;


 dcl SetupDiOpenDeviceInterfaceRegKey
     entry (type HDEVINFO,
            type SP_DEVICE_INTERFACE_DATA byaddr,
            type DWORD,
            type REGSAM)
     returns (type HKEY byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiOpenDeviceInterfaceRegKey');

 /* Backward compatibility--do not use. */

 %dcl SetupDiOpenInterfaceDeviceRegKey char ext;
 %SetupDiOpenInterfaceDeviceRegKey='SetupDiOpenDeviceInterfaceRegKey';


 dcl SetupDiDeleteDeviceInterfaceRegKey
     entry (type HDEVINFO,
            type SP_DEVICE_INTERFACE_DATA byaddr,
            type DWORD)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiDeleteDeviceInterfaceRegKey');

 /* Backward compatibility--do not use. */

 %dcl SetupDiDeleteInterfaceDeviceRegKey char ext;
 %SetupDiDeleteInterfaceDeviceRegKey
   ='SetupDiDeleteDeviceInterfaceRegKey';


 /* KeyType values for SetupDiCreateDevRegKey, SetupDiOpenDevRegKey, */
 /* and SetupDiDeleteDevRegKey.                                      */

 dcl DIREG_DEV  type DWORD value('00000001'xu);
     /* Open/Create/Delete device key */
 dcl DIREG_DRV  type DWORD value('00000002'xu);
     /* Open/Create/Delete driver key */
 dcl DIREG_BOTH type DWORD value('00000004'xu);
     /* Delete both driver and Device key */

 dcl SetupDiCreateDevRegKeyA
     entry (type HDEVINFO,
            type SP_DEVINFO_DATA byaddr,
            type DWORD,
            type DWORD,
            type DWORD,
            type HINF,
            char(*) varz byaddr nonasgn optional)
     returns (type HKEY byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiCreateDevRegKeyA');

 dcl SetupDiCreateDevRegKeyW
     entry (type HDEVINFO,
            type SP_DEVINFO_DATA byaddr,
            type DWORD,
            type DWORD,
            type DWORD,
            type HINF,
            WCHAR(*) varz byaddr nonasgn optional)
     returns (type HKEY byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiCreateDevRegKeyW');

 %dcl SetupDiCreateDevRegKey char ext;
 %if UNICODE ^= '' %then %do;
   %SetupDiCreateDevRegKey='SetupDiCreateDevRegKeyW';
 %end; %else %do;
   %SetupDiCreateDevRegKey='SetupDiCreateDevRegKeyA';
 %end;


 dcl SetupDiOpenDevRegKey
     entry (type HDEVINFO,
            type SP_DEVINFO_DATA byaddr,
            type DWORD,
            type DWORD,
            type DWORD,
            type REGSAM)
     returns (type HKEY byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiOpenDevRegKey');


 dcl SetupDiDeleteDevRegKey
     entry (type HDEVINFO,
            type SP_DEVINFO_DATA byaddr,
            type DWORD,
            type DWORD,
            type DWORD)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiDeleteDevRegKey');


 dcl SetupDiGetHwProfileList
     entry (type DWORD byaddr,
            type DWORD,
            type DWORD byaddr,
            type DWORD byaddr optional)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiGetHwProfileList');


 dcl SetupDiGetHwProfileListExA
     entry (type DWORD byaddr,
            type DWORD,
            type DWORD byaddr,
            type DWORD byaddr optional,
            char(*) varz byaddr nonasgn optional,
            type PVOID)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiGetHwProfileListExA');

 dcl SetupDiGetHwProfileListExW
     entry (type DWORD byaddr,
            type DWORD,
            type DWORD byaddr,
            type DWORD byaddr optional,
            WCHAR(*) varz byaddr nonasgn optional,
            type PVOID)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiGetHwProfileListExW');

 %dcl SetupDiGetHwProfileListEx char ext;
 %if UNICODE ^= '' %then %do;
   %SetupDiGetHwProfileListEx='SetupDiGetHwProfileListExW';
 %end; %else %do;
   %SetupDiGetHwProfileListEx='SetupDiGetHwProfileListExA';
 %end;


 /* Device registry property codes                                    */
 /* (Codes marked as read-only (R) may only be used for               */
 /* SetupDiGetDeviceRegistryProperty)                                 */

 /* These values should cover the same set of registry properties     */
 /* as defined by the CM_DRP codes in cfgmgr32.h.                     */

 dcl SPDRP_DEVICEDESC                    type DWORD value('00000000'xu);
     /* DeviceDesc (R/W) */
 dcl SPDRP_HARDWAREID                    type DWORD value('00000001'xu);
     /* HardwareID (R/W) */
 dcl SPDRP_COMPATIBLEIDS                 type DWORD value('00000002'xu);
     /* CompatibleIDs (R/W) */
 dcl SPDRP_UNUSED0                       type DWORD value('00000003'xu);
     /* unused */
 dcl SPDRP_SERVICE                       type DWORD value('00000004'xu);
     /* Service (R/W) */
 dcl SPDRP_UNUSED1                       type DWORD value('00000005'xu);
     /* unused */
 dcl SPDRP_UNUSED2                       type DWORD value('00000006'xu);
     /* unused */
 dcl SPDRP_CLASS                         type DWORD value('00000007'xu);
     /* Class (R--tied to ClassGUID) */
 dcl SPDRP_CLASSGUID                     type DWORD value('00000008'xu);
    /* ClassGUID (R/W) */
 dcl SPDRP_DRIVER                        type DWORD value('00000009'xu);
     /* Driver (R/W) */
 dcl SPDRP_CONFIGFLAGS                   type DWORD value('0000000A'xu);
     /* ConfigFlags (R/W) */
 dcl SPDRP_MFG                           type DWORD value('0000000B'xu);
     /* Mfg (R/W) */
 dcl SPDRP_FRIENDLYNAME                  type DWORD value('0000000C'xu);
     /* FriendlyName (R/W) */
 dcl SPDRP_LOCATION_INFORMATION          type DWORD value('0000000D'xu);
     /* LocationInformation (R/W) */
 dcl SPDRP_PHYSICAL_DEVICE_OBJECT_NAME   type DWORD value('0000000E'xu);
     /* PhysicalDeviceObjectName (R) */
 dcl SPDRP_CAPABILITIES                  type DWORD value('0000000F'xu);
     /* Capabilities (R) */
 dcl SPDRP_UI_NUMBER                     type DWORD value('00000010'xu);
     /* UiNumber (R) */
 dcl SPDRP_UPPERFILTERS                  type DWORD value('00000011'xu);
     /* UpperFilters (R/W) */
 dcl SPDRP_LOWERFILTERS                  type DWORD value('00000012'xu);
     /* LowerFilters (R/W) */
 dcl SPDRP_BUSTYPEGUID                   type DWORD value('00000013'xu);
     /* BusTypeGUID (R) */
 dcl SPDRP_LEGACYBUSTYPE                 type DWORD value('00000014'xu);
     /* LegacyBusType (R) */
 dcl SPDRP_BUSNUMBER                     type DWORD value('00000015'xu);
     /* BusNumber (R) */
 dcl SPDRP_ENUMERATOR_NAME               type DWORD value('00000016'xu);
     /* Enumerator Name (R) */
 dcl SPDRP_SECURITY                      type DWORD value('00000017'xu);
     /* Security (R/W, binary form) */
 dcl SPDRP_SECURITY_SDS                  type DWORD value('00000018'xu);
     /* Security (W, SDS form) */
 dcl SPDRP_DEVTYPE                       type DWORD value('00000019'xu);
     /* Device Type (R/W) */
 dcl SPDRP_EXCLUSIVE                     type DWORD value('0000001A'xu);
     /* Device is exclusive-access (R/W) */
 dcl SPDRP_CHARACTERISTICS               type DWORD value('0000001B'xu);
     /* Device Characteristics (R/W) */
 dcl SPDRP_ADDRESS                       type DWORD value('0000001C'xu);
     /* Device Address */
 dcl SPDRP_MAXIMUM_PROPERTY              type DWORD value('0000001D'xu);
     /* Upper bound on ordinals */

 /* Class registry property codes                                     */
 /* (Codes marked as read-only (R) may only be used for               */
 /* SetupDiGetClassRegistryProperty)                                  */

 /* These values should cover the same set of registry properties     */
 /* as defined by the CM_CRP codes in cfgmgr32.h.                     */
 /* They should also have a 1:1 correspondence with Device registers, */
 /* where applicable but no overlap otherwise                         */

 dcl SPCRP_SECURITY                      type DWORD value('00000017'xu);
     /* Security (R/W, binary form) */
 dcl SPCRP_SECURITY_SDS                  type DWORD value('00000018'xu);
     /* Security (W, SDS form) */
 dcl SPCRP_DEVTYPE                       type DWORD value('00000019'xu);
     /* Device Type (R/W) */
 dcl SPCRP_EXCLUSIVE                     type DWORD value('0000001A'xu);
     /* Device is exclusive-access (R/W) */
 dcl SPCRP_CHARACTERISTICS               type DWORD value('0000001B'xu);
     /* Device Characteristics (R/W) */
 dcl SPCRP_MAXIMUM_PROPERTY              type DWORD value('0000001C'xu);
     /* Upper bound on ordinals */


 dcl SetupDiGetDeviceRegistryPropertyA
     entry (type HDEVINFO,
            type SP_DEVINFO_DATA byaddr,
            type DWORD,
            type DWORD byaddr optional,
            (*) type BYTE byaddr,
            type DWORD,
            type DWORD byaddr optional)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiGetDeviceRegistryPropertyA');

 dcl SetupDiGetDeviceRegistryPropertyW
     entry (type HDEVINFO,
            type SP_DEVINFO_DATA byaddr,
            type DWORD,
            type DWORD byaddr optional,
            (*) type BYTE byaddr,
            type DWORD,
            type DWORD byaddr optional)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiGetDeviceRegistryPropertyW');

 %dcl SetupDiGetDeviceRegistryProperty char ext;
 %if UNICODE ^= '' %then %do;
  %SetupDiGetDeviceRegistryProperty='SetupDiGetDeviceRegistryPropertyW';
 %end; %else %do;
  %SetupDiGetDeviceRegistryProperty='SetupDiGetDeviceRegistryPropertyA';
 %end;


 dcl SetupDiGetClassRegistryPropertyA
     entry (type GUID byaddr,
            type DWORD,
            type DWORD byaddr optional,
            (*) type BYTE byaddr,
            type DWORD,
            type DWORD byaddr optional,
            char(*) varz byaddr nonasgn optional,
            type PVOID)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiGetClassRegistryPropertyA');

 dcl SetupDiGetClassRegistryPropertyW
     entry (type GUID byaddr,
            type DWORD,
            type DWORD byaddr optional,
            (*) type BYTE byaddr,
            type DWORD,
            type DWORD byaddr optional,
            WCHAR(*) varz byaddr nonasgn optional,
            type PVOID)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiGetClassRegistryPropertyW');


 %dcl SetupDiGetClassRegistryProperty char ext;
 %if UNICODE ^= '' %then %do;
   %SetupDiGetClassRegistryProperty='SetupDiGetClassRegistryPropertyW';
 %end; %else %do;
   %SetupDiGetClassRegistryProperty='SetupDiGetClassRegistryPropertyA';
 %end;


 dcl SetupDiSetDeviceRegistryPropertyA
     entry (type HDEVINFO,
            type SP_DEVINFO_DATA byaddr,
            type DWORD,
            (*) type BYTE byaddr nonasgn optional,
            type DWORD)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiSetDeviceRegistryPropertyA');

 dcl SetupDiSetDeviceRegistryPropertyW
     entry (type HDEVINFO,
            type SP_DEVINFO_DATA byaddr,
            type DWORD,
            (*) type BYTE byaddr nonasgn optional,
            type DWORD)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiSetDeviceRegistryPropertyW');

 %dcl SetupDiSetDeviceRegistryProperty char ext;
 %if UNICODE ^= '' %then %do;
  %SetupDiSetDeviceRegistryProperty='SetupDiSetDeviceRegistryPropertyW';
 %end; %else %do;
  %SetupDiSetDeviceRegistryProperty='SetupDiSetDeviceRegistryPropertyA';
 %end;


 dcl SetupDiSetClassRegistryPropertyA
     entry (type GUID byaddr,
            type DWORD,
            (*) type BYTE byaddr nonasgn optional,
            type DWORD,
            char(*) varz byaddr nonasgn optional,
            type PVOID)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiSetClassRegistryPropertyA');

 dcl SetupDiSetClassRegistryPropertyW
     entry (type GUID byaddr,
            type DWORD,
            (*) type BYTE byaddr nonasgn optional,
            type DWORD,
            WCHAR(*) varz byaddr nonasgn optional,
            type PVOID)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiSetClassRegistryPropertyW');

 %dcl SetupDiSetClassRegistryProperty char ext;
 %if UNICODE ^= '' %then %do;
   %SetupDiSetClassRegistryProperty='SetupDiSetClassRegistryPropertyW';
 %end; %else %do;
   %SetupDiSetClassRegistryProperty='SetupDiSetClassRegistryPropertyA';
 %end;


 dcl SetupDiGetDeviceInstallParamsA
     entry (type HDEVINFO,
            type SP_DEVINFO_DATA byaddr optional,
            type SP_DEVINSTALL_PARAMS_A byaddr)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiGetDeviceInstallParamsA');

 dcl SetupDiGetDeviceInstallParamsW
     entry (type HDEVINFO,
            type SP_DEVINFO_DATA byaddr optional,
            type SP_DEVINSTALL_PARAMS_W byaddr)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiGetDeviceInstallParamsW');

 %dcl SetupDiGetDeviceInstallParams char ext;
 %if UNICODE ^= '' %then %do;
   %SetupDiGetDeviceInstallParams='SetupDiGetDeviceInstallParamsW';
 %end; %else %do;
   %SetupDiGetDeviceInstallParams='SetupDiGetDeviceInstallParamsA';
 %end;


 dcl SetupDiGetClassInstallParamsA
     entry (type HDEVINFO,
            type SP_DEVINFO_DATA byaddr optional,
            type SP_CLASSINSTALL_HEADER byaddr optional,
            type DWORD,
            type DWORD byaddr optional)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiGetClassInstallParamsA');

 dcl SetupDiGetClassInstallParamsW
     entry (type HDEVINFO,
            type SP_DEVINFO_DATA byaddr optional,
            type SP_CLASSINSTALL_HEADER byaddr optional,
            type DWORD,
            type DWORD byaddr optional)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiGetClassInstallParamsW');

 %dcl SetupDiGetClassInstallParams char ext;
 %if UNICODE ^= '' %then %do;
   %SetupDiGetClassInstallParams='SetupDiGetClassInstallParamsW';
 %end; %else %do;
   %SetupDiGetClassInstallParams='SetupDiGetClassInstallParamsA';
 %end;


 dcl SetupDiSetDeviceInstallParamsA
     entry (type HDEVINFO,
            type SP_DEVINFO_DATA byaddr optional,
            type SP_DEVINSTALL_PARAMS_A byaddr)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiSetDeviceInstallParamsA');

 dcl SetupDiSetDeviceInstallParamsW
     entry (type HDEVINFO,
            type SP_DEVINFO_DATA byaddr optional,
            type SP_DEVINSTALL_PARAMS_W byaddr)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiSetDeviceInstallParamsW');

 %dcl SetupDiSetDeviceInstallParams char ext;
 %if UNICODE ^= '' %then %do;
   %SetupDiSetDeviceInstallParams='SetupDiSetDeviceInstallParamsW';
 %end; %else %do;
   %SetupDiSetDeviceInstallParams='SetupDiSetDeviceInstallParamsA';
 %end;


 dcl SetupDiSetClassInstallParamsA
     entry (type HDEVINFO,
            type SP_DEVINFO_DATA byaddr optional,
            type SP_CLASSINSTALL_HEADER byaddr optional,
            type DWORD)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiSetClassInstallParamsA');

 dcl SetupDiSetClassInstallParamsW
     entry (type HDEVINFO,
            type SP_DEVINFO_DATA byaddr optional,
            type SP_CLASSINSTALL_HEADER byaddr optional,
            type DWORD)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiSetClassInstallParamsW');

 %dcl SetupDiSetClassInstallParams char ext;
 %if UNICODE ^= '' %then %do;
   %SetupDiSetClassInstallParams='SetupDiSetClassInstallParamsW';
 %end; %else %do;
   %SetupDiSetClassInstallParams='SetupDiSetClassInstallParamsA';
 %end;


 dcl SetupDiGetDriverInstallParamsA
     entry (type HDEVINFO,
            type SP_DEVINFO_DATA byaddr optional,
            type SP_DRVINFO_DATA_A byaddr,
            type SP_DRVINSTALL_PARAMS byaddr)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiGetDriverInstallParamsA');


 dcl SetupDiGetDriverInstallParamsW
     entry (type HDEVINFO,
            type SP_DEVINFO_DATA byaddr optional,
            type SP_DRVINFO_DATA_W byaddr,
            type SP_DRVINSTALL_PARAMS byaddr)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiGetDriverInstallParamsW');

 %dcl SetupDiGetDriverInstallParams char ext;
 %if UNICODE ^= '' %then %do;
   %SetupDiGetDriverInstallParams='SetupDiGetDriverInstallParamsW';
 %end; %else %do;
   %SetupDiGetDriverInstallParams='SetupDiGetDriverInstallParamsA';
 %end;


 dcl SetupDiSetDriverInstallParamsA
     entry (type HDEVINFO,
            type SP_DEVINFO_DATA byaddr optional,
            type SP_DRVINFO_DATA_A byaddr,
            type SP_DRVINSTALL_PARAMS byaddr)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiSetDriverInstallParamsA');

 dcl SetupDiSetDriverInstallParamsW
     entry (type HDEVINFO,
            type SP_DEVINFO_DATA byaddr optional,
            type SP_DRVINFO_DATA_W byaddr,
            type SP_DRVINSTALL_PARAMS byaddr)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiSetDriverInstallParamsW');

 %dcl SetupDiSetDriverInstallParams char ext;
 %if UNICODE ^= '' %then %do;
   %SetupDiSetDriverInstallParams='SetupDiSetDriverInstallParamsW';
 %end; %else %do;
   %SetupDiSetDriverInstallParams='SetupDiSetDriverInstallParamsA';
 %end;


 dcl SetupDiLoadClassIcon
     entry (type GUID byaddr,
            type HICON byaddr optional,
            type INT byaddr optional)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiLoadClassIcon');


 /* Flags controlling the drawing of mini-icons */

 dcl DMI_MASK    type DWORD value('00000001'xu);
 dcl DMI_BKCOLOR type DWORD value('00000002'xu);
 dcl DMI_USERECT type DWORD value('00000004'xu);


 dcl SetupDiDrawMiniIcon
     entry (type HDC,
            type RECT,
            type INT,
            type DWORD)
     returns (type INT byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiDrawMiniIcon');


 dcl SetupDiGetClassBitmapIndex
     entry (type GUID byaddr nonasgn optional,
            type INT byaddr)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiGetClassBitmapIndex');


 dcl SetupDiGetClassImageList
     entry (type SP_CLASSIMAGELIST_DATA byaddr)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiGetClassImageList');


 dcl SetupDiGetClassImageListExA
     entry (type SP_CLASSIMAGELIST_DATA byaddr,
            char(*) varz byaddr nonasgn optional,
            type PVOID)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiGetClassImageListExA');

 dcl SetupDiGetClassImageListExW
     entry (type SP_CLASSIMAGELIST_DATA byaddr,
            WCHAR(*) varz byaddr nonasgn optional,
            type PVOID)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiGetClassImageListExW');

 %dcl SetupDiGetClassImageListEx char ext;
 %if UNICODE ^= '' %then %do;
   %SetupDiGetClassImageListEx='SetupDiGetClassImageListExW';
 %end; %else %do;
   %SetupDiGetClassImageListEx='SetupDiGetClassImageListExA';
 %end;


 dcl SetupDiGetClassImageIndex
     entry (type SP_CLASSIMAGELIST_DATA byaddr,
            type GUID byaddr nonasgn,
            type INT byaddr)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiGetClassImageIndex');


 dcl SetupDiDestroyClassImageList
     entry (type SP_CLASSIMAGELIST_DATA byaddr)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiDestroyClassImageList');


 /* PropertySheetType values for the SetupDiGetClassDevPropertySheets */
 /* API                                                               */

 dcl DIGCDP_FLAG_BASIC    type DWORD value('00000001'xu);
 dcl DIGCDP_FLAG_ADVANCED type DWORD value('00000002'xu);

 dcl SetupDiGetClassDevPropertySheetsA
     entry (type HDEVINFO,
            type SP_DEVINFO_DATA byaddr optional,
            type PROPSHEETHEADERA byaddr,
            type DWORD,
            type DWORD byaddr optional,
            type DWORD)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiGetClassDevPropertySheetsA');

 dcl SetupDiGetClassDevPropertySheetsW
     entry (type HDEVINFO,
            type SP_DEVINFO_DATA byaddr optional,
            type PROPSHEETHEADERW byaddr,
            type DWORD,
            type DWORD byaddr optional,
            type DWORD)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiGetClassDevPropertySheetsW');

 %dcl SetupDiGetClassDevPropertySheets char ext;
 %if UNICODE ^= '' %then %do;
  %SetupDiGetClassDevPropertySheets='SetupDiGetClassDevPropertySheetsW';
 %end; %else %do;
  %SetupDiGetClassDevPropertySheets='SetupDiGetClassDevPropertySheetsA';
 %end;


 /* Define ICON IDs publicly exposed from setupapi. */

 /* PL/I Note: IDI_* constants here made consistent with IDI_*        */
 /* constants in WINUSER.CPY. Original C has integer types here.      */

 dcl IDI_RESOURCEFIRST          pointer value(MAKEINTRESOURCE(159));
 dcl IDI_RESOURCE               pointer value(MAKEINTRESOURCE(159));
 dcl IDI_RESOURCELAST           pointer value(MAKEINTRESOURCE(161));
 dcl IDI_RESOURCEOVERLAYFIRST   pointer value(MAKEINTRESOURCE(161));
 dcl IDI_RESOURCEOVERLAYLAST    pointer value(MAKEINTRESOURCE(161));
 dcl IDI_CONFLICT               pointer value(MAKEINTRESOURCE(161));

 dcl IDI_CLASSICON_OVERLAYFIRST pointer value(MAKEINTRESOURCE(500));
 dcl IDI_CLASSICON_OVERLAYLAST  pointer value(MAKEINTRESOURCE(502));
 dcl IDI_PROBLEM_OVL            pointer value(MAKEINTRESOURCE(500));
 dcl IDI_DISABLED_OVL           pointer value(MAKEINTRESOURCE(501));
 dcl IDI_FORCED_OVL             pointer value(MAKEINTRESOURCE(502));


 dcl SetupDiAskForOEMDisk
     entry (type HDEVINFO,
            type SP_DEVINFO_DATA byaddr optional)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiAskForOEMDisk');


 dcl SetupDiSelectOEMDrv
     entry (type HWND,
            type HDEVINFO,
            type SP_DEVINFO_DATA byaddr optional)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiSelectOEMDrv');


 dcl SetupDiClassNameFromGuidA
     entry (type GUID byaddr nonasgn,
            char(*) varz byaddr,
            type DWORD,
            type DWORD byaddr optional)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiClassNameFromGuidA');

 dcl SetupDiClassNameFromGuidW
     entry (type GUID byaddr nonasgn,
            WCHAR(*) varz byaddr,
            type DWORD,
            type DWORD byaddr optional)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiClassNameFromGuidW');

 %dcl SetupDiClassNameFromGuid char ext;
 %if UNICODE ^= '' %then %do;
   %SetupDiClassNameFromGuid='SetupDiClassNameFromGuidW';
 %end; %else %do;
   %SetupDiClassNameFromGuid='SetupDiClassNameFromGuidA';
 %end;


 dcl SetupDiClassNameFromGuidExA
     entry (type GUID byaddr nonasgn,
            char(*) varz byaddr,
            type DWORD,
            type DWORD byaddr optional,
            char(*) varz byaddr nonasgn optional,
            type PVOID)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiClassNameFromGuidExA');

 dcl SetupDiClassNameFromGuidExW
     entry (type GUID byaddr nonasgn,
            WCHAR(*) varz byaddr,
            type DWORD,
            type DWORD byaddr optional,
            WCHAR(*) varz byaddr nonasgn optional,
            type PVOID)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiClassNameFromGuidExW');

 %dcl SetupDiClassNameFromGuidEx char ext;
 %if UNICODE ^= '' %then %do;
   %SetupDiClassNameFromGuidEx='SetupDiClassNameFromGuidExW';
 %end; %else %do;
   %SetupDiClassNameFromGuidEx='SetupDiClassNameFromGuidExA';
 %end;


 dcl SetupDiClassGuidsFromNameA
     entry (char(*) varz byaddr nonasgn,
            (*) type GUID byaddr,
            type DWORD,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiClassGuidsFromNameA');

 dcl SetupDiClassGuidsFromNameW
     entry (WCHAR(*) varz byaddr nonasgn,
            (*) type GUID byaddr,
            type DWORD,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiClassGuidsFromNameW');


 %dcl SetupDiClassGuidsFromName char ext;
 %if UNICODE ^= '' %then %do;
   %SetupDiClassGuidsFromName='SetupDiClassGuidsFromNameW';
 %end; %else %do;
   %SetupDiClassGuidsFromName='SetupDiClassGuidsFromNameA';
 %end;


 dcl SetupDiClassGuidsFromNameExA
     entry (char(*) varz byaddr nonasgn,
            (*) type GUID byaddr,
            type DWORD,
            type DWORD byaddr,
            char(*) varz byaddr nonasgn optional,
            type PVOID)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiClassGuidsFromNameExA');

 dcl SetupDiClassGuidsFromNameExW
     entry (WCHAR(*) varz byaddr nonasgn,
            (*) type GUID byaddr,
            type DWORD,
            type DWORD byaddr,
            WCHAR(*) varz byaddr nonasgn optional,
            type PVOID)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiClassGuidsFromNameExW');

 %dcl SetupDiClassGuidsFromNameEx char ext;
 %if UNICODE ^= '' %then %do;
   %SetupDiClassGuidsFromNameEx='SetupDiClassGuidsFromNameExW';
 %end; %else %do;
   %SetupDiClassGuidsFromNameEx='SetupDiClassGuidsFromNameExA';
 %end;


 dcl SetupDiGetHwProfileFriendlyNameA
     entry (type DWORD,
            char(*) varz byaddr,
            type DWORD,
            type DWORD byaddr optional)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiGetHwProfileFriendlyNameA');

 dcl SetupDiGetHwProfileFriendlyNameW
     entry (type DWORD,
            WCHAR(*) varz byaddr,
            type DWORD,
            type DWORD byaddr optional)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiGetHwProfileFriendlyNameW');

 %dcl SetupDiGetHwProfileFriendlyName char ext;
 %if UNICODE ^= '' %then %do;
   %SetupDiGetHwProfileFriendlyName='SetupDiGetHwProfileFriendlyNameW';
 %end; %else %do;
   %SetupDiGetHwProfileFriendlyName='SetupDiGetHwProfileFriendlyNameA';
 %end;


 dcl SetupDiGetHwProfileFriendlyNameExA
     entry (type DWORD,
            char(*) varz byaddr,
            type DWORD,
            type DWORD byaddr optional,
            char(*) varz byaddr nonasgn optional,
            type PVOID)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiGetHwProfileFriendlyNameExA');

 dcl SetupDiGetHwProfileFriendlyNameExW
     entry (type DWORD,
            WCHAR(*) varz byaddr,
            type DWORD,
            type DWORD byaddr optional,
            WCHAR(*) varz byaddr nonasgn optional,
            type PVOID)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiGetHwProfileFriendlyNameExW');

 %dcl SetupDiGetHwProfileFriendlyNameEx char ext;
 %if UNICODE ^= '' %then %do;
   %SetupDiGetHwProfileFriendlyNameEx
     ='SetupDiGetHwProfileFriendlyNameExW';
 %end; %else %do;
   %SetupDiGetHwProfileFriendlyNameEx
     ='SetupDiGetHwProfileFriendlyNameExA';
 %end;


 /* PageType values for SetupDiGetWizardPage API */

 dcl SPWPT_SELECTDEVICE    type DWORD value('00000001'xu);

 /* Flags for SetupDiGetWizardPage API */

 dcl SPWP_USE_DEVINFO_DATA type DWORD value('00000001'xu);

 dcl SetupDiGetWizardPage
     entry (type HDEVINFO,
            type SP_DEVINFO_DATA byaddr optional,
            type SP_INSTALLWIZARD_DATA byaddr,
            type DWORD,
            type DWORD)
     returns (type HPROPSHEETPAGE byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiGetWizardPage');


 dcl SetupDiGetSelectedDevice
     entry (type HDEVINFO,
            type SP_DEVINFO_DATA byaddr)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiGetSelectedDevice');


 dcl SetupDiSetSelectedDevice
     entry (type HDEVINFO,
            type SP_DEVINFO_DATA byaddr)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiSetSelectedDevice');


 dcl SetupDiGetActualSectionToInstallA
     entry (type HINF,
            char(*) varz byaddr nonasgn,
            char(*) varz byaddr optional,
            type DWORD,
            type DWORD byaddr optional,
            type PSTR byaddr optional)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiGetActualSectionToInstallA');

 dcl SetupDiGetActualSectionToInstallW
     entry (type HINF,
            WCHAR(*) varz byaddr nonasgn,
            WCHAR(*) varz byaddr optional,
            type DWORD,
            type DWORD byaddr optional,
            type PWSTR byaddr optional)
     returns (type BOOL byvalue optional)
     WINSETUPAPI WINAPI external('SetupDiGetActualSectionToInstallW');

 %dcl SetupDiGetActualSectionToInstall char ext;
 %if UNICODE ^= '' %then %do;
  %SetupDiGetActualSectionToInstall='SetupDiGetActualSectionToInstallW';
 %end; %else %do;
  %SetupDiGetActualSectionToInstall='SetupDiGetActualSectionToInstallA';
 %end;

 %end; /* _INC_SETUPAPI */

